USE `hnqzx`;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for wm_quiz_item
-- ----------------------------
DROP TABLE IF EXISTS `wm_quiz_item`;
CREATE TABLE `wm_quiz_item`
(
    `item_id`      INT AUTO_INCREMENT COMMENT 'Id',
    `quiz_sn`      VARCHAR(64)  NOT NULL COMMENT '试卷序号',
    `label`        VARCHAR(64)  NOT NULL COMMENT '标题',
    `quiz_options` JSON COMMENT '选项',
    `answer`       VARCHAR(255) NULL COMMENT '答案',
    `widget`       BIGINT       NOT NULL COMMENT '排序权重',
    `mark`         INT          NOT NULL DEFAULT 0 COMMENT '分数',
    `create_by`    VARCHAR(64)  NOT NULL COMMENT '创建人',
    `update_by`    VARCHAR(64)  NOT NULL COMMENT '修改人',
    `create_time`  DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `update_time`  DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
    PRIMARY KEY `pk_id` (`item_id`) USING BTREE,
    INDEX `idx_quiz_sn` (`quiz_sn`) USING BTREE
) ENGINE = InnoDB
    COMMENT ='试卷项表';


SET FOREIGN_KEY_CHECKS = 1;
