USE `hnqzx`;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for wm_question
-- ----------------------------
DROP TABLE IF EXISTS `wm_question`;
CREATE TABLE `wm_question`
(
    `qst_id`      INT AUTO_INCREMENT COMMENT 'Id',
    `serial_num`  VARCHAR(64)  NOT NULL COMMENT '序列号',
    `label`       VARCHAR(64)  NOT NULL COMMENT '标题',
    `options`     JSON COMMENT '选项',
    `answer`      VARCHAR(255) NULL COMMENT '答案',
    `ent_id`      INT UNSIGNED NOT NULL COMMENT '企业信息',
    `create_by`   VARCHAR(64)  NOT NULL COMMENT '创建人',
    `update_by`   VARCHAR(64)  NOT NULL COMMENT '修改人',
    `create_time` DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `update_time` DATETIME     NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
    PRIMARY KEY `pk_id` (`qst_id`) USING BTREE,
    UNIQUE KEY `uk_sn` (`serial_num`) USING BTREE,
    INDEX `idx_eid` (`ent_id`) USING BTREE
) ENGINE = InnoDB
    COMMENT ='试题表';


SET FOREIGN_KEY_CHECKS = 1;
