-- 新增医疗器械表
create table if not exists medical_equipment
(
    id            int auto_increment comment '医疗器械'
        primary key,
    name          varchar(64)      null comment '器械名称',
    manufacturer  varchar(64)      null comment '生产厂家',
    drug_ent_id   int              null comment '所属企业id',
    drug_ent_name varchar(64)      null comment '所属企业名称',
    specification varchar(64)      null comment '规格',
    measure_unit  varchar(64)      null comment '计量单位组名称',
    level         varchar(20)      null comment '等级',
    remark        varchar(64)      null comment '备注',
    del_flag      char default '0' null comment '删除标记,1:已删除,0:正常',
    create_time   datetime         null comment '创建时间',
    create_user   int              null comment '创建人',
    update_time   datetime         null comment '更新时间',
    update_user   int              null comment '更新人'
)
    comment '医疗器械';

-- 新增任务类型手术跟台
INSERT INTO hnqzx.wm_task_type (id, task_type_name, task_type_level, task_score_start, task_score_end, score, task_ent_id, durgent_id, level1_id, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user, status, base_id, real_flag, rule_id, parent_id) VALUES (42, '手术跟台-一级', '1', 0, 500, 500, null, null, null, null, 0, '0', 1, '2022-11-07 16:52:06', null, '2022-11-07 16:44:22', null, 0, '专项服务', null, '1', 'p-17');
INSERT INTO hnqzx.wm_task_type (id, task_type_name, task_type_level, task_score_start, task_score_end, score, task_ent_id, durgent_id, level1_id, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user, status, base_id, real_flag, rule_id, parent_id) VALUES (43, '手术跟台-二级', '1', 0, 1000, 1000, null, null, null, null, 0, '0', 1, '2022-11-07 16:52:06', null, '2022-11-07 16:44:22', null, 0, '专项服务', null, '1', 'p-17');
INSERT INTO hnqzx.wm_task_type (id, task_type_name, task_type_level, task_score_start, task_score_end, score, task_ent_id, durgent_id, level1_id, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user, status, base_id, real_flag, rule_id, parent_id) VALUES (44, '手术跟台-三级', '1', 0, 2000, 2000, null, null, null, null, 0, '0', 1, '2022-11-07 17:15:55', null, '2022-11-07 16:44:22', null, 0, '专项服务', null, '1', 'p-17');

-- 新增任务类型手术跟台-小程序页面字段配置
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp32', '关联积分包', 1, 'domain', 1, 200, '', '', 'package_list', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp2', '手术名称', 2, 'text', 4, 50, '', '', '', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp4', '跟台时间', 5, 'datetime', 1, 200, '', '', '', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp31', '位置打卡', 6, 'map', 1, 200, '', '', '', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp6', '手术单/术前讨论会（1张）', 7, 'img', 1, 5, '', '', '', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp10', '跟台总结', 11, 'longtext', 5, 100, '', '', '', '0', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp7', '产品出库单（1张）', 8, 'img', 1, 5, '', '', '', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp12', '应用产品', 3, 'domain', 1, 200, null, '', 'medical_equipment_list', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp23', '跟台级别', 4, 'select', 1, 2, '', '', 'operating_heel_table_level', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp8', '现场照片（最少3张，需包含现场照片、医生照片）', 9, 'img', 3, 5, '', '', '', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);
INSERT INTO hnqzx.wm_task_content_config (base_type_id, task_type_id, task_filed_key, task_filed_value, seq, task_filed_type, task_filed_minsize, task_filed_maxsize, task_filed_alert, dict_url, dict_group_name, is_mustfill, dept_id, del_flag, enable_flag, tenant_id, create_time, create_user, update_time, update_user) VALUES ('42', '42', 'temp9', '术后小结（1张，需包含对应产品列示）', 10, 'img', 1, 5, '', '', '', '1', null, '0', '0', 1, '2022-11-07 17:28:54', null, '2022-11-07 17:28:54', null);