-- 任务提交百分比限制规则表
create table wm_task_sub_percent_rule
(
    rule_id     int(20) auto_increment comment '规则ID'
        primary key,
    dept_id     int(20)                            not null comment '企业id',
    sub_cate    varchar(32)                        not null comment '次级分类',
    batch_id    varchar(32)                        null comment '批量保存编号',
    sub_rule    json                               null comment '规则',
    opt_flag    varchar(32)                        not null comment '操作标记',
    create_time datetime default CURRENT_TIMESTAMP not null comment '创建时间',
    update_time datetime default CURRENT_TIMESTAMP not null on update CURRENT_TIMESTAMP comment '修改时间'
)
    comment '任务提交百分比限制规则表' charset = utf8mb4;

create index idx_dept_id
    on wm_task_sub_percent_rule (dept_id);

create index idx_sub_cate
    on wm_task_sub_percent_rule (sub_cate);


create table wm_task_type_sub_cate2
(
    dtt_id      int(20) auto_increment comment '主键ID'
        primary key,
    type_id     int(20)                            not null comment '企业id',
    type_name   varchar(32)                        not null comment '任务名称',
    sub_cate    varchar(32)                        not null comment '次级分类',
    create_time datetime default CURRENT_TIMESTAMP not null comment '创建时间',
    update_time datetime default CURRENT_TIMESTAMP not null on update CURRENT_TIMESTAMP comment '修改时间'
)
    comment '任务类型二级分类表' charset = utf8mb4;

create index idx_dept_id
    on wm_task_type_sub_cate2 (type_id);

create index idx_sub_cate
    on wm_task_type_sub_cate2 (sub_cate);
