USE hnqzx;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for wm_task_type_sub_cate
-- ----------------------------
DROP TABLE IF EXISTS `wm_task_type_sub_cate`;
CREATE TABLE `wm_task_type_sub_cate`
(
    `ttsc_id`     INT(20)     NOT NULL AUTO_INCREMENT COMMENT '规则ID',
    `type_id`     INT(20)     NOT NULL COMMENT '企业id',
    `type_name`   VARCHAR(32) NOT NULL COMMENT '任务名称',
    `sub_cate`    VARCHAR(32) NOT NULL COMMENT '次级分类',
    `create_time` DATETIME    NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `update_time` DATETIME    NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
    PRIMARY KEY (`ttsc_id`) USING BTREE,
    INDEX `idx_dept_id` (`type_id`) USING BTREE,
    INDEX `idx_sub_cate` (`sub_cate`) USING BTREE
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4 COMMENT ='任务提交规则表';

-- ----------------------------
-- Records of wm_task_type_sub_cate
-- ----------------------------
BEGIN;
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (1, 1, '医院科室推广会', 'CONFERENCE', '2022-08-17 17:11:16', '2022-08-17 17:11:16');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (2, 2, '区域学术沙龙', 'CONFERENCE', '2022-08-17 17:11:16', '2022-08-17 17:11:16');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (3, 3, '城市卫星会', 'CONFERENCE', '2022-08-17 17:11:16', '2022-08-17 17:11:16');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (4, 4, '省级学科年会', 'CONFERENCE', '2022-08-17 17:11:16', '2022-08-17 17:11:16');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (5, 5, '医院拜访', 'HOSPITAL_VISIT', '2022-08-17 17:11:16', '2022-08-17 17:11:16');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (6, 6, '商业公司拜访', 'BUSINESS_COMPANY_VISIT', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (7, 8, '产品相册分享', 'PRODUCT_ALBUM', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (8, 9, '学术信息交流', 'PRODUCT_ALBUM', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (9, 10, '受众阅读文章', 'PRODUCT_ALBUM', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (10, 11, '受众打开产品相册', 'PRODUCT_ALBUM', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (11, 19, '一对一专访', 'ONE_ON_ONE_INTERVIEW', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (12, 30, '医院信息修改', 'HOSPITAL_INFO_COLLECTION', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (13, 33, '药店拜访', 'PHARMACY_VISIT', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (14, 34, '医院患者教育培训', 'TRAINING', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (15, 35, '药店药师培训', 'TRAINING', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
INSERT INTO wm_task_type_sub_cate (ttsc_id, type_id, type_name, sub_cate, create_time, update_time) VALUES (16, 36, '商业公司培训', 'TRAINING', '2022-08-17 17:11:17', '2022-08-17 17:11:17');
COMMIT;

SET FOREIGN_KEY_CHECKS = 1;