USE hnqzx;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for single_member_settle_amount_overrun_in_several_months
-- ----------------------------
DROP TABLE IF EXISTS `single_member_settle_amount_overrun_in_several_months`;
CREATE TABLE `single_member_settle_amount_overrun_in_several_months`
(
    `record_id`               INT UNSIGNED AUTO_INCREMENT COMMENT 'id',
    `note_id`                 INT UNSIGNED   NULL COMMENT '积分包计算记录id',
    `realname`                VARCHAR(32)    NULL COMMENT '用户名称',
    `username`                VARCHAR(11)    NULL COMMENT '用户名',
    `dept_id`                 INT            NULL COMMENT '结算企业id',
    `dept_name`               VARCHAR(64)    NULL COMMENT '结算企业名称',
    `settle_amount`           DECIMAL(20, 2) NULL COMMENT '结算金额',
    `sub_to_gig_time`         DATETIME       NULL COMMENT '结算时间',
    `settle_state`            VARCHAR(16)    NULL COMMENT '结算企业名称',
    `sub_type_name`           VARCHAR(16)    NULL COMMENT '结算渠道名称',
    `package_name`            VARCHAR(64)    NULL COMMENT '积分包名称',
    `settle_note_create_time` DATETIME       NULL COMMENT '结算记录创建时间',
    `period`                  INT UNSIGNED   NULL COMMENT '统计周期',
    `platform_limit`          DECIMAL        NULL COMMENT '结算限制',
    `uuid`                    VARCHAR(64)    NOT NULL COMMENT 'uuid',
    `create_time`             DATETIME       NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    PRIMARY KEY (`record_id`) USING BTREE,
    KEY `idx_uuid` (uuid) USING BTREE
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4 COMMENT ='单人连续多月结算额超标';


SET FOREIGN_KEY_CHECKS = 1;