USE hnqzx;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for single_member_without_such_task_types_in_several_months
-- ----------------------------
DROP TABLE IF EXISTS `single_member_without_such_task_types_in_several_months`;
CREATE TABLE `single_member_without_such_task_types_in_several_months`
(
    `record_id`            INT UNSIGNED AUTO_INCREMENT COMMENT 'id',
    `user_id`              INT UNSIGNED NULL COMMENT '用户id',
    `package_id`           INT UNSIGNED NULL COMMENT '积分包id',
    `package_name`         VARCHAR(32)  NULL COMMENT '积分包名称',
    `status`               VARCHAR(11)  NULL COMMENT '积分包状态',
    `realname`             VARCHAR(32)  NULL COMMENT '用户名称',
    `username`             VARCHAR(11)  NULL COMMENT '用户名',
    `dept_id`              INT          NULL COMMENT '结算企业id',
    `dept_name`            VARCHAR(64)  NULL COMMENT '结算企业名称',
    `period`               INT UNSIGNED NULL COMMENT '统计周期',
    `type_list`            VARCHAR(255) NULL COMMENT '风控任务类型',
    `package_create_time`  DATETIME     NULL COMMENT '积分包创建时间',
    `package_pick_up_time` DATETIME     NULL COMMENT '积分包领取时间',
    `first_task_time`      DATETIME     NULL COMMENT '首个任务时间',
    `uuid`                    VARCHAR(64)    NOT NULL COMMENT 'uuid',
    `create_time`             DATETIME       NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    PRIMARY KEY (`record_id`) USING BTREE,
    KEY `idx_uuid` (uuid) USING BTREE
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4 COMMENT ='单人连续多月结算相同金额';


SET FOREIGN_KEY_CHECKS = 1;
