package com.qunzhixinxi.hnqz.common.rabbitmq.annotation;

import org.springframework.core.annotation.AliasFor;
import org.springframework.stereotype.Component;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 消息队列初始化注解
 * @author Hengchen.Sun
 * @date 2021/08/23 16:25:23
 * @version 1.0.0
 */
@Documented
@Inherited
@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Component
public @interface RabbitMqComponent {
    @AliasFor(
            annotation = Component.class
    )
    String value();
}
