package com.qunzhixinxi.hnqz.common.taxhelper.entity.request;

import com.qunzhixinxi.hnqz.common.taxhelper.entity.model.TaxHelperBindingCardVerificationModel;
import lombok.Data;

/**
 * {@code TaxHelperBindingCardVerificationRequest} 获取绑卡验证码
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-02-19
 * @since ver.1.0.0
 */
@Data
public class TaxHelperBindingCardVerificationRequest extends TaxHelperRequest {

	/**
	 * 获取绑卡验证码地址
	 */
	private final static String PATH = "/lgsby/api/bindingCard";

	public TaxHelperBindingCardVerificationRequest(TaxHelperBindingCardVerificationModel taxHelperBindingCardVerificationModel) {
		this.bizModel = taxHelperBindingCardVerificationModel;
		this.queryUrl = String.format("%s%s", taxHelperBindingCardVerificationModel.getQueryUrl(), PATH);
	}
}
