package com.qunzhixinxi.hnqz.common.taxhelper.entity.vo;

import lombok.Data;
import lombok.Getter;

import java.io.Serializable;

/**
 * {@code TaxHelperECheckFaceNotify} E证通认证回调
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-06-09
 * @since ver.1.0.0
 */
@Data
public class TaxHelperECheckFaceNotify implements Serializable {

	private static final long serialVersionUID = 7655471243167776361L;

	/**
	 * 认证时的token
	 */
	private String token;

	/**
	 * 认证token结果状态：1-> token有误；2-> token过期；
	 */
	private ECheckTokenStatus tokenStatus;

	/**
	 * 认证结果：以中文返回，2时，为错误原因；1和3时返回空字符串
	 */
	private Boolean verifyDone;

	/**
	 * E证通token状态枚举
	 */
	@Getter
	enum ECheckTokenStatus {
		INVALID_TOKEN(1), TOKEN_EXPIRY(2);

		private int val;

		ECheckTokenStatus(int val) {
			this.val = val;
		}
	}
}
