package com.qunzhixinxi.hnqz.admin.api.dto;

import com.qunzhixinxi.hnqz.admin.api.constant.UpmsLevel;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 企业关系Dto
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-11-02 14:45
 */
@Data
@ToString
public class SysEnterpriseRelationDTO implements Serializable {
	private static final long serialVersionUID = 1318703734982431471L;


	/**
	 * id
	 */
	private Integer relId;

	/**
	 * 企业id
	 */
	private Integer enterpriseId;

	/**
	 * 企业类型
	 */
	private UpmsType.EnterpriseType enterpriseType;

	/**
	 * 产品线
	 */
	private UpmsType.ProductLine productLine;

	/**
	 * 企业等级
	 */
	private UpmsLevel.EnterpriseLevel enterpriseLevel;

	/**
	 * 父级id
	 */
	private Integer parentId;

	/**
	 * 服务费
	 */
	private List<Map<String, Object>> serviceCharges;


}
