package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsLevel;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;

/**
 * 企业关系表
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-11-02 10:45
 */
@Data
@ToString
@TableName(value = "sys_ent_rel")
public class SysEnterpriseRelation implements Serializable {
	private static final long serialVersionUID = 6584285982757215110L;

	/**
	 * id
	 */
	@TableId(value = "rel_id", type = IdType.AUTO)
	private Integer relId;

	/**
	 * 企业id
	 */
	@TableField(value = "ent_id")
	private Integer enterpriseId;

	/**
	 * 企业类型
	 */
	@TableField(value = "e_type")
	private UpmsType.EnterpriseType enterpriseType;

	/**
	 * 产品线
	 */
	@TableField(value = "pro_line")
	private UpmsType.ProductLine productLine;

	/**
	 * 企业等级
	 */
	@TableField(value = "e_level")
	private UpmsLevel.EnterpriseLevel enterpriseLevel;

	/**
	 * 父级id
	 */
	private Integer parentId;

	/**
	 * 根id
	 */
	private Integer rootId;


}
