package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 积分包的试卷
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-10-19 11:51
 */
@Data
@TableName(value = "wm_pkg_quiz_rel", autoResultMap = true)
public final class WmPkgQuizRelation {

	@TableId(value = "rel_id", type = IdType.AUTO)
	private Integer relationId;

	private Integer pkgId;

	private Integer quizId;

	@TableField(value = "quiz_title")
	private String title;

	private Integer itemQty;

	private Integer totalMark;

	private Integer passingMark;

	@TableField(value = "quiz_items", typeHandler = JacksonTypeHandler.class)
	private Item[] items;

	/**
	 * 是否可用
	 */
	@TableField(value = "avail")
	private Boolean available;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	@Data
	public static class Item implements Serializable{

		private static final long serialVersionUID = 8067658146266706311L;

		private String label;

		private WmQuestion.Option[] options;

		private String answer;

		private Integer mark;

	}
}
