package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 试题实体
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-10-16 14:58
 */
@Data
@TableName(value = "wm_question", autoResultMap = true)
public final class WmQuestion {

	@TableId(value = "qst_id", type = IdType.AUTO)
	private Integer questionId;

	@TableField(value = "serial_num")
	private String serialNumber;

	private String label;

	@TableField(typeHandler = JacksonTypeHandler.class)
	private Option[] options;

	private String answer;

	@TableField(value = "ent_id")
	private Integer enterpriseId;

	/**
	 * 创建人
	 */
	@TableField(fill = FieldFill.INSERT)
	private String createBy;

	/**
	 * 修改人
	 */
	@TableField(fill = FieldFill.INSERT_UPDATE)
	private String updateBy;

	/**
	 * 创建时间
	 */
	@TableField(fill = FieldFill.INSERT)
	private LocalDateTime createTime;

	/**
	 * 修改时间
	 */
	@TableField(fill = FieldFill.INSERT_UPDATE)
	private LocalDateTime updateTime;

	/**
	 * 选项实体
	 *
	 * @author jimmy
	 * @version 1.0.0
	 * @date 2023-10-16 15:13
	 */
	@Data
	public static class Option implements Serializable {

		private static final long serialVersionUID = -3212524654632400045L;

		/**
		 * 选项编号
		 */
		@NotBlank(message = "选项编号必填")
		private String no;

		/**
		 * 选项文本
		 */
		@NotBlank(message = "选项文本必填")
		private String text;

	}
}
