package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.qunzhixinxi.hnqz.common.core.constant.enums.UpmsState;
import com.qunzhixinxi.hnqz.common.core.constant.enums.UpmsType;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 试卷实体
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-10-16 14:20
 */
@Data
@TableName(value = "wm_quiz", autoResultMap = true)
public final class WmQuiz implements Serializable {

	private static final long serialVersionUID = -4251199161109646452L;

	/**
	 * 试卷ID
	 */
	@TableId(value = "quiz_id", type = IdType.AUTO)
	private Integer quizId;

	/**
	 * 问卷序列号
	 */
	@TableField(value = "serial_num")
	private String serialNumber;

	/**
	 * 标题
	 */
	@TableField(value = "quiz_title")
	private String title;

	/**
	 * 简介
	 */
	private String introduction;

	/**
	 * 问卷来源类型
	 */
	private UpmsType.QuizSourceType sourceType;

	/**
	 * 问卷状态
	 */
	@TableField(value = "quiz_state")
	private UpmsState.QuizState state;

	/**
	 * 企业id
	 */
	@TableField(value = "ent_id")
	private Integer enterpriseId;

	@TableField(value = "quiz_expand", typeHandler = JacksonTypeHandler.class)
	private Expand expand;

	/**
	 * 创建人
	 */
	@TableField(fill = FieldFill.INSERT)
	private String createBy;

	/**
	 * 修改人
	 */
	@TableField(fill = FieldFill.INSERT_UPDATE)
	private String updateBy;

	/**
	 * 创建时间
	 */
	@TableField(fill = FieldFill.INSERT)
	private LocalDateTime createTime;

	/**
	 * 修改时间
	 */
	@TableField(fill = FieldFill.INSERT_UPDATE)
	private LocalDateTime updateTime;

	@Data
	public static class Expand implements Serializable {

		private static final long serialVersionUID = 1637589344595080989L;

		@NotNull(message = "试卷项数量必填")
		private Integer itemQty;

		@NotNull(message = "试卷总分必填")
		private Integer totalMark;

		@NotNull(message = "及格分数必填")
		private Integer passingMark;

	}


}
