package com.qunzhixinxi.hnqz.admin.api.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 试卷项
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-10-16 14:58
 */
@Data
@TableName(value = "wm_quiz_item", autoResultMap = true)
public final class WmQuizItem implements Serializable {

	private static final long serialVersionUID = -2548220720337564269L;

	@TableId(value = "item_id", type = IdType.AUTO)
	private Integer itemId;

	@TableField(value = "quiz_sn")
	private String quizSerialNumber;

	private String label;

	@TableField(value = "quiz_options", typeHandler = JacksonTypeHandler.class)
	private WmQuestion.Option[] options;

	private String answer;

	private Long widget;

	private Integer mark;

	/**
	 * 创建人
	 */
	@TableField(fill = FieldFill.INSERT)
	private String createBy;

	/**
	 * 修改人
	 */
	@TableField(fill = FieldFill.INSERT_UPDATE)
	private String updateBy;

	/**
	 * 创建时间
	 */
	@TableField(fill = FieldFill.INSERT)
	private LocalDateTime createTime;

	/**
	 * 修改时间
	 */
	@TableField(fill = FieldFill.INSERT_UPDATE)
	private LocalDateTime updateTime;
}
