package com.qunzhixinxi.hnqz.admin.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 *  项目内 请求URL配置
 *
 * @author zhangwt
 * @since 1.0
 */
@Data
@Component
@ConfigurationProperties( prefix = "app.config")
public class UpmsConfig {

	private Boolean enable;
    /**
     * apiUrl
     */
    private String apiUrl;
    private String serverUrl;
    private String clientUrl;
    private String basePath;

	/**
	 * 最大分享值
	 */
	private Integer maxShareTimes;

	private String formMail;

	/**
	 * 小程序环境
	 */
	private String wechatEnv;

	/**
	 * 零工服务地址
	 */
	private String gigServiceUrl;


	private Integer tagId;

	private Map<Integer, Long> custMeetingTimes;

	/**
	 * 端类型
	 */
	private String endType;

	private Integer durationLimit;

	private Integer eachDurationLimit;

	/**
	 * 平台企业ID
	 */
	private Integer pltEntId;

}
