package com.qunzhixinxi.hnqz.admin.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.api.dto.SysEnterpriseRelationDTO;
import com.qunzhixinxi.hnqz.admin.api.vo.SysEnterpriseRelationVO;
import com.qunzhixinxi.hnqz.admin.service.SysEnterpriseRelationService;
import com.qunzhixinxi.hnqz.common.core.util.R;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 企业关系控制层
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-11-02 11:12
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping(value = "/ent/rel")
public class SysEnterpriseRelationController {


	private final SysEnterpriseRelationService enterpriseRelationService;


	/**
	 * 获取企业分页
	 *
	 * @param page 分页参数
	 * @return 分页
	 */
	@GetMapping(value = "/page")
	public R<Page<SysEnterpriseRelationVO>> pageEntRels(Page<SysEnterpriseRelationVO> page,
														@RequestParam(value = "entName", required = false) String entName) {
		return R.ok(enterpriseRelationService.pageEntRels(page, entName));
	}

	/**
	 * 更新企业关系
	 *
	 * @param relationDTO 关系内容
	 * @return 更新结果
	 */
	@PostMapping
	public R<Boolean> updateEntRel(@RequestBody SysEnterpriseRelationDTO relationDTO) {

		return R.ok(enterpriseRelationService.updateEntRel(relationDTO));


	}
}
