package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.entity.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;

/**
 * 医疗器械
 * @TableName medical_equipment
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value ="medical_equipment")
public class MedicalEquipment extends Model<MedicalEquipment> {
    /**
     * 医疗器械id
     */
	@NotNull(message = "id不能为空", groups = BaseEntity.Update.class)
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 器械名称
     */
	@NotBlank(message = "器械名称不能为空", groups = BaseEntity.Create.class)
    private String name;

    /**
     * 生产厂家
     */
	@NotBlank(message = "生产厂家不能为空", groups = BaseEntity.Create.class)
    private String manufacturer;

    /**
     * 所属企业id（这里改存药企或CSO的deptId）
     */
	@NotNull(message = "所属企业id不能为空", groups = BaseEntity.Create.class)
    private Integer drugEntId;

    /**
     * 所属企业名称
     */
    private String drugEntName;

    /**
     * 规格
     */
	@NotBlank(message = "规格不能为空", groups = BaseEntity.Create.class)
    private String specification;

    /**
     * 计量单位组名称
     */
	@NotBlank(message = "计量单位组名称不能为空", groups = BaseEntity.Create.class)
    private String measureUnit;

    /**
     * 等级
     */
    private String level;

    /**
     * 备注
     */
    private String remark;

	/**
	 * 删除标记,1:已删除,0:正常
	 */
	@TableLogic
	private String delFlag;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 创建人
	 */
	private Integer createUser;

	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;

	/**
	 * 更新人
	 */
	private Integer updateUser;

}