/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import java.math.BigDecimal;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 风险监控
 *
 * @author ryz
 * @date 2021-04-19 16:08:29
 */
@Data
@ToString
@TableName("monitoring_indicator")
@EqualsAndHashCode(callSuper = true)
public class MonitoringIndicator extends Model<MonitoringIndicator> {

	private static final long serialVersionUID = 1L;

	/**
	 * id
	 */
	@TableId
	private Integer id;
	/**
	 * 报警金额
	 */
	@ApiModelProperty(value = "报警金额")
	private BigDecimal alarmAmount;
	/**
	 * 限制金额
	 */
	@ApiModelProperty(value = "限制金额")
	private BigDecimal limitAmount;

	/**
	 * 平台限额
	 */
	private BigDecimal yaoyiLimitAmount;

	/**
	 * 税源地
	 */
	private SubjectLocation subjectLocation;
}
