package com.qunzhixinxi.hnqz.admin.entity;

import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * {@code PartyAEncryptedInputRecord} 甲方请求加密信息记录实体
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-05-31
 * @since ver.1.0.0
 */
@Data
public class PartyAEncryptedInputRecord implements Serializable {
	/**
	 * id
	 */
	private Integer id;

	/**
	 * 主体id
	 */
	private Integer deptId;

	/**
	 * 请求时服务器公钥
	 */
	private String serPublicKey;

	/**
	 * 请求时服务器私钥
	 */
	private String serPrivateKey;

	/**
	 * 请求时客户端公钥
	 */
	private String cliPublicKey;

	/**
	 * 请求时客户端私钥
	 */
	private String cliPrivateKey;

	/**
	 * 请求时签名字符串
	 */
	private String signature;

	/**
	 * 加密后的信息
	 */
	private String originalText;

	/**
	 * 密文密码
	 */
	private String password;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

}
