package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.Getter;

import java.time.LocalDateTime;
import java.util.Date;

/**
 * 福建企赋回调异步通知记录
 * @TableName qifu_input_record
 */
@TableName(value ="qifu_input_record")
@Data
public class QifuInputRecord extends Model<QifuInputRecord> {
	private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 请求业务类型
     */
    private String reqType;

    /**
     * 请求序号
     */
    private String reqId;

    /**
     * 请求body
     */
    private String reqBody;

    /**
     * 解密后的body
     */
    private String decryptBody;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    @Getter
    @AllArgsConstructor
    public enum ReqType {
        SIGN_NOTIFY("SIGN_NOTIFY", "签约回调"),
        SETTLE_NOTIFY("SETTLE_NOTIFY", "结算回调");

        /**
         * 请求类型
         */
        @EnumValue
        private final String type;

        /**
         * 描述
         */
        private final String desc;
    }
}