package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 用户认证相关的扩展信息实体
 *
 * @author lixuesong
 * @date 2022年07月20日 18:36
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("sys_user_ext_record")
public class SysUserExtRecord extends Model<SysUserExtRecord> {

    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 用户id
     */
    private Integer userId;

    /**
     * 部门id
     */
    private Integer deptId;

    /**
     * 用户姓名
     */
    private String realName;

    /**
     * 手机号
     */
    private String phone;

    /**
     * 身份证号
     */
    private String idCardNumber;

    /**
     * 银行卡号
     */
    private String bankCardNumber;

    /**
     * 银行预留手机号
     */
    private String bankPhone;

    /**
     * 身份证照片-正面
     */
    private String idCardFrontUrl;

    /**
     * 身份证照片-反面
     */
    private String idCardBackUrl;

    /**
     * 身份证照片-正面base64
     */
    private String idCardFrontBase64;

    /**
     * 身份证照片-反面base64
     */
    private String idCardBackBase64;

    /**
     * 最佳帧照片url
     */
    private String bestFrameUrl;

    /**
     * 最佳帧照片base64
     */
    private String bestFrameBase64;

	/**
	 * etoken
	 */
	private String etoken;

    /**
     * 备注
     */
    private String remark;

    /**
     * 删除标记
     */
    private String delFlag;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 更新时间

     */
    private LocalDateTime updateTime;

    /**
     * 更新人
     */
    private Integer updateUser;

}