/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * CRO管理
 *
 * @author Dhy
 * @date 2020-12-17 14:37:09
 */
@Data
@TableName("wm_cro")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "CRO管理")
public class WmCro extends Model<WmCro> {
private static final long serialVersionUID = 1L;

    /**
     * 
     */
    @TableId
    @ApiModelProperty(value="")
    private Integer id;
    /**
     * 企业名称
     */
    @ApiModelProperty(value="企业名称")
    private String qymc;
    /**
     * 统一社会信用代码
     */
    @ApiModelProperty(value="统一社会信用代码")
    private String tyshxydm;
    /**
     * 派工权限
     */
    @ApiModelProperty(value="派工权限")
    private String pgqx;
    /**
     * 最新更新时间
     */
    @ApiModelProperty(value="最新更新时间")
    private LocalDateTime updateTime;
    /**
     * 最新更新时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 状态
     */
    @ApiModelProperty(value="状态")
    private String statu;
    /**
     * 营业执照
     */
    @ApiModelProperty(value="营业执照")
    private String yyzz;
    /**
     * 社保纳税证明
     */
    @ApiModelProperty(value="社保纳税证明")
    private String sbnszm;
    /**
     * 法人身份证人像面
     */
    @ApiModelProperty(value="法人身份证人像面")
    private String frsfzrxm;
    /**
     * 法人身份证国徽面
     */
    @ApiModelProperty(value="法人身份证国徽面")
    private String frsfzghm;
    /**
     * 法人身份证国徽面
     */
    @ApiModelProperty(value="法人身份证手持")
    private String frsfzsc;
    /**
     * 信用状态
     */
    @ApiModelProperty(value="信用状态")
    private String creditStatu;
    /**
     * 任务状态
     */
    @ApiModelProperty(value="任务状态")
    private String taskStatu;
    }
