/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 档案-药企药品
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_drug_ent_drugtable")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "档案-药企药品")
public class WmDaDrugEntDrugtable extends Model<WmDaDrugEntDrugtable> {
	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	@TableId
	@ApiModelProperty(value = "")
	private String id;
	/**
	 * 药品名称
	 */
	@ApiModelProperty(value = "药品名称")
	private String drugname;
	/**
	 * 通用药品你名称
	 */
	@ApiModelProperty(value = "通用药品你名称")
	private String drugnameTy;
	/**
	 * 企业ID
	 */
	@ApiModelProperty(value = "企业ID")
	private String drugEntId;
	/**
	 * 是否医保
	 */
	@ApiModelProperty(value = "是否医保")
	private String isYb;
	/**
	 * 剂型ID
	 */
	@ApiModelProperty(value = "剂型ID")
	private String doseId;
	/**
	 * 规格ID
	 */
	@ApiModelProperty(value = "规格ID")
	private String guigeId;
	/**
	 * 备注
	 */
	@ApiModelProperty(value = "备注")
	private String remark;
	/**
	 * 组织机构ID
	 */
	@ApiModelProperty(value = "组织机构ID")
	private Integer deptId;
	/**
	 * 是否删除
	 */
	@ApiModelProperty(value = "是否删除")
	private String delFlag;
	/**
	 * 是否禁用
	 */
	@ApiModelProperty(value = "是否禁用")
	private String enableFlag;
	/**
	 * 所属租户
	 */
	@ApiModelProperty(value = "所属租户", hidden = true)
	private Integer tenantId;
	/**
	 * 创建时间
	 */
	@ApiModelProperty(value = "创建时间")
	private LocalDateTime createTime;
	/**
	 * 创建人
	 */
	@ApiModelProperty(value = "创建人")
	private Integer createUser;
	/**
	 * 更新时间
	 */
	@ApiModelProperty(value = "更新时间")
	private LocalDateTime updateTime;
	/**
	 * 更新人
	 */
	@ApiModelProperty(value = "更新人")
	private Integer updateUser;

	private String drugEntName;

	private String ssxkcyy;

	/**
	 * 0-原研  1-仿制
	 */
	private String yyfz;

	private Integer drugEntNum;

	/**
	 * 分配的推广企业
	 */
	@TableField(exist = false)
	private List<String> reDeptList;
}
