/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 档案-医院
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Data
@TableName("wm_da_hospital")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "档案-医院")
public class WmDaHospital extends Model<WmDaHospital> {
private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId
    @ApiModelProperty(value="主键id")
    private String id;
    /**
     * 医院名称
     */
    @ApiModelProperty(value="医院名称")
    private String yymc;
    /**
     * 省
     */
    @ApiModelProperty(value="省")
    private String province;
    /**
     * 市
     */
    @ApiModelProperty(value="市")
    private String city;
    /**
     * 区
     */
    @ApiModelProperty(value="区")
    private String area;
    /**
     * 地址
     */
    @ApiModelProperty(value="地址")
    private String address;
    /**
     * 经度
     */
    @ApiModelProperty(value="经度")
    private String longitude;
    /**
     * 纬度
     */
    @ApiModelProperty(value="纬度")
    private String latitude;
    /**
     * 医院规模
     */
    @ApiModelProperty(value="医院规模")
    private String yygm;

	/**
	 * 医院规模
	 */
	@ApiModelProperty(value="医院性质")
	private String yyxz;
    /**
     * 联系总机
     */
    @ApiModelProperty(value="联系总机")
    private String lxzj;
    /**
     * 公共邮箱
     */
    @ApiModelProperty(value="公共邮箱")
    private String ggyx;
    /**
     * 院长姓名
     */
    @ApiModelProperty(value="院长姓名")
    private String yzxm;
    /**
     * 院长联系方式
     */
    @ApiModelProperty(value="院长联系方式")
    private String yzlxfs;
    /**
     * 副院长姓名
     */
    @ApiModelProperty(value="副院长姓名")
    private String fyzxm;
    /**
     * 副院长联系方式
     */
    @ApiModelProperty(value="副院长联系方式")
    private String fyzlxfs;
    /**
     * 医务处处长姓名
     */
    @ApiModelProperty(value="医务处处长姓名")
    private String ywcczxm;
    /**
     * 医务处处长联系方式
     */
    @ApiModelProperty(value="医务处处长联系方式")
    private String ywcczlxfs;
    /**
     * 教务处处长姓名
     */
    @ApiModelProperty(value="教务处处长姓名")
    private String jwcczxm;
    /**
     * 教务处处长联系方式
     */
    @ApiModelProperty(value="教务处处长联系方式")
    private String jwcczlxfs;
    /**
     * 药剂科主任姓名
     */
    @ApiModelProperty(value="药剂科主任姓名")
    private String yjkzrxm;
    /**
     * 药剂科主任联系方式
     */
    @ApiModelProperty(value="药剂科主任联系方式")
    private String yjkzrlsfs;
    /**
     * 院病床总数（张）
     */
    @ApiModelProperty(value="院病床总数（张）")
    private String ybczs;

	/**
	 * 医院官网
	 */
	@ApiModelProperty(value="医院官网")
    private String website;

	/**
	 * 主流供货商业
	 */
	@ApiModelProperty(value="主流供货商业")
	private String zlghsy;

    /**
     * 普什品种是否入院
     */
    @ApiModelProperty(value="普什品种是否入院")
    private String pspzsfry;
    /**
     * 普什品种配送商业
     */
    @ApiModelProperty(value="普什品种配送商业")
    private String pspzpssy;
    /**
     * 组织机构ID
     */
    @ApiModelProperty(value="组织机构ID")
    private String deptId;
    /**
     * 是否删除
     */
    @ApiModelProperty(value="是否删除")
    private String delFlag;
    /**
     * 是否禁用
     */
    @ApiModelProperty(value="是否禁用")
    private String enableFlag;
    /**
     * 所属租户
     */
    @ApiModelProperty(value="所属租户",hidden=true)
    private Integer tenantId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value="创建人")
    private Integer createUser;
    /**
     * 更新时间
     */
    @ApiModelProperty(value="更新时间")
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value="更新人")
    private Integer updateUser;
    }
