package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 企业规章制度
 * @TableName wm_dept_regulations
 */
@TableName(value ="wm_dept_regulations", autoResultMap = true)
@Data
public class WmDeptRegulations implements Serializable {
    private static final long serialVersionUID = 345213921273253849L;
    
    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 部门id
     */
    private Integer deptId;

    /**
     * 文件名称(见字典值dept_regulations_filename)
     */
    @NotBlank(message = "文件名称必填")
    private String fileName;

    /**
     * 文件地址
     */
    @NotEmpty(message = "文件地址必填")
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<FileUrlObj> fileUrl;

    /**
     * 排序
     */
    private Integer sort;

    /**
     * 删除标记:0(未删除)，1(已删除)
     */
    private String delFlag;

    /**
     * 是否禁用:0(启用)，1(禁用)
     */
    @NotBlank(message = "是否禁用必填")
    private String enableFlag;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    private LocalDateTime updateTime;

    /**
     * 文件 URL obj
     *
     * @author lixuesong
     * @date 2023/09/27
     */
    @Data
    public static class FileUrlObj implements Serializable {
        private static final long serialVersionUID = 7914265352319844404L;

        private String fileName;

        private String url;
    }

}