package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.entity.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;

/**
 * 部门任务类型模板实体
 *
 * @author lixuesong
 * @date 2022年01月18日 11:53
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("wm_dept_task_type_template")
public class WmDeptTaskTypeTemplate extends Model<WmDeptTaskTypeTemplate> {

	/**
	 * 主键id
	 */
	@TableId
	@NotNull(message = "id不能为空", groups = BaseEntity.Update.class)
	private Integer id;

	/**
	 * 部门id
	 */
	@NotNull(message = "部门id不能为空", groups = BaseEntity.Create.class)
	private Integer deptId;

	/**
	 * 任务类型id
	 */
	@NotNull(message = "任务类型id不能为空", groups = BaseEntity.Create.class)
	private String taskTypeId;

	/**
	 * 任务类型名称
	 */
	@TableField(exist = false)
	private String taskTypeName;

	/**
	 * 任务积分
	 */
	@TableField(exist = false)
	private Integer score;

	/**
	 * 模板
	 */
	@NotBlank(message = "模板不能为空", groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private String template;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 创建人
	 */
	private Integer createUser;

	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;

	/**
	 * 更新人
	 */
	private Integer updateUser;
}
