/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.time.LocalDateTime;

/**
 * 导入任务成员表
 *
 * @author pigx code generator
 * @date 2021-01-06 19:39:17
 */
@Data
@TableName("wm_import_user")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "导入任务成员表")
public class WmImportUser extends Model<WmImportUser> {
private static final long serialVersionUID = 1L;

    /**
     *
     */
    @TableId
    @ApiModelProperty(value="")
    private Integer id;
    /**
     * 积分包ID
     */
    @ApiModelProperty(value="积分包ID")
    private String scoreId;
    /**
     * 姓名
     */
    @ApiModelProperty(value="姓名")
    private String importName;
    /**
     * 手机号
     */
    @ApiModelProperty(value="手机号")
    private String importPhone;
    /**
     * 身份证号
     */
    @ApiModelProperty(value="身份证号")
    private String importIdCardNumber;
    /**
     * 签名
     */
    @ApiModelProperty(value="签名")
    private String userSign;
    /**
     * 认证状态
     */
    @ApiModelProperty(value="认证状态")
    private Integer certStatus;
    /**
     * 认证结果描述
     */
    @ApiModelProperty(value="认证结果描述")
    private String certRemark;
    /**
     * 创建时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value="创建人")
    private Integer createUser;
    /**
     * 是否删除
     */
    @ApiModelProperty(value="是否删除")
    private String delFlag;
    /**
     * 是否禁用
     */
    @ApiModelProperty(value="是否禁用")
    private String realFlag;
    }
