package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.qunzhixinxi.hnqz.admin.api.entity.WmQuestion;
import com.qunzhixinxi.hnqz.admin.api.model.WmQuizResultModel;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 领包记录
 *
 * @date 2020-07-17 23:32:01
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "wm_score_package_status", autoResultMap = true)
public class WmScorePackageStatus extends Model<WmScorePackageStatus> {

	private static final long serialVersionUID = 1L;

	/**
	 * id
	 */
	@TableId
	private Integer id;

	/**
	 * 用户id
	 */
	private String userId;

	/**
	 * 积分包id
	 */
	private String packageId;

	/**
	 * 积分包状态
	 */
	private String status;

	/**
	 * 组织机构ID
	 */
	private String deptId;

	/**
	 * 是否删除
	 */
	private String delFlag;

	/**
	 * 是否禁用
	 */
	private String enableFlag;

	/**
	 * 所属租户
	 */
	private Integer tenantId;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 创建人
	 */
	private Integer createUser;

	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;

	/**
	 * 更新人
	 */
	private Integer updateUser;

	/**
	 * 手机号
	 */
	@TableField(exist = false)
	private String phone;

	/**
	 * 服务地区
	 */
	@TableField(exist = false)
	private String address;

	/**
	 * 个人预计包值
	 */
	private String userScore;

	/**
	 * 终止方式
	 */
	private String enableType;

	/**
	 * 是否可以继续添加任务,0:不可添加任务，1：可以添加任务
	 */
	private String taskAddFlag;

	/**
	 * 任务数量
	 */
	private Integer taskNum;

	/**
	 * 积分包名称
	 */
	private String scorePackageName;

	/**
	 * 接单人id
	 */
	private String taskUserId;

	/**
	 * 专员名称
	 */
	@TableField(exist = false)
	private String userRealName;

	/**
	 * 团队id list
	 */
	@TableField(exist = false)
	private List<String> teamIdList;

	/**
	 * 积分包编号
	 */
	@TableField(exist = false)
	private String packageSn;

	/**
	 * 试卷结果
	 */
	@TableField(value = "quiz_res", typeHandler = JacksonTypeHandler.class)
	private WmQuizResultModel[] quizResult;

}
