/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 任务内容字段配置
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:25
 */
@Data
@TableName("wm_task_content_config")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "任务内容字段配置")
public class WmTaskContentConfig extends Model<WmTaskContentConfig> {
private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId
    @ApiModelProperty(value="id")
    private Integer id;
    /**
     * 任务大类ID
     */
	@ApiModelProperty(value="任务大类")
	private String baseTypeId;

	/**
	 * 任务ID
	 */
    @ApiModelProperty(value="任务ID")
    private String taskTypeId;

    /**
     * 字段1
     */
    @ApiModelProperty(value="字段1")
    private String taskFiledKey;

    /**
     * 字段2
     */
    @ApiModelProperty(value="字段2")
    private String taskFiledValue;
    /**
     * 字段类型
     */
    @ApiModelProperty(value="字段类型")
    private String taskFiledType;
    /**
     * 最大长度
     */
    @ApiModelProperty(value="最大长度")
    private Integer taskFiledMinsize;
    /**
     * 最小长度
     */
    @ApiModelProperty(value="最小长度")
    private Integer taskFiledMaxsize;
    /**
     * 弹框提示
     */
    @ApiModelProperty(value="弹框提示")
    private String taskFiledAlert;
    /**
     * 字典值请求URL
     */
    @ApiModelProperty(value="字典值请求URL")
    private String dictUrl;
    /**
     * 字典值分组名称
     */
    @ApiModelProperty(value="字典值分组名称")
    private String dictGroupName;
    /**
     * 是否必填
     */
    @ApiModelProperty(value="是否必填")
    private String isMustfill;
    /**
     * 组织机构ID
     */
    @ApiModelProperty(value="组织机构ID")
    private Integer deptId;
    /**
     * 是否删除
     */
    @ApiModelProperty(value="是否删除")
    private String delFlag;
    /**
     * 是否禁用
     */
    @ApiModelProperty(value="是否禁用")
    private String enableFlag;
    /**
     * 所属租户
     */
    @ApiModelProperty(value="所属租户",hidden=true)
    private Integer tenantId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value="创建人")
    private Integer createUser;
    /**
     * 更新时间
     */
    @ApiModelProperty(value="更新时间")
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value="更新人")
    private Integer updateUser;

	/**
	 * 顺序
	 */
	@ApiModelProperty(value="顺序")
	private Integer seq;
    }
