/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 任务积分规则
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:24
 */
@Data
@TableName("wm_task_rule")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "任务积分规则")
public class WmTaskRule extends Model<WmTaskRule> {
private static final long serialVersionUID = 1L;

    /**
     * 
     */
    @TableId
    @ApiModelProperty(value="")
    private String id;
    /**
     * 药企ID
     */
    @ApiModelProperty(value="药企ID")
    private String drugentId;
    /**
     * 规则类型，1药企 2一级代理商
     */
    @ApiModelProperty(value="规则类型，1药企 2一级代理商")
    private String ruleTypeId;
    /**
     * 规则月份
     */
    @ApiModelProperty(value="规则月份")
    private String ruleMonth;
    /**
     * 一级代理商ID
     */
    @ApiModelProperty(value="一级代理商ID")
    private String level1Id;
    /**
     * 二级代理商ID
     */
    @ApiModelProperty(value="二级代理商ID")
    private String level2Id;
    /**
     * 组织机构ID
     */
    @ApiModelProperty(value="组织机构ID")
    private String deptId;
    /**
     * 是否删除
     */
    @ApiModelProperty(value="是否删除")
    private String delFlag;
    /**
     * 是否禁用
     */
    @ApiModelProperty(value="是否禁用")
    private String enableFlag;
    /**
     * 所属租户
     */
    @ApiModelProperty(value="所属租户",hidden=true)
    private Integer tenantId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value="创建人")
    private Integer createUser;
    /**
     * 更新时间
     */
    @ApiModelProperty(value="更新时间")
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value="更新人")
    private Integer updateUser;
    }
