package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.qunzhixinxi.hnqz.admin.entity.base.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;

/**
 * 团队管理实体
 *
 * @author lixuesong
 * @date 2021年12月08日 13:34
 */
@Data
@TableName("wm_team")
@EqualsAndHashCode(callSuper = true)
public class WmTeam extends Model<WmTeam> {

	/**
	 * 主键id
	 */
	@NotNull(groups = {BaseEntity.Update.class})
	@TableId
	private Integer id;

	/**
	 * 组织机构id
	 */
	private Integer deptId;

	/**
	 * 团队名称
	 */
	@NotBlank(groups = {BaseEntity.Create.class})
	private String name;

	/**
	 * 团队负责人
	 */
	private String[] leader;

	/**
	 * 团队负责人名称
	 */
	@TableField(exist = false)
	private String[] leaderName;

	/**
	 * 团队成员
	 */
	private String[] member;

	/**
	 * 团队成员名称
	 */
	@TableField(exist = false)
	private String[] memberName;

	/**
	 * 是否禁用（0-企业，1-禁用）
	 */
	private String enableFlag;

	/**
	 * 是否删除（0-正常，1-已删除）
	 */
	private String delFlag;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;

	/**
	 * 创建人
	 */
	private Integer createUser;

	/**
	 * 更新人
	 */
	private Integer updateUser;
}
