/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 用户签到表
 *
 * @author pigx code generator
 * @date 2020-07-14 20:10:02
 */
@Data
@TableName("wm_user_sign")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "用户签到表")
public class WmUserSign extends Model<WmUserSign> {
	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	@TableId
	@ApiModelProperty(value = "")
	private Integer id;
	/**
	 * 签到人
	 */
	@ApiModelProperty(value = "签到人")
	private String signUserid;
	/**
	 * 签到企业ID
	 */
	@ApiModelProperty(value = "签到企业ID")
	private String signEntId;
	/**
	 * 签到日期
	 */
	@ApiModelProperty(value = "签到日期")
	private LocalDateTime signDate;
	/**
	 * 得分
	 */
	@ApiModelProperty(value = "得分")
	private Integer score;
	/**
	 * 经度
	 */
	@ApiModelProperty(value = "经度")
	private String longitude;
	/**
	 * 纬度
	 */
	@ApiModelProperty(value = "纬度")
	private String latitude;


	/**
	 * 签单企业名称
	 */
	@ApiModelProperty(value = "签到企业名称")
	private String signEntName;

	/**
	 * 签单企业名称
	 */
	@ApiModelProperty(value = "签到企业类型,1 药企 2.商业公司")
	private String signEntType;

	@TableField(exist = false)
	private String packageId;

	/**
	 * 签到详情
	 */
	@TableField(exist = false)
	private WmUserSignDetail userSignDetail;

	/**
	 * 拜访任务类型id
	 */
	private String taskTypeId;

}
