package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 用户签到详情实体
 *
 * @author lixuesong
 * @date 2022年01月18日 17:45
 */
@Data
@TableName("wm_user_sign_detail")
@EqualsAndHashCode(callSuper = true)
public class WmUserSignDetail extends Model<WmUserSignDetail> {

	/**
	 * 主键id
	 */
	@TableId
	private Integer id;

	/**
	 * 签到表id
	 */
	private Integer signId;

	/**
	 * 推广药品
	 */
	private String[] drug;

	/**
	 * 拜访目的
	 */
	private String[] purpose;

	/**
	 * 拜访目的名称
	 */
	@TableField(exist = false)
	private String[] purposeName;

	/**
	 * 拜访结果
	 */
	private String result;

	/**
	 * 拜访结果名称
	 */
	@TableField(exist = false)
	private String resultName;

	/**
	 * 备注
	 */
	private String remark;
}
