/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 文库-相册
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:24
 */
@Data
@TableName("wm_wk_album")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "文库-相册")
public class WmWkAlbum extends Model<WmWkAlbum> {
private static final long serialVersionUID = 1L;

    /**
     * 
     */
    @TableId
    @ApiModelProperty(value="")
    private String id;
    /**
     * 相册名称
     */
    @ApiModelProperty(value="相册名称")
    private String xcmc;
    /**
     * 封面
     */
    @ApiModelProperty(value="封面")
    private String scfm;
    /**
     * 关联药品
     */
    @ApiModelProperty(value="关联药品")
    private String glyp;
    /**
     * 文本
     */
    @ApiModelProperty(value="文本")
    private String wb;

	/**
	 * 文章来源
	 */
	@ApiModelProperty(value="转发数")
	private Integer forwardNum;

    /**
     * 组织机构ID
     */
    @ApiModelProperty(value="组织机构ID")
    private Integer deptId;
    /**
     * 是否删除
     */
    @TableLogic
    @ApiModelProperty(value="是否删除")
    private Integer delFlag;
    /**
     * 是否禁用
     */
    @ApiModelProperty(value="是否禁用")
    private Integer enableFlag;
    /**
     * 所属租户
     */
    @ApiModelProperty(value="所属租户",hidden=true)
    private Integer tenantId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value="创建人")
    private Integer createUser;
    /**
     * 更新时间
     */
    @ApiModelProperty(value="更新时间")
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value="更新人")
    private Integer updateUser;


    private String temp1;

	private String score;

}
