package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.Getter;

/**
 * 众蚁云回调异步通知记录
 * @TableName zhongyiyun_input_record
 */
@Data
@TableName(value ="zhongyiyun_input_record")
public class ZhongyiyunInputRecord implements Serializable {

	private static final long serialVersionUID = -1449330958713284749L;
	/**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 请求业务类型
     */
    private String reqType;

    /**
     * 请求序号
     */
    private String reqId;

    /**
     * 请求body
     */
    private String reqBody;

    /**
     * 解密后的body
     */
    private String decryptBody;

    /**
     * 创建时间
     */
    private Date createTime;

	@Getter
	@AllArgsConstructor
	public enum ReqType {
		SIGN_NOTIFY("SIGN_NOTIFY", "签约回调"),
		SETTLE_NOTIFY("SETTLE_NOTIFY", "结算回调");

		/**
		 * 请求类型
		 */
		@EnumValue
		private final String type;

		/**
		 * 描述
		 */
		private final String desc;
	}
}