package com.qunzhixinxi.hnqz.admin.entity;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.Getter;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 中智回调异步通知记录
 * @TableName zhongzhi_input_record
 */
@TableName(value ="zhongzhi_input_record")
@Data
public class ZhongzhiInputRecord implements Serializable {

	private static final long serialVersionUID = 2315253613947884869L;

	/**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 请求业务类型
     */
    private String reqType;

    /**
     * 三方订单号
     */
	@TableField(value = "order_no")
    private String thirdOrderNo;

    /**
     * 请求body
     */
    private String reqBody;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

	@Getter
	@AllArgsConstructor
	public enum ReqType {
//		SIGN_NOTIFY("SIGN_NOTIFY", "签约回调"),
		SETTLE_NOTIFY("SETTLE_NOTIFY", "结算回调");

		/**
		 * 请求类型
		 */
		@EnumValue
		private final String type;

		/**
		 * 描述
		 */
		private final String desc;
	}

}