package com.qunzhixinxi.hnqz.admin.entity.dto;

import com.baomidou.mybatisplus.annotation.EnumValue;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.Getter;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * 签署协议请求
 *
 * @author lixuesong
 * @date 2023/09/06
 */
@Data
public class SignAgreementDTO implements Serializable {
    private static final long serialVersionUID = -1590830291205177428L;

    /**
     * 协议类型
     */
    @NotNull(message = "协议类型必填")
    private SignAgreementType agreementType;

    /**
     * 备注
     */
    private String remark;

    /**
     * 协议类型
     *
     * @author lixuesong
     * @date 2023/09/06
     */
    @Getter
    @AllArgsConstructor
    public enum SignAgreementType {
        HONEST_AGREEMENT("HONEST_AGREEMENT", "廉洁协议");

        /**
         * 类型
         */
        @EnumValue
        private final String type;

        /**
         * 描述
         */
        private final String description;
    }
}
