package com.qunzhixinxi.hnqz.admin.entity.dto;

import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * 拆包DTO
 *
 * @author snows
 * @date 2023/5/31 10:31
 */
@Data
public class UnpackDTO implements Serializable {
	private static final long serialVersionUID = -3581313016062588900L;

	/**
	 * 积分包id
	 */
	@NotBlank(message = "积分包id必填")
	private String scorePackageId;

	/**
	 * 原积分包剩余积分包值
	 */
	@NotNull(message = "原积分包剩余积分包值必填")
	private Integer remainPackageScore;

	/**
	 * 已选任务积分值
	 */
	@NotNull(message = "已选任务积分值必填")
	private Integer selectTaskScore;

	/**
	 * 已选任务id列表
	 */
	@NotEmpty(message = "已选任务id列表必填")
	private List<String> selectTaskIds;
}
