package com.qunzhixinxi.hnqz.admin.entity.dto;

import com.qunzhixinxi.hnqz.admin.enums.GigTypeEnum;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 用户签约认证DTO
 *
 * @author lixuesong
 * @date 2022年03月03日 15:28
 */
@Data
public class UserSignCertDTO implements Serializable {

	private static final long serialVersionUID = 5494145502730380527L;

	/**
	 * 用户id
	 */
	private Integer userId;

	/**
	 * 身份证号
	 */
	private String idCardNumber;

	/**
	 * 银行卡号
	 */
	private String bankCardNumber;

	/**
	 * 银行预留手机号
	 */
	private String bankPhone;

	/**
	 * 开户行
	 */
	private String bankName;

	/**
	 * 身份证照片-正面
	 */
	private String idCardFrontUrl;

	/**
	 * 身份证照片-反面
	 */
	private String idCardBackUrl;

	/**
	 * 认证视频1
	 */
	private String certVideo1Url;

	/**
	 * 认证视频2
	 */
	private String certVideo2Url;

	/**
	 * 协议
	 */
	private String agreementUrl;

	/**
	 * 零工认证渠道
	 */
	@Deprecated
	private List<GigTypeEnum> gigTypeList;

	/**
	 * 税源地
	 */
	private SubjectLocation subjectLocation;

	/**
	 * 验证码
	 */
	private String verifyCode;

	/**
	 * 令牌
	 */
	private String token;

	/**
	 * 是否上传核身视频
	 */
	private Boolean uploadFaceID;
}
