package com.qunzhixinxi.hnqz.admin.entity.dto;

import com.qunzhixinxi.hnqz.admin.entity.WmTaskType;
import com.qunzhixinxi.hnqz.admin.entity.base.BaseEntity;
import lombok.Data;

import javax.validation.Valid;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * 部门任务类型配置DTO
 *
 * @author lixuesong
 * @date 2021年12月03日 10:28
 */
@Data
public class WmDeptTaskTypeConfigDTO {

	/**
	 * 主键id
	 */
	private Integer id;

	/**
	 * 部门id
	 */
	@NotNull(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private Integer deptId;

	/**
	 * 任务配置列表
	 */
	@Valid
	@NotEmpty(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private List<WmDeptTaskTypeConfigJsonDTO> configList;

}
