package com.qunzhixinxi.hnqz.admin.entity.dto;

import com.qunzhixinxi.hnqz.admin.entity.base.BaseEntity;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * 部门任务类型配置json DTO
 *
 * @author lixuesong
 * @date 2021年12月03日 10:33
 */
@Data
public class WmDeptTaskTypeConfigJsonDTO {

	/**
	 * 任务类型id
	 */
	@NotBlank(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private String taskTypeId;

	/**
	 * 任务类型名称
	 */
	@NotBlank(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private String taskTypeName;

	/**
	 * 任务积分
	 */
	private String score;

	/**
	 * 是否限定任务
	 */
	@NotNull(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private Boolean qualifiedTask = false;

	/**
	 * 是否勾选兼职学术信息沟通专员状态
	 */
	@NotNull(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private Boolean zbdbStatusSelect = false;

	/**
	 * 是否启用兼职学术信息沟通专员状态
	 */
	@NotNull(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private Boolean zbdbStatusEnable;

	/**
	 * 是否勾选全职学术信息沟通专员状态
	 */
	@NotNull(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private Boolean yydbStatusSelect = false;

	/**
	 * 是否启用全职学术信息沟通专员状态
	 */
	@NotNull(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private Boolean yydbStatusEnable = true;

	/**
	 * 是否关联下级
	 */
	@NotNull(groups = {BaseEntity.Create.class, BaseEntity.Update.class})
	private Boolean associateLower = false;
}
