package com.qunzhixinxi.hnqz.admin.entity.input;

import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageSettleNote;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import lombok.Data;
import lombok.ToString;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 积分包结算输入信息
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-07-27 15:07
 */
@Data
@ToString
public class WmScorePackageSettleInput implements Serializable {

	private static final long serialVersionUID = -4460944815143863772L;

	// 积分包id
	@NotBlank(message = "积分包信息必填")
	private String id;

	// 发票类目
//	@NotNull(message = "发票类目必填")
	private Integer invoiceCategory;

	@NotBlank(message = "结算token必填")
	private String token;

	private String categoryName;

	private String status;

	private String settleFlag;

	private String enableType;

	private String taskAddFlag;

	private String sendPackageDeptId;

	private String packageFinishStatus;

	private String packageEntName;

	private String packageType1;

	private String packageType2;

	private String typeid;

	private String scorePackageName;

	private LocalDateTime createTime;

	private String belongDate;

	private Integer score;

	// 已提交
	private Integer ytj;

	// 已审核
	private Integer ysh;

	// 待审核
	private Integer dsh;

	@NotEmpty(message = "结算信息必填")
	private List<WmScorePackageSettleNote> notes;

	private String realName;

	private String description;

	private String subType;

	// 税源地
	private SubjectLocation subjectLocation;

	/**
	 * MAH结算-药企deptId
	 */
	private Integer mahSettleDeptId;

	/**
	 * 结算人员
	 */
	private String userNames;

}
