package com.qunzhixinxi.hnqz.admin.entity.model;

import com.qunzhixinxi.hnqz.admin.enums.MemberIDCardType;
import com.qunzhixinxi.hnqz.admin.enums.MemberType;
import com.qunzhixinxi.hnqz.admin.enums.PayChannel;
import lombok.Data;

import java.io.Serializable;

/**
 * 用户信息
 *
 * @author lixuesong
 * @date 2022年03月03日 14:27
 */
@Data
public class GigUserInfoModel implements Serializable {

	private static final long serialVersionUID = 1418999433019620755L;

	/**
	 * 用户id
	 */
	private Integer userId;

	/**
	 * 姓名
	 */
	private String name;

	/**
	 * 税号
	 */
	private String entCode;

	/**
	 * 手机号
	 */
	private String username;

	/**
	 * 身份证号
	 */
	private String idCard;

	/**
	 * 部门id
	 */
	private Integer deptId;

	/**
	 * 证件类型
	 */
	private MemberIDCardType idCardType;

	/**
	 * 人员类型与行业
	 */
	private MemberType memberType;

	/**
	 * 支付渠道
	 */
	private PayChannel payChannel;

	/**
	 * 银行预留手机号
	 */
	private String bankPhone;

	/**
	 * 银行卡号
	 */
	private String bankCard;

	/**
	 * 银行卡号
	 */
	private String newBankCard;

	/**
	 * 开户行
	 */
	private String bankName;

	/**
	 * 身份证照片-正面
	 */
	private String idCardFront;

	/**
	 * 身份证照片-反面
	 */
	private String idCardBack;

	/**
	 * 认证视频1
	 */
	private String certVideo1;

	/**
	 * 认证视频2
	 */
	private String certVideo2;

	/**
	 * 身份证照片-正面base64
	 */
	private String idCardFrontBase64;

	/**
	 * 身份证照片-反面base64
	 */
	private String idCardBackBase64;

	/**
	 * 最佳帧照片url
	 */
	private String bestFrameBase64;

	/**
	 * 协议签名
	 */
	private String signImageUrl;

	/**
	 * 邮箱
	 */
	private String email;

	/**
	 * 地址
	 */
	private String address;

	/**
	 * 是否上传核身视频
	 */
	private Boolean uploadFaceID;
}
