package com.qunzhixinxi.hnqz.admin.entity.vo;

import com.qunzhixinxi.hnqz.admin.enums.GigCallBackStatus;
import com.qunzhixinxi.hnqz.admin.enums.GigChannelEnum;
import com.qunzhixinxi.hnqz.admin.enums.GigTypeEnum;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * 用户签约认证主体信息实体
 *
 * @author lixuesong
 * @date 2022年03月01日 18:17
 */
@Data
public class SysUserSubVO {

	/**
	 * 主键id
	 */
	private Integer id;

	/**
	 * 用户id
	 */
	private Integer userId;

	/**
	 * 部门id
	 */
	private Integer deptId;

	/**
	 * 零工平台类型（订单支付方式类型）
	 */
	private GigTypeEnum gigType;

	/**
	 * 渠道
	 */
	private GigChannelEnum gigChannel;

	/**
	 * 税源地
	 */
	private SubjectLocation subjectLocation;

	/**
	 * 回调状态
	 */
	private GigCallBackStatus callbackStatus;

	/**
	 * 认证状态
	 */
	private String certStatus;

	/**
	 * 认证状态: 展示
	 */
	private String certStatusDisplay;

	/**
	 * 认证结果描述
	 */
	private String certRemark;

	/**
	 * 人员类型
	 */
	private String userType;

	/**
	 * 银行预留手机号
	 */
	private String bankPhone;

	/**
	 * 银行卡号
	 */
	private String bankCardNumber;

	/**
	 * 身份证照片-正面
	 */
	private String idCardFrontUrl;

	/**
	 * 身份证照片-反面
	 */
	private String idCardBackUrl;

	/**
	 * 认证视频1
	 */
	private String certVideo1Url;

	/**
	 * 认证视频2
	 */
	private String certVideo2Url;

	/**
	 * 协议
	 */
	private String agreementUrl;

	/**
	 * 创建时间
	 */
	private LocalDateTime createTime;

	/**
	 * 更新时间
	 */
	private LocalDateTime updateTime;

	/**
	 * 创建人
	 */
	private Integer createUser;

	/**
	 * 更新人
	 */
	private Integer updateUser;

}
