package com.qunzhixinxi.hnqz.admin.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 部门级别
 *
 * @author lixuesong
 * @date 2021年12月03日 14:13
 */
@Getter
@AllArgsConstructor
public enum DeptLevelEnum {

	// 1-要易业务管理平台，2-药企，3-一级CSO，4-二级CSO，5-CRO
	ADMIN(1, "要易业务管理平台"),
	ENT(2, "药企"),
	CSO_L1(3, "一级CSO"),
	CSO_L2(4, "二级CSO"),
	CRO(5, "CRO");

	/**
	 * level值
	 */
	private Integer val;

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 根据val获取枚举
	 *
	 * @param val level值
	 * @return 枚举对象
	 */
	public static DeptLevelEnum getEnumByVal(Integer val) {
		for (DeptLevelEnum deptLevelEnum : DeptLevelEnum.values()) {
			if (deptLevelEnum.getVal().equals(val)) {
				return deptLevelEnum;
			}
		}
		return null;
	}
}
