package com.qunzhixinxi.hnqz.admin.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @author: lixuesong
 * @createTime: 2022/10/27 15:03
 * @description: 浪潮认证状态
 */
@Getter
@AllArgsConstructor
public enum LangChaoCertStatus {

	// 签约状态（注意：CERT实际对应浪潮的已签约状态/最终状态，SIGN为我们内部额外添加的状态）
	UN_SIGN(0, "未签约"),
	CERT(1, "已认证"),
	SIGN(2, "已签约");

	private final int code;

	private final String message;

	/**
	 * 根据枚举编码获取枚举对象
	 *
	 * @param code 枚举编码
	 * @return 如果存在返回枚举，否则返回 {@code null}
	 */
	public static LangChaoCertStatus resolve(final int code) {
		for (LangChaoCertStatus certStatus : LangChaoCertStatus.values()) {
			if (certStatus.getCode() == code) {
				return certStatus;
			}
		}
		return UN_SIGN;

	}
}
