package com.qunzhixinxi.hnqz.admin.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * WmScorePackage实体类的scorePackageStatus积分包状态枚举类
 *
 * @author lixuesong
 * @date 2021年05月27日 15:42
 */
@Getter
@AllArgsConstructor
public enum ScorePackageStatusEnum {

	/**
	 * 已下发待申领
	 */
	UNCLAIMED("1", "已下发待申领"),
	/**
	 * 已申领待审批
	 */
	PENDING_APPROVAL("2", "已申领待审批"),
	/**
	 * 进行中
	 */
	IN_PROGRESS("3", "进行中"),
	/**
	 * 已完成待结算
	 */
	TO_BE_SETTLED("4", "已完成待结算"),
	/**
	 * 已提交结算申请
	 */
	SETTLEMENT_SUBMITTED("5", "已提交结算申请"),
	/**
	 * 已终止
	 */
	TERMINATED("6", "已终止"),
	/**
	 * 已完成待提交审批
	 */
	TO_BE_APPROVAL("7", "已完成待上级审批");

	private final String val;

	private final String desc;

	public String val() {
		return this.val;
	}

	public static ScorePackageStatusEnum getByVal(String val) {
		for (ScorePackageStatusEnum statusEnum : ScorePackageStatusEnum.values()) {
			if (statusEnum.val.equals(val)) {
				return statusEnum;
			}
		}
		return null;
	}
}
