package com.qunzhixinxi.hnqz.admin.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 *  结算渠道
 */
@Getter
@AllArgsConstructor
public enum SubjectTypeEnum {

	TYPE_RENLIJIA("0", "人力家"),
	TYPE_SHUIBANGYUN("1", "税邦云"),
	TYPE_OLADING("2", "自由职家"),
	TYPE_YEE("3", "易联数科"),
	TYPE_ZHENG_QI_ZHI_XING("4", "政企之星"),
	TYPE_LANG_CHAO("5", "浪潮"),
	TYPE_HUI_QI_YUN("6", "汇企云"),
	TYPE_ZHONG_YI_YUN("7", "众蚁云"),
	TYPE_ZHONG_ZHI("8", "中智"),
	TYPE_QI_FU("9", "福建企赋"),
	TYPE_SHEN_ZHEN_REN_CAI("10", "深圳人才"),

	ENABLE_FLAG_FALSE("0", "无效"),
	ENABLE_FLAG_TRUE("1", "有效"),

	TYPE_NULL("", "")
	;

	/**
	 * 类型
	 */
	private String code;

	/**
	 * 描述
	 */
	private String desc;

	public static SubjectTypeEnum resolve(String code) {
		for (SubjectTypeEnum subjectTypeEnum: SubjectTypeEnum.values()){
			if (subjectTypeEnum.code.equals(code) && subjectTypeEnum.name().startsWith("TYPE_")){
				return subjectTypeEnum;
			}
		}
		return TYPE_NULL;
	}

}
