package com.qunzhixinxi.hnqz.admin.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 打卡详情-拜访目的
 *
 * @author lixuesong
 * @date 2022年01月21日 11:45
 */
@Getter
@AllArgsConstructor
public enum UserSignPurposeEnum {

	// 拜访目的
	PURPOSE0("0", "传递医药产品信息"),
	PURPOSE1("1", "收集反馈药品临床使用情况"),
	PURPOSE2("2", "收集反馈医院需求信息"),
	PURPOSE3("3", "处理异议"),
	PURPOSE4("4", "推广活动"),
	PURPOSE5("5", "相关信息收集");

	/**
	 * 值
	 */
	private String val;

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 根据val查询
	 *
	 * @param val
	 * @return
	 */
	public static UserSignPurposeEnum resolve(String val) {
		for (UserSignPurposeEnum purposeEnum: UserSignPurposeEnum.values()){
			if (purposeEnum.val.equals(val)){
				return purposeEnum;
			}
		}
		return null;
	}

	/**
	 * 根据签到类型，获取字典类型
	 *
	 * @param signEntType
	 * @return
	 */
	public static String getDictTypeBySignEntType(String signEntType) {
		String dictType = null;
		switch (signEntType) {
			case "1":
				dictType = "user_sign_detail_purpose";
				break;
			case "2":
				dictType = "user_sign_detail_distribution_purpose";
				break;
			case "3":
				dictType = "user_sign_detail_pharmacy_purpose";
				break;
			default:
				dictType = "";
		}

		return dictType;
	}
}
