package com.qunzhixinxi.hnqz.admin.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @author: lixuesong
 * @createTime: 2022/09/07 10:58
 * @description: 正启之星认证状态
 */
@Getter
@AllArgsConstructor
public enum ZhengQiZhiXingCertStatus {

	// 签约状态
	UN_SIGN(0, "未签约"),
	CERT(1, "已认证"),
	SIGN(2, "已签约");

	private final int code;

	private final String message;

	/**
	 * 根据枚举编码获取枚举对象
	 *
	 * @param code 枚举编码
	 * @return 如果存在返回枚举，否则返回 {@code null}
	 */
	public static ZhengQiZhiXingCertStatus resolve(final int code) {
		for (ZhengQiZhiXingCertStatus certStatus : ZhengQiZhiXingCertStatus.values()) {
			if (certStatus.getCode() == code) {
				return certStatus;
			}
		}
		return UN_SIGN;

	}
}
