package com.qunzhixinxi.hnqz.admin.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 众蚁云认证状态
 *
 * @author snows
 * @date 2023/2/1 14:04
 */
@Getter
@AllArgsConstructor
public enum ZhongYiYunCertStatus {

	// 签约状态
	UN_SIGN(0, "未签约"),
	CERT(1, "已认证"),
	SIGN(2, "已签约"),
	SIGNING(3, "签约中");

	private final int code;

	private final String message;

	/**
	 * 根据枚举编码获取枚举对象
	 *
	 * @param code 枚举编码
	 * @return 如果存在返回枚举，否则返回 {@code null}
	 */
	public static ZhongYiYunCertStatus resolve(final int code) {
		for (ZhongYiYunCertStatus certStatus : ZhongYiYunCertStatus.values()) {
			if (certStatus.getCode() == code) {
				return certStatus;
			}
		}
		return UN_SIGN;
	}
}
