package com.qunzhixinxi.hnqz.admin.listener;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.config.TaxNotifyConfig;
import com.qunzhixinxi.hnqz.admin.config.UpmsConfig;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageSettleNote;
import com.qunzhixinxi.hnqz.admin.event.OladingFinishTaskEvent;
import com.qunzhixinxi.hnqz.admin.service.SysDeptService;
import com.qunzhixinxi.hnqz.admin.service.WmScorePackageService;
import com.qunzhixinxi.hnqz.admin.service.WmScorePackageSettleNoteService;
import com.qunzhixinxi.hnqz.admin.service.gig.GigThirdApiService;
import com.qunzhixinxi.hnqz.common.core.constant.CommonConstants;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.RandomStringUtils;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.event.EventListener;
import org.springframework.core.annotation.Order;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.MediaType;
import org.springframework.scheduling.annotation.Async;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * @author: lixuesong
 * @createTime: 2022/10/10 11:06
 * @description: 阿拉钉完单操作事件监听器
 */
@Slf4j
@AllArgsConstructor
@Configuration
public class OladingFinishTaskEventListener {
	private final GigThirdApiService gigThirdApiService;

	@Async
	@Order
	@EventListener(OladingFinishTaskEvent.class)
	public void pushEvent(OladingFinishTaskEvent event) {

		gigThirdApiService.finishTask(event.getNoteList());
	}

}
