/*
 *
 *      Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the pig4cloud.com developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: hnqz
 *
 */

package com.qunzhixinxi.hnqz.admin.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptRelation;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author hnqz
 * @since 2018-02-12
 */
@Mapper
public interface SysDeptRelationMapper extends BaseMapper<SysDeptRelation> {

	/**
	 * 删除部门关系表数据
	 * @param id 部门ID
	 */
	void deleteDeptRelationsById(Integer id);

	/**
	 * 更改部分关系表数据
	 * @param deptRelation
	 */
	void updateDeptRelations(SysDeptRelation deptRelation);

	void deleteDeptById(Integer id);

	List<SysDeptRelation> selectDeptRelationsList(@Param("query") SysDeptRelation sysDeptRelation);

	List<SysDeptRelation> selectDeptRelation(@Param("query") SysDeptRelation sysDeptRelation);

	List<SysDeptRelation> selectByDescendantList(@Param("query") SysDeptRelation sysDeptRelation);

	List<SysDeptRelation> selectListByAncestor(@Param("query") SysDeptRelation sysDeptRelation);

	List<SysDeptRelation> selectListByDescendant(@Param("query") SysDeptRelation sysDeptRelation);

	int deleteByPrimaryKey(Long id);
}
