package com.qunzhixinxi.hnqz.admin.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.entity.WmDaCustomer;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 档案-客户管理
 *
 * @author lixuesong
 * @date 2021年06月04日 15:47
 */
@Mapper
public interface WmDaCustomerMapper extends BaseMapper<WmDaCustomer> {

	/**
	 * 分页查询
	 *
	 * @param page
	 * @param wmDaCustomer
	 * @return
	 */
	IPage<WmDaCustomer> listCustomerPage(Page page, @Param("query") WmDaCustomer wmDaCustomer);

	/**
	 * 查询销售报表展示的客户（停用的，有结算额的要展示）
	 *
	 * @param page 分页对象
	 * @param wmDaCustomer 客户对象
	 * @param year 年份
	 * @param startMonth 开始月份
	 * @param endMonth 结束月份
	 * @return
	 */
	IPage<WmDaCustomer> listCustomerWithGmvPage(Page page, @Param("query") WmDaCustomer wmDaCustomer, @Param("year") String year,
												@Param("startMonth") Integer startMonth, @Param("endMonth") Integer endMonth);

	/**
	 * 查询销售报表展示的客户（停用的，有结算额的要展示）
	 *
	 * @param wmDaCustomer 客户对象
	 * @param year 年份
	 * @param startMonth 开始月份
	 * @param endMonth 结束月份
	 * @return
	 */
	List<WmDaCustomer> listCustomerWithGmv(@Param("query") WmDaCustomer wmDaCustomer, @Param("year") String year,
										   @Param("startMonth") Integer startMonth, @Param("endMonth") Integer endMonth);
}
