package com.qunzhixinxi.hnqz.admin.recharge.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.recharge.enums.InvoiceApprovalStatus;
import com.qunzhixinxi.hnqz.admin.recharge.enums.InvoiceType;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 企业开票表
 * @TableName sys_dept_invoice
 */
@TableName(value ="sys_dept_invoice")
@Data
public class SysDeptInvoice implements Serializable {
    private static final long serialVersionUID = -4830423850806042441L;

    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 组织机构ID
     */
    private Integer deptId;

    /**
     * 开票金额（元）
     */
    private BigDecimal invoiceAmount;

    /**
     * 关联积分值
     */
    private Integer relationPackageScore;

    /**
     * 关联积分包个数
     */
    private Integer relationPackageNumber;

    /**
     * 审核状态
     */
    private InvoiceApprovalStatus approvalStatus;

    /**
     * 审核时间
     */
    private LocalDateTime approvalTime;

    /**
     * 发票类型
     */
    private InvoiceType invoiceType;

    /**
     * 邮寄地址
     */
    private String address;

    /**
     * 收件人姓名
     */
    private String addresseeName;

    /**
     * 收件人手机号
     */
    private String addresseePhone;

    /**
     * 是否删除
     */
    private String delFlag;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 更新时间
     */
    private LocalDateTime updateTime;

    /**
     * 更新人
     */
    private Integer updateUser;
}