package com.qunzhixinxi.hnqz.admin.recharge.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.recharge.enums.InvoiceStatus;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 企业开票关联表
 * @TableName sys_dept_invoice_relation
 */
@TableName(value ="sys_dept_invoice_relation")
@Data
public class SysDeptInvoiceRelation implements Serializable {
    private static final long serialVersionUID = 6309513073341858328L;

    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 发包企业id
     */
    private Integer deptId;

    /**
     * 积分包id
     */
    private String packageId;

    /**
     * 企业开票表ID
     */
    private Integer invoiceId;

    /**
     * 开票状态
     */
    private InvoiceStatus invoiceStatus;

    /**
     * 开票时间
     */
    private LocalDateTime invoiceTime;

    /**
     * 是否删除
     */
    private String delFlag;

    /**
     * 创建/申请时间
     */
    private LocalDateTime createTime;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 更新时间
     */
    private LocalDateTime updateTime;

    /**
     * 更新人
     */
    private Integer updateUser;

}