package com.qunzhixinxi.hnqz.admin.recharge.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qunzhixinxi.hnqz.admin.recharge.enums.RechargeRecordPackageType;
import com.qunzhixinxi.hnqz.admin.recharge.enums.RechargeRecordType;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 积分充值/使用记录表
 * @TableName sys_dept_recharge_record
 */
@TableName(value ="sys_dept_recharge_record")
@Data
public class SysDeptRechargeRecord implements Serializable {
    private static final long serialVersionUID = -7732924467238140614L;

    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 积分充值表ID
     */
    private Integer rechargeId;

    /**
     * 组织机构ID
     */
    private Integer deptId;

    /**
     * 关联组织机构ID（关联操作对象）
     */
    private Integer relationDeptId;

    /**
     * 充值积分
     */
    private Integer changeScore;

//    /**
//     * 充值金额（元）
//     */
//    private BigDecimal changeAmount;

    /**
     * 操作类型
     */
    private RechargeRecordType type;

    /**
     * 充值后积分余额
     */
    private Integer currentScore;

//    /**
//     * 充值后积分余额（元）
//     */
//    private BigDecimal currentBalance;

    /**
     * 积分包id
     */
    private String packageId;

    /**
     * 积分包类型
     */
    private RechargeRecordPackageType packageType;

    /**
     * 是否删除
     */
    private String delFlag;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 创建人
     */
    private Integer createUser;

}