package com.qunzhixinxi.hnqz.admin.recharge.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 企业开票-开票状态
 *
 * @author snows
 * @date 2023/6/16 11:56
 */
@Getter
@AllArgsConstructor
public enum InvoiceStatus {

    NOT_APPLY("NOT_APPLY", "未申请"),
    PENDING("PENDING", "待审核"),
    PASSED("PASSED", "已开票");

    @EnumValue
    private final String status;

    private final String description;

    /**
     * 根据审核状态获取发票状态
     *
     * @param approvalStatus 审核状态
     * @return 发票状态
     */
    public static InvoiceStatus getByApproveStatus(InvoiceApprovalStatus approvalStatus) {
        switch (approvalStatus) {
            case PASSED:
                return InvoiceStatus.PASSED;
            case REJECTED:
                return InvoiceStatus.NOT_APPLY;
            case PENDING:
                return InvoiceStatus.PENDING;
        }
        return null;
    }
}
