package com.qunzhixinxi.hnqz.admin.recharge.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qunzhixinxi.hnqz.admin.recharge.dto.SysDeptInvoiceRequest;
import com.qunzhixinxi.hnqz.admin.recharge.entity.SysDeptInvoiceRelation;
import com.qunzhixinxi.hnqz.admin.recharge.vo.SysDeptInvoiceRelationVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;

/**
* @author snows
* @description 针对表【sys_dept_invoice_relation(企业开票关联表)】的数据库操作Mapper
* @createDate 2023-06-16 14:28:24
* @Entity com.qunzhixinxi.hnqz.admin.recharge.entity.SysDeptInvoiceRelation
*/
@Mapper
public interface SysDeptInvoiceRelationMapper extends BaseMapper<SysDeptInvoiceRelation> {

    /**
     * 开票和积分包关联查询
     *
     * @param page 分页参数
     * @param toScorePackagePage 查询条件参数
     * @param deptIdList 企业id列表
     * @return 分页结果
     */
    IPage<SysDeptInvoiceRelationVO> pageInvoiceScorePacakgeRelation(Page<SysDeptInvoiceRelation> page,
                                                                    @Param("query") SysDeptInvoiceRequest.ToScorePackagePage toScorePackagePage,
                                                                    @Param("deptIdList") Set<Integer> deptIdList);

    /**
     * 开票和积分包关联查询
     *
     * @param toScorePackagePage 查询条件参数
     * @param deptIdList 企业id列表
     * @return 分页结果
     */
    List<SysDeptInvoiceRelationVO> listInvoiceScorePacakgeRelation(@Param("query") SysDeptInvoiceRequest.ToScorePackagePage toScorePackagePage,
                                                                   @Param("deptIdList") Set<Integer> deptIdList);

    /**
     * 开票和积分包关联查询2
     *
     * @param page      分页参数
     * @param invoiceId 企业开票表ID
     * @return 分页结果
     */
    IPage<SysDeptInvoiceRelationVO> pageInvoiceScorePacakgeRelation2(Page<SysDeptInvoiceRelation> page, @Param("invoiceId") Integer invoiceId);
}




