package com.qunzhixinxi.hnqz.admin.recharge.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.recharge.dto.SysDeptInvoiceRequest;
import com.qunzhixinxi.hnqz.admin.recharge.entity.SysDeptInvoice;
import com.qunzhixinxi.hnqz.admin.recharge.vo.SysDeptInvoiceRelationVO;
import com.qunzhixinxi.hnqz.admin.recharge.vo.SysDeptInvoiceVO;

import java.util.List;

/**
* @author snows
* @description 针对表【sys_dept_invoice(企业开票表)】的数据库操作Service
* @createDate 2023-06-16 14:08:32
*/
public interface SysDeptInvoiceService extends IService<SysDeptInvoice> {

    /**
     * 企业-开票管理列表
     *
     * @param toScorePackagePage 分页参数
     * @return 分页结果
     */
    IPage<SysDeptInvoiceRelationVO> pageInvoiceForDept(Page<SysDeptInvoiceRelationVO> page, SysDeptInvoiceRequest.ToScorePackagePage toScorePackagePage);

    /**
     * 平台财务管理-开票列表
     *
     * @param page 分页参数
     * @param toInvoicePage 请求参数
     * @return 响应结果
     */
    IPage<SysDeptInvoiceVO> pageInvoiceForAdmin(Page<SysDeptInvoiceVO> page, SysDeptInvoiceRequest.ToInvoicePage toInvoicePage);

    /**
     * 开票记录
     *
     * @param page 分页参数
     * @param toInvoicePage 请求参数
     * @return 响应结果
     */
    IPage<SysDeptInvoiceVO> pageInvoiceRecord(Page<SysDeptInvoiceVO> page, SysDeptInvoiceRequest.ToInvoicePage toInvoicePage);

    /**
     * 平台财务-关联积分包列表
     *
     * @param page   分页参数
     * @param invoiceId 企业开票表ID
     * @return 响应结果
     */
    IPage<SysDeptInvoiceRelationVO> pageInvoice(Page<SysDeptInvoiceRelationVO> page, Integer invoiceId);

    /**
     * 可开票积分
     *
     * @param deptId 企业id
     * @return 可开票积分记录
     */
    List<SysDeptInvoiceRelationVO> listToInvoiceScore(Integer deptId);

    /**
     * 开发票
     *
     * @param toInvoice 开票参数
     * @return 响应结果
     */
    Boolean toInvoice(SysDeptInvoiceRequest.ToInvoice toInvoice);

    /**
     * 开票审核
     *
     * @param toApprove 开票参数
     * @return 响应结果
     */
    Boolean toApprove(SysDeptInvoiceRequest.ToApprove toApprove);
}
