package com.qunzhixinxi.hnqz.admin.recharge.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.recharge.entity.SysDeptRechargeRecord;
import com.qunzhixinxi.hnqz.admin.recharge.enums.RechargeRecordType;
import com.qunzhixinxi.hnqz.admin.recharge.vo.SysDeptRechargeRecordForDeptVO;
import com.qunzhixinxi.hnqz.admin.recharge.vo.SysDeptRechargeRecordVO;

import java.time.LocalDateTime;

/**
* @author snows
* @description 针对表【sys_dept_recharge_record(积分充值/使用记录表)】的数据库操作Service
* @createDate 2023-06-12 14:40:23
*/
public interface SysDeptRechargeRecordService extends IService<SysDeptRechargeRecord> {

    /**
     * 充值记录
     *
     * @param page       分页参数
     * @param deptId     企业id
     * @param type       操作类型
     * @return 分页结果
     */
    IPage<SysDeptRechargeRecordVO> pageRechargeRecord(Page<SysDeptRechargeRecordVO> page, Integer deptId, RechargeRecordType type);

    /**
     * 分配、发包记录(企业)
     *
     * @param page       分页参数
     * @param type       操作类型
     * @param createTime 创建时间范围
     * @return 分页结果
     */
    IPage<SysDeptRechargeRecordForDeptVO> pageRecordForDept(Page<SysDeptRechargeRecordForDeptVO> page,
                                                            RechargeRecordType type, LocalDateTime[] createTime);
}
