package com.qunzhixinxi.hnqz.admin.recharge.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.recharge.dto.SysDeptRechargeRequest;
import com.qunzhixinxi.hnqz.admin.recharge.entity.SysDeptRecharge;
import com.qunzhixinxi.hnqz.admin.recharge.vo.SysDeptRechargeVO;

/**
* @author snows
* @description 针对表【sys_dept_recharge(积分充值表)】的数据库操作Service
* @createDate 2023-06-12 10:47:24
*/
public interface SysDeptRechargeService extends IService<SysDeptRecharge> {

    /**
     * 分页查询(平台财务)
     *
     * @param page 分页参数
     * @param toPage 条件参数
     * @return 分页结果
     */
    IPage<SysDeptRechargeVO> pageRechargeForAdmin(Page<SysDeptRechargeVO> page, SysDeptRechargeRequest.ToPage toPage);

    /**
     * 充值
     *
     * @param toRecharge 充值参数
     * @return 结果
     */
    Boolean recharge(SysDeptRechargeRequest.ToRecharge toRecharge);

    /**
     * 配置(权限管理)
     *
     * @param toConfig 配置参数
     * @return 结果
     */
    Boolean toConfig(SysDeptRechargeRequest.ToConfig toConfig);

}
