package com.qunzhixinxi.hnqz.admin.recharge.vo;

import com.qunzhixinxi.hnqz.admin.recharge.enums.InvoiceStatus;
import com.qunzhixinxi.hnqz.admin.recharge.enums.RechargeRecordType;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 企业开票关联积分包VO
 *
 * @author snows
 * @date 2023/6/16 15:35
 */
@Data
public class SysDeptInvoiceRelationVO implements Serializable {
    private static final long serialVersionUID = -3333768260717968665L;

    /**
     * 积分包id
     */
    private String scorePackageId;

    /**
     * 积分包名称
     */
    private String scorePackageName;

    /**
     * 发包企业id
     */
    private Integer deptId;

    /**
     * 发包企业
     */
    private String deptName;

    /**
     * 积分包值
     */
    private Integer score;

    /**
     * 发布日期
     */
    private LocalDateTime packageCreateTime;

    /**
     * 接单对象
     */
    private String taskUsers;

    /**
     * 积分包状态
     */
    private String scorePackageStatus;

    /**
     * 积分包状态名称
     */
    private String scorePackageStatusStr;

    /**
     * 申请时间
     */
    private LocalDateTime createTime;

    /**
     * 企业开票表ID
     */
    private Integer invoiceId;

    /**
     * 开票状态
     */
    private InvoiceStatus invoiceStatus = InvoiceStatus.NOT_APPLY;

    /**
     * 开票状态名称
     */
    private String invoiceStatusStr = InvoiceStatus.NOT_APPLY.getDescription();

    /**
     * 操作类型
     */
    private RechargeRecordType type;

    /**
     * 操作类型名称
     */
    private String typeStr;

    /**
     * 开票时间
     */
    private LocalDateTime invoiceTime;

    /**
     * 更新时间
     */
    private LocalDateTime updateTime;

    /**
     * 更新人
     */
    private Integer updateUser;
}
