package com.qunzhixinxi.hnqz.admin.recharge.vo;

import com.qunzhixinxi.hnqz.admin.recharge.enums.InvoiceApprovalStatus;
import com.qunzhixinxi.hnqz.admin.recharge.enums.InvoiceType;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 企业开票表
 * @TableName sys_dept_invoice
 */
@Data
public class SysDeptInvoiceVO implements Serializable {
    private static final long serialVersionUID = 7897443620044727943L;

    /**
     * 主键id
     */
    private Integer id;

    /**
     * 组织机构ID
     */
    private Integer deptId;

    /**
     * 企业名称
     */
    private String deptName;

    /**
     * 开票金额（元）
     */
    private BigDecimal invoiceAmount;

    /**
     * 关联积分值
     */
    private Integer relationPackageScore;

    /**
     * 关联积分包个数
     */
    private Integer relationPackageNumber;

    /**
     * 审核状态
     */
    private InvoiceApprovalStatus approvalStatus;

    /**
     * 审核状态名称
     */
    private String approvalStatusStr;

    /**
     * 审核时间
     */
    private LocalDateTime approvalTime;

    /**
     * 发票类型
     */
    private InvoiceType invoiceType;

    /**
     * 发票类型名称
     */
    private String invoiceTypeStr;

    /**
     * 邮寄地址
     */
    private String address;

    /**
     * 收件人姓名
     */
    private String addresseeName;

    /**
     * 收件人手机号
     */
    private String addresseePhone;

    /**
     * 是否删除
     */
    private String delFlag;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 更新时间
     */
    private LocalDateTime updateTime;

    /**
     * 更新人
     */
    private Integer updateUser;
}