package com.qunzhixinxi.hnqz.admin.recharge.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.qunzhixinxi.hnqz.admin.recharge.enums.RechargeRecordType;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 积分充值/使用记录表VO
 */
@Data
public class SysDeptRechargeRecordForDeptVO implements Serializable {
    private static final long serialVersionUID = -757283078695677161L;

    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 积分充值表ID
     */
    private Integer rechargeId;

    /**
     * 组织机构ID
     */
    private Integer deptId;

    /**
     * 企业名称
     */
    private String deptName;

    /**
     * 企业类型
     */
    private Integer deptLevel;

    /**
     * 企业类型名称
     */
    private String deptLevelStr;

    /**
     * 充值/消耗积分
     */
    private Integer changeScore;

    /**
     * 操作类型
     */
    private RechargeRecordType type;

    /**
     * 充值/消耗后积分余额
     */
    private Integer currentScore;

    /**
     * 关联对象（相对于当前登录企业的另一方）
     */
    private String operatingTarget;

    /**
     * 积分包名称
     */
    private String scorePackageName;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 创建人名称
     */
    private String creaUserStr;

}