package com.qunzhixinxi.hnqz.admin.recharge.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.qunzhixinxi.hnqz.admin.recharge.enums.RechargeRecordType;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 积分充值/使用记录表VO
 */
@Data
public class SysDeptRechargeRecordVO implements Serializable {
    private static final long serialVersionUID = -7467561813221224627L;

    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 积分充值表ID
     */
    private Integer rechargeId;

    /**
     * 组织机构ID
     */
    private Integer deptId;

    /**
     * 企业名称
     */
    private String deptName;

    /**
     * 企业类型
     */
    private Integer deptLevel;

    /**
     * 企业类型名称
     */
    private String deptLevelStr;

    /**
     * 充值/消耗积分
     */
    private Integer changeScore;

    /**
     * 充值金额（元）
     */
    private BigDecimal changeAmount;

    /**
     * 操作类型
     */
    private RechargeRecordType type;

    /**
     * 充值/消耗后积分余额
     */
    private Integer currentScore;

    /**
     * 充值后积分余额（元）
     */
    private BigDecimal currentBalance;

    /**
     * 是否删除
     */
    private String delFlag;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 创建人
     */
    private Integer createUser;

    /**
     * 创建人名称
     */
    private String creaUserStr;

}