package com.qunzhixinxi.hnqz.admin.recharge.vo;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 积分充值表VO
 */
@Data
public class SysDeptRechargeVO implements Serializable {
    private static final long serialVersionUID = -7923044280968088176L;

    /**
     * 主键id
     */
    private Integer id;

    /**
     * 组织机构ID
     */
    private Integer deptId;

    /**
     * 企业名称
     */
    private String deptName;

    /**
     * 企业类型
     */
    private Integer deptLevel;

    /**
     * 企业类型名称
     */
    private String deptLevelStr;

    /**
     * 积分余额
     */
    private Integer score = 0;

    /**
     * 余额（元）
     */
    private BigDecimal balance = BigDecimal.ZERO;

    /**
     * 权限
     */
    private String[] permissions;

    /**
     * 服务费率
     */
    private BigDecimal serviceCharge;

    /**
     * 可透支金额
     */
    private BigDecimal overdrawAmount;

    /**
     * 可透支积分
     */
    private Integer overdrawScore;

    /**
     * 累计充值积分
     */
    private Integer totalRechargeScore = 0;

    /**
     * 累计开票积分
     */
    private Integer totalInvoiceScore = 0;

    /**
     * 累计开票金额（元）
     */
    private BigDecimal totalInvoiceAmount = BigDecimal.ZERO;

}