/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.entity.MonitoringIndicator;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageSettleNote;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.List;

/**
 * 风险监控
 *
 * @author ryz
 * @date 2021-04-19 16:08:29
 */
public interface MonitoringIndicatorService extends IService<MonitoringIndicator> {

	/**
	 * 获取税源地限额
	 *
	 * @param subjectLocation 税源地
	 * @return 限额信息
	 */
	MonitoringIndicator locationLimit(SubjectLocation subjectLocation);

	/**
	 * 结算校验
	 *
	 * @param notes    结算记录
	 * @param location 税源地
	 * @return 总结算额
	 */
	BigDecimal settleMonitoringIndicator(Collection<WmScorePackageSettleNote> notes, SubjectLocation location);
}
