package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.SysEnterpriseRelationDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.SysEnterpriseRelation;
import com.qunzhixinxi.hnqz.admin.api.vo.SysEnterpriseRelationVO;

/**
 * 企业关系服务
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-11-02 11:08
 */
public interface SysEnterpriseRelationService extends IService<SysEnterpriseRelation> {


	/**
	 * 获取分页
	 *
	 * @param entName 企业名称
	 * @param page    分页参数
	 * @return 翻页结果
	 */
	Page<SysEnterpriseRelationVO> pageEntRels(Page<SysEnterpriseRelationVO> page, String entName);

	/**
	 * 更新企业关系信息
	 *
	 * @param relationDTO 更新内容
	 * @return 更新结果
	 */
	Boolean updateEntRel(SysEnterpriseRelationDTO relationDTO);
}
