/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.entity.WmDaDrugEntDrugtable;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.List;
import java.util.Set;

/**
 * 档案-药企药品
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
public interface WmDaDrugEntDrugtableService extends IService<WmDaDrugEntDrugtable> {

	/**
	 * 给药品分配推广企业
	 * @param wmDaDrugEntDrugtable
	 * @return
	 */
	R distribute(WmDaDrugEntDrugtable wmDaDrugEntDrugtable);

	/**
	 * 获取推广企业列表
	 * @param wmDaDrugEntDrugtable
	 * @return
	 */
	R listReDept(WmDaDrugEntDrugtable wmDaDrugEntDrugtable);

	/**
	 * 获取药品
	 *
	 * @param page     分页信息
	 * @param deptId   部门id
	 * @param drugName 药品名称
	 * @return 药品列表
	 */
	IPage<WmDaDrugEntDrugtable> listDrugs(Page page, Integer deptId, String drugName);

	/**
	 * 根据部门id获取关联药品生产生产企业名称
	 * @param deptId 部门id
	 * @return 生产企业列表
	 */
	Set<String> listDrugProducerByDeptId(Integer deptId);
}
