package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPkgQuizRelation;

import java.util.List;

/**
 * 积分包问卷关系服务
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-10-19 13:22
 */
public interface WmPkgQuizRelationService extends IService<WmPkgQuizRelation> {

	/**
	 * 创建积分包关联的试卷
	 *
	 * @param quizIds 试卷ID
	 * @param pkgId   积分包ID
	 */
	void createPkgQuizzes(List<Integer> quizIds, Integer pkgId);

	/**
	 * 复制关联关系
	 *
	 * @param pkgId           积分包ID
	 * @param quizRelationIds 关联关系列表
	 */
	void copyQuizRelations(List<Integer> quizRelationIds, Integer pkgId);

	/**
	 * 获取积分包的关联试卷
	 *
	 * @param pkgIds 积分包id
	 * @return 关联试卷集合
	 */
	List<WmPkgQuizRelation> listQuizRelationsByPkgIds(List<Integer> pkgIds);
}
