package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.dto.WmQuizDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.WmQuizItem;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;

import java.util.List;

/**
 * 试卷项服务
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2023-10-16 22:30
 */
public interface WmQuizItemService extends IService<WmQuizItem> {

	/**
	 * 删除试卷项
	 *
	 * @param itemId 试卷项ID
	 * @return 删除结果
	 */
	Boolean delQuizItem(Integer itemId);

	/**
	 * 创建试卷项
	 *
	 * @param resource 试卷项信息
	 * @param user     操作人
	 * @return 试卷项
	 */
	WmQuizItem createItem(WmQuizDTO.OnItemCreate resource, HnqzUser user);

	/**
	 * 批量创建试卷项
	 *
	 * @param resources 试卷项集合
	 * @param user      操作人
	 * @return 试卷项列表
	 */
	List<WmQuizItem> createItems(List<WmQuizDTO.OnItemCreate> resources, HnqzUser user);

	/**
	 * 更新试卷项
	 *
	 * @param resource 试卷信息
	 * @param user     操作人
	 * @return 更新结果
	 */
	Boolean updateItem(WmQuizDTO.OnItemUpdate resource, HnqzUser user);

	/**
	 * 获取试卷项详情
	 *
	 * @param itemId 试卷项ID
	 * @return 试卷项详情
	 */
	WmQuizItem getItemDetails(Integer itemId);

	/**
	 * 获取试卷的试卷项
	 *
	 * @param sn 试卷编号
	 * @return 试卷项集合
	 */
	List<WmQuizItem> listItems(String sn);
}
