/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskSettleNote;
import com.qunzhixinxi.hnqz.admin.entity.output.WmTaskSettleNoteOutput;
import com.qunzhixinxi.hnqz.common.core.util.R;

/**
 *
 *
 * @author winter
 * @date 2021-03-03 18:15:22
 */
public interface WmTaskSettleNoteService extends IService<WmTaskSettleNote> {

	R getSettleInfo(WmTaskSettleNote wmTaskSettleNote);

	IPage<WmTaskSettleNoteOutput> getWmTaskSettleInfoPage(Page page, WmTaskSettleNote wmTaskSettleNote);
	IPage<WmTaskSettleNoteOutput> getWmTaskForSettlePage(Page page, WmTaskSettleNote wmTaskSettleNote);

	R saveSettleInfo(WmTaskSettleNote wmTaskSettleNote);

	R subSettleInfo(WmTaskSettleNote note);

	R singletSettle(WmTaskSettleNote note);

	R batchSettle(WmTaskSettleNote note);

	R revokeSettle(WmTaskSettleNote note);

	R settleNotify(String streamId);
}
