package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSubmissionPercentRule;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.common.core.util.R;

import java.util.Collection;
import java.util.List;

/**
 * 任务提交百分比规则
 *
 * @author snows
 * @date 2022/12/22 15:32
 */
public interface WmTaskSubmissionPercentRuleService extends IService<WmTaskSubmissionPercentRule> {

	/**
	 * 初始化企业的任务类型配置的信息
	 *
	 * @param deptIds 企业id集合
	 * @return 初始化结果
	 */
	Boolean initTaskTypeConfigRule(Collection<Integer> deptIds);

	/**
	 * 初始化企业的任务类型配置的信息
	 *
	 * @param deptIds 企业id集合
	 * @param sourceDeptId 源数据企业id
	 * @return 初始化结果
	 */
	Boolean initTaskTypeConfigRule(Collection<Integer> deptIds, Integer sourceDeptId);

	/**
	 * 校验任务百分比限制规则（达到要求的积分包，【任务配置】-【百分比限制】所选的任务总完成积分值不得大于积分包值*百分比）
	 *
	 * @param scorePackage 积分包实体
	 * @param deptId 部门id
	 * @param taskUserId 任务承接人userId
	 * @param checkTaskTypeList 要校验的任务类型list
	 * @return
	 */
	R<?> checkPercentRule(WmScorePackage scorePackage, Integer deptId, Integer taskUserId, List<String> checkTaskTypeList);

	/**
	 * 更新
	 *
	 * @param rules
	 * @return
	 */
	Boolean updateRule(List<WmTaskSubmissionPercentRule> rules);
}
