package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSubmissionRule;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 任务提交服务
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-08-15 18:06
 */
public interface WmTaskSubmissionRuleService extends IService<WmTaskSubmissionRule> {

	/**
	 * 获取部门限制信息
	 *
	 * @param deptId 部门id
	 * @return 限制信息
	 */
	Map<UpmsType.TaskCategory, List<WmTaskSubmissionRule>> listDeptTaskSubmissionRules(Integer deptId);


	/**
	 * 初始化企业限制信息
	 *
	 * @param deptIds 企业id集合
	 * @return 初始化结果
	 */
	Boolean initDeptTaskSubmissionRule(Collection<Integer> deptIds);

	/**
	 * 初始化企业限制信息（基于前企业数据）
	 *
	 * @param deptIds 企业id集合
	 * @param sourceDeptId 源数据企业id
	 * @return 初始化结果
	 */
	Boolean initDeptTaskSubmissionRule(Collection<Integer> deptIds, Integer sourceDeptId);
}
