package com.qunzhixinxi.hnqz.admin.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.admin.entity.WmTeam;
import com.qunzhixinxi.hnqz.admin.entity.model.excel.WmTeamExcelModel;

import java.util.List;
import java.util.Map;

/**
 * 团队管理服务
 *
 * @author lixuesong
 * @date 2021年12月08日 13:50
 */
public interface WmTeamService extends IService<WmTeam> {

	/**
	 * 查询可选择的人员
	 *
	 * @param deptId
	 * @param teamId
	 * @param userNameOrPhone
	 * @return
	 */
	Map<String, Object> listSelectableUser(Integer deptId, Integer teamId, String userNameOrPhone);

	/**
	 * 查询接单对象范围名称
	 *
	 * @param packageUserScope
	 * @return
	 */
	String getPackageUserScopeName(String packageUserScope);

	/**
	 * 团队批量导入成员
	 *
	 * @param teamId
	 * @param excelMap
	 * @return
	 */
	Map<String, String> batchImport(Integer teamId, Map<String, List<WmTeamExcelModel>> excelMap);
}
