package com.qunzhixinxi.hnqz.admin.service.gig;

import cn.hutool.json.JSONObject;
import com.qunzhixinxi.hnqz.admin.api.dto.OladingCommonRequest;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageSettleNote;

import java.util.List;

/**
 * 第三方零工接口处理
 *
 * @author lixuesong
 * @date 2022年04月17日 11:54
 */
public interface GigThirdApiService {

	/**
	 * 福建企赋结算回调业务处理
	 *
	 * @param bodyJson
	 * @return
	 */
	boolean qiFuSettleNotify(com.alibaba.fastjson.JSONObject bodyJson);

	/**
	 * 福建企赋签约回调业务处理
	 *
	 * @param newBodyJson
	 * @return
	 */
	boolean qiFuSignNotify(com.alibaba.fastjson.JSONObject newBodyJson);

	/**
	 * 中智结算回调业务处理
	 *
	 * @param bodyJson 请求数据
	 * @return 是否成功
	 */
	boolean zhongzhiSettleNotify(JSONObject bodyJson);

	/**
	 * 众蚁云结算回调业务处理
	 *
	 * @param bodyJson
	 * @return
	 */
	boolean zhongYiYunSettleNotify(JSONObject bodyJson);

	/**
	 * 众蚁云签约回调业务处理
	 *
	 * @param newBodyJson
	 * @return
	 */
	boolean zhongYiYunSignNotify(JSONObject newBodyJson);

	/**
	 * 汇企云回调业务处理
	 *
	 * @param reqMsgId 报文流水号
	 * @param reqBody 请求总的body
	 * @param inputId 记录id
	 * @return
	 */
	boolean huiqiyunNotify(String reqMsgId, JSONObject reqBody, Integer inputId);


	/**
	 * 浪潮(灵才接好活)结算回调
	 *
	 * @param channel 通知类型（recharge 充值，batchQuery 批量结果，refund  退款）
	 * @param batchNo 项目单号
	 * @param orderStatus 项目订单状态（0未支付，1已支付，2已取消）
	 * @return 是否成功状态
	 */
	String lingcaiaiNotify(String channel, String batchNo, Integer orderStatus);

	/**
	 * 正启之星回调业务处理
	 *
	 * @param actionName
	 * @param orderUuid
	 * @param orderStatus
	 */
	void xinbadaNotify(String actionName, String orderUuid, Integer orderStatus);

	/**
	 * 自由职家回调业务处理
	 *
	 * @param requestId
	 * @param req
	 */
	void oladingNotify(String requestId, OladingCommonRequest.Req req);

	/**
	 * 自由职家签约结果回调
	 *  @param requestId
	 * @param signUpCertStatus
	 * @param req
	 */
	void oladingSignUp(String requestId, OladingCommonRequest.SignUpStatus signUpCertStatus, OladingCommonRequest.Req req);

	/**
	 * 自由职家证照上传结果回调
	 *
	 * @param requestId
	 * @param uploadIdCertStatus
	 */
	void oladingUploadIdCardImage(String requestId, OladingCommonRequest.UploadIdCardImageStatus uploadIdCertStatus, OladingCommonRequest.Req req);

	/**
	 * 自由职家上传企业纳税人协议回调
	 *
	 * @param requestId
	 * @param agreementStatus
	 */
	void oladingUploadTaxpayerAgreement(String requestId, OladingCommonRequest.UploadTaxpayerAgreementStatus agreementStatus, OladingCommonRequest.Req req);

	/**
	 * 完单操作
	 *
	 * @param noteList
	 */
	void finishTask(List<WmScorePackageSettleNote> noteList);

}
