package com.qunzhixinxi.hnqz.admin.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qunzhixinxi.hnqz.admin.entity.MedicalEquipment;
import com.qunzhixinxi.hnqz.admin.mapper.MedicalEquipmentMapper;
import com.qunzhixinxi.hnqz.admin.service.MedicalEquipmentService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author lixuesong
 * @description 针对表【medical_equipment(医疗器械)】的数据库操作Service实现
 * @createDate 2022-11-08 10:03:50
 */
@Service
@AllArgsConstructor
public class MedicalEquipmentServiceImpl extends ServiceImpl<MedicalEquipmentMapper, MedicalEquipment>
		implements MedicalEquipmentService {

	/**
	 * 查询指定企业对应的医疗器械
	 *
	 * @param deptId
	 * @return
	 */
	public List<MedicalEquipment> listByDrugId(Integer deptId) {

		return this.list(Wrappers.<MedicalEquipment>lambdaQuery()
				.eq(MedicalEquipment::getDrugEntId, deptId));
	}
}
