package com.qunzhixinxi.hnqz.admin.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.DesensitizedUtil;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.csp.sentinel.util.StringUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.common.collect.ImmutableMap;
import com.qunzhixinxi.hnqz.admin.api.constant.CacheConstants;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDictItem;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUser;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPkgQuizRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.WmReportOpt;
import com.qunzhixinxi.hnqz.admin.api.vo.UserVO;
import com.qunzhixinxi.hnqz.admin.api.vo.WmScorePackageVO;
import com.qunzhixinxi.hnqz.admin.entity.*;
import com.qunzhixinxi.hnqz.admin.entity.dto.UnpackDTO;
import com.qunzhixinxi.hnqz.admin.entity.input.WmScorePackageApiOutput;
import com.qunzhixinxi.hnqz.admin.entity.input.WmScorePackageSettleInput;
import com.qunzhixinxi.hnqz.admin.entity.input.WmScorePackageSettleOutput;
import com.qunzhixinxi.hnqz.admin.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.enums.EnableEnum;
import com.qunzhixinxi.hnqz.admin.enums.PackageFinishStatusEnum;
import com.qunzhixinxi.hnqz.admin.enums.PackageStatusEnum;
import com.qunzhixinxi.hnqz.admin.enums.PackageTypeEnum;
import com.qunzhixinxi.hnqz.admin.enums.ReportEnum;
import com.qunzhixinxi.hnqz.admin.enums.ScorePackageStatusEnum;
import com.qunzhixinxi.hnqz.admin.enums.TaskStatusEnum;
import com.qunzhixinxi.hnqz.admin.mapper.*;
import com.qunzhixinxi.hnqz.admin.recharge.entity.SysDeptRecharge;
import com.qunzhixinxi.hnqz.admin.recharge.entity.SysDeptRechargeRecord;
import com.qunzhixinxi.hnqz.admin.recharge.enums.RechargeRecordPackageType;
import com.qunzhixinxi.hnqz.admin.recharge.enums.RechargeRecordType;
import com.qunzhixinxi.hnqz.admin.recharge.mapper.SysDeptRechargeMapper;
import com.qunzhixinxi.hnqz.admin.recharge.mapper.SysDeptRechargeRecordMapper;
import com.qunzhixinxi.hnqz.admin.service.*;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.data.datascope.DataScope;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.AsyncResult;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.function.Function;
import java.util.stream.Collectors;

import static com.qunzhixinxi.hnqz.admin.enums.ReportEnum.REPORT_STATUS_END;

/**
 * 积分包
 *
 * @author gaoyanng
 * @date 2020-06-25 23:35:42
 */
@Slf4j
@Service
@AllArgsConstructor
public class WmScorePackageServiceImpl extends ServiceImpl<WmScorePackageMapper, WmScorePackage> implements WmScorePackageService {

	private final WmScorePackageMapper wmScorePackageMapper;
	private final SysDeptRelationMapper sysDeptRelationMapper;
	private final WmTaskMapper wmTaskMapper;
	private final SysDeptMapper sysDeptMapper;
	private final SysUserMapper sysUserMapper;
	private final WmScoreTaskTypeMapper wmScoreTaskTypeMapper;
	private final SysDeptService sysDeptService;
	private final WmDaAgentService wmDaAgentService;
	private final WmScorePackageStatusService wmScorePackageStatusService;
	private final WmTaskTypeMapper wmTaskTypeMapper;
	private final WmDaDrugEntService wmDaDrugEntService;
	private final WmScorePackageSettleNoteMapper settleNoteMapper;
	private final WmDaDrugEntDrugtableService wmDaDrugEntDrugtableService;
	private final WmReportMapper wmReportMapper;
	private final SysDictItemService sysDictItemService;
	private final WmTeamService wmTeamService;
	private final SysDeptRechargeMapper sysDeptRechargeMapper;
	private final SysDeptRechargeRecordMapper sysDeptRechargeRecordMapper;
	private final RedisTemplate<String, String> redisTemplate;
	private final WmPkgQuizRelationService pkgQuizRelationService;

	@Override
	public List<WmScorePackage> listWmScorePackageAndTask(WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.listWmScorePackageAndTask(wmScorePackage, new DataScope());
	}

	@Override
	public List<WmScorePackage> listWmScorePackageAndTaskExt(WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.listWmScorePackageAndTaskExt(wmScorePackage);
	}

	@Override
	public List<WmScorePackage> listWmScorePackageAndTaskExtOld(WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.listWmScorePackageAndTaskExtOld(wmScorePackage);
	}

	@Override
	public List<WmScorePackage> listWmScorePackageAndTaskExt2(WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.listWmScorePackageAndTaskExt2(wmScorePackage);
	}


	@Override
	public List<WmScorePackage> listWmScorePackageAndTaskExt2Old(WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.listWmScorePackageAndTaskExt2Old(wmScorePackage);
	}

	@Override
	public List<WmScorePackage> listWmScorePackageAndTaskLevel1(WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.listWmScorePackageAndTaskLevel1(wmScorePackage, new DataScope());
	}

	@Override
	public List<WmScorePackage> listWmScorePackageAndTaskLevel3(WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.listWmScorePackageAndTaskLevel3(wmScorePackage, new DataScope());
	}

	@Override
	public List<WmScorePackage> pageList(QueryWrapper<WmScorePackage> wrappers) {
		return wmScorePackageMapper.selectListByScope(wrappers, new DataScope());
	}

	@Override
	public String getPackageScoreEntByTaskInfo(WmScorePackage wmScorePackage) {
		String deptId = "";
		String userId = "";

		if (null == SecurityUtils.getUser() || null != SecurityUtils.getUser().getDeptId()) {

			if (null != wmScorePackage.getXxdbId() && wmScorePackage.getXxdbId().length() > 1) {
				userId = wmScorePackage.getXxdbId();
			}

			if (null != wmScorePackage.getZbId() && wmScorePackage.getZbId().length() > 1) {
				userId = wmScorePackage.getZbId();
			}

			SysUser sysUser = sysUserMapper.selectById(wmScorePackage.getXxdbId());
			if (null != sysUser) {
				deptId = sysUser.getDeptId() + "";
			} else {
				sysUser = sysUserMapper.selectById(wmScorePackage.getZbId());
				if (null != sysUser) {
					deptId = sysUser.getDeptId() + "";
				} else {
					return "-1000";
				}
			}


		} else {
			deptId = SecurityUtils.getUser().getDeptId() + "";
		}


		SysDept sysDept = sysDeptMapper.selectById(deptId);
		if (sysDept.getLevel() == 3) {
			return null;
		}
		wmScorePackage.setXxdbId(null);
		wmScorePackage.setZbId(null);

		wmScorePackage.setTypeid("2");
		wmScorePackage.setLevel1Id(sysDept.getLevel2Id() + "");
		wmScorePackage.setAgentTypeId("2");
		wmScorePackage.setDelFlag("0");
		wmScorePackage.setEnableFlag("0");
		List<WmScorePackage> wmScorePackages = super.list(Wrappers.query(wmScorePackage)
				.lambda()
				.isNotNull(WmScorePackage::getLevel2Id)
				.ne(WmScorePackage::getLevel2Id, "")
				.orderByDesc(WmScorePackage::getIsConduct)
				.orderByAsc(WmScorePackage::getReceiveDate));

		if (wmScorePackages.size() > 0) {
			for (int i = 0; i < wmScorePackages.size(); i++) {
				WmTask wmTask = new WmTask();
				wmTask.setScorePackageLevel1Id(wmScorePackages.get(i).getId());

				List<String> taskStatus = new ArrayList<>();
				taskStatus.add("5");
				//TODO 需要确认已审核的逻辑
				List<WmTask> wmTaskList = wmTaskMapper.selectList(Wrappers.query(wmTask)
						.lambda()
						.notIn(WmTask::getTaskStatus, taskStatus));
				int socre = 0;
				for (WmTask wmT :
						wmTaskList) {
					if (null != wmT.getScore()) {
						socre += wmT.getScore();
					}
				}
				if (socre <= wmScorePackages.get(i).getScore()) {
					return wmScorePackages.get(i).getId();
				}
			}

		}
		return null;
	}


	@Override
	public WmScorePackage getPackageScoreByTaskInfo(WmScorePackage wmScorePackage) {
		wmScorePackage.setEnableFlag("0");
		wmScorePackage.setDelFlag("0");
		List<WmScorePackage> wmScorePackages = super.list(Wrappers.query(wmScorePackage).lambda().
				orderByDesc(WmScorePackage::getIsConduct).orderByAsc(WmScorePackage::getReceiveDate));

		if (wmScorePackages.size() > 0) {
			for (int i = 0; i < wmScorePackages.size(); i++) {
				WmTask wmTask = new WmTask();
				/**
				 * 2020-12-21
				 * 只查生效的任务
				 * 0-生效 1-无效  9-待审核
				 */
				wmTask.setRealFlag("0");
				wmTask.setScorePackageId(wmScorePackages.get(i).getId());

				List<String> taskStatus = new ArrayList<>();
				taskStatus.add("5");
				//TODO 需要确认已审核的逻辑
				List<WmTask> wmTaskList = wmTaskMapper.selectList(Wrappers.query(wmTask).lambda()
						.notIn(WmTask::getTaskStatus, taskStatus)
						.orderByAsc(WmTask::getCreateTime)
				);
				int socre = 0;
				for (WmTask wmT :
						wmTaskList) {
					if (null != wmT.getScore()) {
						socre += wmT.getScore();
					}
				}
				if (socre < wmScorePackages.get(i).getScore()) {
					return wmScorePackages.get(i);
				}
			}

		}
		return null;
	}

	@Override
	public List<WmScorePackage> listPage(Page page, WmScorePackage wmScorePackage) {
		return null;
	}

	public IPage<WmScorePackage> getExportPackageTotalList1(Page page, WmScorePackage wmScorePackage) {
		OrderItem orderItem = new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);
		IPage<WmScorePackage> list1 = wmScorePackageMapper.getExportPackageTotalList1(page, wmScorePackage);
		List<WmScorePackage> records = list1.getRecords();

		for (WmScorePackage scorePackage : records) {

			scorePackage.setReportMqName(CacheConstants.EXPORT_ZB_REPORT_CACHE);
			this.getReportOpt(scorePackage);
			// 封装excel报告状态
			this.getExcelReportOpt(scorePackage, CacheConstants.EXCEL_EXPORT_ZB_REPORT_CACHE);

		}


		return list1;
	}

	public IPage<WmScorePackage> getExportPackageTotalList(Page page, WmScorePackage wmScorePackage) {
		OrderItem orderItem = new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);
		return wmScorePackageMapper.getExportPackageTotalList(page, wmScorePackage);
	}

	public IPage<Map<String, Object>> getPlatTotalData(Page page, WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.getPlatTotalData(page, wmScorePackage);
	}

	@Override
	public IPage<Map<String, Object>> selectWmScorePackageList(Page page, WmScorePackage wmScorePackage) {
		OrderItem orderItem = new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);
		return wmScorePackageMapper.selectWmScorePackageList(page, wmScorePackage);
	}

	@Override
	public R updateByIdWithType(WmScorePackageVO wmScorePackageVO) {
		WmScorePackage wmScorePackage = new WmScorePackage();

		wmScorePackage.setId(wmScorePackageVO.getId());
		if ("3".equals(wmScorePackageVO.getFormType())) {
			wmScorePackage.setInvoiceCategory(wmScorePackageVO.getInvoiceCategory());
		} else if ("1".equals(wmScorePackageVO.getFormType())) {
			BigDecimal settleAmount = wmScorePackageVO.getScore()
					.multiply(wmScorePackageVO.getDiscount()).setScale(2, BigDecimal.ROUND_HALF_UP);
			wmScorePackage.setDiscount(wmScorePackageVO.getDiscount());
			wmScorePackage.setSettleAmount(settleAmount);
		} else if ("2".equals(wmScorePackageVO.getFormType())) {
			BigDecimal discount = wmScorePackageVO.getSettleAmount()
					.divide(wmScorePackageVO.getScore(), 2, BigDecimal.ROUND_HALF_UP);
			wmScorePackage.setDiscount(discount);
			wmScorePackage.setSettleAmount(wmScorePackageVO.getSettleAmount());
		}

		wmScorePackageMapper.updateById(wmScorePackage);
		return R.ok();
	}

	@Override
	public WmScorePackage selectByPackage(String id) {
		return wmScorePackageMapper.selectByPackage(id);
	}

	@Override
	public List<WmScorePackage> selectLists(WmScorePackage wmScorePackage) {
		wmScorePackage.getRelationScoreId();
		return wmScorePackageMapper.selectLists(wmScorePackage);
	}

	@Override
	public Map<String, Object> selectSettleStatus(WmScorePackage wmScorePackage) {
		wmScorePackage.setRelationScoreId(wmScorePackage.getId());
		List<WmScorePackage> wmScorePackageList = wmScorePackageMapper.selectLists(wmScorePackage);
		Map<String, Object> totalMap = new HashMap<>();
		List<Integer> list = new ArrayList<>();
		if (wmScorePackageList.size() > 0) {
			List<String> ids2 = wmScorePackageList.stream().map(p -> p.getId()).collect(Collectors.toList());
			for (String id : ids2) {
				WmScorePackage wmScorePackage2 = new WmScorePackage();
				wmScorePackage2.setRelationScoreId(id);
				List<WmScorePackage> wmScorePackageList2 = wmScorePackageMapper.selectLists(wmScorePackage2);
				List<String> ids4 = wmScorePackageList2.stream().map(p -> p.getId()).collect(Collectors.toList());
				if (wmScorePackageList2.size() > 0) {
					for (String id2 : ids4) {
						WmScorePackage wmScorePackage1 = new WmScorePackage();
						wmScorePackage1.setId(id2);
						wmScorePackage1.setSettleStatus(1);
						List<Map<String, Object>> wmScorePackageList1 = wmScorePackageMapper.selectListById(wmScorePackage1);
						if (wmScorePackageList1.size() > 0) {
							Integer total = 0;
							Integer total1 = 0;
							for (Map<String, Object> map : wmScorePackageList1) {
								if (null != map.get("score")) {
									total += Integer.parseInt(map.get("score") + "");
								}
								list.add(total);
							}
							for (int i = 0; i < list.size(); i++) {
								total1 += list.get(i);
							}
							totalMap.put("score", total1);
						}
					}
				}
				WmScorePackage wmScorePackage1 = new WmScorePackage();
				wmScorePackage1.setId(id);
				wmScorePackage1.setSettleStatus(1);
				List<Map<String, Object>> wmScorePackageList1 = wmScorePackageMapper.selectListById(wmScorePackage1);
				if (wmScorePackageList1.size() > 0) {
					Integer total = 0;
					Integer total1 = 0;
					for (Map<String, Object> map : wmScorePackageList1) {
						if (null != map.get("score")) {
							total += Integer.parseInt(map.get("score") + "");
						}
						list.add(total);
					}
					for (int i = 0; i < list.size(); i++) {
						total1 += list.get(i);
					}
					totalMap.put("score", total1);
				}
			}
		} else if (wmScorePackageList.size() == 0) {
			WmScorePackage wmScorePackage1 = new WmScorePackage();
			wmScorePackage1.setId(wmScorePackage.getId());
			wmScorePackage1.setSettleStatus(1);
			List<Map<String, Object>> wmScorePackageList1 = wmScorePackageMapper.selectListById(wmScorePackage1);
			if (wmScorePackageList1.size() > 0) {
				Integer total = 0;
				Integer total1 = 0;

				for (Map<String, Object> map : wmScorePackageList1) {
					if (null != map.get("score")) {
						total += Integer.parseInt(map.get("score") + "");
					}
					list.add(total);
				}
				for (int i = 0; i < list.size(); i++) {
					total1 += list.get(i);
				}
				totalMap.put("score", total1);

			}
		}

		return totalMap;
	}

	@Override
	public List<SysDept> selectSendPackageDeptId(WmScorePackage wmScorePackage) {
		SysDeptRelation sysDeptRelation = new SysDeptRelation();
		sysDeptRelation.setDescendant(SecurityUtils.getUser().getDeptId());
		List<SysDeptRelation> sysDeptRelationList = sysDeptRelationMapper.selectByDescendantList(sysDeptRelation);
		List<Integer> ids = sysDeptRelationList.stream().map(p -> p.getAncestor()).collect(Collectors.toList());
		List<SysDept> list = new ArrayList<>();
		for (Integer id : ids) {
			SysDept sysDept = sysDeptService.getById(id);
			list.add(sysDept);
		}
		return list;
	}

	@Override
	public List<WmScorePackage> selectWmScorePackageByCode(Map<String, Object> map) {

		return wmScorePackageMapper.selectWmScorePackageByCode(map);
	}

	@Override
	public WmScorePackage selectWmScorePackage(WmScorePackage wmScorePackage) {

		String pkgId = wmScorePackage.getScoreId();
		wmScorePackage = wmScorePackageMapper.selectByScoreId(wmScorePackage.getScoreId());

		if (StrUtil.isBlank(wmScorePackage.getRelationScoreId())) {
			wmScorePackage.setRelationScoreId("-1");
		}

		WmScoreTaskType wmScoreTaskType = new WmScoreTaskType();
		wmScoreTaskType.setScoreId("-1".equals(wmScorePackage.getRelationScoreId()) ? wmScorePackage.getId() : wmScorePackage.getRelationScoreId());
		List<WmScoreTaskType> taskTypeList = wmScoreTaskTypeMapper.listWmScoreTaskType(wmScoreTaskType);
		Set<String> taskTypeSet = taskTypeList.stream().map(WmScoreTaskType::getTaskTypeId).collect(Collectors.toSet());
		wmScorePackage.setTaskTypeSet(taskTypeSet);


		// 查询关联的试卷
		List<WmPkgQuizRelation> quizRelations = pkgQuizRelationService.listQuizRelationsByPkgIds(Collections.singletonList(Integer.parseInt(pkgId)));

		if (CollUtil.isNotEmpty(quizRelations)){

			List<Integer> quizIds = quizRelations.stream().map(WmPkgQuizRelation::getQuizId).collect(Collectors.toList());
			List<Integer> relIds = quizRelations.stream().map(WmPkgQuizRelation::getRelationId).collect(Collectors.toList());
			wmScorePackage.setQuizIds(quizIds);
			wmScorePackage.setQuizRelationIds(relIds);

		}

		wmScorePackage.setQuizRelations(quizRelations);

		return wmScorePackage;
	}

	@Override
	public IPage<WmScorePackage> selectWmScorePackageLists(Page page, WmScorePackage wmScorePackage) {
		OrderItem orderItem = new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);

		SysDept sysDept = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
		wmScorePackage.setSendPackageDeptId(String.valueOf(sysDept.getDeptId()));
		return wmScorePackageMapper.selectWmScorePackageLists(page, wmScorePackage);
	}

	@Override
	public WmScorePackage selectKfpjf(String scoreId) {
		return wmScorePackageMapper.selectByScoreId(scoreId);
	}

	@Override
	public WmScorePackage selectKfpjfs(String scoreName) {
		return wmScorePackageMapper.selectByScoreIds(scoreName);
	}

	@Override
	public WmScorePackage selectWmScorePackageById(String relationScoreId) {
		return wmScorePackageMapper.selectByRelationScoreId(relationScoreId);
	}

	@Override
	public List<WmScorePackage> selectRelationScoreId(String relationScoreId) {
		return wmScorePackageMapper.selectRelationScoreId(relationScoreId);
	}

	@Override
	public List<WmScorePackage> selectByReRelatedService(WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.selectByReRelatedService(wmScorePackage);
	}

	/**
	 * 查询关联积分包列表
	 *
	 * @param wmScorePackage
	 * @return
	 */
	@Override
	public R getRelationScoreList(WmScorePackage wmScorePackage) {
		long start = System.currentTimeMillis();
		SysDept relatedService = new SysDept();
		if (null != wmScorePackage.getRelatedService()) {
			relatedService = sysDeptMapper.selectById(wmScorePackage.getRelatedService());
		}
		//查询分配给当前用户机构的积分包，deptid为当前用户，而且typeid=1或2
		Integer deptId = SecurityUtils.getUser().getDeptId();
		Integer superDeptId = StrUtil.isNotBlank(wmScorePackage.getRelatedService()) ?
				Integer.valueOf(wmScorePackage.getRelatedService()) : null;
		List<WmScorePackage> packageList =
				this.getScorePackagekfpjf(superDeptId, deptId,
						new String[]{"0", "1", "2"}, StrUtil.isNotBlank(wmScorePackage.getId()) ?
								new String[]{wmScorePackage.getId()} : null);
		log.info("查询关联积分包值耗时:{}ms", System.currentTimeMillis() - start);

		Set<String> packageIdSet = packageList.stream().map(WmScorePackage::getId).collect(Collectors.toSet());
		List<WmScoreTaskType> allTaskTypelist =
				wmScoreTaskTypeMapper.getScoreTaskTypeByScoreId(CollUtil.join(packageIdSet, ","));
		Map<String, List<WmScoreTaskType>> scoreTaskTypeMap = allTaskTypelist.stream()
				.collect(Collectors.groupingBy(WmScoreTaskType::getScoreId));
		for (WmScorePackage wmScorePackage1 : packageList) {
//			List<WmScoreTaskType> taskTypelist = wmScoreTaskTypeMapper.getScoreTaskTypeByScoreId(wmScorePackage1.getId());
			List<WmScoreTaskType> taskTypelist = scoreTaskTypeMap.get(wmScorePackage1.getId());
			wmScorePackage1.setTaskTypeList1(taskTypelist);
			Set taskTypeSet = taskTypelist.stream().map(WmScoreTaskType::getTaskTypeId).collect(Collectors.toSet());
			wmScorePackage1.setTaskTypeSet(taskTypeSet);
		}

		//一个机构同时是一级cso和二级cso时，可以自己给自己发包
		if (null != relatedService.getLevel() && relatedService.getLevel() == 4) {
			List<SysDept> deptList = sysDeptMapper.getAllParentDept(relatedService);//所有的上级机构
			List<Integer> levels = deptList.stream().map(SysDept::getLevel).collect(Collectors.toList());
			if (levels.contains(2)) {
				relatedService.setLevel(3);
			}
		}

		if (relatedService.getDeptId() != null) {
			if (null != relatedService.getLevel() && relatedService.getLevel() != 4) {
				SysDept sysDept = sysDeptMapper.selectById(deptId);
				if (wmScorePackage.getRelatedService().equals(sysDept.getDeptId() + "")) {
					//if(sysDept.getDeptId().equals(wmScorePackage.getRelatedService())){
					WmScorePackage wmScorePackage1 = new WmScorePackage();
					wmScorePackage1.setId("-1");
					wmScorePackage1.setScorePackageName("无");
					packageList.add(wmScorePackage1);
				}
			}
		} else {
			WmScorePackage wmScorePackage1 = new WmScorePackage();
			wmScorePackage1.setId("-1");
			wmScorePackage1.setScorePackageName("无");
			packageList.add(wmScorePackage1);
		}

		// 获取积分包的试卷
		List<Integer> pkgIds = packageList.stream().map(pkg -> Integer.parseInt(pkg.getId())).collect(Collectors.toList());
		List<WmPkgQuizRelation> quizRelations = pkgQuizRelationService.listQuizRelationsByPkgIds(pkgIds);

		if (CollUtil.isNotEmpty(quizRelations)){
			Map<Integer, List<WmPkgQuizRelation>> map = quizRelations.stream().collect(Collectors.groupingBy(WmPkgQuizRelation::getPkgId));

			packageList.forEach(pkg -> {
				List<WmPkgQuizRelation> relations = map.get(Integer.parseInt(pkg.getId()));
				pkg.setQuizRelations(CollUtil.isNotEmpty(relations) ? relations : Collections.emptyList());
			});

		}


		log.info("查询关联积分包值+拼装参数总耗时:{}ms", System.currentTimeMillis() - start);

		return R.ok(packageList);
	}


	/**
	 * 查询积分规则ruleID
	 *
	 * @param wmDaDrugEnt
	 * @param wmDaAgent
	 * @return
	 */
	public String queryRuleID(WmDaDrugEnt wmDaDrugEnt, WmDaAgent wmDaAgent) {
		LambdaQueryWrapper<WmTaskType> queryWrapper1 = new LambdaQueryWrapper<>();
		queryWrapper1.eq(WmTaskType::getDelFlag, "0");
		queryWrapper1.eq(WmTaskType::getEnableFlag, "0");
		if (wmDaDrugEnt != null) {
			queryWrapper1.eq(WmTaskType::getDeptId, wmDaDrugEnt.getDeptId());
			queryWrapper1.eq(WmTaskType::getDurgentId, wmDaDrugEnt.getId());
		} else if (wmDaAgent != null) {
			queryWrapper1.eq(WmTaskType::getLevel1Id, wmDaAgent.getId());
			queryWrapper1.eq(WmTaskType::getDeptId, wmDaAgent.getDeptId());
			queryWrapper1.isNull(WmTaskType::getDurgentId);
		}
		List<WmTaskType> typeList = wmTaskTypeMapper.selectList(queryWrapper1);
		if (typeList != null && typeList.size() > 0) {
			List<String> sList = typeList.stream().map(WmTaskType::getRuleId).collect(Collectors.toList());
			if (sList != null && sList.size() > 0) {
				return sList.get(0);
			}
		}
		return null;
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public R addWmScorePackage(WmScorePackage wmScorePackage) {
		HnqzUser currentUser = SecurityUtils.getUser();
		//判断名字不能重复和积分包序列号不能重复
		if (StrUtil.isNotBlank(wmScorePackage.getScorePackageName())) {

			long existed = this.count(Wrappers.<WmScorePackage>lambdaQuery().eq(WmScorePackage::getDelFlag, "0").eq(WmScorePackage::getDeptId, currentUser.getDeptId().toString()).and(
					i -> i.eq(WmScorePackage::getScorePackageName, wmScorePackage.getScorePackageName()).or().eq(WmScorePackage::getPackageSn, wmScorePackage.getPackageSn())
			));
			if (existed != 0) {
				return R.failed("积分包名称或积分包序列号已存在");
			}

		}

		//
		// if (null != wmScorePackage.getScorePackageName() && !"".equals(wmScorePackage.getScorePackageName())) {
		// 	WmScorePackage wmScorePackage1 = new WmScorePackage();
		// 	wmScorePackage1.setDelFlag("0");
		// 	wmScorePackage1.setDeptId(currentUser.getDeptId() + "");
		// 	wmScorePackage1.setScorePackageName(wmScorePackage.getScorePackageName());
		// 	List<WmScorePackage> wmScorePackageList = this.list(Wrappers.<WmScorePackage>lambdaQuery(wmScorePackage1).or().eq(WmScorePackage::getPackageSn, wmScorePackage.getPackageSn()));
		// 	if (wmScorePackageList.size() > 0) {
		// 		return R.failed("积分包名称或积分包序列号已存在");
		// 	}
		// }
		if (wmScorePackage.getPackageType1().equals("1")) {//定额
			if (!StringUtil.isEmpty(wmScorePackage.getUserScore()) && wmScorePackage.getUserNum() > 0) {
				wmScorePackage.setScore(Integer.valueOf(wmScorePackage.getUserScore()) * wmScorePackage.getUserNum());
			}
		} else {
			if (!StringUtil.isEmpty(wmScorePackage.getUserScore())) {
				if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
					// 如果是患者教育，积分值转换为以'分'为单位保存
					int scoreFen = new BigDecimal(wmScorePackage.getUserScore()).multiply(new BigDecimal("100"))
							.intValue();
					wmScorePackage.setScore(scoreFen);
					wmScorePackage.setUserScore(String.valueOf(scoreFen));
				} else {
					wmScorePackage.setScore(Integer.valueOf(wmScorePackage.getUserScore()));
				}
			}
		}

		// 校验 满足以下任一条件，则可以发包
		// 1.存在积分充值配置，并且 发包积分 < 积分充值分配的积分
		// 2.关联了上级积分包
		boolean relatedScoreId = StrUtil.isNotBlank(wmScorePackage.getRelationScoreId()) && Integer.parseInt(wmScorePackage.getRelationScoreId()) > 0;
		SysDeptRecharge deptRecharge = null;
		LocalDateTime now = LocalDateTime.now();
		if (!relatedScoreId) {
			deptRecharge = sysDeptRechargeMapper.selectOne(Wrappers.<SysDeptRecharge>lambdaQuery()
					.eq(SysDeptRecharge::getDeptId, currentUser.getDeptId()));
			if (deptRecharge == null) {
				log.warn("未配置积分充值信息");
				throw new RuntimeException("积分余额：0。积分不足");
			}
			int limitScore = deptRecharge.getScore() + deptRecharge.getOverdrawScore();
			if (wmScorePackage.getScore() > limitScore) {
				log.warn("已分配积分不足，发包积分={}，剩余积分={}，透支额度={}",
						wmScorePackage.getScore(), deptRecharge.getScore(), limitScore);
				throw new RuntimeException(String.format("积分余额：%s。积分不足", deptRecharge.getScore()));
			}
		}

		WmScorePackage relationScorePackage = new WmScorePackage();//关联积分包
		//判断预积分包值不能大于可分配积分值
		if (!StringUtil.isEmpty(wmScorePackage.getRelationScoreId()) && !wmScorePackage.getRelationScoreId()
				.equals("-1")) {
//			WmScorePackage wmScorePackage1 = new WmScorePackage();
//			wmScorePackage1.setId(wmScorePackage.getRelationScoreId());
//			WmScorePackage wmScorePackage2 = wmScorePackageMapper.selectById(wmScorePackage1.getId());
			Integer kfpjf = 0;

			List<WmScorePackage> scorePackagekfpjf = this.getScorePackagekfpjf(null, null, new String[]{"0", "1", "2"},
					new String[]{wmScorePackage.getRelationScoreId()});

			if (CollUtil.isNotEmpty(scorePackagekfpjf)) {
				kfpjf = scorePackagekfpjf.get(0).getKfpjf();
//				kfpjf = wmScorePackage2.getKfpjf() == null ? 0 : wmScorePackage2.getKfpjf();
				if (kfpjf > 0 && wmScorePackage.getScore() > kfpjf) {
					return R.failed("预积分包值不能大于可分配积分值");
				}
				//更新可分配积分包值
				if (kfpjf >= wmScorePackage.getScore()) {
					relationScorePackage.setId(wmScorePackage.getRelationScoreId());
					relationScorePackage.setKfpjf(kfpjf - wmScorePackage.getScore());
				}
			}
//			List<WmScorePackage> packageList=wmScorePackageMapper.getScorePackagekfpjf(wmScorePackage1);
//			Integer kfpjf=0;
//			if(null!=packageList&&packageList.size()!=0){
//				kfpjf=packageList.get(0).getKfpjf();
//			}

		}

		//关联积分包为空时
		if (wmScorePackage.getRelationScoreId() == null || (wmScorePackage.getRelationScoreId() != null && wmScorePackage
				.getRelationScoreId()
				.equals("-1"))) {

			wmScorePackage.setRelationScoreId(null);
			SysDept dept = new SysDept();
			//关联积分包为空，需要判断是不是是不是药企
			if (wmScorePackage.getRelatedService() == null) {
				dept = sysDeptMapper.selectById(currentUser.getDeptId());
			} else {
				dept = sysDeptMapper.selectById(wmScorePackage.getRelatedService());
			}
			wmScorePackage.setSendPackageDeptId(currentUser.getDeptId() + "");
			wmScorePackage.setDeptId(currentUser.getDeptId() + "");
			if (dept == null) {
				return R.failed("未查询到当前登陆人的");
			} else {
				if (dept.getLevel() == 2) {//药企
					WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getOne(Wrappers.<WmDaDrugEnt>lambdaQuery()
							.eq(WmDaDrugEnt::getDeptId, dept.getDeptId()));
					wmScorePackage.setDrugEntId(wmDaDrugEnt.getId() + "");
					wmScorePackage.setRuleId(this.queryRuleID(wmDaDrugEnt, null));
				} else if (dept.getLevel() == 3 || dept.getLevel() == 4) {//一级cso
					WmDaAgent wmDaAgent = wmDaAgentService.getOne(Wrappers.<WmDaAgent>lambdaQuery()
							.eq(WmDaAgent::getDeptId, dept.getDeptId()));
					wmScorePackage.setRuleId(this.queryRuleID(null, wmDaAgent));

				}
			}
			wmScorePackage.setBelongDate(LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM")) + "");
		} else {
			WmScorePackage relationScore = this.getById(wmScorePackage.getRelationScoreId());
			if (relationScore == null) {
				return R.failed("未查询到关联积分包！");
			}
			wmScorePackage.setDrugEntId(relationScore.getDrugEntId());
			wmScorePackage.setRuleId(relationScore.getRuleId());
			wmScorePackage.setSendPackageDeptId(currentUser.getDeptId() + "");
			wmScorePackage.setDeptId(currentUser.getDeptId() + "");
			wmScorePackage.setBelongDate(relationScore.getBelongDate());
		}
		wmScorePackage.setDelFlag("0");
		wmScorePackage.setEnableFlag("0");
		wmScorePackage.setPackageFinishStatus("0");
		// 数据来源类型（0-手动上传，1-系统对接）
		wmScorePackage.setSourceType("0");

		if ("3".equals(wmScorePackage.getTypeid()) || "5".equals(wmScorePackage.getTypeid())) {
			// 全职学术推广员/招商经理角色的处理
			// 不允许接单
			wmScorePackage.setIsReceive("1");
			// 全职学术推广员不需要审核，所有状态直接是进行中
			wmScorePackage.setScorePackageStatus("3");
		} else if ("4".equals(wmScorePackage.getTypeid())) {
			// 兼职学术推广员的处理
			// 允许接单
			wmScorePackage.setIsReceive("0");
			// 已分派待申领
			wmScorePackage.setScorePackageStatus("1");//已分派待申领
		}
		if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
			// 患者教育，固定只能一人领取
			wmScorePackage.setUserNum(1);
		} else if (PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
			// 多人承接-按积分值
			wmScorePackage.setUserNum(9999);
		}
		wmScorePackage.setCreateUser(currentUser.getId());
		wmScorePackage.setCreateTime(LocalDateTime.now());
		boolean isAnswer = this.save(wmScorePackage);
		if (isAnswer) {

			//保存接单对象，全职学术推广员，允许选多个
			List<String> userList = wmScorePackage.getUserList();
			if (null != userList && userList.size() > 0) {
				List<WmScorePackageStatus> stuList = new ArrayList<>();
				for (String userId : userList) {
					WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
					wmScorePackageStatus.setUserId(userId);
					wmScorePackageStatus.setStatus("2");
					wmScorePackageStatus.setPackageId(wmScorePackage.getId());
					UserVO user = sysUserMapper.getUserVoById(Integer.valueOf(userId));
					wmScorePackageStatus.setDeptId(user.getDeptId() + "");
					if (wmScorePackage.getPackageType1().equals("1")) {//定额包
						wmScorePackageStatus.setUserScore(wmScorePackage.getScore() + "");
					} else {//定量包
						wmScorePackageStatus.setTaskNum(wmScorePackage.getTaskNum());
					}
					wmScorePackageStatus.setEnableFlag("0");
					wmScorePackageStatus.setDelFlag("0");
					wmScorePackageStatus.setCreateTime(LocalDateTime.now());
					wmScorePackageStatus.setCreateUser(currentUser.getId());
					stuList.add(wmScorePackageStatus);
				}
				wmScorePackageStatusService.saveBatch(stuList);
				wmScorePackage.setUserNum(userList.size());
				this.updateById(wmScorePackage);
			}
			//保存有效任务类型
			List<WmTaskTypeTree> tasktypeList = wmScorePackage.getTaskTypeList();

			if (null != tasktypeList && tasktypeList.size() > 0) {

				// 如果存在taskTypeId=39 则同时增加应收账款回款-A类、B类、C类任务类型（39/40/41）
				if (tasktypeList.stream().anyMatch(wmTaskTypeTree -> "39".equals(wmTaskTypeTree.getTaskTypeId()))) {
					WmTaskTypeTree addTaskTypeTree40 = new WmTaskTypeTree();
					addTaskTypeTree40.setTaskTypeId("40");
					addTaskTypeTree40.setTaskTypeName("应收账款回款-B类");
					WmTaskTypeTree addTaskTypeTree41 = new WmTaskTypeTree();
					addTaskTypeTree41.setTaskTypeId("41");
					addTaskTypeTree41.setTaskTypeName("应收账款回款-C类");
					tasktypeList.add(addTaskTypeTree40);
					tasktypeList.add(addTaskTypeTree41);
				}
				// 如果存在taskTypeId=42 则同时增加手术跟台-一级/手术跟台-二级/手术跟台-三级任务类型（42/43/44）
				if (tasktypeList.stream().anyMatch(wmTaskTypeTree -> "42".equals(wmTaskTypeTree.getTaskTypeId()))) {
					WmTaskTypeTree addTaskTypeTree43 = new WmTaskTypeTree();
					addTaskTypeTree43.setTaskTypeId("43");
					WmTaskTypeTree addTaskTypeTree44 = new WmTaskTypeTree();
					addTaskTypeTree44.setTaskTypeId("44");
					tasktypeList.add(addTaskTypeTree43);
					tasktypeList.add(addTaskTypeTree44);
				}
				// 如果存在taskTypeId=47 47,库存调研 48,竞品调研  49,培训 50,使用情况调查
				if (tasktypeList.stream().anyMatch(wmTaskTypeTree -> "47".equals(wmTaskTypeTree.getTaskTypeId()))) {
					WmTaskTypeTree addTaskTypeTree48 = new WmTaskTypeTree();
					addTaskTypeTree48.setTaskTypeId("48");
					WmTaskTypeTree addTaskTypeTree49 = new WmTaskTypeTree();
					addTaskTypeTree49.setTaskTypeId("49");
					WmTaskTypeTree addTaskTypeTree50 = new WmTaskTypeTree();
					addTaskTypeTree50.setTaskTypeId("50");
					tasktypeList.add(addTaskTypeTree48);
					tasktypeList.add(addTaskTypeTree49);
					tasktypeList.add(addTaskTypeTree50);
				}
				// 如果存在taskTypeId=51 51,信用管理A  52,信用管理B 53,信用管理C
//				if (tasktypeList.stream().anyMatch(wmTaskTypeTree -> "51".equals(wmTaskTypeTree.getTaskTypeId()))) {
//					WmTaskTypeTree addTaskTypeTree51 = new WmTaskTypeTree();
//					addTaskTypeTree51.setTaskTypeId("52");
//					WmTaskTypeTree addTaskTypeTree52 = new WmTaskTypeTree();
//					addTaskTypeTree52.setTaskTypeId("53");
//					tasktypeList.add(addTaskTypeTree51);
//					tasktypeList.add(addTaskTypeTree52);
//				}

				for (WmTaskTypeTree type : tasktypeList) {
					WmScoreTaskType wmScoreTaskType = new WmScoreTaskType();
					wmScoreTaskType.setScoreId(wmScorePackage.getId());
					wmScoreTaskType.setTaskTypeId(type.getTaskTypeId());
					wmScoreTaskType.setType(type.getType());
					wmScoreTaskTypeMapper.insert(wmScoreTaskType);
					if (null == type.getChildren()) {
						continue;
					}
					if (type.getChildren() != null || type.getChildren().size() > 0) {
						List<WmTaskTypeTree> childtasktypeList = type.getChildren();
						for (WmTaskTypeTree type1 : childtasktypeList) {
							WmScoreTaskType wmScoreTaskType1 = new WmScoreTaskType();
							wmScoreTaskType1.setScoreId(wmScorePackage.getId());
							wmScoreTaskType1.setType(type1.getType());
							wmScoreTaskType1.setTaskTypeId(type1.getTaskTypeId());
							wmScoreTaskTypeMapper.insert(wmScoreTaskType1);
						}
					}
				}
			} else {
				if (wmScorePackage.getPackageType1().equals(PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val())
						|| wmScorePackage.getPackageType1().equals(PackageTypeEnum.TYPE1_HCP_PACKAGE.val())
						|| wmScorePackage.getPackageType1().equals(PackageTypeEnum.TYPE1_SETTLE_PACKAGE.val())
						|| wmScorePackage.getPackageType2().equals(PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val())) {
					//结算包
					WmScoreTaskType wmScoreTaskType = new WmScoreTaskType();
					wmScoreTaskType.setScoreId(wmScorePackage.getId());
					wmScoreTaskType.setTaskTypeId(wmScorePackage.getTaskTypeId());
					wmScoreTaskType.setType("2");
					wmScoreTaskTypeMapper.insert(wmScoreTaskType);
				}
			}

			//更新关联积分包可分配积分值
			if (!StringUtil.isEmpty(relationScorePackage.getId())) {
				this.updateById(relationScorePackage);
			}
		}

		if (!relatedScoreId) {
			int currentScore = deptRecharge.getScore() - wmScorePackage.getScore();
			// 更新积分充值信息
			int updateRecharge = sysDeptRechargeMapper.update(null, Wrappers.<SysDeptRecharge>lambdaUpdate()
					.eq(SysDeptRecharge::getId, deptRecharge.getId())
					.eq(SysDeptRecharge::getVersion, deptRecharge.getVersion())
					.set(SysDeptRecharge::getScore, currentScore)
					.set(SysDeptRecharge::getVersion, deptRecharge.getVersion() + 1)
					.set(SysDeptRecharge::getUpdateTime, now)
					.set(SysDeptRecharge::getUpdateUser, currentUser.getId()));
			if (updateRecharge <= 0) {
				log.warn("更新积分充值信息失败");
				throw new RuntimeException("操作失败，请重试");
			}
			// 更新积分充值记录
			SysDeptRechargeRecord rechargeRecord = new SysDeptRechargeRecord();
			rechargeRecord.setDeptId(currentUser.getDeptId());
			rechargeRecord.setChangeScore(-wmScorePackage.getScore());
			rechargeRecord.setRechargeId(deptRecharge.getId());
			rechargeRecord.setPackageType(RechargeRecordPackageType.TO_PERSON);
			rechargeRecord.setPackageId(wmScorePackage.getId());
			rechargeRecord.setType(RechargeRecordType.SEND_PACKAGE_PERSONAL);
			rechargeRecord.setCurrentScore(currentScore);
			rechargeRecord.setCreateUser(currentUser.getId());
			rechargeRecord.setCreateTime(now);
			sysDeptRechargeRecordMapper.insert(rechargeRecord);
		}

		// 保存关联的试卷
		if (CollUtil.isNotEmpty(wmScorePackage.getQuizIds())) {
			pkgQuizRelationService.createPkgQuizzes(wmScorePackage.getQuizIds(), Integer.parseInt(wmScorePackage.getId()));
		}

		// 判断是否有关联关系
		if (CollUtil.isNotEmpty(wmScorePackage.getQuizRelationIds())) {
			pkgQuizRelationService.copyQuizRelations(wmScorePackage.getQuizRelationIds(), Integer.parseInt(wmScorePackage.getId()));
		}

		return R.ok(wmScorePackage.getId(), "新增成功");
	}

	/**
	 * 派工平台--分配积分 列表查询
	 *
	 * @param page
	 * @param wmScorePackage
	 * @return
	 */
	public R getScorePackagePage(Page page, WmScorePackage wmScorePackage) {

		OrderItem orderItem = new OrderItem();
		orderItem.setColumn("create_time");
		orderItem.setAsc(false);
		page.addOrder(orderItem);
		wmScorePackage.setSendPackageDeptId(SecurityUtils.getUser().getDeptId() + "");
		if (StringUtil.isEmpty(wmScorePackage.getTypeid())) {
			wmScorePackage.setTypeid("3,4,5");
		}
		IPage<WmScorePackage> pages = wmScorePackageMapper.getScorePackageList(page, wmScorePackage);
		List<WmScorePackage> records = pages.getRecords();

		List<String> reportWaitingCheckStatus = Arrays.asList("0", "1");


		for (WmScorePackage wmScorePackage1 : records) {

			List<WmScorePackageSettleNote> list = settleNoteMapper.selectList(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
					.eq(WmScorePackageSettleNote::getPackageId, wmScorePackage1.getId()));
			if (CollectionUtil.isNotEmpty(list)) {
				wmScorePackage1.setNotifyDate(list.get(0).getNotifyTime());
			}

			if ("2".equals(wmScorePackage.getPackageType2())) {
				WmScorePackageSettleNote wsquery = new WmScorePackageSettleNote();
				wsquery.setPackageId(wmScorePackage1.getId());
				int wsNum = settleNoteMapper.selectCount(Wrappers.query(wsquery)
						.lambda().in(WmScorePackageSettleNote::getSettleNoteStatus, 2, 9));
				WmScorePackageSettleNote asquery = new WmScorePackageSettleNote();
				asquery.setPackageId(wmScorePackage1.getId());
				asquery.setSettleNoteStatus(1);
				int asNum = settleNoteMapper.selectCount(Wrappers.query(asquery));
				wmScorePackage1.setWsTaskNum(wsNum);
				wmScorePackage1.setAsTaskNum(asNum);
			}
			if (PackageTypeEnum.TYPE1_HCP_PACKAGE.getName().equals(wmScorePackage1.getPackageType1())) {
				// 如果是患者教育，则转换积分值 '分'-> '元'
				Integer score = wmScorePackage1.getScore();
				String userScore = wmScorePackage1.getUserScore();
				if (StringUtils.isNumeric(userScore)) {
					wmScorePackage1.setUserScore(String.format("%.2f", Integer.parseInt(userScore) / 100.0));
				}
			}

			if (wmScorePackage1.getYshtt() != null && wmScorePackage1.getYshtt() > 100) {
				// if (wmScorePackage.getScore().equals(wmScorePackage.getShtg()) && !wmScorePackage.getScore().equals(wmScorePackage.getYsh()) ) {
				wmScorePackage1.setYsh(wmScorePackage1.getScore());
				// }
				wmScorePackage1.setYshtt(100);
			}
			if (wmScorePackage1.getShbtgtt() != null && wmScorePackage1.getShbtgtt() > 100) {
				wmScorePackage1.setShbtgtt(100);
			}
			if (wmScorePackage1.getShtgtt() != null && wmScorePackage1.getShtgtt() > 100) {
				wmScorePackage1.setShtgtt(100);
			}
			List<WmScoreTaskType> taskTypelist = wmScoreTaskTypeMapper.getScoreTaskTypeByScoreId(wmScorePackage1.getId());
			if (taskTypelist != null && taskTypelist.size() > 0) {
				String taskTypes = taskTypelist.stream().map(
						WmScoreTaskType::getTaskTypeName).collect(Collectors.joining(","));
				wmScorePackage1.setTaskTypes(taskTypes);
			}

			WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
			wmScorePackageStatus.setPackageId(wmScorePackage1.getId());
			wmScorePackageStatus.setStatus("2");
			wmScorePackage1.setUserListNum(0);
			List<WmScorePackageStatus> staList = wmScorePackageStatusService.getByPackageId(wmScorePackageStatus);
			if (staList != null && staList.size() > 0) {
				List<String> userList = staList.stream()
						.map(WmScorePackageStatus::getUserId)
						.collect(Collectors.toList());
				wmScorePackage1.setUserList(userList);
				wmScorePackage1.setUserListNum(userList.size());
			}
			wmScorePackageStatus.setStatus("1");
			wmScorePackage1.setYjddsh(wmScorePackageStatusService.count(Wrappers.query(wmScorePackageStatus)));

			// 设置中止状态
			WmScorePackage.PackageStopStatus stopStatus;

			if (wmScorePackage1.getRelationScoreId() == null) {
				stopStatus = WmScorePackage.PackageStopStatus.ALL_IN;
			} else {
				List<WmTask> tasks = wmTaskMapper.selectList(Wrappers.<WmTask>lambdaQuery()
						.eq(WmTask::getScorePackageId, String.valueOf(wmScorePackage1.getId())));

				//统计发包方还未审核的
				long drugNeedToCheckCount = tasks.stream()
						.filter(t -> "3".equals(t.getTaskStatus()) && "2".equals(t.getReportOneApprovalStatus()))
						.count();

				// 统计cso未审核 和审核通过的还未提交到药企的任务数
				long csoNeedToCheckCount = tasks.stream()
						.filter(t -> "2".equals(t.getTaskStatus()) ||
								("3".equals(t.getTaskStatus()) && reportWaitingCheckStatus.contains(t.getReportOneApprovalStatus())))
						.count();

				// 如果有发包方未审核的不能中止
				if (drugNeedToCheckCount != 0L) {
					stopStatus = WmScorePackage.PackageStopStatus.NOTHING;
				} else if (csoNeedToCheckCount != 0L) {
					// 如果有cso未审核的提示信息
					stopStatus = WmScorePackage.PackageStopStatus.REMAIN_MSG;
				} else {
					// 无提示信息
					stopStatus = WmScorePackage.PackageStopStatus.REMAIN;
				}
			}

			wmScorePackage1.setStopStatus(stopStatus);
		}
		return R.ok(pages);
	}


	/**
	 * 终止任务
	 *
	 * @param wmScorePackage
	 * @return
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public R updateEnable(WmScorePackage wmScorePackage) {
		String enableType = wmScorePackage.getEnableType();
		wmScorePackage = this.getById(wmScorePackage.getId());
		if (null == wmScorePackage) {
			return R.ok("未查询到积分包信息！");
		}
		wmScorePackage.setEnableType(enableType);
		wmScorePackage.setPackageStatus(wmScorePackage.getPackageStatus());
		WmTask wmTask = new WmTask();
		wmTask.setScorePackageId(wmScorePackage.getId());
		//wmTask.setRealFlag("0");
		List<WmTask> taskList = wmTaskMapper.selectList(Wrappers.query(wmTask));
		//将所有未接单审核的，改成审核不通过
		wmScorePackageStatusService.update(new WmScorePackageStatus(),
				Wrappers.<WmScorePackageStatus>lambdaUpdate()
						.eq(WmScorePackageStatus::getPackageId, wmScorePackage.getId())
						.eq(WmScorePackageStatus::getStatus, "1")
						.set(WmScorePackageStatus::getStatus, "3")
						.set(WmScorePackageStatus::getTaskAddFlag, "0")
		);
		//查询所有接单审核通过的
		LambdaQueryWrapper<WmScorePackageStatus> queryWrapper = new LambdaQueryWrapper();
		queryWrapper.eq(WmScorePackageStatus::getPackageId, wmScorePackage.getId());
		queryWrapper.eq(WmScorePackageStatus::getDelFlag, "0");
		queryWrapper.in(WmScorePackageStatus::getStatus, "2");
		List<WmScorePackageStatus> scorestatusList = wmScorePackageStatusService.list(queryWrapper);
		//全部终止，终止任务和积分包
		int recoveryScore = 0;
		if ("1".equals(enableType)) {
			wmScorePackage.setScorePackageStatus("6");//已终止
			//更新结单
			if (null != scorestatusList && scorestatusList.size() > 0) {
				wmScorePackageStatusService.update(new WmScorePackageStatus(),
						Wrappers.<WmScorePackageStatus>lambdaUpdate()
								.eq(WmScorePackageStatus::getPackageId, wmScorePackage.getId())
								.set(WmScorePackageStatus::getTaskAddFlag, "0")
								.set(WmScorePackageStatus::getEnableFlag, "1")
								.set(WmScorePackageStatus::getEnableType, "1")
				);
			}
			wmScorePackage.setEnableFlag("1");
			this.updateById(wmScorePackage);
			if (null != taskList && taskList.size() > 0) {
				wmTaskMapper.update(
						wmTask, Wrappers.<WmTask>lambdaUpdate()
								.eq(WmTask::getScorePackageId, wmScorePackage.getId())
								.set(WmTask::getEnableFlag, "1"));
			}
			if (wmScorePackage.getPackageType1().equals("1")) {
				updateRelationScore(wmScorePackage.getId(), wmScorePackage.getScore());
			}

		} else if ("2".equals(enableType)) {
			wmScorePackage.setScorePackageStatus("4");//已完成待结算
			//部分终止，收回剩余积分值，没有审核的任务继续审核
			//先更新任务状态为已审核
			int resSum = 0;//收回值
			boolean pickedButNotSubmitted = false;
			if (CollUtil.isNotEmpty(scorestatusList)) {
				wmScorePackage.setUserNum(scorestatusList.size());
				for (WmScorePackageStatus wmScorePackageStatus : scorestatusList) {
					WmTask wmTask1 = new WmTask();
					wmTask1.setEnableFlag("0");
					wmTask1.setScorePackageId(wmScorePackageStatus.getPackageId());
					wmTask1.setTaskUserId(wmScorePackageStatus.getUserId());
					wmTask1.setTaskStatus("1,2,3");
					List<WmTask> taskList1 = wmTaskMapper.selectByTask(wmTask1);
					Integer res = 0;
					boolean all = false;
					if (CollUtil.isEmpty(taskList1)) {
						if (wmScorePackage.getPackageType1().equals("1") || wmScorePackage.getPackageType1()
								.equals("5")) {//定额
							//这个用户还没有做任务时，积分值设为0
							int userScore = Integer.parseInt(wmScorePackageStatus.getUserScore());
							wmScorePackageStatus.setUserScore("0");
							// wmScorePackage.setScore(wmScorePackage.getScore() - Integer.parseInt(wmScorePackageStatus.getUserScore()));
							resSum += userScore;
							// 已终止
							wmScorePackage.setScorePackageStatus("6");
							pickedButNotSubmitted = true;
						} else {//2，3 定量
							//定量收回任务个数
							//定量收回任务个数
							wmScorePackageStatus.setTaskNum(0);
						}
						wmScorePackage.setPackageFinishStatus("1");//已完成

					} else {
						if (wmScorePackage.getPackageType1().equals("1") || wmScorePackage.getPackageType1()
								.equals("5")) {//定额
							int sum;
							if (wmScorePackage.getRelationScoreId() == null) {
								// 审核不通过的不计入
								sum = taskList1.stream()
										.filter(task1 -> !"4".equals(task1.getTaskStatus()))
										.mapToInt(WmTask::getScore)
										.sum();
								res = Integer.parseInt(wmScorePackageStatus.getUserScore()) - sum;
								if (res > 0) {//个人积分包值大于任务积分值
									wmScorePackageStatus.setUserScore(sum + "");
									resSum += res;
								}
							} else {
								int passed = taskList1.stream()
										.filter(task -> ReportEnum.APPROVAL_OPINION_YES.getType()
												.equals(task.getReportDrugApprovalOpinion()))
										.mapToInt(WmTask::getScore)
										.sum();
								if (passed == 0) {
									wmScorePackage.setScorePackageStatus("6");//已终止
									wmScorePackage.setEnableFlag("1");
									taskList1.forEach(task -> {
										task.setEnableFlag("1");
										if (StringUtils.equalsAny(task.getReportOneApprovalStatus(), "0", "1")) {
											task.setTaskStatus("4");
										}
										task.setReportDrugApprovalStatus(REPORT_STATUS_END.getType());
										task.setReportDrugApprovalOpinion(ReportEnum.APPROVAL_OPINION_NO.getType());
										wmTaskMapper.updateById(task);
									});
									all = true;
								}

								if (!all) {
									taskList1.forEach(task -> {
										if (StringUtils.equalsAny(task.getReportOneApprovalStatus(), "0", "1")) {
											task.setTaskStatus("4");
										}
										wmTaskMapper.updateById(task);
									});
								}

								res = sum = passed;
								if (res > 0) {//个人积分包值大于任务积分值
									wmScorePackageStatus.setUserScore(sum + "");
									resSum += (wmScorePackage.getScore() - res);
								} else {
									resSum = wmScorePackage.getScore();
								}
							}


						} else {//2，3 定量
							//定量收回任务个数
							wmScorePackageStatus.setTaskNum(taskList1.size());
						}

						List<String> statusList = taskList1.stream()
								.map(WmTask::getTaskStatus)
								.collect(Collectors.toList());
						if (statusList.contains("2")) {//有未审核通过的任务，积分包状态还是进行中
							wmScorePackage.setScorePackageStatus("3");//进行中
						} else {//没有未审核通过的任务，已完成
							wmScorePackage.setPackageFinishStatus("1");//已完成
						}

					}

					wmScorePackageStatus.setTaskAddFlag("0");
					if (all) {
						wmScorePackageStatus.setEnableType("1");
					} else {
						//更新接单数据
						wmScorePackageStatus.setEnableType("2");
					}
					wmScorePackageStatusService.updateById(wmScorePackageStatus);

				}
				//更新积分包的积分总值
				if (resSum > 0) {
					if (!pickedButNotSubmitted) {
						wmScorePackage.setScore(wmScorePackage.getScore() - resSum);
					}
					if (wmScorePackage.getPackageType1().equals("5")) {
						// 如果是患者教育，则需要更新下个人积分包值
						wmScorePackage.setUserScore(String.valueOf(Integer.parseInt(wmScorePackage.getUserScore()) - resSum));
					}
				}
			} else {//没有人接单审核通过
				//积分包
				wmScorePackage.setUserNum(0);
				wmScorePackage.setTaskNum(0);
				wmScorePackage.setPackageFinishStatus("1");//已完成
				wmScorePackage.setScorePackageStatus("4");//已完成待结算
				//积分包承接对象为0的时候，返回积分包积分且积分包状态改为已终止
				if (StringUtil.isNotEmpty(wmScorePackage.getRelationScoreId())) {
					resSum = wmScorePackage.getScore();
					wmScorePackage.setScorePackageStatus("6");//积分包已终止
				}
			}
			wmScorePackage.setIsReceive("1");//不允许接单
			wmScorePackage.setTaskAddFlag("0");//不允许新增任务
			this.updateById(wmScorePackage);
			if (resSum > 0 && wmScorePackage.getPackageType1().equals("1")) {
				updateRelationScore(wmScorePackage.getId(), resSum);
			}

			recoveryScore = resSum;
		}

		Integer userId = SecurityUtils.getUser().getId();
		Integer deptId = SecurityUtils.getUser().getDeptId();
		// 如果是通过积分充值的积分发的包，则回收积分
		SysDeptRechargeRecord rechargeRecord = sysDeptRechargeRecordMapper.selectOne(Wrappers.<SysDeptRechargeRecord>lambdaQuery()
				.eq(SysDeptRechargeRecord::getPackageId, wmScorePackage.getId())
				.in(SysDeptRechargeRecord::getType, RechargeRecordType.SEND_PACKAGE_DEPT, RechargeRecordType.SEND_PACKAGE_PERSONAL));
		if (rechargeRecord != null) {
			log.info("终止积分包，更新积分配置信息");
			SysDeptRecharge deptRecharge = sysDeptRechargeMapper.selectById(rechargeRecord.getRechargeId());
			int currentScore = deptRecharge.getScore() + recoveryScore;
			// 更新企业配置的积分信息
			int update = sysDeptRechargeMapper.update(null, Wrappers.<SysDeptRecharge>lambdaUpdate()
					.eq(SysDeptRecharge::getId, rechargeRecord.getRechargeId())
					.eq(SysDeptRecharge::getVersion, deptRecharge.getVersion())
					.set(SysDeptRecharge::getScore, currentScore)
					.set(SysDeptRecharge::getVersion, deptRecharge.getVersion() + 1)
					.set(SysDeptRecharge::getUpdateUser, userId)
					.set(SysDeptRecharge::getUpdateTime, LocalDateTime.now()));
			if (update <= 0) {
				throw new RuntimeException("更新失败");
			}
			// 新增积分记录
			SysDeptRechargeRecord newRechargeRecord = new SysDeptRechargeRecord();
			newRechargeRecord.setRechargeId(deptRecharge.getId());
			newRechargeRecord.setChangeScore(recoveryScore);
			newRechargeRecord.setCurrentScore(currentScore);
			newRechargeRecord.setType(RechargeRecordType.RECOVERY);
			newRechargeRecord.setDeptId(deptRecharge.getDeptId());
			newRechargeRecord.setRelationDeptId(rechargeRecord.getRelationDeptId());
			newRechargeRecord.setPackageId(wmScorePackage.getId());
			newRechargeRecord.setCreateUser(userId);
			sysDeptRechargeRecordMapper.insert(newRechargeRecord);
		} else {
			// 数据历史处理：如果是源头包，则回收积分包到积分充值余额
			boolean relatedScoreId = StrUtil.isNotBlank(wmScorePackage.getRelationScoreId()) && Integer.parseInt(wmScorePackage.getRelationScoreId()) > 0;
			if (!relatedScoreId) {
				log.info("终止积分包，更新积分配置信息（历史积分包处理）");
				SysDeptRecharge deptRecharge = sysDeptRechargeMapper.selectOne(Wrappers.<SysDeptRecharge>lambdaQuery()
						.eq(SysDeptRecharge::getDeptId, deptId));
				int currentScore = deptRecharge.getScore() + recoveryScore;
				// 更新企业配置的积分信息
				int update = sysDeptRechargeMapper.update(null, Wrappers.<SysDeptRecharge>lambdaUpdate()
						.eq(SysDeptRecharge::getId, deptRecharge.getId())
						.eq(SysDeptRecharge::getVersion, deptRecharge.getVersion())
						.set(SysDeptRecharge::getScore, currentScore)
						.set(SysDeptRecharge::getVersion, deptRecharge.getVersion() + 1)
						.set(SysDeptRecharge::getUpdateUser, userId)
						.set(SysDeptRecharge::getUpdateTime, LocalDateTime.now()));
				if (update <= 0) {
					throw new RuntimeException("更新失败");
				}
				// 新增积分记录
				SysDeptRechargeRecord newRechargeRecord = new SysDeptRechargeRecord();
				newRechargeRecord.setRechargeId(deptRecharge.getId());
				newRechargeRecord.setChangeScore(recoveryScore);
				newRechargeRecord.setCurrentScore(currentScore);
				newRechargeRecord.setType(RechargeRecordType.RECOVERY);
				newRechargeRecord.setDeptId(deptRecharge.getDeptId());
				newRechargeRecord.setPackageId(wmScorePackage.getId());
				newRechargeRecord.setCreateUser(userId);
				sysDeptRechargeRecordMapper.insert(newRechargeRecord);
			}

		}

		return R.ok("终止成功");
	}

	/**
	 * 更新关联积分包可分配积分
	 *
	 * @param Id
	 * @param score
	 */
	public void updateRelationScore(String Id, Integer score) {
		WmScorePackage wmScorePackage = wmScorePackageMapper.selectById(Id);
		if (wmScorePackage != null && wmScorePackage.getRelationScoreId() != null) {
			WmScorePackage relationScore = wmScorePackageMapper.selectById(wmScorePackage.getRelationScoreId());
			if (relationScore != null) {
				relationScore.setKfpjf(relationScore.getKfpjf() + score);
				wmScorePackageMapper.updateById(relationScore);
			}
		}

	}


	private WmScorePackage getRemainScore(String pkgId) {

		List<WmScorePackage> packages = this.list(Wrappers.<WmScorePackage>lambdaQuery().eq(WmScorePackage::getDelFlag, "0").eq(WmScorePackage::getEnableFlag, "0"));

		// List<WmScorePackage> allParentPkg = packages.stream().filter(p -> Objects.isNull(p.getRelationScoreId())).collect(Collectors.toList());

		Map<String, List<WmScorePackage>> relMap = packages.stream().filter(p -> Objects.nonNull(p.getRelationScoreId())).collect(Collectors.groupingBy(WmScorePackage::getRelationScoreId));

		packages.forEach(p -> {
			List<WmScorePackage> scorePackages = relMap.get(p.getId());
			int sum = 0;
			if (CollUtil.isNotEmpty(scorePackages)) {
				sum = scorePackages.stream().mapToInt(WmScorePackage::getScore).sum();
			}
			if (Objects.nonNull(p.getScore())) {
				p.setScore(p.getScore() - sum);
			}
		});

		return packages.stream().collect(Collectors.toMap(WmScorePackage::getId, Function.identity())).get(pkgId);
	}

	@Override
	public R<?> getScorePackagePageById(WmScorePackage wmScorePackage) {

		String pkgId = wmScorePackage.getId();
		wmScorePackage = getRemainScore(pkgId);

		if (StringUtil.isEmpty(wmScorePackage.getRelationScoreId())) {
			wmScorePackage.setRelationScoreId("-1");
		}
		//查询有效任务类型
		List<WmScoreTaskType> taskTypelist = wmScoreTaskTypeMapper.getScoreTaskTypeByScoreId(wmScorePackage.getId());
		wmScorePackage.setTaskTypeList1(taskTypelist);
		Set taskTypeSet = taskTypelist.stream().map(WmScoreTaskType::getTaskTypeId).collect(Collectors.toSet());
		wmScorePackage.setTaskTypeSet(taskTypeSet);
		wmScorePackage.setTaskTypeId(taskTypelist.get(0).getTaskTypeId());
		if (wmScorePackage.getTypeid().equals("3") || wmScorePackage.getTypeid().equals("5")) {
			//查询接单对象(3-全职,5-招商经理)
			List<WmScorePackageStatus> staList = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
					.eq(WmScorePackageStatus::getPackageId, wmScorePackage.getId())
					.eq(WmScorePackageStatus::getDelFlag, "0"));
			if (staList != null && staList.size() > 0) {
				List<String> userList = staList.stream()
						.map(WmScorePackageStatus::getUserId)
						.collect(Collectors.toList());
				wmScorePackage.setUserList(userList);
			}
		}
		if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
			// 如果是患者教育，则转换积分值 '分'-> '元'
			String userScore = wmScorePackage.getUserScore();
			if (StringUtils.isNumeric(userScore)) {
				wmScorePackage.setUserScore(String.format("%.2f", Integer.parseInt(userScore) / 100.0));
			}
		}

		// 查询关联的试卷
		List<WmPkgQuizRelation> quizRelations = pkgQuizRelationService.listQuizRelationsByPkgIds(Collections.singletonList(Integer.parseInt(pkgId)));

		if (CollUtil.isNotEmpty(quizRelations)){

			List<Integer> quizIds = quizRelations.stream().map(WmPkgQuizRelation::getQuizId).collect(Collectors.toList());
			List<Integer> relIds = quizRelations.stream().map(WmPkgQuizRelation::getRelationId).collect(Collectors.toList());
			wmScorePackage.setQuizIds(quizIds);
			wmScorePackage.setQuizRelationIds(relIds);

		}

		wmScorePackage.setQuizRelations(quizRelations);
		
		return R.ok(wmScorePackage);
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public R updateEasy(WmScorePackage wmScorePackage) {
		if (null != wmScorePackage.getDelFlag() && wmScorePackage.getDelFlag().equals("1")) {
			WmScorePackage relationScorePackage = new WmScorePackage();//关联积分包
			wmScorePackage = wmScorePackageMapper.selectById(wmScorePackage.getId());
			wmScorePackage.setDelFlag("1");

			if (wmScorePackage.getPackageType1().equals("1")) {//定额
				if (!StringUtil.isEmpty(wmScorePackage.getRelationScoreId())) {
					relationScorePackage = this.getById(wmScorePackage.getRelationScoreId());
					relationScorePackage.setKfpjf(relationScorePackage.getKfpjf() + wmScorePackage.getScore());
					this.updateById(relationScorePackage);
				}
			}
			wmScorePackageStatusService.delStatusByPackageId(wmScorePackage.getId());
			wmScoreTaskTypeMapper.delete(Wrappers.<WmScoreTaskType>lambdaQuery()
					.eq(WmScoreTaskType::getScoreId, wmScorePackage.getId()));

		}
		this.updateById(wmScorePackage);
		return R.ok();
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public R updateWmScorePackage(WmScorePackage wmScorePackage) {

		if (wmScorePackage.getPackageType1().equals("1")) {//定额
			if (!StringUtil.isEmpty(wmScorePackage.getUserScore()) && wmScorePackage.getUserNum() > 0) {
				wmScorePackage.setScore(Integer.valueOf(wmScorePackage.getUserScore()) * wmScorePackage.getUserNum());
			}
		} else {
			if (!StringUtil.isEmpty(wmScorePackage.getUserScore())) {
				if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
					// 如果是患者教育，积分值转换为以'分'为单位保存
					int scoreFen = new BigDecimal(wmScorePackage.getUserScore()).multiply(new BigDecimal("100"))
							.intValue();
					wmScorePackage.setScore(scoreFen);
					wmScorePackage.setUserScore(String.valueOf(scoreFen));
				} else {
					wmScorePackage.setScore(Integer.valueOf(wmScorePackage.getUserScore()));
				}
			}
		}
		WmScorePackage relationScorePackage = new WmScorePackage();//关联积分包
		//判断预积分包值不能大于可分配积分值
		if (!StringUtil.isEmpty(wmScorePackage.getRelationScoreId()) && !wmScorePackage.getRelationScoreId()
				.equals("-1")) {
			WmScorePackage wmScorePackage1 = new WmScorePackage();
			wmScorePackage1.setId(wmScorePackage.getRelationScoreId());
			WmScorePackage wmScorePackage2 = wmScorePackageMapper.selectById(wmScorePackage1.getId());
			Integer kfpjf = 0;
			if (wmScorePackage2 != null) {
				kfpjf += wmScorePackage2.getKfpjf() == null ? 0 : wmScorePackage2.getKfpjf();
				WmScorePackage wmScorePackageOld = wmScorePackageMapper.selectById(wmScorePackage.getId());
				kfpjf += wmScorePackageOld.getScore();
				if (kfpjf > 0 && wmScorePackage.getScore() > kfpjf) {
					return R.failed("预积分包值不能大于可分配积分值");
				}
				//更新可分配积分包值
				if (kfpjf >= wmScorePackage.getScore()) {
					relationScorePackage.setId(wmScorePackage.getRelationScoreId());
					relationScorePackage.setKfpjf(kfpjf - wmScorePackage.getScore());
				}

			}
			//List<WmScorePackage> packageList=wmScorePackageMapper.getScorePackagekfpjf(wmScorePackage1);
			//Integer kfpjf=0;
//			if(null!=packageList&&packageList.size()!=0){
//				kfpjf=packageList.get(0).getKfpjf();
//			}

		}
		HnqzUser currentUser = SecurityUtils.getUser();
		if (wmScorePackage.getRelationScoreId() == null || (wmScorePackage.getRelationScoreId() != null && wmScorePackage
				.getRelationScoreId()
				.equals("-1"))) {

			wmScorePackage.setRelationScoreId(null);
			SysDept dept = new SysDept();
			//关联积分包为空，需要判断是不是是不是药企
			if (wmScorePackage.getRelatedService() == null) {
				dept = sysDeptMapper.selectById(currentUser.getDeptId());
			} else {
				dept = sysDeptMapper.selectById(wmScorePackage.getRelatedService());
			}
			wmScorePackage.setSendPackageDeptId(currentUser.getDeptId() + "");
			wmScorePackage.setDeptId(currentUser.getDeptId() + "");
			if (dept.getDeptId() == null) {
				return R.failed("未查询到当前登陆人的");
			} else {
				if (dept.getLevel() == 2) {//药企
					WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getOne(Wrappers.<WmDaDrugEnt>lambdaQuery()
							.eq(WmDaDrugEnt::getDeptId, dept.getDeptId()));
					wmScorePackage.setDrugEntId(wmDaDrugEnt.getId() + "");
					wmScorePackage.setRuleId(this.queryRuleID(wmDaDrugEnt, null));
				} else if (dept.getLevel() == 3 || dept.getLevel() == 4) {//一级cso
					WmDaAgent wmDaAgent = wmDaAgentService.getOne(Wrappers.<WmDaAgent>lambdaQuery()
							.eq(WmDaAgent::getDeptId, dept.getDeptId()));
					wmScorePackage.setRuleId(this.queryRuleID(null, wmDaAgent));

				}
			}

			wmScorePackage.setBelongDate(LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM")) + "");
		} else {
			WmScorePackage relationScore = this.getById(wmScorePackage.getRelationScoreId());
			if (relationScore == null) {
				return R.failed("未查询到关联积分包！");
			}
			wmScorePackage.setDrugEntId(relationScore.getDrugEntId());
			wmScorePackage.setRuleId(relationScore.getRuleId());
			wmScorePackage.setSendPackageDeptId(currentUser.getDeptId() + "");
			wmScorePackage.setDeptId(currentUser.getDeptId() + "");
			wmScorePackage.setBelongDate(relationScore.getBelongDate());
		}

		//保存接单对象，全职学术推广员，允许选多个
		wmScorePackageStatusService.delStatusByPackageId(wmScorePackage.getId());
		if (wmScorePackage.getTypeid().equals("3") || wmScorePackage.getTypeid().equals("5")) {
			List<String> userList = wmScorePackage.getUserList();
			if (null != userList && userList.size() > 0) {
				List<WmScorePackageStatus> stuList = new ArrayList<>();
				for (String userId : userList) {
					WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
					wmScorePackageStatus.setUserId(userId);
					wmScorePackageStatus.setStatus("2");
					wmScorePackageStatus.setPackageId(wmScorePackage.getId());
					UserVO user = sysUserMapper.getUserVoById(Integer.valueOf(userId));
					wmScorePackageStatus.setDeptId(user.getDeptId() + "");
					if (wmScorePackage.getPackageType1().equals("1")) {//定额包
						wmScorePackageStatus.setUserScore(wmScorePackage.getScore() + "");
					} else {//定量包
						wmScorePackageStatus.setTaskNum(wmScorePackage.getTaskNum());
					}
					wmScorePackageStatus.setEnableFlag("0");
					wmScorePackageStatus.setDelFlag("0");
					wmScorePackageStatus.setCreateTime(LocalDateTime.now());
					wmScorePackageStatus.setCreateUser(currentUser.getId());
					stuList.add(wmScorePackageStatus);
				}
				wmScorePackageStatusService.saveBatch(stuList);
				wmScorePackage.setUserNum(userList.size());
			}
		} else {
			if (wmScorePackage.getUserNum() == null) {
				wmScorePackage.setUserNum(1);
			}
		}


		if (wmScorePackage.getPackageType1().equals("5") || wmScorePackage.getPackageType1().equals("4")
				|| wmScorePackage.getPackageType2().equals("2")) {
			wmScoreTaskTypeMapper.delete(Wrappers.<WmScoreTaskType>lambdaQuery()
					.eq(WmScoreTaskType::getScoreId, wmScorePackage.getId()));
			//结算包
			WmScoreTaskType wmScoreTaskType = new WmScoreTaskType();
			wmScoreTaskType.setScoreId(wmScorePackage.getId());
			wmScoreTaskType.setTaskTypeId(wmScorePackage.getTaskTypeId());
			wmScoreTaskType.setType("2");
			wmScoreTaskTypeMapper.insert(wmScoreTaskType);
		} else {
			//保存有效任务类型
			List<WmTaskTypeTree> tasktypeList = wmScorePackage.getTaskTypeList();
			if (tasktypeList != null && tasktypeList.size() > 0) {
				wmScoreTaskTypeMapper.delete(Wrappers.<WmScoreTaskType>lambdaQuery()
						.eq(WmScoreTaskType::getScoreId, wmScorePackage.getId()));

				// 如果存在taskTypeId=39 则同时增加应收账款回款-A类、B类、C类任务类型（39/40/41）
				if (wmScorePackage.getTaskTypeList().stream().anyMatch(wmTaskTypeTree -> "39".equals(wmTaskTypeTree.getTaskTypeId()))) {
					WmTaskTypeTree addTaskTypeTree40 = new WmTaskTypeTree();
					addTaskTypeTree40.setTaskTypeId("40");
					addTaskTypeTree40.setTaskTypeName("应收账款回款-B类");
					WmTaskTypeTree addTaskTypeTree41 = new WmTaskTypeTree();
					addTaskTypeTree41.setTaskTypeId("41");
					addTaskTypeTree41.setTaskTypeName("应收账款回款-C类");
					wmScorePackage.getTaskTypeList().add(addTaskTypeTree40);
					wmScorePackage.getTaskTypeList().add(addTaskTypeTree41);
				}
				// 如果存在taskTypeId=42 则同时增加手术跟台-一级/手术跟台-二级/手术跟台-三级任务类型（42/43/44）
				if (wmScorePackage.getTaskTypeList().stream().anyMatch(wmTaskTypeTree -> "42".equals(wmTaskTypeTree.getTaskTypeId()))) {
					WmTaskTypeTree addTaskTypeTree43 = new WmTaskTypeTree();
					addTaskTypeTree43.setTaskTypeId("43");
					WmTaskTypeTree addTaskTypeTree44 = new WmTaskTypeTree();
					addTaskTypeTree44.setTaskTypeId("44");
					wmScorePackage.getTaskTypeList().add(addTaskTypeTree43);
					wmScorePackage.getTaskTypeList().add(addTaskTypeTree44);
				}
				// 如果存在taskTypeId=47 47,库存调研 48,竞品调研  49,培训 50,使用情况调查
				if (tasktypeList.stream().anyMatch(wmTaskTypeTree -> "47".equals(wmTaskTypeTree.getTaskTypeId()))) {
					WmTaskTypeTree addTaskTypeTree48 = new WmTaskTypeTree();
					addTaskTypeTree48.setTaskTypeId("48");
					WmTaskTypeTree addTaskTypeTree49 = new WmTaskTypeTree();
					addTaskTypeTree49.setTaskTypeId("49");
					WmTaskTypeTree addTaskTypeTree50 = new WmTaskTypeTree();
					addTaskTypeTree50.setTaskTypeId("50");
					tasktypeList.add(addTaskTypeTree48);
					tasktypeList.add(addTaskTypeTree49);
					tasktypeList.add(addTaskTypeTree50);
				}
				// 如果存在taskTypeId=51 51,信用管理A  52,信用管理B 53,信用管理C
//				if (tasktypeList.stream().anyMatch(wmTaskTypeTree -> "51".equals(wmTaskTypeTree.getTaskTypeId()))) {
//					WmTaskTypeTree addTaskTypeTree51 = new WmTaskTypeTree();
//					addTaskTypeTree51.setTaskTypeId("52");
//					WmTaskTypeTree addTaskTypeTree52 = new WmTaskTypeTree();
//					addTaskTypeTree52.setTaskTypeId("53");
//					tasktypeList.add(addTaskTypeTree51);
//					tasktypeList.add(addTaskTypeTree52);
//				}

				for (WmTaskTypeTree type : tasktypeList) {
					WmScoreTaskType wmScoreTaskType = new WmScoreTaskType();
					wmScoreTaskType.setScoreId(wmScorePackage.getId());
					wmScoreTaskType.setType(type.getType());
					wmScoreTaskType.setTaskTypeId(type.getTaskTypeId());
					wmScoreTaskTypeMapper.insert(wmScoreTaskType);
					if (null == type.getChildren()) {
						continue;
					}
					List<WmTaskTypeTree> childtasktypeList = type.getChildren();
					for (WmTaskTypeTree type1 : childtasktypeList) {
						WmScoreTaskType wmScoreTaskType1 = new WmScoreTaskType();
						wmScoreTaskType1.setScoreId(wmScorePackage.getId());
						wmScoreTaskType1.setType(type1.getType());
						wmScoreTaskType1.setTaskTypeId(type1.getTaskTypeId());
						wmScoreTaskTypeMapper.insert(wmScoreTaskType1);
					}


				}
			}
		}
		if (wmScorePackage.getTypeid() != null && wmScorePackage.getTypeid().equals("4")) {//兼职学术推广员
			wmScorePackage.setXxdbId(null);
		}
		if ("3".equals(wmScorePackage.getTypeid()) || "5".equals(wmScorePackage.getTypeid())) {//全职学术推广员
			wmScorePackage.setIsReceive("1");//不允许接单
			wmScorePackage.setScorePackageStatus("3");//全职学术推广员不需要审核，所有状态直接是进行中

		} else if ("4".equals(wmScorePackage.getTypeid())) {
			wmScorePackage.setIsReceive("0");//允许接单
			wmScorePackage.setScorePackageStatus("1");//已分派待申领
		}
		if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
			// 患者教育，固定只能一人领取
			wmScorePackage.setUserNum(1);
		}
		// 数据来源类型（0-手动上传，1-系统对接）
		wmScorePackage.setSourceType("0");
		wmScorePackage.setUpdateTime(LocalDateTime.now());
		wmScorePackage.setUpdateUser(SecurityUtils.getUser().getId());

		// 查询原积分包值
		int oldPackageScore = this.getById(wmScorePackage.getId()).getScore();

		this.updateById(wmScorePackage);
		if (wmScorePackage.getRelationScoreId() == null) {
			this.update(Wrappers.<WmScorePackage>lambdaUpdate()
					.eq(WmScorePackage::getId, wmScorePackage.getId())
					.set(WmScorePackage::getRelationScoreId, null));
		}

		//更新关联积分包可分配积分值
		if (!StringUtil.isEmpty(relationScorePackage.getId())) {
			this.updateById(relationScorePackage);
		}

		// 如果是通过积分充值的积分发的包，则回收积分
		SysDeptRechargeRecord rechargeRecord = sysDeptRechargeRecordMapper.selectOne(Wrappers.<SysDeptRechargeRecord>lambdaQuery()
				.eq(SysDeptRechargeRecord::getPackageId, wmScorePackage.getId())
				.in(SysDeptRechargeRecord::getType, RechargeRecordType.SEND_PACKAGE_DEPT, RechargeRecordType.SEND_PACKAGE_PERSONAL));

		boolean relatedScoreId = StrUtil.isNotBlank(wmScorePackage.getRelationScoreId()) && Integer.parseInt(wmScorePackage.getRelationScoreId()) > 0;

		// 积分值相比修改前的变动（相对于积分余额，增加则为负-消耗，减少则为正-回收）
		int changeScore = oldPackageScore - wmScorePackage.getScore();

		if (!relatedScoreId) {
			// 没有关联上级积分包的情况
			log.info("修改积分包，更新积分配置信息");
			Integer userId = SecurityUtils.getUser().getId();
			Integer deptId = SecurityUtils.getUser().getDeptId();
			SysDeptRecharge deptRecharge = sysDeptRechargeMapper.selectOne(Wrappers.<SysDeptRecharge>lambdaQuery()
					.eq(SysDeptRecharge::getDeptId, deptId));
			if (deptRecharge == null) {
				log.warn("未配置积分充值信息");
				throw new RuntimeException("积分余额：0。积分不足");
			}

			int currentScore = deptRecharge.getScore() + changeScore;

			int limitScore = deptRecharge.getScore() + deptRecharge.getOverdrawScore();
			if (changeScore < 0 && Math.abs(changeScore) > limitScore) {
				log.warn("已分配积分不足，修改积分={}，剩余积分={}，透支额度={}",
						changeScore, deptRecharge.getScore(), deptRecharge.getOverdrawScore());
				throw new RuntimeException(String.format("积分余额：%s。积分不足", deptRecharge.getScore()));
			}


			// 更新企业配置的积分信息
			int update = sysDeptRechargeMapper.update(null, Wrappers.<SysDeptRecharge>lambdaUpdate()
					.eq(SysDeptRecharge::getId, deptRecharge.getId())
					.eq(SysDeptRecharge::getVersion, deptRecharge.getVersion())
					.set(SysDeptRecharge::getScore, currentScore)
					.set(SysDeptRecharge::getVersion, deptRecharge.getVersion() + 1)
					.set(SysDeptRecharge::getUpdateUser, userId)
					.set(SysDeptRecharge::getUpdateTime, LocalDateTime.now()));
			if (update <= 0) {
				log.warn("更新小包积分充值信息失败");
				throw new RuntimeException("更新失败");
			}
			// 新增积分记录
			SysDeptRechargeRecord newRechargeRecord = new SysDeptRechargeRecord();
			newRechargeRecord.setRechargeId(deptRecharge.getId());
			newRechargeRecord.setChangeScore(changeScore);
			newRechargeRecord.setCurrentScore(currentScore);
			newRechargeRecord.setType(RechargeRecordType.RECOVERY);
			newRechargeRecord.setDeptId(deptRecharge.getDeptId());
			newRechargeRecord.setRelationDeptId(rechargeRecord != null ? rechargeRecord.getRelationDeptId() : null);
			newRechargeRecord.setPackageType(RechargeRecordPackageType.TO_PERSON);
			newRechargeRecord.setPackageId(wmScorePackage.getId());
			newRechargeRecord.setCreateUser(userId);
			sysDeptRechargeRecordMapper.insert(newRechargeRecord);
		} else {
			if (changeScore < 0) {
				// 变动积分值为增加,则校验上级可分配积分值
				List<WmScorePackage> scorePackagekfpjf = this.getScorePackagekfpjf(null, null, new String[]{"0", "1", "2"},
						new String[]{wmScorePackage.getRelationScoreId()});

				if (CollUtil.isNotEmpty(scorePackagekfpjf)) {
					int kfpjf = scorePackagekfpjf.get(0).getKfpjf();
					if (Math.abs(changeScore) > kfpjf) {
						throw new RuntimeException("可分配积分值不足");
					}
				}
			}
		}

		return R.ok();
	}

	@Override
	public WmScorePackage selectRelationScoreIdList(WmScorePackage wmScorePackage) {
		WmScorePackage wmScorePackage1 = this.getById(wmScorePackage.getRelationScoreId());
		return wmScorePackage1;
	}

	@Override
	public List<WmScorePackage> listWmScorePackages(WmScorePackage wmScorePackage1) {
		return wmScorePackageMapper.listWmScorePackages(wmScorePackage1);
	}

	@Override
	public IPage<WmScorePackageApiOutput> getPackageListForReceive(Page page, WmScorePackage wmScorePackage) {
		return wmScorePackageMapper.getPackageListForReceive(page, wmScorePackage);
	}

	/**
	 * 积分包结算列表（分页）
	 *
	 * @param page  分页信息
	 * @param input 分页条件
	 * @return 分页结果
	 */
	@Override
	public Page<WmScorePackageSettleOutput> listPackageSettleList(Page<WmScorePackageSettleOutput> page, WmScorePackageSettleInput input) {
		Page<WmScorePackageSettleOutput> settleListPage;

		if (StrUtil.isNotBlank(input.getUserNames())) {
			settleListPage = wmScorePackageMapper.listPackageSettleList2(page, input);
		} else {
			settleListPage = wmScorePackageMapper.listPackageSettleList(page, input);
		}

		List<WmScorePackageSettleOutput> settleList = settleListPage.getRecords();
		for (WmScorePackageSettleOutput ouPut : settleList) {
			WmScorePackageStatus statusQuery = new WmScorePackageStatus();
			statusQuery.setPackageId(ouPut.getId());
			statusQuery.setStatus("2");
			List<WmScorePackageStatus> statusList = wmScorePackageStatusService.getByPackageId(statusQuery);
			String userNames = statusList.stream()
					.map(WmScorePackageStatus::getUserId)
					.collect(Collectors.joining(","));
			ouPut.setUserNames(userNames);

			Set<String> userIds = statusList.stream().map(WmScorePackageStatus::getTaskUserId).collect(Collectors.toSet());
			if (CollUtil.isNotEmpty(userIds)) {
				List<SysUser> users = sysUserMapper.selectList(Wrappers.<SysUser>lambdaQuery().in(SysUser::getUserId, userIds));
				String userPhones = users.stream().map(SysUser::getUsername).collect(Collectors.joining(","));
				ouPut.setUserPhones(userPhones);
				// 脱敏的身份证号
				String idCardNums = users.stream().map(user -> DesensitizedUtil.idCardNum(user.getIdCardNumber(), 5, 4)).collect(Collectors.joining(","));
				ouPut.setIdCardNums(idCardNums);
			}
			// 查询结算成功时间
			List<WmScorePackageSettleNote> packageSettleNoteList = settleNoteMapper.selectList(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
					.eq(WmScorePackageSettleNote::getPackageId, ouPut.getId()));
			if (CollectionUtil.isNotEmpty(packageSettleNoteList)) {
				WmScorePackageSettleNote settleNote = packageSettleNoteList.get(0);
				LocalDateTime notifyTime = settleNote.getNotifyTime();
				if (notifyTime != null) {
					ouPut.setBelongDate(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss").format(notifyTime));
				}
				if (ouPut.getInvoiceCategory() == null) {
					ouPut.setInvoiceCategory(settleNote.getInvoiceType());
				}

				if (ouPut.getSettleAmount() == null) {
					BigDecimal tmp = new BigDecimal("0");
					for (WmScorePackageSettleNote note : packageSettleNoteList) {
						if (null != note.getSettleAmount()) {
							tmp = tmp.add(note.getSettleAmount());
						}
					}
					ouPut.setSettleAmount(tmp);
				}
				if (StringUtils.isBlank(ouPut.getSettleStatus())) {
					ouPut.setSettleStatus(String.valueOf(settleNote.getSettleNoteStatus()));
				}
				ouPut.setSubjectLocation(settleNote.getSubjectLocation());
				ouPut.setSubToGigTime(settleNote.getSubToGigTime());
				ouPut.setActualAmount(settleNote.getActualAmount());
			}
			if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(ouPut.getPackageType1())) {
				// 如果是患者教育，则转换积分值 '分'->'元'
				WmScorePackage scorePackage = this.getById(ouPut.getId());
				if (scorePackage != null && StringUtils.isNumeric(scorePackage.getUserScore())) {
					ouPut.setScore(String.format("%.2f", Integer.parseInt(scorePackage.getUserScore()) / 100.0));
				}
			}
		}
		return settleListPage;
	}

	/**
	 * 积分包结算列表
	 *
	 * @param input
	 * @return
	 */
	@Override
	public List<WmScorePackageSettleOutput> listAllPackageSettle(WmScorePackageSettleInput input) {
		List<WmScorePackageSettleOutput> settleList = null;
		if (StrUtil.isNotBlank(input.getUserNames())) {
			settleList = wmScorePackageMapper.listAllPackageSettle2(input);
		} else {
			settleList = wmScorePackageMapper.listAllPackageSettle(input);
		}
		for (WmScorePackageSettleOutput ouPut : settleList) {
			WmScorePackageStatus statusQuery = new WmScorePackageStatus();
			statusQuery.setPackageId(ouPut.getId());
			statusQuery.setStatus("2");
			List<WmScorePackageStatus> statusList = wmScorePackageStatusService.getByPackageId(statusQuery);
			String userNames = statusList.stream()
					.map(WmScorePackageStatus::getUserId)
					.collect(Collectors.joining(","));
			ouPut.setUserNames(userNames);
			// 查询结算成功时间
			List<WmScorePackageSettleNote> packageSettleNoteList = settleNoteMapper.selectList(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
					.eq(WmScorePackageSettleNote::getPackageId, ouPut.getId()));
			if (CollectionUtil.isNotEmpty(packageSettleNoteList)) {
				WmScorePackageSettleNote settleNote = packageSettleNoteList.get(0);
				LocalDateTime notifyTime = settleNote.getNotifyTime();
				if (notifyTime != null) {
					ouPut.setBelongDate(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss").format(notifyTime));
				}
				if (ouPut.getInvoiceCategory() == null) {
					ouPut.setInvoiceCategory(settleNote.getInvoiceType());
				}
				if (ouPut.getSettleAmount() == null) {
					BigDecimal tmp = new BigDecimal("0");
					for (WmScorePackageSettleNote note : packageSettleNoteList) {
						if (null != note.getSettleAmount()) {
							tmp = tmp.add(note.getSettleAmount());
						}
					}
					ouPut.setSettleAmount(tmp);
				}

				// 实际结算金额
				BigDecimal acAmtTmp = BigDecimal.ZERO;
				for (WmScorePackageSettleNote note : packageSettleNoteList) {
					if (null != note.getActualAmount()) {
						acAmtTmp = acAmtTmp.add(note.getActualAmount());
					}
				}
				ouPut.setActualAmount(acAmtTmp.compareTo(BigDecimal.ZERO) == 0 ? null : acAmtTmp);

				if (StringUtils.isBlank(ouPut.getSettleStatus())) {
					ouPut.setSettleStatus(String.valueOf(settleNote.getSettleNoteStatus()));
				}
			}
			if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(ouPut.getPackageType1())) {
				// 如果是患者教育，则转换积分值 '分'->'元'
				WmScorePackage scorePackage = this.getById(ouPut.getId());
				if (scorePackage != null && StringUtils.isNumeric(scorePackage.getUserScore())) {
					ouPut.setScore(String.format("%.2f", Integer.parseInt(scorePackage.getUserScore()) / 100.0));
				}
			}
		}
		return settleList;
	}

	/**
	 * 获取当前部门的基于所有积分包的相关信息
	 *
	 * @return 积分包的相关信息
	 */
	@Override
	public Map<String, Object> getDeptScorePackageInfo(Integer deptId) {
		Map<String, Object> result = new HashMap<>();
		Wrapper<WmScorePackage> wrapper = Wrappers.<WmScorePackage>lambdaQuery()
				.eq(WmScorePackage::getDeptId, deptId)
				.eq(WmScorePackage::getPackageType1, PackageTypeEnum.TYPE1_HCP_PACKAGE.val())
				.eq(WmScorePackage::getPackageType2, PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val())
				.eq(WmScorePackage::getDelFlag, DelEnum.NOT_DEL.val())
				.eq(WmScorePackage::getEnableFlag, EnableEnum.ENABLE.val())
				.eq(WmScorePackage::getSourceType, "1")
				.eq(WmScorePackage::getTypeid, 4);
		List<WmScorePackage> scorePackageList = this.list(wrapper);
		if (CollectionUtil.isNotEmpty(scorePackageList)) {
			// 计算已分配的总积分值
			long totalScore = scorePackageList.stream()
					.filter(wmScorePackage -> StringUtils.isNumeric(wmScorePackage.getUserScore()))
					.mapToLong(value -> Integer.parseInt(value.getUserScore()))
					.sum();
			// 计算已结算的总积分值
			List<Integer> idList = scorePackageList.stream()
					.mapToInt(s -> Integer.parseInt(s.getId()))
					.boxed()
					.collect(Collectors.toList());
			List<WmScorePackageSettleNote> noteList = settleNoteMapper.selectList(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
					.in(WmScorePackageSettleNote::getPackageId, idList)
					.eq(WmScorePackageSettleNote::getSettleNoteStatus, "1"));

			BigDecimal totalSettledScore = new BigDecimal("0");
			if (CollectionUtil.isNotEmpty(noteList)) {
				for (WmScorePackageSettleNote note : noteList) {
					totalSettledScore = totalSettledScore.add(note.getSettleAmount());
				}
			}
			result.put("totalScore", String.format("%.2f", totalScore / 100.0));
			result.put("totalSettledScore", String.format("%.2f", totalSettledScore.doubleValue()));
			// 已结算积分值所占比例（%）
			result.put("settledScoreRate", Math.round(totalSettledScore.doubleValue() * 100 / totalScore));
		}
		return result;
	}

	/**
	 * 根据积分包获取推广的药品
	 *
	 * @param page      分页信息
	 * @param packageId 积分包id
	 * @param drugName  药品名称
	 * @return 药品列表
	 */
	@Override
	public IPage<WmDaDrugEntDrugtable> listDrugsByPackageId(Page page, Integer packageId, String drugName) {

		// 获取积分包
		final WmScorePackage one = getOne(Wrappers.<WmScorePackage>lambdaQuery().eq(WmScorePackage::getId, packageId));

		return wmDaDrugEntDrugtableService.listDrugs(page, Integer.parseInt(one.getRelatedService()), drugName);


	}

	@Override
	public Page<WmScorePackage> selectWmScorePackageLists(Page<WmScorePackage> page, String scorePackageName, String acceptSug, LocalDate allocationDate, LocalDate endLabelDate) {

		Integer deptId = SecurityUtils.getUser().getDeptId();
		return wmScorePackageMapper.newSelectWmScorePackageLists(page, String.valueOf(deptId),
				scorePackageName, acceptSug, allocationDate, endLabelDate);
	}


	@Override
	@Async("doSelectWmScorePackageListsPool")
	public Future<WmScorePackage> finishRate(WmScorePackage wmScorePackage) {
		String packageId = wmScorePackage.getId();
		Set<String> scorePackageIdSet = stepA(packageId);
		List<Map<String, Object>> stepB_1 = stepB_1(scorePackageIdSet);
		List<Map<String, Object>> stepB_2 = stepB_2(packageId);

		List<Map<String, Object>> m = new ArrayList<>(stepB_1.size() + stepB_2.size());
		m.addAll(stepB_1);
		m.addAll(stepB_2);
		Map<String, Integer> result = step3(m, wmScorePackage);
		WmScorePackage p = step4(result, wmScorePackage);

		return new AsyncResult<>(p);
	}

	@Override
	public R getScorePackagePage(Page<WmScorePackage> page, Integer packageType1, Integer packageType2, String scorePackageName, Integer scorePackageStatus, String typeId) {

		List<String> reportWaitingCheckStatus = Arrays.asList("0", "1", "2", "3", "4");

		Integer sendDeptId = SecurityUtils.getUser().getDeptId();

		LambdaQueryWrapper<WmScorePackage> queryWrapper = Wrappers.<WmScorePackage>lambdaQuery()
				.eq(WmScorePackage::getPackageType1, packageType1)
				.eq(WmScorePackage::getPackageType2, packageType2)
				.like(StrUtil.isNotEmpty(scorePackageName), WmScorePackage::getScorePackageName, scorePackageName)
				.eq(scorePackageStatus != null, WmScorePackage::getScorePackageStatus, scorePackageStatus)
				.eq(WmScorePackage::getSendPackageDeptId, sendDeptId);

		if (StringUtil.isEmpty(typeId)) {
			queryWrapper.in(WmScorePackage::getTypeid, "3", "4", "5");
		} else {
			List<String> split = StrUtil.split(typeId, StrUtil.COMMA);
			queryWrapper.in(WmScorePackage::getTypeid, split);
		}

		Page<WmScorePackage> wmScorePackagePage = wmScorePackageMapper.selectPage(page, queryWrapper.orderByDesc(WmScorePackage::getCreateTime));

		List<WmScorePackage> pageRecords = wmScorePackagePage.getRecords();

		for (WmScorePackage scorePackage : pageRecords) {

			// 任务统计
			List<WmTask> taskList = wmTaskMapper.selectList(Wrappers.<WmTask>lambdaQuery()
					.eq(WmTask::getRealFlag, "0")
					.eq(WmTask::getEnableFlag, "0")
					.eq(WmTask::getDelFlag, "0")
					.eq(WmTask::getScorePackageId, scorePackage.getId())
			);

			// 审核通过
			int shtg = taskList.parallelStream()
					.filter(t -> StrUtil.equals(t.getReportDrugApprovalOpinion(), "1") || StrUtil.equals(t.getReportOneApprovalOpinion(), "1"))
					.mapToInt(WmTask::getScore)
					.sum();
			// 审核 不通过
			int shbtg = taskList.parallelStream()
					.filter(t -> StrUtil.equals(t.getReportDrugApprovalOpinion(), "2") || StrUtil.equals(t.getReportOneApprovalOpinion(), "2"))
					.mapToInt(WmTask::getScore)
					.sum();
			// 审核通过数
			long shtgnum = taskList.parallelStream()
					.filter(t -> StrUtil.equals(t.getReportDrugApprovalOpinion(), "1") || StrUtil.equals(t.getReportOneApprovalOpinion(), "1"))
					.count();
			// 审核不通过数
			long shbtgnum = taskList.parallelStream()
					.filter(t -> StrUtil.equals(t.getReportDrugApprovalOpinion(), "2") || StrUtil.equals(t.getReportOneApprovalOpinion(), "2"))
					.count();
			// 平台未审核
			int temp = taskList.parallelStream()
					.filter(t -> StrUtil.equals(t.getTaskStatus(), "1"))
					.mapToInt(WmTask::getScore)
					.sum();
			// 待审核
			int dsh = taskList.parallelStream()
					.filter(t -> StrUtil.equals(t.getTaskStatus(), "2"))
					.mapToInt(WmTask::getScore)
					.sum();
			// 已审核
			int ysh = taskList.parallelStream()
					.filter(t -> StrUtil.equals(t.getTaskStatus(), "3"))
					.mapToInt(WmTask::getScore)
					.sum();
			// 已审核数
			long yshnum = taskList.parallelStream().filter(t -> StrUtil.equals(t.getTaskStatus(), "3")).count();
			// 已提交
			int ytj = temp + dsh + ysh;

			// 已审核百分比
			long yshtt = 0;
			// 审核通过百分比
			long shtgtt = 0;
			// 审核不通过百分比
			long shbtgtt = 0;
			if (StrUtil.equals(scorePackage.getPackageType1(), "1")) {
				int score = scorePackage.getScore();
				yshtt = ysh * 100L / score;
				yshtt = yshtt > 100 ? 100 : yshtt;

				shtgtt = shtg * 100L / score;
				shtgtt = shtgtt > 100 ? 100 : shtgtt;

				shbtgtt = shbtg * 100L / score;
				shbtgtt = shbtgtt > 100 ? 100 : shbtgtt;
			} else {
				int score = scorePackage.getUserNum() * scorePackage.getTaskNum();
				yshtt = yshnum * 100 / score;
				shtgtt = shtgnum * 100 / score;
				shbtgtt = shbtgnum * 100 / score;
			}


			// 领取积分包记录
			List<WmScorePackageStatus> scorePackageStatusList = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
					.eq(WmScorePackageStatus::getPackageId, scorePackage.getId())
			);

			List<WmScorePackageStatus> packageStatusList = scorePackageStatusList.stream()
					.filter(s -> StrUtil.equals(s.getEnableFlag(), "0") && StrUtil.equals(s.getDelFlag(), "0"))
					.collect(Collectors.toList());


			List<WmScorePackageStatus> staList = scorePackageStatusList.stream()
					.filter(record -> StrUtil.equals(record.getStatus(), "2"))
					.collect(Collectors.toList());
			;

			if (CollUtil.isNotEmpty(staList)) {
				List<String> userIdList = staList.stream()
						.map(WmScorePackageStatus::getUserId)
						.collect(Collectors.toList());

				List<String> userNameList = sysUserMapper.selectList(Wrappers.<SysUser>lambdaQuery()
								.in(SysUser::getUserId, userIdList))
						.stream()
						.map(SysUser::getRealname)
						.collect(Collectors.toList());
				scorePackage.setUserList(userNameList);
				scorePackage.setUserListNum(userNameList.size());
			} else {
				scorePackage.setUserListNum(0);
			}

			// 已结单
			long yjd = packageStatusList.stream()
					.filter(s -> StrUtil.equalsAny(s.getStatus(), "1", "2"))
					.count();
			// 已结单待审核
			long yjddsh = packageStatusList.stream()
					.filter(s -> StrUtil.equals(s.getStatus(), "1"))
					.count();


			//获取上级包
			WmScorePackage relationScorePackage = wmScorePackageMapper.selectOne(Wrappers.<WmScorePackage>lambdaQuery()
					.eq(WmScorePackage::getId, scorePackage.getRelationScoreId()).last("limit 1"));


			// 类型标签
			SysDictItem package_type1 = sysDictItemService.getOne(Wrappers.<SysDictItem>lambdaQuery()
					.eq(SysDictItem::getType, "package_type1")
					.eq(SysDictItem::getValue, packageType1));
			SysDictItem package_type2 = sysDictItemService.getOne(Wrappers.<SysDictItem>lambdaQuery()
					.eq(SysDictItem::getType, "package_type2")
					.eq(SysDictItem::getValue, packageType2));

			String type1Lable = package_type1.getLabel();
			String type2Lable = package_type2.getLabel();


			// 设置
			// scorePackage.setYsh(yshtt >= 100 ? scorePackage.getScore() : ysh);
			scorePackage.setYjd((int) yjd);
			scorePackage.setYjddsh((int) yjddsh);
			scorePackage.setDsh(dsh);
			scorePackage.setYtj(ytj);
			if (!StrUtil.equals(scorePackage.getScorePackageStatus(), "1") && !StrUtil.equals(scorePackage.getScorePackageStatus(), "6")) {
				scorePackage.setYsh(ysh);
				scorePackage.setShtg(shtg);
				scorePackage.setShbtg(shbtg);
				scorePackage.setShbtgnum((int) shbtgnum);
				scorePackage.setShtgnum((int) shtgnum);
				scorePackage.setShtgtt((int) shtgtt);
				scorePackage.setShbtgtt((int) shbtgtt);
				scorePackage.setYshtt((int) yshtt);
			}
			scorePackage.setIsTask(scorePackage.getId());
			scorePackage.setPackageType1(type1Lable);
			scorePackage.setPackageType2(type2Lable);
			scorePackage.setRelationScoreId(relationScorePackage != null ? relationScorePackage.getScorePackageName() : null);


			// 结算记录
			WmScorePackageSettleNote note = settleNoteMapper.selectOne(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
					.eq(WmScorePackageSettleNote::getPackageId, scorePackage.getId()).last("limit 1"));

			if (note != null) {
				scorePackage.setNotifyDate(note.getNotifyTime());
			}

			if (packageType2 == 2) {

				LambdaQueryWrapper<WmScorePackageSettleNote> wrapper = Wrappers.<WmScorePackageSettleNote>lambdaQuery()
						.eq(WmScorePackageSettleNote::getPackageId, scorePackage.getId());

				int wsNum = settleNoteMapper.selectCount(wrapper.in(WmScorePackageSettleNote::getSettleNoteStatus, 2, 9));
				int asNum = settleNoteMapper.selectCount(wrapper.eq(WmScorePackageSettleNote::getSettleNoteStatus, 1));
				scorePackage.setWsTaskNum(wsNum);
				scorePackage.setAsTaskNum(asNum);

			}

			if (PackageTypeEnum.TYPE1_HCP_PACKAGE.getName().equals(scorePackage.getPackageType1())) {
				// 如果是患者教育，则转换积分值 '分'-> '元'
				Integer score = scorePackage.getScore();
				String userScore = scorePackage.getUserScore();
				if (StringUtils.isNumeric(userScore)) {
					scorePackage.setUserScore(String.format("%.2f", Integer.parseInt(userScore) / 100.0));
				}
			}

			List<WmScoreTaskType> taskTypeList = wmScoreTaskTypeMapper.getScoreTaskTypeByScoreId(scorePackage.getId());
			if (CollUtil.isNotEmpty(taskTypeList)) {
				String taskTypes = taskTypeList.stream().map(
						WmScoreTaskType::getTaskTypeName).collect(Collectors.joining(","));
				scorePackage.setTaskTypes(taskTypes);
			}


			// 设置中止状态
			if (relationScorePackage != null) {
				// 关联了上级包的情况
				// 统计发包方还未审核的
				long drugNeedToCheckCount = taskList.stream()
						.filter(t -> "3".equals(t.getTaskStatus()) && reportWaitingCheckStatus.contains(t.getReportDrugApprovalStatus()))
						.count();

				// 统计cso未审核 和审核通过的还未提交到药企的任务数
				long csoNeedToCheckCount = taskList.stream()
						.filter(t -> "2".equals(t.getTaskStatus()) ||
								("3".equals(t.getTaskStatus()) && (reportWaitingCheckStatus.contains(t.getReportOneApprovalStatus()))))
						.count();

				// 如果有发包方未审核的不能中止
				if (drugNeedToCheckCount != 0L || csoNeedToCheckCount != 0L) {
					scorePackage.setStopStatus(WmScorePackage.PackageStopStatus.NOTHING);
				}
			} else {
				// 没有关联上级包的情况
				// 统计待审核任务数
				long toApproveCount = taskList.stream().filter(t -> TaskStatusEnum.UNDER_REVIEW.val().equals(t.getTaskStatus())).count();
				if (toApproveCount > 0) {
					scorePackage.setStopStatus(WmScorePackage.PackageStopStatus.NOTHING);
				}
			}
		}


		return R.ok(wmScorePackagePage);
	}

	@Override
	@Async(value = "doGetScorePackagePagePool")
	public Future<WmScorePackage> buildScorePackage(WmScorePackage scorePackage, Integer packageType1, Integer packageType2) {

		List<String> reportWaitingCheckStatus = Arrays.asList("0", "1", "2", "3", "4");

		// 任务统计
		List<WmTask> taskList = wmTaskMapper.selectList(Wrappers.<WmTask>lambdaQuery()
				.eq(WmTask::getRealFlag, "0")
				.eq(WmTask::getEnableFlag, "0")
				.eq(WmTask::getDelFlag, "0")
				.eq(WmTask::getScorePackageId, scorePackage.getId())
		);

		// 审核通过
		int shtg = taskList.parallelStream()
				.filter(t -> StrUtil.equals(t.getReportDrugApprovalOpinion(), "1") || StrUtil.equals(t.getReportOneApprovalOpinion(), "1"))
				.mapToInt(WmTask::getScore)
				.sum();
		// 审核 不通过
		int shbtg = taskList.parallelStream()
				.filter(t -> StrUtil.equals(t.getReportDrugApprovalOpinion(), "2") || StrUtil.equals(t.getReportOneApprovalOpinion(), "2"))
				.mapToInt(WmTask::getScore)
				.sum();
		// 审核通过数
		long shtgnum = taskList.parallelStream()
				.filter(t -> StrUtil.equals(t.getReportDrugApprovalOpinion(), "1") || StrUtil.equals(t.getReportOneApprovalOpinion(), "1"))
				.count();
		// 审核不通过数
		long shbtgnum = taskList.parallelStream()
				.filter(t -> StrUtil.equals(t.getReportDrugApprovalOpinion(), "2") || StrUtil.equals(t.getReportOneApprovalOpinion(), "2"))
				.count();
		// 平台未审核
		int temp = taskList.parallelStream()
				.filter(t -> StrUtil.equals(t.getTaskStatus(), "1"))
				.mapToInt(t -> t.getScore() == null ? 0 : t.getScore())
				.sum();
		// 待审核
		int dsh = taskList.parallelStream()
				.filter(t -> StrUtil.equals(t.getTaskStatus(), "2"))
				.mapToInt(t -> t.getScore() == null ? 0 : t.getScore())
				.sum();
		// 已审核
		int ysh = taskList.parallelStream()
				.filter(t -> StrUtil.equals(t.getTaskStatus(), "3"))
				.mapToInt(t -> t.getScore() == null ? 0 : t.getScore())
				.sum();
		// 已审核数
		long yshnum = taskList.parallelStream().filter(t -> StrUtil.equals(t.getTaskStatus(), "3")).count();
		// 已提交
		int ytj = temp + dsh + ysh;

		// 已审核百分比
		long yshtt = 0;
		// 审核通过百分比
		long shtgtt = 0;
		// 审核不通过百分比
		long shbtgtt = 0;
		if (StrUtil.equals(scorePackage.getPackageType1(), PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val())
				|| StrUtil.equals(scorePackage.getPackageType1(), PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val())) {
			int score = scorePackage.getScore();
			if (score != 0) {
				yshtt = ysh * 100L / score;
				yshtt = yshtt > 100 ? 100 : yshtt;

				shtgtt = shtg * 100L / score;
				shtgtt = shtgtt > 100 ? 100 : shtgtt;

				shbtgtt = shbtg * 100L / score;
				shbtgtt = shbtgtt > 100 ? 100 : shbtgtt;
			}
		} else {
			int score = scorePackage.getUserNum() * (scorePackage.getTaskNum() == null ? 0 : scorePackage.getTaskNum());
			if (score != 0) {
				yshtt = yshnum * 100 / score;
				shtgtt = shtgnum * 100 / score;
				shbtgtt = shbtgnum * 100 / score;
			}
		}


		// 领取积分包记录
		List<WmScorePackageStatus> scorePackageStatusList = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
				.eq(WmScorePackageStatus::getPackageId, scorePackage.getId())
		);

		List<WmScorePackageStatus> packageStatusList = scorePackageStatusList.stream()
				.filter(s -> StrUtil.equals(s.getEnableFlag(), "0") && StrUtil.equals(s.getDelFlag(), "0"))
				.collect(Collectors.toList());


		List<WmScorePackageStatus> staList = scorePackageStatusList.stream()
				.filter(record -> StrUtil.equals(record.getStatus(), "2"))
				.collect(Collectors.toList());
		;

		if (CollUtil.isNotEmpty(staList)) {
			List<String> userIdList = staList.stream()
					.map(WmScorePackageStatus::getUserId)
					.collect(Collectors.toList());

			List<String> userNameList = sysUserMapper.selectList(Wrappers.<SysUser>lambdaQuery()
							.in(SysUser::getUserId, userIdList))
					.stream()
					.map(SysUser::getRealname)
					.collect(Collectors.toList());
			scorePackage.setUserList(userNameList);
			scorePackage.setUserListNum(userNameList.size());
		} else {
			scorePackage.setUserListNum(0);
		}

		// 已结单
		long yjd = packageStatusList.stream()
				.filter(s -> StrUtil.equalsAny(s.getStatus(), "1", "2"))
				.count();
		// 已结单待审核
		long yjddsh = packageStatusList.stream()
				.filter(s -> StrUtil.equals(s.getStatus(), "1"))
				.count();


		//获取上级包
		WmScorePackage relationScorePackage = wmScorePackageMapper.selectOne(Wrappers.<WmScorePackage>lambdaQuery()
				.eq(WmScorePackage::getId, scorePackage.getRelationScoreId()).last("limit 1"));


		// 类型标签
		SysDictItem package_type1 = sysDictItemService.getOne(Wrappers.<SysDictItem>lambdaQuery()
				.eq(SysDictItem::getType, "package_type1")
				.eq(SysDictItem::getValue, packageType1));
		SysDictItem package_type2 = sysDictItemService.getOne(Wrappers.<SysDictItem>lambdaQuery()
				.eq(SysDictItem::getType, "package_type2")
				.eq(SysDictItem::getValue, packageType2));

		String type1Lable = package_type1.getLabel();
		String type2Lable = package_type2.getLabel();


		// 设置
		// scorePackage.setYsh(yshtt >= 100 ? scorePackage.getScore() : ysh);
		scorePackage.setYjd((int) yjd);
		scorePackage.setYjddsh((int) yjddsh);
		scorePackage.setDsh(dsh);
		if (!StrUtil.equalsAny(scorePackage.getScorePackageStatus(), "1", "6")) {
			scorePackage.setYsh(ysh);
			scorePackage.setShtg(shtg);
			scorePackage.setShbtg(shbtg);
			scorePackage.setShbtgnum((int) shbtgnum);
			scorePackage.setShtgnum((int) shtgnum);
			scorePackage.setShtgtt((int) shtgtt);
			scorePackage.setShbtgtt((int) shbtgtt);
			scorePackage.setYshtt((int) yshtt);
		}
		scorePackage.setIsTask(scorePackage.getId());
		scorePackage.setYtj(ytj);
		scorePackage.setPackageType1(type1Lable);
		scorePackage.setPackageType2(type2Lable);
		scorePackage.setRelationScoreId(relationScorePackage != null ? relationScorePackage.getScorePackageName() : null);


		// 结算记录
		WmScorePackageSettleNote note = settleNoteMapper.selectOne(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
				.eq(WmScorePackageSettleNote::getPackageId, scorePackage.getId()).last("limit 1"));

		if (note != null) {
			scorePackage.setNotifyDate(note.getNotifyTime());
			scorePackage.setSubToGigTime(note.getSubToGigTime());
		}

		if (packageType2 == 2) {


			int wsNum = settleNoteMapper.selectCount(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
					.eq(WmScorePackageSettleNote::getPackageId, scorePackage.getId())
					.in(WmScorePackageSettleNote::getSettleNoteStatus, 2, 9));
			int asNum = settleNoteMapper.selectCount(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
					.eq(WmScorePackageSettleNote::getPackageId, scorePackage.getId())
					.eq(WmScorePackageSettleNote::getSettleNoteStatus, 1));
			scorePackage.setWsTaskNum(wsNum);
			scorePackage.setAsTaskNum(asNum);

		}

		if (PackageTypeEnum.TYPE1_HCP_PACKAGE.getName().equals(scorePackage.getPackageType1())) {
			// 如果是患者教育，则转换积分值 '分'-> '元'
			Integer score = scorePackage.getScore();
			String userScore = scorePackage.getUserScore();
			if (StringUtils.isNumeric(userScore)) {
				scorePackage.setUserScore(String.format("%.2f", Integer.parseInt(userScore) / 100.0));
			}
		}

		List<WmScoreTaskType> taskTypeList = wmScoreTaskTypeMapper.getScoreTaskTypeByScoreId(scorePackage.getId());
		if (CollUtil.isNotEmpty(taskTypeList)) {
			String taskTypes = taskTypeList.stream().map(
					WmScoreTaskType::getTaskTypeName).collect(Collectors.joining(","));
			scorePackage.setTaskTypes(taskTypes);
		}


		// 设置中止状态
		if (relationScorePackage != null) {
			// 关联了上级包的情况
			// 统计发包方还未审核的
			long drugNeedToCheckCount = taskList.stream()
					.filter(t -> "3".equals(t.getTaskStatus()) && reportWaitingCheckStatus.contains(t.getReportDrugApprovalStatus()))
					.count();

			// 统计cso未审核 和审核通过的还未提交到药企的任务数
			long csoNeedToCheckCount = taskList.stream()
					.filter(t -> "2".equals(t.getTaskStatus()) ||
							("3".equals(t.getTaskStatus()) && (reportWaitingCheckStatus.contains(t.getReportOneApprovalStatus()))))
					.count();

			// 如果有发包方未审核的不能中止
			if (drugNeedToCheckCount != 0L || csoNeedToCheckCount != 0L) {
				scorePackage.setStopStatus(WmScorePackage.PackageStopStatus.NOTHING);
			}
		} else {
			// 没有关联上级包的情况
			// 统计待审核任务数
			long toApproveCount = taskList.stream().filter(t -> TaskStatusEnum.UNDER_REVIEW.val().equals(t.getTaskStatus())).count();
			if (toApproveCount > 0) {
				scorePackage.setStopStatus(WmScorePackage.PackageStopStatus.NOTHING);
			}
		}

		// 封装报告记录
		scorePackage.setReportMqName(CacheConstants.EXPORT_ZB_REPORT_CACHE);
		getReportOpt(scorePackage);

		// 封装excel报告状态
		this.getExcelReportOpt(scorePackage, CacheConstants.EXCEL_EXPORT_ZB_REPORT_CACHE);

		// 接单对象范围名称
		if (StrUtil.isNotBlank(scorePackage.getPackageUserScope())) {
			String packageUserScopeName = wmTeamService.getPackageUserScopeName(scorePackage.getPackageUserScope());
			scorePackage.setPackageUserScopeName(packageUserScopeName);
		}

		return new AsyncResult<>(scorePackage);
	}


	private Set<String> stepA(String packageId) {

		Set<String> scorePackageIdSet = new HashSet<>();
		scorePackageIdSet.add(packageId);


		List<WmScorePackage> relationScoreList = wmScorePackageMapper.selectList(Wrappers.<WmScorePackage>lambdaQuery()
				.eq(WmScorePackage::getRelationScoreId, packageId));

		Set<String> relationScoreIdSet = relationScoreList.stream().map(WmScorePackage::getId)
				.collect(Collectors.toSet());

		if (CollUtil.isNotEmpty(relationScoreIdSet)) {
			scorePackageIdSet.addAll(relationScoreIdSet);
			List<WmScorePackage> relationRelationScoreIdList = wmScorePackageMapper.selectList(Wrappers.<WmScorePackage>lambdaQuery()
					.in(WmScorePackage::getRelationScoreId, relationScoreIdSet));
			Set<String> relationRelationScoreIdSet = relationRelationScoreIdList.stream()
					.map(WmScorePackage::getScoreId)
					.collect(Collectors.toSet());
			if (CollUtil.isNotEmpty(relationRelationScoreIdSet)) {
				scorePackageIdSet.addAll(relationRelationScoreIdSet);
			}
		}

		return scorePackageIdSet;
	}


	private List<Map<String, Object>> stepB_1(Set<String> scorePackageIdSet) {

		List<Map<String, Object>> mapList = wmTaskMapper.selectMaps(Wrappers.<WmTask>query()
				.select("0 AS payScore", "SUM(IF(task_status = 3, score, 0)) ysh")
				.in("score_package_id", scorePackageIdSet)
				.eq("enable_flag", "0")
				.eq("real_flag", "0")
				.eq("del_flag", "0")
				.groupBy("score_package_id")

		);

		return mapList;

	}

	private List<Map<String, Object>> stepB_2(String scoreId) {


		List<WmReport> wmReportList = wmReportMapper.selectList(Wrappers.<WmReport>lambdaQuery()
				.eq(WmReport::getReportStatus, "6")
				.eq(WmReport::getScoreId, scoreId)
		);

		Set<Integer> reportIdSet = wmReportList.stream().mapToInt(WmReport::getId).boxed().collect(Collectors.toSet());

		if (CollUtil.isNotEmpty(reportIdSet)) {
			List<Map<String, Object>> mapList = wmTaskMapper.selectMaps(Wrappers.<WmTask>query()
					.select("SUM(score) AS payScore", "0 AS ysh")
					.and(i -> i.eq("report_drug_approval_opinion", "1").or().eq("report_one_approval_opinion", 1))
					.and(i -> i.in("report_one_id", reportIdSet)
							.or()
							.in("report_second_id", reportIdSet)
							.or()
							.in("report_drug_id", reportIdSet))

			);
			return mapList;

		} else {
			Map<String, Object> map = ImmutableMap.of("payScore", 0, "ysh", 0);
			return Collections.singletonList(map);
		}


	}


	public Map<String, Integer> step3(List<Map<String, Object>> m, WmScorePackage wmScorePackage) {
		int payScore = 0;
		int ysh = 0;

		for (Map<String, Object> tmp : m) {
			for (Map.Entry<String, Object> entry : tmp.entrySet()) {
				String key = entry.getKey();
				Object value = entry.getValue();
				if (StrUtil.equals(key, "payScore")) {
					if (value instanceof Long) {
						Long val = (Long) entry.getValue();
						payScore += val.intValue();
					} else if (value instanceof Integer) {
						Integer val = (Integer) entry.getValue();
						payScore += val;
					} else if (value instanceof BigDecimal) {
						BigDecimal val = (BigDecimal) entry.getValue();
						payScore += val.intValue();
					}
				} else if (StrUtil.equals(key, "ysh")) {
					if (value instanceof Long) {
						Long val = (Long) entry.getValue();
						ysh += val.intValue();
					} else if (value instanceof Integer) {
						Integer val = (Integer) entry.getValue();
						ysh += val;
					} else if (value instanceof BigDecimal) {
						BigDecimal val = (BigDecimal) entry.getValue();
						ysh += val.intValue();
					}
				}
			}

		}

		return ImmutableMap.of("payScore", payScore, "ysh", ysh);

	}


	public WmScorePackage step4(Map<String, Integer> payScoreAndYsh, WmScorePackage wmScorePackage) {
		int payScore = payScoreAndYsh.get("payScore");
		int ysh = payScoreAndYsh.get("ysh");

		BigDecimal payRate = new BigDecimal(payScore).multiply(BigDecimal.valueOf(100))
				.divide(new BigDecimal(wmScorePackage.getScore()), 2, BigDecimal.ROUND_HALF_UP);
		if (payRate.compareTo(new BigDecimal("100")) >= 0) {
			wmScorePackage.setPayRate(100 + ".00");
		} else {
			wmScorePackage.setPayRate(payRate + "");
		}

		BigDecimal fin = new BigDecimal(ysh).multiply(BigDecimal.valueOf(100))
				.divide(new BigDecimal(wmScorePackage.getScore()), 2, BigDecimal.ROUND_HALF_UP);
		if (fin.compareTo(new BigDecimal("100")) > 0) {
			wmScorePackage.setFinishRate(100 + ".00");
			if ("0".equals(wmScorePackage.getPackageFinishStatus())) {
				wmScorePackage.setPackageFinishStatus("1");
			}
		} else {
			wmScorePackage.setFinishRate(fin + "");
		}

		if (wmScorePackage.getFinishRate().equals("100.00")) {
			if ("0".equals(wmScorePackage.getPackageFinishStatus())) {
				wmScorePackage.setPackageFinishStatus("1");
			}
		}

		wmScorePackage.setPayScore(payScoreAndYsh.get("payScore"));
		wmScorePackage.setYsh(payScoreAndYsh.get("ysh"));

		// 封装报告状态
		wmScorePackage.setReportMqName(CacheConstants.EXPORT_NBA_REPORT_CACHE);
		getReportOpt(wmScorePackage);

		// 封装excel报告状态
		this.getExcelReportOpt(wmScorePackage, CacheConstants.EXCEL_EXPORT_NBA_REPORT_CACHE);

		// 企业大包终止条件判断
		int relatedPackageCount = this.count(Wrappers.<WmScorePackage>lambdaQuery()
				.eq(WmScorePackage::getRelationScoreId, wmScorePackage.getId())
				.ne(WmScorePackage::getScorePackageStatus, ScorePackageStatusEnum.TERMINATED.val()));
		if (relatedPackageCount > 0) {
			wmScorePackage.setStopStatus(WmScorePackage.PackageStopStatus.NOTHING);
		}

		return wmScorePackage;
	}


	/**
	 * 查询报告导出状态
	 *
	 * @param wmScorePackage 列表
	 */
	@Override
	public void getReportOpt(WmScorePackage wmScorePackage) {

		WmReportOpt opt = new WmReportOpt();

		// 获取生成记录
		String key = String.format(wmScorePackage.getReportMqName(), wmScorePackage.getId());
		String o = redisTemplate.opsForValue().get(key);

		if (StrUtil.isNotEmpty(o)) {

			// 生成中的
			if ("GENERATING".equals(o)) {
				opt.setStatus(WmReportOpt.WmReportOptStatus.GENERATING);
			}
			// 生成失败的
			else if (o.startsWith("ERROR")) {
				opt.setStatus(WmReportOpt.WmReportOptStatus.ERROR);
				opt.setErrorMsg(o.split(StrUtil.UNDERLINE)[1]);
			}
			// 生成失败的2
			else if (!o.startsWith("http")) {
				opt.setStatus(WmReportOpt.WmReportOptStatus.ERROR);
				opt.setErrorMsg(o);
			}
			// 成功的
			else {
				Long expire = redisTemplate.opsForValue().getOperations().getExpire(key, TimeUnit.SECONDS);
				opt.setStatus(WmReportOpt.WmReportOptStatus.GENERATED);
				opt.setTtl(LocalDateTime.now().plusSeconds(expire));
				// o = "https://pre.yaoyi.net/admin/sys-file/wmkj/兼职学术信息沟通专员业绩报告(2249)-20211116191527.doc";
				opt.setLatestUrl(o);
			}

		} else {
			opt.setStatus(WmReportOpt.WmReportOptStatus.NOT_GENERATE);
		}


		wmScorePackage.setReportOpt(opt);

	}

	/**
	 * 查询excel报告导出状态
	 *
	 * @param wmScorePackage      列表
	 * @param excelReportCacheKey 缓存key
	 */
	@Override
	public void getExcelReportOpt(WmScorePackage wmScorePackage, String excelReportCacheKey) {

		WmReportOpt opt = new WmReportOpt();

		// 获取生成记录
		String key = String.format(excelReportCacheKey, wmScorePackage.getId());
		String o = redisTemplate.opsForValue().get(key);

		if (StrUtil.isNotEmpty(o)) {

			// 生成中的
			if ("GENERATING".equals(o)) {
				opt.setStatus(WmReportOpt.WmReportOptStatus.GENERATING);
			}
			// 生成失败的
			else if (o.startsWith("ERROR")) {
				opt.setStatus(WmReportOpt.WmReportOptStatus.ERROR);
				opt.setErrorMsg(o.split(StrUtil.UNDERLINE)[1]);
			}
			// 生成失败的2
			else if (!o.startsWith("http")) {
				opt.setStatus(WmReportOpt.WmReportOptStatus.ERROR);
				opt.setErrorMsg(o);
			}
			// 成功的
			else {
				Long expire = redisTemplate.opsForValue().getOperations().getExpire(key, TimeUnit.SECONDS);
				opt.setStatus(WmReportOpt.WmReportOptStatus.GENERATED);
				opt.setTtl(LocalDateTime.now().plusSeconds(expire));
				// o = "https://pre.yaoyi.net/admin/sys-file/wmkj/兼职学术信息沟通专员业绩报告(2249)-20211116191527.doc";
				opt.setLatestUrl(o);
			}

		} else {
			opt.setStatus(WmReportOpt.WmReportOptStatus.NOT_GENERATE);
		}


		wmScorePackage.setExcelReportOpt(opt);

	}

	/**
	 * 校验积分包是否可以结算
	 *
	 * @param pkg 基本包
	 */
	@Override
	public void checkPkgToSettle(WmScorePackage pkg) {
		if (!"0".equals(pkg.getSettleFlag())) {
			throw new RuntimeException("结算状态异常，请勿重复结算");
		}
		;
	}

	/**
	 * 拆包
	 *
	 * @param unpackDTO 拆包参数
	 * @return 是否成功
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public Boolean unpack(UnpackDTO unpackDTO) {
		// 原积分包
		WmScorePackage scorePackage = this.getById(unpackDTO.getScorePackageId());
		if (scorePackage == null) {
			throw new RuntimeException("原积分包不存在");
		}
		if (!PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val().equals(scorePackage.getPackageType1())
				|| !PackageTypeEnum.TYPE2_TASK_PACKAGE.val().equals(scorePackage.getPackageType2())) {
			throw new RuntimeException("不支持该积分包类型");
		}
		// 业务校验1
		if (!ScorePackageStatusEnum.TO_BE_SETTLED.val().equals(scorePackage.getScorePackageStatus())) {
			throw new RuntimeException("只有“已完成待结算”的积分包可以拆包");
		}
		// 原审核通过的任务列表
		QueryWrapper<WmTask> queryWrapper = Wrappers.query();
		queryWrapper.eq("task_status", TaskStatusEnum.APPROVED.val());
		queryWrapper.eq("score_package_id", unpackDTO.getScorePackageId());
		queryWrapper.eq("del_flag", DelEnum.NOT_DEL.val());
		queryWrapper.eq("real_flag", "0");
		queryWrapper.orderByDesc("lookinto_date");
		List<WmTask> taskList = wmTaskMapper.selectList(queryWrapper);

		Set<String> taskIds = taskList.stream().map(WmTask::getId).collect(Collectors.toSet());
		// 校验已选择的任务是否都在原任务中
		if (!CollUtil.containsAll(taskIds, unpackDTO.getSelectTaskIds())) {
			throw new RuntimeException("已选择的任务不在原任务中");
		}
		// 已选择的任务
		List<WmTask> selectTaskList = wmTaskMapper.selectBatchIds(unpackDTO.getSelectTaskIds());
		if (CollUtil.isEmpty(selectTaskList)) {
			throw new RuntimeException("已选择的任务不存在");
		}
		// 校验已选择的任务分值
		int selectTaskScore = selectTaskList.stream().mapToInt(WmTask::getScore).sum();
		if (!unpackDTO.getSelectTaskScore().equals(selectTaskScore)) {
			throw new RuntimeException("已选任务分值不正确");
		}
		// 业务校验2
		if (selectTaskScore >= scorePackage.getScore()) {
			throw new RuntimeException("“已选总任务积分”必须小于“总积分包值”");
		}
		// 拆包后的原积分包包值：取剩任务分值
		int oldScorePackageScore = scorePackage.getScore() - selectTaskScore;
		if (!unpackDTO.getRemainPackageScore().equals(oldScorePackageScore)) {
			throw new RuntimeException("原积分包剩余积分包值不正确");
		}

//		LocalDateTime now = LocalDateTime.now();
//		Integer operatorId = SecurityUtils.getUser().getId();
		// 创建新包
		String newScorePackageName = null;
		// 校验积分包名称是否存在
		for (int i = 0; i < 10; i++) {
			newScorePackageName = String.format("%s-%s", scorePackage.getScorePackageName(), RandomUtil.randomNumbers(3));
			int newScorePackageCount = this.count(Wrappers.<WmScorePackage>lambdaQuery().eq(WmScorePackage::getScorePackageName, newScorePackageName));
			if (newScorePackageCount <= 0) {
				break;
			}
		}
		WmScorePackage newScorePackage = BeanUtil.copyProperties(scorePackage, WmScorePackage.class);
		newScorePackage.setId(null);
//		newScorePackage.setUpdateTime(null);
//		newScorePackage.setUpdateUser(null);
//		newScorePackage.setCreateTime(now);
//		newScorePackage.setCreateUser(operatorId);
//		newScorePackage.setReceiveDate(now);
		newScorePackage.setScore(unpackDTO.getSelectTaskScore());
		newScorePackage.setScorePackageName(newScorePackageName);
		newScorePackage.setRemark(String.format("拆包自原积分包id=%s", unpackDTO.getScorePackageId()));
		log.info("创建新积分包参数：{}", newScorePackage);
		this.save(newScorePackage);
		// 复制原包积分规则
		List<WmScoreTaskType> oldScoreTaskTypes = wmScoreTaskTypeMapper.selectList(Wrappers.<WmScoreTaskType>lambdaQuery()
				.eq(WmScoreTaskType::getScoreId, unpackDTO.getScorePackageId()));
		if (CollUtil.isNotEmpty(oldScoreTaskTypes)) {
			oldScoreTaskTypes.forEach(wmScoreTaskType -> {
				WmScoreTaskType newScoreTaskType = BeanUtil.copyProperties(wmScoreTaskType, WmScoreTaskType.class);
				newScoreTaskType.setId(null);
				newScoreTaskType.setScoreId(newScorePackage.getId());
				wmScoreTaskTypeMapper.insert(newScoreTaskType);
			});
		}

		// 更新原积分包包值
		WmScorePackage updateOldPackage = new WmScorePackage();
		updateOldPackage.setId(unpackDTO.getScorePackageId());
		updateOldPackage.setScore(oldScorePackageScore);
//		updateOldPackage.setUpdateTime(now);
//		updateOldPackage.setUpdateUser(operatorId);
		updateOldPackage.setRemark(String.format("%s; 原积分包值%s更新为%s",
				StrUtil.emptyIfNull(updateOldPackage.getRemark()), scorePackage.getScore(), oldScorePackageScore));
		log.info("更新原积分包参数：{}", updateOldPackage);
		this.updateById(updateOldPackage);

		// 原积分包的领包记录
		WmScorePackageStatus oldScorePackageStatus = wmScorePackageStatusService.getOne(Wrappers.<WmScorePackageStatus>lambdaQuery()
				.eq(WmScorePackageStatus::getPackageId, unpackDTO.getScorePackageId())
				.eq(WmScorePackageStatus::getStatus, PackageStatusEnum.APPROVED.val()));

		// 更新原领包记录值
		WmScorePackageStatus updateOldPackageStatus = new WmScorePackageStatus();
		updateOldPackageStatus.setId(oldScorePackageStatus.getId());
		log.info("更新原领包记录参数：{}", oldScorePackageScore);
		updateOldPackageStatus.setUserScore(String.valueOf(oldScorePackageScore));

		wmScorePackageStatusService.updateById(updateOldPackageStatus);

		// 创建新积分包的领包记录
		WmScorePackageStatus newScorePackageStatus = BeanUtil.copyProperties(oldScorePackageStatus, WmScorePackageStatus.class);
		newScorePackageStatus.setPackageId(newScorePackage.getId());
		newScorePackageStatus.setUserScore(String.valueOf(newScorePackage.getScore()));
		newScorePackageStatus.setTaskNum(newScorePackage.getTaskNum());
//		newScorePackageStatus.setCreateTime(now);
//		newScorePackageStatus.setCreateUser(operatorId);
//		newScorePackageStatus.setUpdateUser(null);
//		newScorePackageStatus.setUpdateTime(null);
		log.info("创建新积分包的领包记录：{}", newScorePackageStatus);
		wmScorePackageStatusService.save(newScorePackageStatus);

		// 任务关联到新积分包
		selectTaskList.forEach(wmTask -> {
			WmTask updateTask = new WmTask();
			updateTask.setId(wmTask.getId());
			updateTask.setScorePackageId(newScorePackage.getId());
//			updateTask.setUpdateUser(String.valueOf(operatorId));
//			updateTask.setUpdateTime(now);
			updateTask.setExtIds(Collections.singletonList(String.format("拆包任务，原积分包id=%s", unpackDTO.getScorePackageId())));
			log.info("更新任务参数：{}", updateTask);
			wmTaskMapper.updateById(updateTask);
		});

		return Boolean.TRUE;
	}

	/**
	 * 终止积分包(个人)
	 * 用于个人承接积分值/多人承接积分值的包
	 *
	 * @param packageId            积分包id
	 * @param terminatePackageType 终止积分包类型
	 * @return {@link Boolean} 结果
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public Boolean terminatePackageForPersonal(String packageId, UpmsType.TerminatePackageType terminatePackageType) {
		Integer userId = SecurityUtils.getUser().getId();
		LocalDateTime now = LocalDateTime.now();

		// 查询积分包
		WmScorePackage scorePackage = this.getById(packageId);
		if (ScorePackageStatusEnum.TERMINATED.val().equals(scorePackage.getScorePackageStatus())) {
			throw new RuntimeException("积分包已终止");
		}
		// 查询上级积分包
		WmScorePackage parentScorePackage = null;
		if (StrUtil.isNotBlank(scorePackage.getRelationScoreId())) {
			parentScorePackage = this.getById(scorePackage.getRelationScoreId());
		}
		// 查询所有任务
		List<WmTask> taskList = wmTaskMapper.selectList(Wrappers.<WmTask>lambdaQuery().eq(WmTask::getScorePackageId, packageId)
				.eq(WmTask::getDelFlag, DelEnum.NOT_DEL.val())
				.eq(WmTask::getEnableFlag, EnableEnum.ENABLE.val()));
		int approvedScore = 0;
		if (CollUtil.isNotEmpty(taskList)) {
			// 个人包审核情况
			boolean pendingTaskApprovalFlag = taskList.stream()
					.anyMatch(wmTask -> TaskStatusEnum.UNDER_REVIEW.val().equals(wmTask.getTaskStatus())
							|| TaskStatusEnum.INIT.val().equals(wmTask.getTaskStatus()));
			if (pendingTaskApprovalFlag) {
				throw new RuntimeException("有在途任务,不允许终止");
			}
			// 有上级包的情况
			boolean pendingReportApprovalFlag = taskList.stream()
					.filter(t -> TaskStatusEnum.APPROVED.val().equals(t.getTaskStatus()))
					.anyMatch(wmTask -> ReportEnum.REPORT_STATUS_APPROVAL.getType().equals(wmTask.getReportDrugApprovalStatus())
							|| ReportEnum.REPORT_STATUS_APPROVAL.getType().equals(wmTask.getReportOneApprovalStatus())
							|| ReportEnum.REPORT_STATUS_PART_APPROVAL.getType().equals(wmTask.getReportDrugApprovalStatus())
							|| ReportEnum.REPORT_STATUS_PART_APPROVAL.getType().equals(wmTask.getReportOneApprovalStatus())
							|| StrUtil.isBlank(wmTask.getReportDrugApprovalOpinion())
							|| StrUtil.isBlank(wmTask.getReportOneApprovalOpinion()));
			if (pendingReportApprovalFlag && parentScorePackage != null) {
				throw new RuntimeException("有在途任务,不允许终止");
			}

			if (parentScorePackage != null) {
				// 关联了大包的情况
				// 审核通过的任务
				List<WmTask> approvedTasks = taskList.stream()
						.filter(t -> TaskStatusEnum.APPROVED.val().equals(t.getTaskStatus()))
						.filter(wmTask -> ReportEnum.APPROVAL_OPINION_YES.getType().equals(wmTask.getReportDrugApprovalOpinion())
								|| ReportEnum.APPROVAL_OPINION_YES.getType().equals(wmTask.getReportOneApprovalOpinion()))
						.collect(Collectors.toList());
				// 审核通过的积分
				approvedScore = approvedTasks.stream()
						.mapToInt(WmTask::getScore).sum();
			} else {
				// 没有关联大包的情况
				// 审核通过的任务
				List<WmTask> approvedTasks = taskList.stream()
						.filter(t -> TaskStatusEnum.APPROVED.val().equals(t.getTaskStatus()))
						.collect(Collectors.toList());
				// 审核通过的积分
				approvedScore = approvedTasks.stream()
						.mapToInt(WmTask::getScore).sum();
			}
		}

		// 更新积分包状态
		WmScorePackage updateScorePackage = new WmScorePackage();
		updateScorePackage.setId(packageId);
		if (UpmsType.TerminatePackageType.ALL.equals(terminatePackageType) || approvedScore <= 0) {
			// 全部终止/或已审核: 改为已终止
			updateScorePackage.setScorePackageStatus(ScorePackageStatusEnum.TERMINATED.val());
		} else {
			// 剩余回收: 积分包值改为 审核通过的任务积分值
			updateScorePackage.setScore(approvedScore);
			// 根据是否存在父级包,更新积分包完成状态
			updateScorePackage.setScorePackageStatus(ScorePackageStatusEnum.TO_BE_SETTLED.val());
		}
		// 终止方式
		updateScorePackage.setEnableType(terminatePackageType.getEnableType());
		// 禁用
		updateScorePackage.setEnableFlag(EnableEnum.DISABLE.val());
		// 不允许新增任务
		updateScorePackage.setTaskAddFlag("0");
		// 不允许接单
		updateScorePackage.setIsReceive("1");
		// 已完成
		updateScorePackage.setPackageFinishStatus(PackageFinishStatusEnum.COMPLETED.val());
		log.info("积分包更新参数:{}", updateScorePackage);
		this.updateById(updateScorePackage);

		// 更新任务状态(全部终止: 更新所有任务状态为禁用, 剩余回收: 暂不操作)
		if (UpmsType.TerminatePackageType.ALL.equals(terminatePackageType)) {
			// 全部终止: 更新所有任务状态为禁用
			Set<String> taskIds = taskList.stream().map(WmTask::getId).collect(Collectors.toSet());
			if (CollUtil.isNotEmpty(taskIds)) {
				log.info("任务更新参数(全部终止):taskIds={},packageId={},enableFlag={}", taskIds, packageId, EnableEnum.DISABLE.val());
				wmTaskMapper.update(null, Wrappers.<WmTask>lambdaUpdate()
						.in(WmTask::getId, taskIds)
						.eq(WmTask::getScorePackageId, packageId)
						.set(WmTask::getEnableFlag, EnableEnum.DISABLE.val()));
			}

			// 全部终止,将所有的领包记录，改成审核不通过
			log.info("更新领包记录参数:条件packageId={}; 设置参数enableType={},taskAddFlag={}", packageId, "1", "0");
			wmScorePackageStatusService.update(Wrappers.<WmScorePackageStatus>lambdaUpdate()
					.eq(WmScorePackageStatus::getPackageId, packageId)
					.set(WmScorePackageStatus::getEnableType, "1")
					.set(WmScorePackageStatus::getTaskAddFlag, "0"));
		} else {
			// 剩余回收,更新领包记录状态
			// 将所有未接单审核的，改成审核不通过
			log.info("更新领包记录参数:条件packageId={},status={}; 设置参数status={},taskAddFlag={}", packageId, "1", "3", "0");
			wmScorePackageStatusService.update(Wrappers.<WmScorePackageStatus>lambdaUpdate()
					.eq(WmScorePackageStatus::getPackageId, packageId)
					.eq(WmScorePackageStatus::getStatus, "1")
					.set(WmScorePackageStatus::getStatus, "3")
					.set(WmScorePackageStatus::getEnableType, "2")
					.set(WmScorePackageStatus::getTaskAddFlag, "0"));
			// 将所有已接单审核的，改成不可接单状态
			log.info("更新领包记录参数2:条件packageId={},status={}; 设置参数status={},enableType={},taskAddFlag={}", packageId, "1", "2", "2", "0");
			wmScorePackageStatusService.update(Wrappers.<WmScorePackageStatus>lambdaUpdate()
					.eq(WmScorePackageStatus::getPackageId, packageId)
					.eq(WmScorePackageStatus::getStatus, "2")
					.set(WmScorePackageStatus::getEnableType, "2")
					.set(WmScorePackageStatus::getTaskAddFlag, "0"));
		}



		// 回收积分
		int recoveryScore = 0;
		if (UpmsType.TerminatePackageType.ALL.equals(terminatePackageType)) {
			// 全部终止
			recoveryScore = scorePackage.getScore();
		} else {
			// 剩余回收(剩余回收积分值 = 积分包值 - 审核通过的任务积分值)
			recoveryScore = scorePackage.getScore() - approvedScore;
		}
		// 如果关联了大包 回收整包的积分值到大包的可分配积分值。如果没有关联大包，回收整包积分值到该企业的余额
		if (parentScorePackage != null) {
			// 更新父级积分包
			WmScorePackage updateParentPackage = new WmScorePackage();
			updateParentPackage.setId(parentScorePackage.getId());
			updateParentPackage.setKfpjf(parentScorePackage.getKfpjf() + recoveryScore);
			updateParentPackage.setUpdateTime(now);
			updateParentPackage.setUpdateUser(userId);
			log.info("回收整包的积分值到大包的参数:{}", updateParentPackage);
			this.updateById(updateParentPackage);
		} else {
			// 更新积分余额信息
			this.updateDeptRecharge(packageId, recoveryScore);
		}

		return Boolean.TRUE;
	}

	/**
	 * 终止积分包(企业大包)
	 *
	 * @param packageId            积分包id
	 * @param terminatePackageType 终止积分包类型
	 * @return {@link Boolean} 结果
	 */
	@Override
	@Transactional(rollbackFor = Exception.class)
	public Boolean terminatePackageForDept(String packageId, UpmsType.TerminatePackageType terminatePackageType) {
		Integer userId = SecurityUtils.getUser().getId();
		LocalDateTime now = LocalDateTime.now();

		WmScorePackage scorePackage = this.getById(packageId);
		if (!StrUtil.equalsAny(scorePackage.getTypeid(), "0", "1", "2")) {
			throw new RuntimeException("请选择企业承接的大包");
		}
		if (ScorePackageStatusEnum.TERMINATED.val().equals(scorePackage.getScorePackageStatus())) {
			throw new RuntimeException("积分包已终止");
		}
		// 可分配积分值
		if (scorePackage.getKfpjf() <= 0) {
			throw new RuntimeException("积分包已全部分派，请联系下属CSO终止关联积分包后再进行次操作");
		}

		// 已分配积分值
		int assignedScore = 0;
		// 查询子包的积分
		List<WmScorePackage> subPackages = this.list(Wrappers.<WmScorePackage>lambdaQuery()
				.eq(WmScorePackage::getRelationScoreId, packageId)
				.ne(WmScorePackage::getScorePackageStatus, ScorePackageStatusEnum.TERMINATED.val()));
		if (CollUtil.isNotEmpty(subPackages)) {
			assignedScore += subPackages.stream().mapToInt(WmScorePackage::getScore).sum();
		}
		// 查询企业任务的积分
		List<WmTask> entTaskList = wmTaskMapper.selectList(Wrappers.<WmTask>lambdaQuery()
				.eq(WmTask::getScorePackageId, packageId));
		if (CollUtil.isNotEmpty(entTaskList)) {
			assignedScore += entTaskList.stream().mapToInt(WmTask::getScore).sum();
		}

		log.info("当前积分包终止前数据:{}", scorePackage);
		if (UpmsType.TerminatePackageType.ALL.equals(terminatePackageType) || assignedScore <= 0) {
			// 全部终止的校验
			if (CollUtil.isNotEmpty(subPackages)) {
				throw new RuntimeException("积分包已被分派，请联系下属CSO终止关联积分包后再进行次操作");
			}
			// 全部终止/或已分配积分为0的: 更新积分包状态为已终止
			WmScorePackage updateEntity = new WmScorePackage();
			updateEntity.setId(packageId);
			updateEntity.setPackageFinishStatus("2");
			updateEntity.setEnableType(terminatePackageType.getEnableType());
			updateEntity.setEnableFlag(EnableEnum.DISABLE.val());
			updateEntity.setScorePackageStatus(ScorePackageStatusEnum.TERMINATED.val());
			updateEntity.setUpdateTime(now);
			updateEntity.setUpdateUser(userId);
			log.info("更新积分包参数:{}", updateEntity);
			this.updateById(updateEntity);
		} else {
			// 剩余回收
			// 剩余收回: 更新积分包分值为已分配的积分, 更新可分配积分值为0
			WmScorePackage updateEntity = new WmScorePackage();
			updateEntity.setId(packageId);
			updateEntity.setEnableType(terminatePackageType.getEnableType());
			updateEntity.setScore(assignedScore);
			updateEntity.setKfpjf(0);
			updateEntity.setUpdateTime(now);
			updateEntity.setUpdateUser(userId);
			log.info("更新积分包参数:{}", updateEntity);
			this.updateById(updateEntity);
		}

		// 回收积分值
		int recoveryScore = 0;
		if (UpmsType.TerminatePackageType.ALL.equals(terminatePackageType) || assignedScore <= 0) {
			// 回收整包积分值
			recoveryScore = scorePackage.getScore();
		} else {
			// 回收剩余积分值
			recoveryScore = scorePackage.getScore() - assignedScore;
		}

		// 如果关联了大包 回收整包的积分值到大包的可分配积分值。如果没有关联大包，回收整包积分值到该企业的余额
		boolean relatedScoreId = StrUtil.isNotBlank(scorePackage.getRelationScoreId()) && Integer.parseInt(scorePackage.getRelationScoreId()) > 0;
		if (relatedScoreId) {
			WmScorePackage parentPackage = this.getById(scorePackage.getRelationScoreId());
			// 更新父级积分包
			WmScorePackage updateParentPackage = new WmScorePackage();
			updateParentPackage.setId(scorePackage.getRelationScoreId());
			updateParentPackage.setKfpjf(parentPackage.getKfpjf() + recoveryScore);
			updateParentPackage.setUpdateTime(now);
			updateParentPackage.setUpdateUser(userId);
			log.info("回收整包的积分值到大包的参数:{}", updateParentPackage);
			this.updateById(updateParentPackage);
		} else {
			// 更新积分余额信息
			this.updateDeptRecharge(packageId, recoveryScore);
		}

		return Boolean.TRUE;
	}

	/**
	 * 更新积分余额信息
	 *
	 * @param packageId     积分包id
	 * @param recoveryScore 回收积分值
	 */
	private void updateDeptRecharge(String packageId, int recoveryScore) {
		Integer userId = SecurityUtils.getUser().getId();
		Integer deptId = SecurityUtils.getUser().getDeptId();
		LocalDateTime now = LocalDateTime.now();

		// 积分余额信息
		SysDeptRecharge deptRecharge = sysDeptRechargeMapper.selectOne(Wrappers.<SysDeptRecharge>lambdaQuery()
				.eq(SysDeptRecharge::getDeptId, deptId));
		if (deptRecharge == null) {
			throw new RuntimeException("没有配置企业余额信息");
		}

		SysDeptRechargeRecord rechargeRecord = sysDeptRechargeRecordMapper.selectOne(Wrappers.<SysDeptRechargeRecord>lambdaQuery()
				.eq(SysDeptRechargeRecord::getPackageId, packageId)
				.in(SysDeptRechargeRecord::getType, RechargeRecordType.SEND_PACKAGE_DEPT, RechargeRecordType.SEND_PACKAGE_PERSONAL));
		int currentScore = deptRecharge.getScore() + recoveryScore;
		// 更新企业配置的积分信息
		log.info("终止积分包，更新积分余额信息:deptId={},score={},changeScore={}", deptId, currentScore, recoveryScore);
		int update = sysDeptRechargeMapper.update(null, Wrappers.<SysDeptRecharge>lambdaUpdate()
				.eq(SysDeptRecharge::getId, deptRecharge.getId())
				.eq(SysDeptRecharge::getVersion, deptRecharge.getVersion())
				.set(SysDeptRecharge::getScore, currentScore)
				.set(SysDeptRecharge::getVersion, deptRecharge.getVersion() + 1)
				.set(SysDeptRecharge::getUpdateUser, userId)
				.set(SysDeptRecharge::getUpdateTime, now));
		if (update <= 0) {
			throw new RuntimeException("更新余额失败");
		}
		// 新增积分记录
		SysDeptRechargeRecord newRechargeRecord = new SysDeptRechargeRecord();
		newRechargeRecord.setRechargeId(deptRecharge.getId());
		newRechargeRecord.setChangeScore(recoveryScore);
		newRechargeRecord.setCurrentScore(currentScore);
		newRechargeRecord.setType(RechargeRecordType.RECOVERY);
		newRechargeRecord.setDeptId(deptRecharge.getDeptId());
		if (rechargeRecord != null) {
			newRechargeRecord.setRelationDeptId(rechargeRecord.getRelationDeptId());
		}
		newRechargeRecord.setPackageId(packageId);
		newRechargeRecord.setCreateUser(userId);
		newRechargeRecord.setCreateTime(now);
		sysDeptRechargeRecordMapper.insert(newRechargeRecord);
	}

	/**
	 * 获取指定企业下积分包的可分配积分值
	 *
	 * @param superDeptId 上级企业id
	 * @param deptId      企业id
	 * @param typeIds     企业类型
	 * @param packageIds  积分包id
	 * @return 结果
	 */
	@Override
	public List<WmScorePackage> getScorePackagekfpjf(Integer superDeptId, Integer deptId, String[] typeIds, String[] packageIds) {
		// 查询企业下的积分包
		LambdaQueryWrapper<WmScorePackage> queryWrapper = Wrappers.<WmScorePackage>lambdaQuery()
				.in(WmScorePackage::getTypeid, typeIds)
				.eq(WmScorePackage::getDelFlag, DelEnum.NOT_DEL.val())
				.eq(WmScorePackage::getEnableFlag, EnableEnum.ENABLE.val())
				.eq(WmScorePackage::getOldPackage, "0");
		if (superDeptId != null) {
			queryWrapper.eq(WmScorePackage::getSendPackageDeptId, superDeptId);
		}
		if (deptId != null) {
			queryWrapper.eq(WmScorePackage::getDeptId, deptId);
		}
		if (ArrayUtil.isNotEmpty(packageIds)) {
			queryWrapper.in(WmScorePackage::getId, packageIds);
		}
		List<WmScorePackage> packages = this.list(queryWrapper);

		if (CollUtil.isNotEmpty(packages)) {
			// 查询积分包的子包
			Set<String> packageIdSet = packages.stream().map(WmScorePackage::getId).collect(Collectors.toSet());
			List<WmScorePackage> subPackages = this.list(Wrappers.<WmScorePackage>lambdaQuery()
					.in(WmScorePackage::getRelationScoreId, packageIdSet)
					.eq(WmScorePackage::getDelFlag, DelEnum.NOT_DEL.val())
					.eq(WmScorePackage::getEnableFlag, EnableEnum.ENABLE.val()));
			Map<String, Integer> relatedPackageScoresMap = new HashMap<>();
			if (CollUtil.isNotEmpty(subPackages)) {
				// 已分配的积分
				relatedPackageScoresMap = subPackages.stream()
						.collect(Collectors.groupingBy(WmScorePackage::getRelationScoreId, Collectors.summingInt(WmScorePackage::getScore)));
			}

			// 查询积分包的任务
			List<WmTask> tasks = wmTaskMapper.selectList(Wrappers.<WmTask>lambdaQuery()
					.in(WmTask::getScorePackageId, packageIdSet)
                    .eq(WmTask::getDelFlag, DelEnum.NOT_DEL.val())
                    .eq(WmTask::getEnableFlag, EnableEnum.ENABLE.val())
					.eq(WmTask::getTaskStatus, TaskStatusEnum.APPROVED.val()));
			Map<String, Integer> relatedTaskScoresMap = new HashMap<>();
			if (CollUtil.isNotEmpty(tasks)) {
                // 已分配的积分
                relatedTaskScoresMap = tasks.stream()
                        .collect(Collectors.groupingBy(WmTask::getScorePackageId, Collectors.summingInt(WmTask::getScore)));
            }

			Map<String, Integer> finalRelatedPackageScoresMap = relatedPackageScoresMap;
			Map<String, Integer> finalRelatedTaskScoresMap = relatedTaskScoresMap;
			packages.forEach(pkg -> {
				String packageId = pkg.getId();
				// 统计可分配积分值
                Integer score = pkg.getScore();
                if (finalRelatedPackageScoresMap.containsKey(packageId)) {
					score -= finalRelatedPackageScoresMap.get(packageId);
                }
                if (finalRelatedTaskScoresMap.containsKey(packageId)) {
					score -= finalRelatedTaskScoresMap.get(packageId);
                }
                pkg.setKfpjf(score);
			});
		}

		return packages;
	}
}
