package com.qunzhixinxi.hnqz.admin.testpoitl;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import com.deepoove.poi.XWPFTemplate;
import com.deepoove.poi.config.Configure;
import com.deepoove.poi.policy.HackLoopTableRenderPolicy;
import com.qunzhixinxi.hnqz.admin.entity.model.excel.SettlementProofModel;
import com.qunzhixinxi.hnqz.admin.util.OsEnvUtils;

import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.time.LocalDateTime;
import java.util.Collections;
import java.util.HashMap;

public class PoitlTest {

    public static void main(String[] args) {
        // 导出模板渲染
        // 拼装数据
        SettlementProofModel.PackageDetail packageDetail = new SettlementProofModel.PackageDetail();
        packageDetail.setScorePackageName("111");
        packageDetail.setSubjectLocation("12312");
        packageDetail.setActualAmount("11");
        packageDetail.setSettleAmount("123");
        packageDetail.setNumber("1");
        SettlementProofModel settlementProofModel = new SettlementProofModel();
        settlementProofModel.setPackageList(Collections.singletonList(packageDetail));

        // 服务器模板文件路径
        String resourcePath = OsEnvUtils.getEachEnvPaths().get("EXCEL_FILE_PATH") + "settlement_application_form_template.docx";
        // 缓存路径
        String targetPath = OsEnvUtils.getEachEnvPaths().get("EXCEL_FILE_PATH")
                + String.format("out\\settlement_application_form_%s.docx", System.currentTimeMillis());

        HackLoopTableRenderPolicy policy = new HackLoopTableRenderPolicy();

        Configure config = Configure.newBuilder().bind("package_list", policy).build();

        XWPFTemplate template = XWPFTemplate.compile(resourcePath, config).render(
                new HashMap<String, Object>() {{
                    put("package_list", settlementProofModel.getPackageList());
                    put("total_settle_amount", "111");
                    put("total_settle_amount_cn", "222");
                    put("collection_name", "222");
                    put("collection_account", "333");
                    put("collection_bank_name", "444");
                }}
        );

        try {
            template.writeToFile(targetPath);

        } catch (IOException e) {
            throw new RuntimeException("导出失败");
        }
    }
}
