/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.codegen;

import com.qunzhixinxi.hnqz.common.datasource.annotation.EnableDynamicDataSource;
import com.qunzhixinxi.hnqz.common.feign.annotation.EnableHnqzFeignClients;
import com.qunzhixinxi.hnqz.common.security.annotation.EnableHnqzResourceServer;
import com.qunzhixinxi.hnqz.common.swagger.annotation.EnableHnqzSwagger2;
import org.springframework.boot.SpringApplication;
import org.springframework.cloud.client.SpringCloudApplication;

/**
 * @author hnqz
 * @date 2018/07/29 代码生成模块
 */
@EnableDynamicDataSource
@EnableHnqzSwagger2
@EnableHnqzFeignClients
@SpringCloudApplication
@EnableHnqzResourceServer
public class HnqzCodeGenApplication {

	public static void main(String[] args) {
		SpringApplication.run(HnqzCodeGenApplication.class, args);
	}

}
