/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.daemon.quartz.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 积分包状态
 *
 * @author pigx code generator
 * @date 2020-07-31 20:07:00
 */
@Data
@TableName("wm_score_package_status")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "积分包状态")
public class WmScorePackageStatus extends Model<WmScorePackageStatus> {
private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId
    @ApiModelProperty(value="主键id")
    private Integer id;
    /**
     * 用户id
     */
    @ApiModelProperty(value="用户id")
    private String userId;
    /**
     * 积分包id
     */
    @ApiModelProperty(value="积分包id")
    private String packageId;
    /**
     * 审核状态：1.审核中，2.审核通过，3.审核不通过
     */
    @ApiModelProperty(value="审核状态：1.审核中，2.审核通过，3.审核不通过")
    private String status;
    /**
     * 组织机构ID
     */
    @ApiModelProperty(value="组织机构ID")
    private String deptId;
    /**
     * 是否删除
     */
    @ApiModelProperty(value="是否删除")
    private String delFlag;
    /**
     * 是否禁用
     */
    @ApiModelProperty(value="是否禁用")
    private String enableFlag;
    /**
     * 所属租户
     */
    @ApiModelProperty(value="所属租户",hidden=true)
    private Integer tenantId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value="创建人")
    private Integer createUser;
    /**
     * 更新时间
     */
    @ApiModelProperty(value="更新时间")
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value="更新人")
    private Integer updateUser;
	/**
	 * 用户积分
	 */
	@ApiModelProperty(value="用户积分")
    private String userScore;
    }
