/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.daemon.quartz.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 任务表
 *
 * @author pigx code generator
 * @date 2020-09-27 18:11:25
 */
@Data
@TableName("wm_task")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "任务表")
public class WmTask extends Model<WmTask> {
private static final long serialVersionUID = 1L;

    /**
     * 
     */
    @TableId
    @ApiModelProperty(value="")
    private Integer id;
    /**
     * 积分规则
     */
    @ApiModelProperty(value="积分规则")
    private String taskRuleId;
    /**
     * 积分值
     */
    @ApiModelProperty(value="积分值")
    private Integer score;
    /**
     * 任务提交到的积分包ID
     */
    @ApiModelProperty(value="任务提交到的积分包ID")
    private String scorePackageDrugId;
    /**
     * 任务提交到一级经销商的集分宝id
     */
    @ApiModelProperty(value="任务提交到一级经销商的集分宝id")
    private String scorePackageLevel1Id;
    /**
     * 积分包
     */
    @ApiModelProperty(value="积分包")
    private String scorePackageId;
    /**
     * 任务类型ID
     */
    @ApiModelProperty(value="任务类型ID")
    private String taskTypeId;
    /**
     * 调研时间
     */
    @ApiModelProperty(value="调研时间")
    private LocalDateTime lookintoDate;
    /**
     * 省
     */
    @ApiModelProperty(value="省")
    private String province;
    /**
     * 市
     */
    @ApiModelProperty(value="市")
    private String city;
    /**
     * 区
     */
    @ApiModelProperty(value="区")
    private String area;
    /**
     * 地址
     */
    @ApiModelProperty(value="地址")
    private String address;
    /**
     * 调研类型ID
     */
    @ApiModelProperty(value="调研类型ID")
    private String lookintoTypeId;
    /**
     * 任务内容ID
     */
    @ApiModelProperty(value="任务内容ID")
    private String taskContentId;
    /**
     * 任务状态
     */
    @ApiModelProperty(value="任务状态")
    private String taskStatus;
    /**
     * 任务用户ID
     */
    @ApiModelProperty(value="任务用户ID")
    private String taskUserId;
    /**
     * 用户类型ID
     */
    @ApiModelProperty(value="用户类型ID")
    private String taskUserType;
    /**
     * 服务药企
     */
    @ApiModelProperty(value="服务药企")
    private String drugEntId;
    /**
     * 组织机构ID
     */
    @ApiModelProperty(value="组织机构ID")
    private String deptId;
    /**
     * 是否删除
     */
    @ApiModelProperty(value="是否删除")
    private String delFlag;
    /**
     * 是否禁用
     */
    @ApiModelProperty(value="是否禁用")
    private String enableFlag;
    /**
     * 所属租户
     */
    @ApiModelProperty(value="所属租户",hidden=true)
    private Integer tenantId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value="创建时间")
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value="创建人")
    private Integer createUser;
    /**
     * 更新时间
     */
    @ApiModelProperty(value="更新时间")
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value="更新人")
    private Integer updateUser;
    /**
     * 提交状态
     */
    @ApiModelProperty(value="提交状态")
    private String submitStatus;
    /**
     * 分享图片地址
     */
    @ApiModelProperty(value="分享图片地址")
    private String shareImgUrl;
    /**
     * 平台审核状态
     */
    @ApiModelProperty(value="平台审核状态")
    private String platAuditStatus;

    private String taskInfoImg;
    }
