package com.qunzhixinxi.hnqz.daemon.quartz.service;

import com.qunzhixinxi.hnqz.daemon.quartz.entity.WmDeptGMVs;

import java.time.LocalDate;
import java.util.List;

/**
 * {@code WmStatisticsService} 统计服务接口
 *
 * @author Hengchen.Sun
 * @version 1.0.0
 * @date 2021-06-07
 * @since ver.1.0.0
 */
public interface WmStatisticsService {

	/**
	 * 每日统计GMVs
	 * @param params 参数
	 */
	void dailyGMVsStatistics(String params);

	/**
	 * 保存数据到数据库
	 *
	 * @param deptGMVsList
	 * @param today
	 */
	void saveGMVsToDb(List<WmDeptGMVs> deptGMVsList, LocalDate today);

	/**
	 * 将部分历史数据合并（如北疆区域、南疆区域、乌市区域都归类到新疆天山莲药业有限公司）
	 */
	void processSpecialGMVData();
}
