/*
 *    Copyright (c) 2018-2025, hnqz All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the pig4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: hnqz
 */

package com.qunzhixinxi.hnqz.daemon.quartz.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qunzhixinxi.hnqz.daemon.quartz.entity.WmTaskSettleNote;

import java.time.LocalDateTime;
import java.util.List;

/**
 * 历史结算service
 *
 * @author winter
 * @date 2021-03-03 18:15:22
 */
public interface WmTaskSettleNoteService extends IService<WmTaskSettleNote> {

	/**
	 * 计算指定部门对应的结算数据之和
	 *
	 * @param deptId
	 * @param subType
	 * @param startTime
	 * @param endTime
	 * @return
	 */
	List<WmTaskSettleNote> listSettleAmountByDeptId(Integer deptId, String subType, LocalDateTime startTime, LocalDateTime endTime);
}
