package com.qunzhixinxi.hnqz.admin.controller;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.bean.copier.CopyOptions;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.lang.Assert;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.IdcardUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringPool;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.zxing.WriterException;
import com.qunzhixinxi.hnqz.admin.api.constant.CacheConstants;
import com.qunzhixinxi.hnqz.admin.api.constant.UpmsType;
import com.qunzhixinxi.hnqz.admin.api.dto.UserDTO;
import com.qunzhixinxi.hnqz.admin.api.dto.WmPkgDTO;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDept;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDeptCsm;
import com.qunzhixinxi.hnqz.admin.api.entity.SysDictItem;
import com.qunzhixinxi.hnqz.admin.api.entity.SysRole;
import com.qunzhixinxi.hnqz.admin.api.entity.SysUser;
import com.qunzhixinxi.hnqz.admin.api.entity.WmAdRecord;
import com.qunzhixinxi.hnqz.admin.api.entity.WmPkgQuizRelation;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSubmissionPercentRule;
import com.qunzhixinxi.hnqz.admin.api.entity.WmTaskSubmissionRule;
import com.qunzhixinxi.hnqz.admin.api.vo.PersonalScoreRecordVO;
import com.qunzhixinxi.hnqz.admin.api.vo.UserVO;
import com.qunzhixinxi.hnqz.admin.config.UpmsConfig;
import com.qunzhixinxi.hnqz.admin.entity.MedicalEquipment;
import com.qunzhixinxi.hnqz.admin.entity.SysDeptSub;
import com.qunzhixinxi.hnqz.admin.entity.SysUserExtRecord;
import com.qunzhixinxi.hnqz.admin.entity.WmDaAgent;
import com.qunzhixinxi.hnqz.admin.entity.WmDaDistribution;
import com.qunzhixinxi.hnqz.admin.entity.WmDaDrugEnt;
import com.qunzhixinxi.hnqz.admin.entity.WmDaDrugEntDrugtable;
import com.qunzhixinxi.hnqz.admin.entity.WmDaHospital;
import com.qunzhixinxi.hnqz.admin.entity.WmDaPharmacy;
import com.qunzhixinxi.hnqz.admin.entity.WmFeedback;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackage;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageSettleNote;
import com.qunzhixinxi.hnqz.admin.entity.WmScorePackageStatus;
import com.qunzhixinxi.hnqz.admin.entity.WmScoreTaskType;
import com.qunzhixinxi.hnqz.admin.entity.WmTask;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskContent;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskContentConfig;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskRule;
import com.qunzhixinxi.hnqz.admin.entity.WmTaskType;
import com.qunzhixinxi.hnqz.admin.entity.WmUserSign;
import com.qunzhixinxi.hnqz.admin.entity.WmUserSignDetail;
import com.qunzhixinxi.hnqz.admin.entity.WmWkAlbum;
import com.qunzhixinxi.hnqz.admin.entity.WmWkArticle;
import com.qunzhixinxi.hnqz.admin.entity.WmWkArticleShare;
import com.qunzhixinxi.hnqz.admin.entity.dto.SignAgreementDTO;
import com.qunzhixinxi.hnqz.admin.entity.input.NoticeApiInput;
import com.qunzhixinxi.hnqz.admin.entity.input.WmScorePackageApiInput;
import com.qunzhixinxi.hnqz.admin.entity.input.WmScorePackageApiOutput;
import com.qunzhixinxi.hnqz.admin.entity.input.WmWkAlbumApiInput;
import com.qunzhixinxi.hnqz.admin.entity.vo.SysUserSubVO;
import com.qunzhixinxi.hnqz.admin.entity.vo.WmTaskTypeVO;
import com.qunzhixinxi.hnqz.admin.enums.DelEnum;
import com.qunzhixinxi.hnqz.admin.enums.EnableEnum;
import com.qunzhixinxi.hnqz.admin.enums.PackageStatusEnum;
import com.qunzhixinxi.hnqz.admin.enums.PackageTypeEnum;
import com.qunzhixinxi.hnqz.admin.enums.SubjectLocation;
import com.qunzhixinxi.hnqz.admin.enums.SubjectTypeEnum;
import com.qunzhixinxi.hnqz.admin.enums.TaskStatusEnum;
import com.qunzhixinxi.hnqz.admin.enums.UserSignResultEnum;
import com.qunzhixinxi.hnqz.admin.mapper.WmScorePackageSettleNoteMapper;
import com.qunzhixinxi.hnqz.admin.mapper.WmScoreTaskTypeMapper;
import com.qunzhixinxi.hnqz.admin.service.MedicalEquipmentService;
import com.qunzhixinxi.hnqz.admin.service.SysDeptCsmService;
import com.qunzhixinxi.hnqz.admin.service.SysDeptService;
import com.qunzhixinxi.hnqz.admin.service.SysDeptSubService;
import com.qunzhixinxi.hnqz.admin.service.SysDictItemService;
import com.qunzhixinxi.hnqz.admin.service.SysFileService;
import com.qunzhixinxi.hnqz.admin.service.SysPublicParamService;
import com.qunzhixinxi.hnqz.admin.service.SysUserExtRecordService;
import com.qunzhixinxi.hnqz.admin.service.SysUserService;
import com.qunzhixinxi.hnqz.admin.service.WmAdRecordService;
import com.qunzhixinxi.hnqz.admin.service.WmDaAgentService;
import com.qunzhixinxi.hnqz.admin.service.WmDaDistributionService;
import com.qunzhixinxi.hnqz.admin.service.WmDaDrugEntDrugtableService;
import com.qunzhixinxi.hnqz.admin.service.WmDaDrugEntService;
import com.qunzhixinxi.hnqz.admin.service.WmDaHospitalService;
import com.qunzhixinxi.hnqz.admin.service.WmDaPharmacyService;
import com.qunzhixinxi.hnqz.admin.service.WmDeptTaskTypeTemplateService;
import com.qunzhixinxi.hnqz.admin.service.WmFeedbackService;
import com.qunzhixinxi.hnqz.admin.service.WmPkgQuizRelationService;
import com.qunzhixinxi.hnqz.admin.service.WmScorePackageService;
import com.qunzhixinxi.hnqz.admin.service.WmScorePackageStatusService;
import com.qunzhixinxi.hnqz.admin.service.WmScoreTaskTypeService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskContentConfigService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskContentService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskRuleService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskSubmissionPercentRuleService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskSubmissionRuleService;
import com.qunzhixinxi.hnqz.admin.service.WmTaskTypeService;
import com.qunzhixinxi.hnqz.admin.service.WmUserSignDetailService;
import com.qunzhixinxi.hnqz.admin.service.WmUserSignService;
import com.qunzhixinxi.hnqz.admin.service.WmWkAlbumService;
import com.qunzhixinxi.hnqz.admin.service.WmWkArticleService;
import com.qunzhixinxi.hnqz.admin.service.WmWkArticleShareService;
import com.qunzhixinxi.hnqz.admin.service.gig.SysUserSignCertService;
import com.qunzhixinxi.hnqz.admin.util.GetOpenIDUtil;
import com.qunzhixinxi.hnqz.admin.util.Html2ImageByJsWrapper;
import com.qunzhixinxi.hnqz.admin.util.QRCodeGenerator;
import com.qunzhixinxi.hnqz.admin.view.user.UserUpdateInput;
import com.qunzhixinxi.hnqz.common.core.constant.CommonConstants;
import com.qunzhixinxi.hnqz.common.core.constant.enums.CommonFlag;
import com.qunzhixinxi.hnqz.common.core.constant.enums.LoginTypeEnum;
import com.qunzhixinxi.hnqz.common.core.util.R;
import com.qunzhixinxi.hnqz.common.log.annotation.SysLog;
import com.qunzhixinxi.hnqz.common.security.annotation.Inner;
import com.qunzhixinxi.hnqz.common.security.service.HnqzUser;
import com.qunzhixinxi.hnqz.common.security.util.SecurityUtils;
import com.qunzhixinxi.hnqz.common.sequence.sequence.Sequence;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.RandomStringUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.http.ResponseEntity;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.multipart.MultipartFile;

import javax.imageio.ImageIO;
import javax.imageio.stream.ImageOutputStream;
import javax.validation.Valid;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.net.URI;
import java.net.URISyntaxException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.Duration;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneId;
import java.time.temporal.TemporalAdjusters;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * 小程序请求接口
 *
 * @author jimmy
 * @version 1.0.0
 * @date 2022-10-10 12:45
 */
@Slf4j
@RestController
@RequiredArgsConstructor
@RequestMapping("/api")
@Api(value = "api", tags = "api接口")
public class ApiController {
	private final WmTaskContentService wmTaskContentService;
	private final WmTaskContentConfigService wmTaskContentConfigService;
	private final WmWkArticleService wmWkArticleService;
	private final SysDictItemService sysDictItemService;
	private final WmDaDrugEntService wmDaDrugEntService;
	private final WmDaAgentService wmDaAgentService;
	private final SysUserService sysUserService;
	private final SysDeptService sysDeptService;
	private final WmTaskRuleService wmTaskRuleService;
	private final WmTaskTypeService wmTaskTypeService;
	private final WmWkArticleShareService wmWkArticleShareService;
	private final WmScorePackageService wmScorePackageService;
	private final WmScoreTaskTypeService wmScoreTaskTypeService;
	private final WmScoreTaskTypeMapper wmScoreTaskTypeMapper;
	private final WmScorePackageStatusService wmScorePackageStatusService;
	private final WmTaskService wmTaskService;
	private final WmDaDistributionService wmDaDistributionService;
	private final WmDaDrugEntDrugtableService wmDaDrugEntDrugtableService;
	private final SysFileService sysFileService;
	private final WmFeedbackService wmFeedbackService;
	private final WmDaPharmacyService wmDaPharmacyService;
	private final RedisTemplate<String, Object> redisTemplate;
	private final UpmsConfig upmsConfig;
	private final SysDeptSubService sysDeptSubService;
	private final SysPublicParamService sysPublicParamService;
	private final WmWkAlbumService wmWkAlbumService;
	private final WmDeptTaskTypeTemplateService wmDeptTaskTypeTemplateService;
	private final WmUserSignDetailService wmUserSignDetailService;
	private final WmAdRecordService adRecordService;
	private final SysUserSignCertService sysUserSignCertService;
	private final SysUserExtRecordService sysUserExtRecordService;
	private final WmTaskSubmissionRuleService taskSubmissionRuleService;
	private final WmTaskSubmissionPercentRuleService wmTaskSubmissionPercentRuleService;
	private final SysDeptCsmService deptCsmService;
	private final MedicalEquipmentService medicalEquipmentService;
	private final WmScorePackageSettleNoteMapper wmScorePackageSettleNoteMapper;
	private final Sequence taskSequence;
	private final WmPkgQuizRelationService quizRelationService;

	@SysLog("通过任务类型获取表单配置")
	@ApiOperation(value = "任务类型表单配置-通过任务类型获取表单配置", notes = "根据任务类型获取表单配置")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "taskTypeId", value = "任务类型ID", dataType = "long", paramType = "path")})
	@GetMapping("/getTaskContentConfigByTaskTypeId/{taskTypeId}")
	public R getById(@PathVariable String taskTypeId) {
		if (null == taskTypeId) {
			return R.failed("taskTypeId不能为空");

		}

		Map<String, Object> connfigMap = new LinkedHashMap<>();

		// 库存调查需要调查常规的/首次的/库存盘点-中药颗粒剂的
		if ("14".equals(taskTypeId) || "31".equals(taskTypeId) || "37".equals(taskTypeId)) {
			// 常规调查
			connfigMap.put("14", getTaskContentConfigByTaskTypeId("14"));
			// 首次调查
			connfigMap.put("31", getTaskContentConfigByTaskTypeId("31"));
			// 库存盘点-中药颗粒剂
			connfigMap.put("37", getTaskContentConfigByTaskTypeId("37"));
		} else if ("39".equals(taskTypeId) || "40".equals(taskTypeId) || "41".equals(taskTypeId)) {
			// 应收账款回款-A类、应收账款回款-B类、应收账款回款-C类 都取39
			connfigMap = getTaskContentConfigByTaskTypeId("39");
		} else if ("42".equals(taskTypeId) || "43".equals(taskTypeId) || "44".equals(taskTypeId)) {
			// 手术跟台-一级/手术跟台-二级/手术跟台-三级 都取42
			connfigMap = getTaskContentConfigByTaskTypeId("42");
		} else if ("47".equals(taskTypeId) || "48".equals(taskTypeId) || "49".equals(taskTypeId) || "50".equals(taskTypeId)) {
			// 库存调研、竞品调研、培训、使用情况调查 都取47
			connfigMap = getTaskContentConfigByTaskTypeId("47");
		} else if ("56".equals(taskTypeId) || "57".equals(taskTypeId)) {
			// 56首营管理-诊所
			connfigMap.put("56", getTaskContentConfigByTaskTypeId("56"));
			// 57首营管理-药店
			connfigMap.put("57", getTaskContentConfigByTaskTypeId("57"));
		} else {
			connfigMap = getTaskContentConfigByTaskTypeId(taskTypeId);
		}

		return R.ok(connfigMap);
	}

	/**
	 * 根据任务类型id获取任务内容配置信息
	 *
	 * @param taskTypeId 任务类型id
	 * @return 任务内容配置信息
	 */
	private Map<String, Object> getTaskContentConfigByTaskTypeId(String taskTypeId) {
		Map<String, Object> connfigMap = new LinkedHashMap<>();
		Map<String, Object> dictMap = new LinkedHashMap<>();

		WmTaskContentConfig queryConn = new WmTaskContentConfig();
		queryConn.setTaskTypeId(taskTypeId);
		queryConn.setDelFlag("0");
		queryConn.setEnableFlag("0");
		List<WmTaskContentConfig> listConfig = wmTaskContentConfigService.list(
				new QueryWrapper<>(queryConn).orderByAsc("seq"));
		for (WmTaskContentConfig config :
				listConfig) {
			if ("select".equals(config.getTaskFiledType())) {
				SysDictItem sysDictItemConn = new SysDictItem();
				sysDictItemConn.setType(config.getDictGroupName());
				List<SysDictItem> dictItems = sysDictItemService.list(new QueryWrapper<>(sysDictItemConn));
				dictMap.put(config.getDictGroupName(), dictItems);
			}

			if ("domain".equals(config.getTaskFiledType())) {
				if ("ent_service".equals(config.getDictGroupName())) {
					List<WmDaDrugEnt> wmDaDrugEnts = new ArrayList<>();
					if (null == SecurityUtils.getUser()) {
						wmDaDrugEnts = wmDaDrugEntService.list();
					} else {
						wmDaDrugEnts = getDrugListBySecUser(SecurityUtils.getUser().getPlatId());
					}
					List<Map<String, Object>> listMap = new ArrayList<>();
					for (int i = 0; i < wmDaDrugEnts.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaDrugEnts.get(i).getEntname());
						map.put("value", wmDaDrugEnts.get(i).getId());
						map.put("type", "drug");
						listMap.add(map);
					}
					dictMap.put(config.getDictGroupName(), listMap);

				} else if ("ent_bus".equals(config.getDictGroupName())) {
					List<WmDaDistribution> wmDaDrugEnts = wmDaDistributionService.list();
					List<Map<String, Object>> listMap = new ArrayList<>();
					for (int i = 0; i < wmDaDrugEnts.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaDrugEnts.get(i).getGsmc());
						map.put("value", wmDaDrugEnts.get(i).getId());
						listMap.add(map);
					}
					dictMap.put(config.getDictGroupName(), listMap);
				} else if ("ent_dclx".equals(config.getDictGroupName())) {
					List<WmDaHospital> wmDaHospitalList = new ArrayList<>();
					List<Map<String, Object>> wmDaHospitalListList = new ArrayList<>();
					for (int i = 0; i < wmDaHospitalList.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaHospitalList.get(i).getYymc());
						map.put("value", wmDaHospitalList.get(i).getId());
						wmDaHospitalListList.add(map);
					}
					dictMap.put("hospital_service", wmDaHospitalListList);


					List<WmDaDistribution> wmDaDistributions = wmDaDistributionService.list();
					List<Map<String, Object>> wmDaDistributionList = new ArrayList<>();
					for (int i = 0; i < wmDaDistributions.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaDistributions.get(i).getGsmc());
						map.put("value", wmDaDistributions.get(i).getId());
						wmDaDistributionList.add(map);
					}
					dictMap.put("distribution_service", wmDaDistributionList);
				} else if ("ent_pharmacy".equals(config.getDictGroupName())) {
					List<WmDaPharmacy> wmDaDrugEnts = wmDaPharmacyService.list();
					List<Map<String, Object>> listMap = new ArrayList<>();
					for (int i = 0; i < wmDaDrugEnts.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaDrugEnts.get(i).getPharmacyName());
						map.put("value", wmDaDrugEnts.get(i).getId());
						listMap.add(map);
					}
					dictMap.put(config.getDictGroupName(), listMap);
				} else if ("package_list".equals(config.getDictGroupName())) {
					/**
					 * 查询可以关联的积分包
					 */
					List<Map<String, Object>> listMap = new ArrayList<>();
					if (null == SecurityUtils.getUser()) {

					} else {
//						UserVO userVO = sysUserService.selectUserVoById(SecurityUtils.getUser().getId());
						WmScorePackageStatus query = new WmScorePackageStatus();
						query.setUserId(String.valueOf(SecurityUtils.getUser().getId()));
						query.setStatus("2");
						query.setTaskAddFlag("1");
						query.setDelFlag("0");
						query.setEnableFlag("0");

						List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(Wrappers.lambdaQuery(query));
						if (CollUtil.isNotEmpty(statusList)) {
							Set<String> scoreIds = statusList.stream()
									.map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
							// 批量查询积分包
							List<WmScorePackage> wmScorePackages = wmScorePackageService.listByIds(scoreIds);
							Map<String, WmScorePackage> scorePackageMap = wmScorePackages.stream()
									.collect(Collectors.toMap(WmScorePackage::getId, Function.identity()));
							// 批量查询scoreTaskType
							List<Map<String, Object>> scoreTaskTypeCountList = wmScoreTaskTypeMapper.countByScoreId(taskTypeId, scoreIds);
							Map<String, Integer> scoreTaskTypeCountMap = scoreTaskTypeCountList.stream()
									.collect(Collectors.toMap(o -> String.valueOf(o.get("score_id")), o -> Integer.parseInt(String.valueOf(o.get("count")))));

							for (WmScorePackageStatus item : statusList) {
								WmScorePackage wmScorePackage = scorePackageMap.get(item.getPackageId());
								if (null != wmScorePackage) {
									if ("0".equals(wmScorePackage.getTaskAddFlag())) {
										continue;
									}
									if ("1".equals(wmScorePackage.getEnableFlag())) {
										continue;
									}
									if (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2())
											&& !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
										continue;
									}

									if ("28".equals(taskTypeId)) {
										if ("3".equals(wmScorePackage.getPackageType1())) {
											Map<String, Object> map = new HashMap<>();
											map.put("label", wmScorePackage.getScorePackageName());
											map.put("value", wmScorePackage.getId());
											String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrUtil.COMMA, wmScorePackage
													.getDrugProducerList());
											map.put("drugProducer", drugProducer);
											listMap.add(map);
										}

									} else {
										if ("3".equals(wmScorePackage.getPackageType1())) {
											continue;
										}
										/**
										 * 过滤有效任务类型
										 */
										WmScoreTaskType taskType = new WmScoreTaskType();
										taskType.setTaskTypeId(taskTypeId);
										taskType.setScoreId(wmScorePackage.getId());

										int total = scoreTaskTypeCountMap.getOrDefault(wmScorePackage.getId(), 0);

										if (total != 0) {
											Map<String, Object> map = new HashMap<>();
											map.put("label", wmScorePackage.getScorePackageName());
											map.put("value", wmScorePackage.getId());
											String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrUtil.COMMA, wmScorePackage
													.getDrugProducerList());
											map.put("drugProducer", drugProducer);
											listMap.add(map);
										}
									}
								}
							}
						}
					}

					dictMap.put(config.getDictGroupName(), listMap);
				} else if ("package_drug_list".equals(config.getDictGroupName())) {
					// 前端自动获取
					dictMap.put(config.getDictGroupName(), "package_drug_list");
				} else if ("medical_equipment_list".equals(config.getDictGroupName())) {
					List<Map<String, Object>> listMap = new ArrayList<>();
					// 手术跟台任务类型-推广产品
					List<MedicalEquipment> medicalEquipmentList = medicalEquipmentService.listByDrugId(SecurityUtils.getUser().getDeptId());
					if (CollUtil.isNotEmpty(medicalEquipmentList)) {
						listMap = medicalEquipmentList.stream().map(medicalEquipment -> {
							Map<String, Object> equipmentMap = new HashMap<>();
							equipmentMap.put("value", medicalEquipment.getId());
							equipmentMap.put("label", medicalEquipment.getName());
							return equipmentMap;
						}).collect(Collectors.toList());
					}
					dictMap.put(config.getDictGroupName(), listMap);
				}

			}
		}
		connfigMap.put("config", listConfig);
		connfigMap.put("dict", dictMap);
		return connfigMap;
	}

	@SysLog("通过任务类型获取表单配置")
	@ApiOperation(value = "任务类型表单配置-通过任务类型获取表单配置", notes = "根据任务类型获取表单配置")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "taskTypeId", value = "任务类型ID", dataType = "long", paramType = "path")})
	@GetMapping("/getTaskContentConfigByTaskTypeByShareId/{taskTypeId}")
	public R getShareById(@PathVariable String taskTypeId) {
		if (null == taskTypeId) {
			return R.failed("taskTypeId不能为空");

		}

		Map<String, Object> connfigMap = new LinkedHashMap<>();
		Map<String, Object> dictMap = new LinkedHashMap<>();

		WmTaskContentConfig queryConn = new WmTaskContentConfig();
		// 应收账款回款-A类/应收账款回款-B类/应收账款回款-C类 统一设置为 39（应收账款回款-A类）
		if ("39".equals(taskTypeId) || "40".equals(taskTypeId) || "41".equals(taskTypeId)) {
			taskTypeId = "39";
		} else if ("42".equals(taskTypeId) || "43".equals(taskTypeId) || "44".equals(taskTypeId)) {
			// 手术跟台-一级/手术跟台-二级/手术跟台-三级 都取42
			taskTypeId = "42";
		} else if ("47".equals(taskTypeId) || "48".equals(taskTypeId) || "49".equals(taskTypeId) || "50".equals(taskTypeId)) {
			// 库存调研、竞品调研、培训、使用情况调查
			taskTypeId = "47";
		} else if ("51".equals(taskTypeId) || "52".equals(taskTypeId) || "53".equals(taskTypeId)) {
			// 信用管理A、信用管理B、信用管理C
			taskTypeId = "51";
		}

		queryConn.setTaskTypeId(taskTypeId);
		queryConn.setDelFlag("0");
		queryConn.setEnableFlag("0");

		List<WmTaskContentConfig> listConfig =
				wmTaskContentConfigService.list(new QueryWrapper<>(queryConn).orderByAsc("seq", "id"));
		for (WmTaskContentConfig config :
				listConfig) {
			if ("select".equals(config.getTaskFiledType())) {
				SysDictItem sysDictItemConn = new SysDictItem();
				sysDictItemConn.setType(config.getDictGroupName());
				List<SysDictItem> dictItems = sysDictItemService.list(new QueryWrapper<>(sysDictItemConn));
				dictMap.put(config.getDictGroupName(), dictItems);
			}

			if ("domain".equals(config.getTaskFiledType())) {
				if ("ent_service".equals(config.getDictGroupName())) {
					List<WmDaDrugEnt> wmDaDrugEnts = new ArrayList<>();
					if (null == SecurityUtils.getUser()) {
						wmDaDrugEnts = wmDaDrugEntService.list();
					} else {
						wmDaDrugEnts = getDrugListBySecUser(SecurityUtils.getUser().getPlatId());
					}
					List<Map<String, Object>> listMap = new ArrayList<>();
					for (int i = 0; i < wmDaDrugEnts.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaDrugEnts.get(i).getEntname());
						map.put("value", wmDaDrugEnts.get(i).getId());
						map.put("type", "drug");
						listMap.add(map);
					}
					dictMap.put(config.getDictGroupName(), listMap);

					List<WmDaDistribution> wmDaDistributions = wmDaDistributionService.list();
					List<Map<String, Object>> wmDaDistributionList = new ArrayList<>();
					for (int i = 0; i < wmDaDistributions.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaDistributions.get(i).getGsmc());
						map.put("value", wmDaDistributions.get(i).getId());
						wmDaDistributionList.add(map);
					}
					dictMap.put("distribution_service", listMap);
				} else if ("ent_bus".equals(config.getDictGroupName())) {
					List<WmDaDistribution> wmDaDrugEnts = wmDaDistributionService.list();
					List<Map<String, Object>> listMap = new ArrayList<>();
					for (int i = 0; i < wmDaDrugEnts.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaDrugEnts.get(i).getGsmc());
						map.put("value", wmDaDrugEnts.get(i).getId());
						listMap.add(map);
					}
					dictMap.put(config.getDictGroupName(), listMap);
				} else if ("ent_pharmacy".equals(config.getDictGroupName())) {
					List<WmDaPharmacy> wmDaDrugEnts = wmDaPharmacyService.list();
					List<Map<String, Object>> listMap = new ArrayList<>();
					for (int i = 0; i < wmDaDrugEnts.size(); i++) {
						Map<String, Object> map = new HashMap<>();
						map.put("label", wmDaDrugEnts.get(i).getPharmacyName());
						map.put("value", wmDaDrugEnts.get(i).getId());
						listMap.add(map);
					}
					dictMap.put(config.getDictGroupName(), listMap);
				} else if ("package_list".equals(config.getDictGroupName())) {
					/**
					 * 查询可以关联的积分包
					 */
					List<Map<String, Object>> listMap = new ArrayList<>();
					if (null == SecurityUtils.getUser()) {

					} else {
						UserVO userVO = sysUserService.selectUserVoById(SecurityUtils.getUser().getId());
						WmScorePackageStatus query = new WmScorePackageStatus();
						query.setUserId(userVO.getUserId() + "");
						query.setStatus("2");
						query.setTaskAddFlag("1");
						query.setDelFlag("0");
						query.setEnableFlag("0");

						List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(Wrappers.lambdaQuery(query));
						for (WmScorePackageStatus item : statusList) {
							WmScorePackage wmScorePackage = wmScorePackageService.getById(item.getPackageId());
							if (null != wmScorePackage) {
								if ("0".equals(wmScorePackage.getTaskAddFlag())) {
									continue;
								}
								if ("1".equals(wmScorePackage.getEnableFlag())) {
									continue;
								}
								if (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2())
										&& !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
									continue;
								}

								if ("28".equals(taskTypeId)) {
									if ("3".equals(wmScorePackage.getPackageType1())) {
										Map<String, Object> map = new HashMap<>();
										map.put("label", wmScorePackage.getScorePackageName());
										map.put("value", wmScorePackage.getId());
										listMap.add(map);
									}

								} else {
									if ("3".equals(wmScorePackage.getPackageType1())) {
										continue;
									}
									/**
									 * 过滤有效任务类型
									 */
									WmScoreTaskType taskType = new WmScoreTaskType();
									taskType.setTaskTypeId(taskTypeId);
									taskType.setScoreId(wmScorePackage.getId());

									int total = wmScoreTaskTypeService.count(Wrappers.query(taskType));

									if (total != 0) {
										Map<String, Object> map = new HashMap<>();
										map.put("label", wmScorePackage.getScorePackageName());
										map.put("value", wmScorePackage.getId());
										listMap.add(map);
									}
//									List<WmScoreTaskType> taskTypes = wmScoreTaskTypeService.
//											list(Wrappers.query(taskType));
//
//									if (CollectionUtils.isNotEmpty(taskTypes)) {
//										Map<String, Object> map = new HashMap<>();
//										map.put("label", wmScorePackage.getScorePackageName());
//										map.put("value", wmScorePackage.getId());
//										listMap.add(map);
//									}
								}

							}
						}
					}

					dictMap.put(config.getDictGroupName(), listMap);
				}

			}
		}

		connfigMap.put("config", listConfig);
		connfigMap.put("dict", dictMap);
		return R.ok(connfigMap);
	}

	@GetMapping("/getDeptBuildName/{deptId}")
	public R getDeptBuildName(@PathVariable String deptId) {
		Map<String, Object> connfigMap = new LinkedHashMap<>();
		if (null == deptId || "".equals(deptId)) {
			return R.failed("deptId不能为空");
		}

		connfigMap.put("buildName", wmDaAgentService.getDeptBuildName(deptId));
		return R.ok(connfigMap);
	}

	/**
	 * 用户信息-获取用户基本信息
	 *
	 * @param code   小程序信息code
	 * @param avatar 头像
	 * @return 用户信息
	 */
	@ApiOperation(value = "用户信息-获取用户基本信息", notes = "登录认证成功后，调用此接口获取用户基本信息")
	@ApiImplicitParams({@ApiImplicitParam(name = "code", value = "小程序信息code", dataType = "String", paramType = "query")})
	@GetMapping("/getUserInfoByCode")
	public R<Map<String, Object>> getUserInfo(String code, String avatar) {
		Map<String, Object> result = new HashMap<>();

		//获取用户基本信息
		HnqzUser hnqzUser = SecurityUtils.getUser();
		UserDTO userDTO = new UserDTO();
		userDTO.setPlatId(hnqzUser.getPlatId());
		List<UserVO> sysUserList = sysUserService.getUserVoByPlatId(userDTO);

		if (CollUtil.isEmpty(sysUserList)) {
			return R.failed("账号信息异常，请联系管理员");
		}

		SysUser u = sysUserService.getById(hnqzUser.getId());
		if (StrUtil.isBlank(u.getWxOpenid()) || StrUtil.isBlank(u.getAvatar())) {
			SysUser updateU = new SysUser();
			// 获取小程序openid
			updateU.setUserId(u.getUserId());
			if (StrUtil.isBlank(u.getWxOpenid())) {
				Map<String, Object> opemMap = GetOpenIDUtil.oauth2GetOpenid(code, upmsConfig.getWechatEnv());
				log.info("opemMap: {}", opemMap);
				if (MapUtil.isNotEmpty(opemMap)) {
					String openid = (String) opemMap.get("openid");
					updateU.setWxOpenid(openid);
				}
			}
			// avatar头像
			if (StrUtil.isBlank(u.getAvatar())) {
				updateU.setAvatar(avatar);
			}
			updateU.setUpdateTime(LocalDateTime.now());
			sysUserService.updateById(updateU);
		}

		List<Integer> roleList = new ArrayList<>();

		List<Map<String, Object>> list = new ArrayList<>(sysUserList.size());
		for (UserVO sysU : sysUserList) {

			Map<String, Object> mapOne = new HashMap<>();
			mapOne.put("userId", sysU.getUserId().toString());
			mapOne.put("realname", sysU.getRealname());
			mapOne.put("phone", sysU.getPhone());
			mapOne.put("idCardNumber", sysU.getIdCardNumber());
			mapOne.put("certStatus", sysU.getCertStatus());
			mapOne.put("rljCertStatus", sysU.getRljCertStatus());
			mapOne.put("userSign", sysU.getUserSign());
			mapOne.put("certRemark", sysU.getCertRemark());
			mapOne.put("taxHelperAgreementSignature", sysU.getTaxHelperAgreementSignature());
			mapOne.put("bankCardNumber", sysU.getBankCardNumber());
			mapOne.put("bankPhone", sysU.getBankPhone());
			mapOne.put("bankName", sysU.getBankName());

			// 获取会员已结算信息和和待结算信息
			List<WmScorePackageStatus> packageStatuses = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
					.eq(WmScorePackageStatus::getUserId, sysU.getUserId())
					.eq(WmScorePackageStatus::getStatus, PackageStatusEnum.APPROVED.val()));

			List<String> ids = packageStatuses.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toList());


			int paid = 0;
			int unpaid = 0;
			if (CollUtil.isNotEmpty(ids)) {
				List<WmScorePackage> packages = wmScorePackageService.listByIds(ids);

				// 已结算
				paid = packages.stream()
						.filter(pkg -> PersonalScoreRecordVO.PersonalScoreRecordStatus.PAID.getSettleStatus().equals(String.valueOf(pkg.getSettleStatus())))
						.map(WmScorePackage::getScore)
						.reduce(0, Integer::sum);
				// 待结算
				unpaid = packages.stream()
						.filter(pkg -> !PersonalScoreRecordVO.PersonalScoreRecordStatus.PAID.getSettleStatus().equals(String.valueOf(pkg.getSettleStatus())))
						.filter(pkg -> StrUtil.split(PersonalScoreRecordVO.PersonalScoreRecordStatus.UNPAID.getScorePackageStatus(), StrUtil.COMMA).contains(pkg.getScorePackageStatus()))
						.map(WmScorePackage::getScore)
						.reduce(0, Integer::sum);

			}
			mapOne.put("paid", paid);
			mapOne.put("unpaid", unpaid);

			if (Boolean.TRUE.equals(redisTemplate.hasKey(CacheConstants.USER_NOTICE_KEY + sysU.getUserId()))) {
				mapOne.put("notice", true);
			}
			if (Boolean.TRUE.equals(redisTemplate.hasKey(CacheConstants.USER_ADD_NOTICE_KEY + sysU.getUserId()))) {
				mapOne.put("userNewFlag", true);
			}

			if (StrUtil.isBlank(sysU.getAvatar())) {
				mapOne.put("avatar", avatar);
				SysUser sysUser2 = sysUserService.getById(sysU.getUserId());
				sysUser2.setAvatar(avatar);
				sysUserService.updateById(sysUser2);
			} else {
				mapOne.put("avatar", sysU.getAvatar());
			}

			// 获取部门信息
			SysDept sysDept = sysDeptService.getById(sysU.getDeptId());
			mapOne.put("deptId", sysDept.getDeptId().toString());
			mapOne.put("deptName", sysDept.getName());

			// 获取csm信息
			SysDeptCsm deptCsm = deptCsmService.getOne(Wrappers.<SysDeptCsm>lambdaQuery().eq(SysDeptCsm::getDeptId, sysU.getDeptId()));
			mapOne.put("csm", deptCsm);

			String management;
			if (sysDept.getLevel() == 2) {
				WmDaDrugEnt drugEnt = wmDaDrugEntService.selectByDeptId(sysDept.getDeptId());
				mapOne.put("management", drugEnt.getManagement());
				management = drugEnt.getManagement();
			} else {
				WmDaAgent agent = wmDaAgentService.selectByDeptId(sysDept.getDeptId());
				mapOne.put("management", agent.getManagement());
				management = agent.getManagement();
			}

			// 小程序角色:5-全职学术信息沟通专员, 6-兼职学术信息沟通专员, 10-兼职CRC, 13-HCP, 31-招商经理
			List<Integer> roleIdList =
					sysU.getRoleList().stream()
							.filter(item -> item.getRoleId() == 5 || item.getRoleId() == 6 || item.getRoleId() == 10
									|| item.getRoleId() == 13 || item.getRoleId() == 31)
							.map(SysRole::getRoleId).collect(Collectors.toList());

			boolean managementFlag = ("2".equals(management) && roleIdList.contains(5))
					|| ("3".equals(management) && (roleIdList.contains(6) || roleIdList.contains(10)))
					|| ("4".equals(management));
			mapOne.put("managementFlag", managementFlag);

			WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getById(sysU.getDrugEntId());
			if (null != wmDaDrugEnt) {
				mapOne.put("drugEntId", wmDaDrugEnt.getId());
				mapOne.put("drugEntName", wmDaDrugEnt.getEntname());
			}

			mapOne.put("roles", roleIdList);
			mapOne.put("temp1", String.valueOf(sysU.getTemp1()));
			mapOne.put("temp2", String.valueOf(sysU.getTemp2()));
			mapOne.put("temp3", String.valueOf(sysU.getTemp3()));
			mapOne.put("temp4", String.valueOf(sysU.getTemp4()));
			mapOne.put("temp5", String.valueOf(sysU.getTemp5()));

			// 查询待审核包
			List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
					.eq(WmScorePackageStatus::getUserId, String.valueOf(sysU.getUserId()))
					.eq(WmScorePackageStatus::getTaskAddFlag, "1")
					.eq(WmScorePackageStatus::getDelFlag, CommonConstants.STATUS_NORMAL)
					.eq(WmScorePackageStatus::getEnableFlag, CommonConstants.STATUS_NORMAL)
			);

			long onTheWay = 0;
			long waitApprove = statusList.stream().filter(item -> "1".equals(item.getStatus())).count();

			Set<String> pkgIds = statusList.stream().filter(item -> "2".equals(item.getStatus())).map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
			List<Map<String, Object>> listMap;
			if (CollUtil.isNotEmpty(pkgIds)) {
				List<WmScorePackage> pkgs = wmScorePackageService.listByIds(pkgIds);
				listMap = pkgs.stream().map(pkg -> {
					Map<String, Object> map = new HashMap<>(2);
					map.put("label", pkg.getScorePackageName());
					map.put("value", pkg.getId());
					return map;
				}).collect(Collectors.toList());
				onTheWay = listMap.size();
			} else {
				listMap = Collections.emptyList();
			}

			mapOne.put("packageList", listMap);
			mapOne.put("waitApprove", String.valueOf(waitApprove));
			mapOne.put("onTheWay", String.valueOf(onTheWay));
			mapOne.put("userType", sysU.getUserType());
			mapOne.put("jumpFlag", "北京遥领医疗科技有限公司".equals(sysDept.getName()) ? "1" : "0");

			// 结算渠道
			List<SysDeptSub> subList = sysDeptSubService.list(Wrappers.<SysDeptSub>lambdaQuery()
					.eq(SysDeptSub::getDeptId, sysU.getDeptId())
					.eq(SysDeptSub::getEnableFlag, SubjectTypeEnum.ENABLE_FLAG_TRUE.getCode())
			);
			List<String> subTypeList = subList.stream()
					.map(SysDeptSub::getSubjectType)
					.distinct()
					.collect(Collectors.toList());
			mapOne.put("subList", subTypeList);

			// 税源地
			List<SubjectLocation> subjectLocationList = subList.stream()
					.map(SysDeptSub::getSubjectLocation)
					.sorted(Comparator.comparing(SubjectLocation::getSort))
					.collect(Collectors.toList());
			mapOne.put("subjectLocationList", subjectLocationList);

			// 查询配置了任务类型模板的任务类型
			mapOne.put("hasTaskTypeTemplate", wmDeptTaskTypeTemplateService.listTaskTypeByDeptId(sysU.getDeptId()));

			// 税源地和channel对应关系
			Map<String, Integer> collect = subList.stream()
					.collect(Collectors.toMap(sysDeptSub -> sysDeptSub.getSubjectLocation().name(), SysDeptSub::getSubjectChannel));
			mapOne.put("subjectTypeAndChannel", collect);

			// 税源地和eidEnable对应关系
			Map<SubjectLocation, Boolean> subEidMap = subList.stream().collect(Collectors.toMap(SysDeptSub::getSubjectLocation, SysDeptSub::getEidEnable));
			mapOne.put("subjectLocationEid", subEidMap);

			// 认证服务信息回显
			List<SysUserSubVO> userSignCertList = sysUserSignCertService.listUserSignCertForApi(sysU.getUserId(), sysU.getDeptId());
			mapOne.put("certList", userSignCertList);

			// 查询E证通数据
			SysUserExtRecord userExtRecord = sysUserExtRecordService.getOne(Wrappers.<SysUserExtRecord>lambdaQuery()
					.eq(SysUserExtRecord::getUserId, sysU.getUserId())
					.eq(SysUserExtRecord::getDelFlag, DelEnum.NOT_DEL.val()));
			if (userExtRecord != null) {
				mapOne.put("existEidResult", true);
				// E证通照片
				Map<String, Object> eidResultMap = new HashMap<>();
				eidResultMap.put("idCardFrontUrl", userExtRecord.getIdCardFrontUrl());
				eidResultMap.put("idCardBackUrl", userExtRecord.getIdCardBackUrl());
				mapOne.put("eidResult", eidResultMap);
			} else {
				mapOne.put("existEidResult", false);
			}

			// 签署协议信息
			mapOne.put("signHonestAgreement", false);
			if (StrUtil.isNotBlank(sysU.getSignAgreement())) {
				JSONArray agreements = JSONUtil.parseArray(sysU.getSignAgreement());
				for (Object agreement : agreements) {
					SignAgreementDTO signAgreementDTO = BeanUtil.toBean(agreement, SignAgreementDTO.class);
					if (SignAgreementDTO.SignAgreementType.HONEST_AGREEMENT.equals(signAgreementDTO.getAgreementType())) {
						// 廉洁协议是否签署
						mapOne.put("signHonestAgreement", true);
						break;
					}
				}
			}

			// 超60周岁是否提醒
			Map<String, String> checkResult = sysUserService.checkSixtyYearsOld(sysU);
			mapOne.put("ageReminder", Boolean.TRUE.equals(sysU.getAgeReminder()) && CollUtil.isNotEmpty(checkResult));
			if (CollUtil.isNotEmpty(checkResult)) {
				mapOne.put("ageReminderInfo", CollUtil.get(checkResult.values(), 0));
			} else {
				mapOne.put("ageReminderInfo", null);
			}

			// 获取发起认证的令牌
			String randomStr;

			// 获取操作员
			HnqzUser finaAdmin = SecurityUtils.getUser();
			final String token = String.format("%d:batch_channel_cert:%d:token", finaAdmin.getTenantId(), finaAdmin.getId());

			// 返回缓存生成好的
			if (Boolean.TRUE.equals(redisTemplate.hasKey(token))) {
				randomStr = (String) redisTemplate.opsForValue().get(token);
			} else {
				// 生成缓存key,将token缓存到redis
				do {
					randomStr = RandomStringUtils.randomNumeric(6);
				} while (Boolean.FALSE.equals(redisTemplate.opsForValue().setIfAbsent(token, randomStr)));
			}
			mapOne.put("certToken", randomStr);

			list.add(mapOne);

			roleList.addAll(roleIdList);

		}

		result.put("userInfo", list);
		result.put("roles", roleList);


		result.put("completedCount", 0);
		result.put("sumCount", 0);
		result.put("taskProgress", 0);

		return R.ok(result);
	}

	/**
	 * @param input
	 * @return
	 */
	@ApiOperation(value = "积分-获取积分规则", notes = "获取积分规则")
	@SysLog("获取积分规则")
	@GetMapping("/getPackageCanTaskList")
	public R getPackageCanTaskList(WmScorePackageApiInput input) {
		if (null == input.getPackageId()) {
			return R.failed("积分包ID不能为空");
		}

		WmScorePackage wmScorePackage = wmScorePackageService.getById(input.getPackageId());
		if (StringUtils.isEmpty(wmScorePackage.getRuleId())) {
			return R.ok();
		}
		WmScoreTaskType query = new WmScoreTaskType();
		query.setScoreId(input.getPackageId());

		/**
		 * 所有能做的任务
		 */
		List<WmScoreTaskType> wmScoreTaskTypeList = wmScoreTaskTypeService.list(Wrappers.query(query));
		// 对应的taskTypeId
		List<String> baseIds = wmScoreTaskTypeList.stream().
				map(WmScoreTaskType::getTaskTypeId).collect(Collectors.toList());
		// 父级parent_id
		List<String> parentId = baseIds.stream().filter(item -> item.startsWith("p")).collect(Collectors.toList());
		// 子级parentId
		List<String> id = baseIds.stream().filter(item -> !item.startsWith("p")).collect(Collectors.toList());

		// 判断任务类型parentId是否包含'p-x'，不包含则直接跳过以下逻辑（解决积分包id9501 没有父类任务报错）
		List<WmTaskType> temp = new ArrayList<>();
		if (CollUtil.isNotEmpty(parentId)) {
			// 记录表中父id的所有子集
			List<WmTaskType> baseTypeList1 = wmTaskTypeService.list(Wrappers.<WmTaskType>query().lambda()
					.eq(WmTaskType::getTaskTypeLevel, "1")
					.in(WmTaskType::getParentId, parentId));

			if (CollUtil.isNotEmpty(baseTypeList1)) {

				// 按照父id分组
				Map<String, Map<String, List<WmTaskType>>> pTaskTypeMap = baseTypeList1.stream()
						.collect(Collectors.groupingBy(WmTaskType::getParentId, Collectors.groupingBy(WmTaskType::getBaseId)));

				if (CollUtil.isNotEmpty(id)) {
					// 查询所有子id对应的taskType列表
					List<WmTaskType> baseTypeList2 = wmTaskTypeService.
							list(Wrappers.<WmTaskType>query().lambda().eq(WmTaskType::getTaskTypeLevel, "1").in(WmTaskType::getId, id));

					// 所有子id对应的taskType列表 按照父id分组
					Map<String, Map<String, List<WmTaskType>>> cTaskTypeMap = baseTypeList2.stream()
							.collect(Collectors.groupingBy(WmTaskType::getParentId, Collectors.groupingBy(WmTaskType::getBaseId)));
					// 对应的parentId
					Set<String> cPidSet = cTaskTypeMap.keySet();

					// 解决页面父级id和数据库存的父级id不一致的问题（如一对一专访在页面父级是p-16，但taskType表中父级id为p-1）
					// 比较baseTypeList1和baseTypeList2中parentId相同的taskTypeId的数据，如果baseId相同，则取baseTypeList2中的taskTypeId
					for (Map.Entry<String, Map<String, List<WmTaskType>>> entry : pTaskTypeMap.entrySet()) {
						// 获取父级id
						String pid = entry.getKey();
						// 判断大类中是否有相同的父类id
						if (cPidSet.contains(pid)) {
							// baseId
							Map<String, List<WmTaskType>> value = entry.getValue();
							Set<String> pBaseIds = value.keySet();
							// small
							Map<String, List<WmTaskType>> cVal = cTaskTypeMap.get(pid);
							Set<String> cBaseIds = cVal.keySet();
							// 求个交集，找出公共的
							Set<String> res = new HashSet<>(pBaseIds);
							res.retainAll(cBaseIds);
							// 找出的存入temp
							for (String bId : res) {
								temp.addAll(cVal.get(bId));
							}
							// 取父级中对应baseId是独有的部分
							pBaseIds.stream().filter(i -> !res.contains(i)).forEach(i -> temp.addAll(value.get(i)));
						}
					}
				} else {
					temp.addAll(baseTypeList1);
				}
			} else {
				// 查询所有子id对应的taskType列表
				List<WmTaskType> baseTypeList2 = wmTaskTypeService.
						list(Wrappers.<WmTaskType>query().lambda().eq(WmTaskType::getTaskTypeLevel, "1").in(WmTaskType::getId, id));
				temp.addAll(baseTypeList2);
			}
		}

		// 把上述操作没有覆盖到的子id加进来
		Set<String> tempIds = temp.stream().map(WmTaskType::getId).collect(Collectors.toSet());
		Set<String> extCIds = id.stream().filter(s -> !tempIds.contains(s)).collect(Collectors.toSet());
		if (CollUtil.isNotEmpty(extCIds)) {
			temp.addAll(wmTaskTypeService.listByIds(extCIds));
		}

		List<String> baseNames = temp.stream().
				map(WmTaskType::getTaskTypeName).distinct().collect(Collectors.toList());
		WmTaskType wmTaskType = new WmTaskType();
		wmTaskType.setRuleId(wmScorePackage.getRuleId());
		wmTaskType.setDelFlag("0");
		wmTaskType.setEnableFlag("0");
		List<WmTaskType> taskTypeList = wmTaskTypeService.list(Wrappers.query(wmTaskType)
				.lambda().in(WmTaskType::getTaskTypeName, baseNames));

		List<WmTaskTypeVO> taskTypeVOList = new ArrayList<>();
		if (CollUtil.isNotEmpty(taskTypeList)) {
			taskTypeList.forEach(taskType -> {
				WmTaskTypeVO taskTypeVO = BeanUtil.copyProperties(taskType, WmTaskTypeVO.class, "score");
				if (StrUtil.isNotBlank(taskType.getTaskTypeName()) && taskType.getTaskTypeName().startsWith("应收账款回款")) {
					// 应收账款回款 任务类 保存的是1000倍数，需要转换回来
					taskTypeVO.setScore(String.valueOf(taskType.getScore() / 1000.0D));
				} else {
					taskTypeVO.setScore(String.valueOf(taskType.getScore()));
				}
				taskTypeVOList.add(taskTypeVO);
			});
		}

		return R.ok(taskTypeVOList);
	}

	/**
	 * 获取药企列表
	 *
	 * @return 角色列表
	 */
	@ApiOperation(value = "积分-获取积分规则", notes = "获取积分规则")
	@SysLog("获取积分规则")
	@GetMapping("/getTaskTypeListByRuleId")
	public R getTaskTypeListByRuleId(WmTaskType wmTaskType) {

		if (StringUtils.isEmpty(wmTaskType.getRuleId())) {
			return R.failed("积分规则ID不能为空");
		}

		wmTaskType.setDelFlag("0");
		wmTaskType.setEnableFlag("0");
		List<String> noDisplayTaskTypeNameList = Arrays.asList("专家咨询", "受试者管理", "医学撰写", "受试者招募", "数据管理",
				"统计分析", "临床监察", "通用", "患者教育");
		List<WmTaskType> wmTaskTypeList = wmTaskTypeService.list(Wrappers.query(wmTaskType)).stream()
				.filter(taskType -> !noDisplayTaskTypeNameList.contains(taskType.getTaskTypeName()))
				.collect(Collectors.toList());

		List<WmTaskTypeVO> voList = new ArrayList<>();
		if (CollUtil.isNotEmpty(wmTaskTypeList)) {
			wmTaskTypeList.forEach(taskType -> {
				WmTaskTypeVO typeVO = BeanUtil.copyProperties(taskType, WmTaskTypeVO.class, "score");
				if (StrUtil.isNotBlank(taskType.getTaskTypeName()) && taskType.getTaskTypeName().startsWith("应收账款回款")) {
					// 应收账款回款 任务类 保存的是1000倍数，需要转换回来
					typeVO.setScore(String.valueOf(taskType.getScore() / 1000.0D));
				} else {
					typeVO.setScore(String.valueOf(taskType.getScore()));
				}
				voList.add(typeVO);
			});
		}

		return R.ok(voList);
	}


	/**
	 * 获取药企列表
	 *
	 * @return 角色列表
	 */
	@ApiOperation(value = "积分-获取积分规则", notes = "获取积分规则")
	@SysLog("获取积分规则")
	@GetMapping("/taskTypeScoreList")
	public R taskTypeScoreList(WmTaskType wmTaskType) {
		if (null == wmTaskType.getDurgentId()) {
			return R.failed("药企ID不能为空");
		}

		WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getById(wmTaskType.getDurgentId());

		SysUser sysUser = new SysUser();
		sysUser.setDrugEntId(wmDaDrugEnt.getId());
		sysUser.setPlatId(SecurityUtils.getUser().getPlatId());
		sysUser.setDelFlag("0");
		List<SysUser> sysUserList = sysUserService.list(Wrappers.query(sysUser));
		if (sysUserList.size() > 0) {
			SysDept sysDept = sysDeptService.getById(sysUserList.get(0).getDeptId());
			wmTaskType.setLevel1Id(sysDept.getLevel2Id() + "");
		} else {
			SysDept sysDept = sysDeptService.getById(SecurityUtils.getUser().getDeptId());
			wmTaskType.setLevel1Id(sysDept.getLevel2Id() + "");
		}


		wmTaskType.setDelFlag("0");
		wmTaskType.setEnableFlag("0");
		wmTaskType.setTaskTypeLevel("2");

		return R.ok(wmTaskTypeService.list(Wrappers.query(wmTaskType)));
	}

	/**
	 * 新增任务内容表
	 *
	 * @param wmTaskContent 任务内容表
	 * @return R
	 */
	@ApiOperation(value = "任务-新增任务内容表", notes = "新增任务内容表")
	@SysLog("新增任务内容表")
	@PostMapping("/saveTaskContent")
	public R<?> saveTaskContent(@RequestBody WmTaskContent wmTaskContent) {
		log.info("saveTaskContent入参：{}", wmTaskContent);
		Set<String> errorHash = new HashSet<>();
		List<String> ducImgUrl = new ArrayList<>();
		List<String> all = new ArrayList<>();

		String draftKey = wmTaskContent.getDraftKey();
		String taskTypeId = wmTaskContent.getTemp30();

		Integer id = SecurityUtils.getUser().getId();
		Field[] fields = wmTaskContent.getClass().getDeclaredFields();
		for (Field field : fields) {

			field.setAccessible(true);

			try {
				String fieldVal = (String) field.get(wmTaskContent);

				all = duplicateImage(fieldVal, id, errorHash, ducImgUrl, all);
			} catch (Exception ignored) {
			}

		}

		if (CollUtil.isNotEmpty(ducImgUrl)) {
			// 保存图片
			log.info("all size:{}", all.size());
			if (CollUtil.isNotEmpty(all)) {
				all.forEach(hash -> {
					String key = String.format("%s:%s", id, hash);
					log.info("key: {}", key);
					redisTemplate.delete(key);
				});
			}
			return R.failed(ducImgUrl, "提交重复的图片");
		}

		if (org.apache.commons.lang.StringUtils.isEmpty(wmTaskContent.getTemp30())) {
			return R.failed("任务类型不能为空");
		}

		if (org.apache.commons.lang.StringUtils.isEmpty(wmTaskContent.getTemp32())) {
			return R.failed("关联积分包不能为空");
		}

		R<?> r = null;
		try {
			r = wmTaskContentService.saveTaskContent(wmTaskContent);
		} catch (Exception e) {
			log.error("", e);
			return R.failed(e.getMessage());
		} finally {
			log.info("结果:{}, 草稿key:{}", r, draftKey);
			if (r != null && r.getCode() == CommonConstants.SUCCESS && StrUtil.isNotEmpty(draftKey)) {
				String key = String.format(CacheConstants.TASK_CONTENT_DRAFT, taskTypeId, id);
				log.info("删除草稿:{}", key);
				redisTemplate.delete(key);
			}

			if (r == null || (r.getCode() == CommonConstants.FAIL && CollUtil.isNotEmpty(all))) {
				// 保存图片
				log.info("all size:{}", all.size());
				all.forEach(hash -> {
					String key = String.format("%s:%s", id, hash);
					log.info("key: {}", key);
					redisTemplate.delete(key);
				});
			}
		}

		return r;
	}

	private List<String> duplicateImage(String contentValue, Integer userId, Set<String> errorHash, List<String> duplicateImageUrl, List<String> all) {


		if (contentValue.startsWith("/admin/sys-file/wmkj")) {

			List<String> split = StrUtil.split(contentValue, StrUtil.COMMA);

			List<String> IMG_EXT_NAME = Arrays.asList("png", "jpg", "gif", "jpeg", "tif", "bmp");

			split.forEach(item -> {
				List<String> temp = StrUtil.split(item, StrUtil.DOT);
				String extName = temp.get(temp.size() - 1);

				if (IMG_EXT_NAME.contains(extName.toLowerCase())) {
					// 文件md5
					try {
						log.info("图片地址:{}", upmsConfig.getClientUrl() + item);
						byte[] bytes = IOUtils.toByteArray(new URI(upmsConfig.getClientUrl() + item));
						MessageDigest md5 = MessageDigest.getInstance("MD5");
						byte[] digest = md5.digest(bytes);
						String hash = new BigInteger(1, digest).toString(16);
						log.info("图片md5:{}", hash);
						Boolean aBoolean = redisTemplate.opsForValue().setIfAbsent(String.format("%s:%s", userId, hash), item);
						if (!aBoolean) {
							log.error("上传了重复的图片, hash:{}", hash);
							errorHash.add(hash);
							duplicateImageUrl.add(upmsConfig.getClientUrl() + item);
						} else {
							all.add(hash);
							log.info("hash:{}, size:{}, list:{}", hash, all.size(), all);
						}
					} catch (IOException | URISyntaxException | NoSuchAlgorithmException e) {
						e.printStackTrace();
					}

				}


			});


		}
		return all;
	}

	/**
	 * 保存任务内容
	 *
	 * @param wmTaskContent 任务内容表
	 * @return R
	 */
	@ApiOperation(value = "任务-保存任务内容", notes = "保存任务内容")
	@SysLog("保存任务内容")
	@PostMapping("/task-content/draft")
	public R taskContentDraft(@RequestBody WmTaskContent wmTaskContent) {

		// 生成草稿key
		String draftKey = IdUtil.fastSimpleUUID();
		log.info("草稿key:{}", draftKey);
		wmTaskContent.setDraftKey(draftKey);

		HnqzUser user = SecurityUtils.getUser();
		String key = String.format(CacheConstants.TASK_CONTENT_DRAFT, wmTaskContent.getTemp30(), user.getId());

		redisTemplate.opsForValue().set(key, JSONUtil.toJsonStr(wmTaskContent), 12, TimeUnit.HOURS);

		return R.ok();
	}

	/**
	 * 获取任务草稿
	 *
	 * @param taskTypeId 任务类型id
	 * @return R
	 */
	@ApiOperation(value = "任务-获取任务草稿", notes = "获取任务草稿")
	@SysLog("获取任务草稿")
	@GetMapping("/task-content/draft/{task_type_id}")
	public R taskContentDraft(@PathVariable(value = "task_type_id") Integer taskTypeId) {

		HnqzUser user = SecurityUtils.getUser();

		String key = String.format(CacheConstants.TASK_CONTENT_DRAFT, taskTypeId, user.getId());

		String o = (String) redisTemplate.opsForValue().get(key);

		return R.ok(StringUtils.isNotEmpty(o) ? JSONUtil.toBean(o, WmTaskContent.class) : null);
	}


	/**
	 * 修改任务内容表
	 *
	 * @param wmTaskContent 任务内容表
	 * @return R
	 */
	@ApiOperation(value = "任务-修改任务内容表", notes = "修改任务内容表")
	@SysLog("修改任务内容表")
	@PostMapping("/updateTaskContent")
	public R updateById(@RequestBody WmTaskContent wmTaskContent) {
		return R.ok(wmTaskContentService.updateById(wmTaskContent));
	}

	/**
	 * 分页查询
	 *
	 * @param page        分页对象
	 * @param wmWkArticle 文库-文章
	 * @return
	 */
	/**
	 * @param page
	 * @param wmWkArticle
	 * @return
	 */
	@ApiOperation(value = "文章-分页获取资讯列表", notes = "分页获取资讯列表")
	@GetMapping("/getArticlePage")
	public R getWmWkArticlePage(Page page, WmWkArticle wmWkArticle) {
		WmWkArticle query = new WmWkArticle();
		query.setEnableFlag(0);
		query.setDelFlag(0);
		LambdaQueryWrapper<WmWkArticle> wrapper = Wrappers.query(query).lambda();
		if (StringUtils.isNotEmpty(wmWkArticle.getArea())) {
			wrapper.like(WmWkArticle::getArea, wmWkArticle.getArea());
		}
		if (StringUtils.isNotEmpty(wmWkArticle.getTitle())) {
			wrapper.like(WmWkArticle::getTitle, wmWkArticle.getTitle());
		}
		wrapper.orderByDesc(WmWkArticle::getHotFlag);
		wrapper.orderByDesc(WmWkArticle::getCreateTime);
		IPage<WmWkArticle> pages = wmWkArticleService.page(page, wrapper);

//		if (showHot) {
//			if (page.getCurrent() == 1L) {
//				for (int i = 0; i < pages.getRecords().size(); i++) {
//					WmWkArticle wkArticle = pages.getRecords().get(i);
//					wkArticle.setHotFlag(1);
////					redisTemplate.opsForZSet().add(CacheConstants.ARTICLE_HOT_KEY, wkArticle.getId(),
////							wmWkArticle.getForwardNum());
//					if (i >= 4) {
//						break;
//					}
//				}
//			}
//		} else {
//			if (page.getCurrent() == 1L) {
//				Set<ZSetOperations.TypedTuple<String>> hotIds = redisTemplate.opsForZSet()
//						.reverseRangeWithScores(CacheConstants.ARTICLE_HOT_KEY, 0, 4);
//				List<Integer> ids = new ArrayList<>();
//				hotIds.forEach(item -> ids.add(Integer.parseInt(item.getValue())));
//				for (WmWkArticle item : pages.getRecords()) {
//					if(ids.contains(item.getId())){
//						item.setHotFlag(1);
//					}
//				}
//			}
//
//		}
		return R.ok(pages);
	}


	/**
	 * 通过id查询文库-文章
	 *
	 * @param id id
	 * @return R
	 */
	@ApiOperation(value = "文章-通过id获取资讯列表", notes = "通过id获取资讯列表")
	@GetMapping("/getArticleById")
	public R getArticleById(Integer id) {
		WmWkArticle wmWkArticle = wmWkArticleService.getById(id);
		wmWkArticle.setReadNum(wmWkArticle.getReadNum() + 1);

//		if (null != id) {
//			redisTemplate.opsForZSet().add(CacheConstants.ARTICLE_HOT_KEY, id.toString(),
//					wmWkArticle.getForwardNum() + wmWkArticle.getReadNum());
//		}

		return R.ok(wmWkArticle);
	}

	/**
	 * 通过id查询文库-相册
	 *
	 * @param articleId   文章id
	 * @param shareUserId 分享人id
	 * @param openUserId  获取打开人openid授权码
	 * @param type        操作类型
	 * @param packageId   积分包id
	 * @param sharePicUrl 分享图片链接
	 * @return 结果
	 */
	@ApiOperation(value = "文章-通过分享链接，获取文章", notes = "文章-通过分享链接，获取文章")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "articleId", value = "文章ID", dataType = "String"),
			@ApiImplicitParam(name = "shareUserId", value = "分享人ID", dataType = "String"),
			@ApiImplicitParam(name = "openUserId", value = "获取打开人openid的授权码", dataType = "String"),
			@ApiImplicitParam(name = "type", value = "操作类型", dataType = "String"),
			@ApiImplicitParam(name = "packageId", value = "所属积分包id", dataType = "String"),
			@ApiImplicitParam(name = "sharePicUrl", value = "分享url", dataType = "String"),
			@ApiImplicitParam(name = "remark", value = "备注", dataType = "String")
	})
	@GetMapping("/shareArticleById")
	public R<?> shareArticleById(String articleId, String shareUserId, String openUserId, String type, String packageId, String sharePicUrl, String remark) {
		return shareAndReadTaskMethod(articleId, shareUserId, openUserId, type, packageId, sharePicUrl, "article", remark);
	}


	/**
	 * 分页查询
	 *
	 * @param page      分页对象
	 * @param wmWkAlbum 文库-相册
	 * @return
	 */
	@ApiOperation(value = "相册-分页获取相册列表", notes = "分页获取相册列表")
	@GetMapping("/getAlbumPage")
	public R getWmWkAlbumPage(Page page, WmWkAlbum wmWkAlbum, String shareUserId) {

		//查询当前登录人药企的
		System.out.println(shareUserId);
		if (StringUtils.isNotEmpty(shareUserId)) {
			WmWkAlbumApiInput input = new WmWkAlbumApiInput();
			SysUser sysUser = sysUserService.getById(shareUserId);
			List<String> drugIds = new ArrayList<>();
			SysDept sysDept = sysDeptService.getById(sysUser.getDeptId());
			if (sysDept.getLevel() == 2) {
				WmDaDrugEnt drugEnt = wmDaDrugEntService.selectByDeptId(sysDept.getDeptId());
				drugIds.add(drugEnt.getId());
			}
			if (sysDept.getLevel() == 3 || sysDept.getLevel() == 4) {

				List<WmDaDrugEnt> entList = wmDaDrugEntService.getListByCsoDeptId(sysDept.getDeptId());

				drugIds.addAll(entList.stream().map(WmDaDrugEnt::getId).collect(Collectors.toList()));
			}

			/**
			 * 能查到药企
			 */
			if (CollectionUtils.isNotEmpty(drugIds)) {
				input.setDrugIds(drugIds);
				Page pageAnswer2 = wmWkAlbumService.pageByCondition(page, input);
				return R.ok(pageAnswer2);
			}
		}

		wmWkAlbum.setDelFlag(0);
		wmWkAlbum.setEnableFlag(0);
		Page pageAnswer = wmWkAlbumService.page(page, Wrappers.query(wmWkAlbum)
				.lambda()
				.orderByDesc(WmWkAlbum::getCreateTime));
		return R.ok(pageAnswer);
	}

	/**
	 * 分页查询
	 *
	 * @param page      分页对象
	 * @param wmWkAlbum 文库-相册
	 * @return
	 */
	@Inner(false)
	@ApiOperation(value = "相册-分页获取相册列表", notes = "分页获取相册列表")
	@GetMapping("/getAlbumPageNew")
	public R getAlbumPageNew(Page page, WmWkAlbum wmWkAlbum, String shareUserId) {

		//查询当前登录人药企的
		System.out.println(shareUserId);
		if (StringUtils.isNotEmpty(shareUserId)) {
			WmWkAlbumApiInput input = new WmWkAlbumApiInput();
			SysUser sysUser = sysUserService.getById(shareUserId);
			input.setDeptId(sysUser.getDeptId());
			Page pageAnswer2 = wmWkAlbumService.pageByConditionNew(page, input);
			return R.ok(pageAnswer2);
		}

		wmWkAlbum.setDelFlag(0);
		wmWkAlbum.setEnableFlag(0);
		Page pageAnswer = wmWkAlbumService.page(page, Wrappers.query(wmWkAlbum)
				.lambda()
				.orderByDesc(WmWkAlbum::getCreateTime));

		return R.ok(pageAnswer);
	}


	/**
	 * 通过id查询文库-相册
	 *
	 * @param id id
	 * @return R
	 */
	@ApiOperation(value = "相册-通过id获取相册信息", notes = "通过id获取相册信息")
	@GetMapping("/getAlbumById")
	public R getById(Integer id) {
		WmWkAlbum wmWkAlbum = wmWkAlbumService.getById(id);
		if (null != wmWkAlbum) {
			if (null != wmWkAlbum.getGlyp()) {
				if (wmWkAlbum.getGlyp().indexOf(",") > 0) {
					String drugTables[] = wmWkAlbum.getGlyp().split(",");
					List<String> stringList = new ArrayList<>();
					for (String str : drugTables) {
						stringList.add(str);
					}
					List<WmDaDrugEntDrugtable> wmDaDrugEntDrugtableList = wmDaDrugEntDrugtableService.listByIds(stringList);
					if (wmDaDrugEntDrugtableList.size() > 0) {
						String drugStr = "";
						for (int i = 0; i < wmDaDrugEntDrugtableList.size(); i++) {
							drugStr += wmDaDrugEntDrugtableList.get(i).getDrugname();
							if (i < wmDaDrugEntDrugtableList.size() - 1) {
								drugStr += "、";
							}
						}
						wmWkAlbum.setGlyp(drugStr);
					}
				} else {
					WmDaDrugEntDrugtable wmDaDrugEntDrugtable = wmDaDrugEntDrugtableService.getById(wmWkAlbum.getGlyp());
					if (null != wmDaDrugEntDrugtable) {
						wmWkAlbum.setGlyp(wmDaDrugEntDrugtable.getDrugname());
					}
				}
			}
		}
		return R.ok(wmWkAlbum);
	}


	/**
	 * 通过id查询文库-相册
	 *
	 * @param id          相册id
	 * @param shareUserId 分享人id
	 * @param openUserId  获取打开人openid授权码
	 * @param type        操作类型
	 * @param packageId   积分包id
	 * @param sharePicUrl 分享图片链接
	 * @return 结果
	 */
	@ApiOperation(value = "相册-分享通过分享链接，获取相册", notes = "通过分享链接，获取相册  type=share 分享， type=open 分享链接打开")
	@ApiImplicitParams({
			@ApiImplicitParam(name = "id", value = "相册id", dataType = "String"),
			@ApiImplicitParam(name = "shareUserId", value = "分享人ID", dataType = "String"),
			@ApiImplicitParam(name = "openUserId", value = "获取打开人openid的授权码", dataType = "String"),
			@ApiImplicitParam(name = "type", value = "操作类型", dataType = "String"),
			@ApiImplicitParam(name = "packageId", value = "所属积分包id", dataType = "String"),
			@ApiImplicitParam(name = "sharePicUrl", value = "分享url", dataType = "String"),
			@ApiImplicitParam(name = "remark", value = "备注", dataType = "String")
	})
	@GetMapping("/shareAlbumById")
	public R<?> shareAlbumById(String id, String shareUserId, String openUserId, String type, String packageId, String sharePicUrl, String remark) {
		return shareAndReadTaskMethod(id, shareUserId, openUserId, type, packageId, sharePicUrl, "album", remark);
	}


	/**
	 * 获取药企列表
	 *
	 * @return 角色列表
	 */
	@ApiOperation(value = "药企-获取药企列表", notes = "获取药企列表")
	@GetMapping("/getDrugEntList")
	public R listDrugEnt(WmDaDrugEnt wmDaDrugEnt) {
		System.out.println("SecurityUtils.getUser():" + SecurityUtils.getUser());
		System.out.println("SecurityUtils.getUser().getPlatId():" + SecurityUtils.getUser().getPlatId());

		List<WmDaDrugEnt> wmDaDrugEntList = new ArrayList<>();
		if (null == SecurityUtils.getUser()) {
			wmDaDrugEnt.setDelFlag("0");
			wmDaDrugEnt.setDelFlag("0");
			return R.ok(wmDaDrugEntService.list(Wrappers.query(wmDaDrugEnt)));
		} else {
			List<SysUser> list = sysUserService.getUserByPlatId(SecurityUtils.getUser().getPlatId());
			if (list.size() > 0) {
				List<String> deptIdList = new ArrayList<>();
				deptIdList.add("-1");
				for (SysUser sysU : list) {
					UserVO userVO = sysUserService.selectUserVoById(sysU.getUserId());
					for (SysRole sysRole : userVO.getRoleList()) {
						if (5 == sysRole.getRoleId() || 6 == sysRole.getRoleId()) {
							deptIdList.add(sysU.getDrugEntId() + "");
						}
					}
				}
				return R.ok(wmDaDrugEntService.listByIds(deptIdList));
			}
		}
		return R.ok();
	}


	public List<WmDaDrugEnt> getDrugListBySecUser(String platId) {
		List<SysUser> list = sysUserService.getUserByPlatId(platId);
		if (list.size() > 0) {
			List<String> deptIdList = new ArrayList<>();
			for (SysUser sysU : list) {
				deptIdList.add(sysU.getDeptId() + "");
			}

			List<String> agentIdList = new ArrayList<>();
			List<SysDept> deptList = sysDeptService.listByIds(deptIdList);
			if (deptList.size() > 0) {
				for (SysDept sysD : deptList) {
					System.out.println("SysDept:" + sysD.getLevel());

					if (3 == sysD.getLevel()) {
						System.out.println("sysD.getLevel2Id():" + sysD.getLevel2Id());
						agentIdList.add(sysD.getLevel2Id() + "");
					} else if (4 == sysD.getLevel()) {
						System.out.println("sysD.getLevel3Id():" + sysD.getLevel3Id());
						agentIdList.add(sysD.getLevel3Id() + "");
					}
				}
			}

			if (agentIdList.size() > 0) {
				List<String> drugIdList = new ArrayList<>();
				List<WmDaAgent> wmDaAgentList = wmDaAgentService.listByIds(agentIdList);
				if (wmDaAgentList.size() > 0) {
					for (WmDaAgent wmDaAgent : wmDaAgentList) {
						if (null != wmDaAgent.getExtDrugEnt()) {
							drugIdList.addAll(Arrays.asList(wmDaAgent.getExtDrugEnt().split(",")));
						}
						drugIdList.add(wmDaAgent.getDrugEntId());
					}
					return wmDaDrugEntService.listByIds(drugIdList);
				}


			}

		}
		return null;
	}

	private final WmUserSignService wmUserSignService;


	/**
	 * 通过id查询用户签到表
	 *
	 * @param id id
	 * @return R
	 */
	@ApiOperation(value = "签到-通过ID获取签到信息", notes = "通过id查询")
	@GetMapping("/getSignInfoById")
	public R getSignInfoById(Integer id) {
		return R.ok(wmUserSignService.getById(id));
	}

	/**
	 * 新增用户签到表
	 *
	 * @param wmUserSign 用户签到表
	 * @return R
	 */
	@ApiOperation(value = "签到-新增用户签到表", notes = "新增用户签到表")
	@SysLog("新增用户签到表")
	@PostMapping("/saveSignInfo")
	public R save(@RequestBody WmUserSign wmUserSign) {

		// 重置打卡时间，以系统为准，规避端设备时间不准的问题
		LocalDateTime now = LocalDateTime.now().plusMinutes(5L);
		if (wmUserSign.getSignDate().isAfter(now)) {
			return R.failed("打卡时间异常，请检查设备日期");
		}

		if (null == wmUserSign.getLatitude() || null == wmUserSign.getLongitude()) {
			return R.failed("签到经纬度不能为空");
		}

		return wmUserSignService.saveWmUserSign(wmUserSign);
	}


	/**
	 * 获取药企列表
	 *
	 * @return 角色列表
	 */
	@ApiOperation(value = "签到-通过用户ID获取签到列表", notes = "通过用户ID获取签到列表")
	@GetMapping("/getSignListByUserId")
	public R listDrugEnt(WmUserSign wmUserSign) {
		return R.ok(wmUserSignService.list(Wrappers.query(wmUserSign)));
	}

	private final WmDaHospitalService wmDaHospitalService;

	/**
	 * 获取药企列表
	 *
	 * @return 角色列表
	 */
	@ApiOperation(value = "医院-获取医院列表", notes = "医院-获取医院列表")
	@GetMapping("/getHospitalList")
	public R getHospitalList(String longitude, String latitude, String type) {
		return R.ok(wmDaHospitalService.list(Wrappers.emptyWrapper()));
	}

	/**
	 * 小程序领取任务包（积分包）列表
	 *
	 * @return 积分包列表
	 */
	@ApiOperation(value = "积分包-获取用户积分包", notes = "积分包-获取用户积分包，selType  众包用户传值，1 可领取  2 已领取")
	@GetMapping("/getUserScorePackageList2")
	public R<?> getUserScorePackageList2(Page page, int selType, String packageName, String selDate, String activeId) {

		UserVO userVO = sysUserService.selectUserVoById(SecurityUtils.getUser().getId());

		List<WmScorePackageApiOutput> scorePackageList;
		if (1 == selType && isZbRole(userVO.getRoleList(), 5)) {
			return R.ok();
		}

		IPage<WmScorePackageApiOutput> scorePage;
		// 小程序角色:5-全职学术信息沟通专员, 6-兼职学术信息沟通专员, 10-兼职CRC, 13-HCP
		if (1 == selType && (isZbRole(userVO.getRoleList(), 6) || isZbRole(userVO.getRoleList(), 10) || isZbRole(userVO.getRoleList(), 13))) {
			WmScorePackage query = new WmScorePackage();
			query.setDeptId(userVO.getDeptId() + "");
			query.setTypeid("4");
			query.setScorePackageName(packageName);
			query.setBelongDate(selDate);
			query.setZbId(userVO.getUserId() + "");
			scorePage = wmScorePackageService.getPackageListForReceive(page, query);
			scorePackageList = scorePage.getRecords();

			// 获取积分包的关联试卷
			Map<Integer, List<WmPkgQuizRelation>> quizMap = null;
			if (CollUtil.isNotEmpty(scorePackageList)) {
				List<Integer> collect = scorePackageList.stream().mapToInt(pkg -> Integer.parseInt(pkg.getId())).boxed().distinct().collect(Collectors.toList());
				List<WmPkgQuizRelation> quizRelations = quizRelationService.listQuizRelationsByPkgIds(collect);

				if (CollUtil.isNotEmpty(quizRelations)) {
					quizMap = quizRelations.stream().collect(Collectors.groupingBy(WmPkgQuizRelation::getPkgId));
				}

			}

			for (WmScorePackageApiOutput item : scorePackageList) {
				WmScorePackageStatus queryGetUser = new WmScorePackageStatus();
				queryGetUser.setPackageId(item.getId());
				queryGetUser.setStatus("2");
				queryGetUser.setDelFlag("0");
				queryGetUser.setEnableFlag("0");
				item.setUserGetNum(wmScorePackageStatusService.count(Wrappers.query(queryGetUser)));

				if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(item.getPackageType1()) && item.getScore() != null) {
					// 如果是患者教育，则转换积分 '分'->'元'
					item.setScore(String.format("%.2f", Integer.parseInt(item.getScore()) / 100.0));
				}

				if (CollUtil.isNotEmpty(quizMap)) {
					List<WmPkgQuizRelation> quizRelations = quizMap.get(Integer.parseInt(item.getId()));
					item.setQuizRelations(quizRelations);
				}
			}
			return R.ok(scorePage);
		}

		if (2 == selType) {
			WmScorePackageApiInput input = new WmScorePackageApiInput();
			input.setScorePackageName(packageName);
			input.setSelDate(selDate);
			input.setUserId(userVO.getUserId() + "");
			if (isZbRole(userVO.getRoleList(), 5)) {
				// 小程序角色:5-全职学术信息沟通专员
				input.setTypeid("3");

				if ("2".equals(activeId)) {
					input.setTaskAddFlag("1");
					input.setStatus("2");
				} else if ("3".equals(activeId)) {
					return R.ok();
				} else if ("4".equals(activeId)) {
					input.setStatus("2");
					input.setTaskAddFlag("0");
				}
			} else if (isZbRole(userVO.getRoleList(), 31)) {
				// 小程序角色:31-招商经理
				input.setTypeid("5");

				if ("2".equals(activeId)) {
					input.setTaskAddFlag("1");
					input.setStatus("2");
				} else if ("3".equals(activeId)) {
					return R.ok();
				} else if ("4".equals(activeId)) {
					input.setStatus("2");
					input.setTaskAddFlag("0");
				}
			} else if (isZbRole(userVO.getRoleList(), 6) || isZbRole(userVO.getRoleList(), 10)
					|| isZbRole(userVO.getRoleList(), 13)) {
				// 小程序角色:6-兼职学术信息沟通专员, 10-兼职CRC, 13-HCP
				input.setTypeid("4");

				if ("2".equals(activeId)) {
					input.setTaskAddFlag("1");
					input.setStatus("2");
				} else if ("3".equals(activeId)) {
					input.setTaskAddFlag("1");
					input.setStatus("1");
				} else if ("4".equals(activeId)) {
					input.setStatus("2");
					input.setTaskAddFlag("0");
				}
			} else {
				return R.ok();
			}

			scorePage = wmScorePackageStatusService.getReceivedPackageList(page, input);

			scorePackageList = scorePage.getRecords();

			// 获取积分包的关联试卷
			Map<Integer, List<WmPkgQuizRelation>> quizMap = null;
			if (CollUtil.isNotEmpty(scorePackageList)) {
				List<Integer> collect = scorePackageList.stream().mapToInt(pkg -> Integer.parseInt(pkg.getId())).boxed().distinct().collect(Collectors.toList());
				List<WmPkgQuizRelation> quizRelations = quizRelationService.listQuizRelationsByPkgIds(collect);

				if (CollUtil.isNotEmpty(quizRelations)) {
					quizMap = quizRelations.stream().collect(Collectors.groupingBy(WmPkgQuizRelation::getPkgId));
				}

			}

			if (CollectionUtils.isNotEmpty(scorePackageList)) {
				Set<String> scorePackageIds = scorePackageList.stream()
						.filter(output -> PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val().equals(output.getPackageType1()))
						.map(WmScorePackageApiOutput::getId).collect(Collectors.toSet());
				Map<String, List<WmScorePackageSettleNote>> settelMap = new HashMap<>();
				if (CollUtil.isNotEmpty(scorePackageIds)) {
					List<WmScorePackageSettleNote> settleNotes = wmScorePackageSettleNoteMapper.selectList(Wrappers.<WmScorePackageSettleNote>lambdaQuery()
							.in(WmScorePackageSettleNote::getPackageId, scorePackageIds));
					if (CollUtil.isNotEmpty(settleNotes)) {
						settelMap = settleNotes.stream()
								.collect(Collectors.groupingBy(WmScorePackageSettleNote::getPackageId));
					}
				}
				for (WmScorePackageApiOutput item : scorePackageList) {

					if (CollUtil.isNotEmpty(quizMap)) {
						List<WmPkgQuizRelation> quizRelations = quizMap.get(Integer.parseInt(item.getId()));
						item.setQuizRelations(quizRelations);
					}

					if (PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val().equals(item.getPackageType1())) {
						// 只处理积分包的情况
						List<WmScorePackageSettleNote> settleNoteList = settelMap.get(item.getId());
						if (CollUtil.isNotEmpty(settleNoteList)) {
							WmScorePackageSettleNote settleNote = settleNoteList.get(0);
							item.setNotifyTime(settleNote.getNotifyTime());
							item.setSettleNoteStatus(String.valueOf(settleNote.getSettleNoteStatus()));
						}
					}

					WmScorePackageStatus queryGetUser = new WmScorePackageStatus();
					queryGetUser.setPackageId(item.getId());
					queryGetUser.setStatus("2");
					queryGetUser.setDelFlag("0");
					queryGetUser.setEnableFlag("0");
					item.setUserGetNum(wmScorePackageStatusService.count(Wrappers.query(queryGetUser)));

					if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val()
							.equals(item.getPackageType1()) && item.getScore() != null) {
						// 如果是患者教育，则转换积分 '分'->'元'
						item.setScore(String.format("%.2f", Integer.parseInt(item.getScore()) / 100.0));
					}

					WmTask wmTask = new WmTask();
					wmTask.setScorePackageId(item.getId());
					wmTask.setTaskUserId(userVO.getUserId() + "");
					wmTask.setRealFlag("0");
					List<WmTask> wmTaskList = wmTaskService.list(Wrappers.query(wmTask)
							.lambda()
							.eq(WmTask::getRealFlag, "0")
							.eq(WmTask::getDelFlag, DelEnum.NOT_DEL.val())
							.ne(WmTask::getTaskStatus, "4"));
					item.setTaskFinishNum(wmTaskList.size());
					item.setSpeedProgress(0);
					item.setFinishScore(0);
					item.setWaitApprovalScore(0);
					item.setWaitApprovalTaskNum(0);
					if ("3".equals(item.getStatus())) {
						item.setTaskAddFlag("1");
						continue;
					}

					if (StrUtil.equals(PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val(), item.getPackageType1())
							|| StrUtil.equals(PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val(), item.getPackageType1())) {
						Integer finishScore = 0;
						Integer waitApprovalScore = 0;
						for (WmTask task : wmTaskList) {
							finishScore += task.getScore();
							if ("2".equals(task.getTaskStatus())) {
								waitApprovalScore += task.getScore();
							}
						}
						item.setFinishScore(finishScore);
						item.setWaitApprovalScore(waitApprovalScore);
						if (StringUtils.isNumeric(item.getScore()) && Integer.parseInt(item.getScore()) > 0) {
							double d = Math.ceil(finishScore * 100 / Integer.parseInt(item.getScore()));
							if (d > 100) {
								d = 100;
							}
							item.setSpeedProgress(new Double(d).intValue());
						}
					} else {
						Integer waitApprovalTaskNum = 0;
						double d = Math.ceil(wmTaskList.size() * 100 / item.getTaskNum());
						if (d > 100) {
							d = 100;
						}
						for (WmTask task : wmTaskList) {
							if ("2".equals(task.getTaskStatus())) {
								waitApprovalTaskNum++;
							}
						}
						item.setWaitApprovalTaskNum(waitApprovalTaskNum);
						item.setSpeedProgress(new Double(d).intValue());
					}


				}
			}
			return R.ok(scorePage);

		}

		return R.ok();

	}


//	/**
//	 * 获取用户积分包
//	 *
//	 * @return 获取用户积分包
//	 */
//	@ApiOperation(value = "积分包-获取用户积分包", notes = "积分包-获取用户积分包，selType  众包用户传值，1 可领取  2 已领取")
//	@GetMapping("/getUserScorePackageList")
//	public R getUserScorePackageList(Page page, int selType, String taskTypeId, String selDate, String packagename, String activeId) {
//
//		if (!"null".equals(selDate) || !"".equals(selDate)) {
//			selDate = null;
//		}
//		boolean isRule = false;
//
//		List<Map<String, Object>> answerList = new ArrayList<>();
//
//		UserVO userVO1 = sysUserService.selectUserVoById(SecurityUtils.getUser().getId());
//
//		Page scorePage = null;
//		WmScorePackage wmScorePackage = new WmScorePackage();
//		if (isZbRole(userVO1.getRoleList(), 5)) {
//			if (1 == selType) {
//				return R.ok();
//			}
//		}
//
//		if (null != selDate && !"".equals(selDate) || null != taskTypeId && !"".equals(taskTypeId)) {
//			WmTaskRule qwmTaskRule = new WmTaskRule();
//			qwmTaskRule.setDrugentId(userVO1.getDrugEntId());
//			qwmTaskRule.setDelFlag("0");
//
//			if (null == selDate || "".equals(selDate)) {
//				qwmTaskRule.setRuleMonth(taskTypeId);
//
//			} else {
//				qwmTaskRule.setRuleMonth(selDate);
//			}
//			List<WmTaskRule> listWmTaskRule = wmTaskRuleService.list(Wrappers.query(qwmTaskRule));
//			if (listWmTaskRule.size() > 0) {
//				wmScorePackage.setTaskRuleId(listWmTaskRule.get(0).getId());
//			} else {
//				wmScorePackage.setTaskRuleId("-1");
//				isRule = true;
//
//			}
//		}
//
//
//		wmScorePackage.setDeptId(userVO1.getDeptId() + "");
//		LambdaQueryWrapper<WmScorePackage> queryWrapper = Wrappers.query(wmScorePackage).lambda().
//				orderByAsc(WmScorePackage::getPackageStatus).orderByDesc(WmScorePackage::getCreateTime);
//		if (StringUtils.isNotEmpty(packagename)) {
//			queryWrapper.like(WmScorePackage::getScoreName, packagename);
//		}
//
//		if (isZbRole(userVO1.getRoleList(), 5)) {
//
//			if (2 == selType && StringUtils.isNotEmpty(activeId)) {
//				if ("2".equals(activeId)) {
//					queryWrapper.eq(WmScorePackage::getPackageStatus, "2");
//					queryWrapper.eq(WmScorePackage::getPackageFinishStatus, "0");
//				} else if ("4".equals(activeId)) {
//					queryWrapper.eq(WmScorePackage::getPackageStatus, "2");
//					queryWrapper.eq(WmScorePackage::getPackageFinishStatus, "1");
//				}
//			}
//
//			wmScorePackage.setTypeid("3");
//			wmScorePackage.setXxdbId(userVO1.getUserId() + "");
//			scorePage = wmScorePackageService.page(page, queryWrapper);
//		}
//
//
//		List<WmScorePackage> type2List = new ArrayList<>();
//
//		if (isZbRole(userVO1.getRoleList(), 6)) {
//			wmScorePackage.setTypeid("4");
//			if (1 == selType) {
//				wmScorePackage.setZbId("");
//				queryWrapper = queryWrapper.isNull(WmScorePackage::getPackageStatus);
//				wmScorePackage.setDeptId(userVO1.getDeptId() + "");
//
//				scorePage = wmScorePackageService.page(page, queryWrapper);
//
//			} else {
//				if (StringUtils.isNotEmpty(activeId) && "2".equals(activeId)) {
//					wmScorePackage.setZbId(userVO1.getUserId() + "");
//					wmScorePackage.setPackageStatus("2");
//					wmScorePackage.setPackageFinishStatus("0");
//					scorePage = wmScorePackageService.page(page, queryWrapper);
//
//				} else if (StringUtils.isNotEmpty(activeId) && "4".equals(activeId)) {
//					wmScorePackage.setZbId(userVO1.getUserId() + "");
//					wmScorePackage.setPackageStatus("2");
//					wmScorePackage.setPackageFinishStatus("1");
//					scorePage = wmScorePackageService.page(page, queryWrapper);
//
//				} else {
//					WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
//					if (isRule) {
//						wmScorePackageStatus.setId(-1);
//					}
//
//					LambdaQueryWrapper<WmScorePackageStatus> wmScorePackageStatusLambdaQueryWrapper = Wrappers.query(wmScorePackageStatus).lambda();
//					if (null != packagename && !"".equals(packagename)) {
//						LambdaQueryWrapper<WmScorePackage> lambdaQueryWrapper = Wrappers.lambdaQuery();
//						lambdaQueryWrapper.like(WmScorePackage::getScoreName, packagename);
//
//						List<WmScorePackage> list = wmScorePackageService.list(lambdaQueryWrapper);
//						List<String> list1 = new ArrayList<>();
//						if (list.size() > 0) {
//							for (WmScorePackage wmScorePackage1 : list) {
//								list1.add(wmScorePackage1.getId());
//							}
//						} else {
//							list1.add("-1");
//						}
//						wmScorePackageStatusLambdaQueryWrapper.in(WmScorePackageStatus::getPackageId, list1);
//					}
//
//					if (null != selDate && !"".equals(selDate) || null != taskTypeId && !"".equals(taskTypeId)) {
//						String dateStr = "";
//						if (null != selDate && !"".equals(selDate)) {
//							dateStr = selDate;
//
//						} else {
//							dateStr = taskTypeId;
//
//						}
//
//						wmScorePackageStatusLambdaQueryWrapper.ge(WmScorePackageStatus::getCreateTime, getLocalDateTime(dateStr, "start"));
//						wmScorePackageStatusLambdaQueryWrapper.le(WmScorePackageStatus::getCreateTime, getLocalDateTime(dateStr, "end"));
//					}
//
//					if (StringUtils.isNotEmpty(activeId) && "3".equals(activeId)) {
//						wmScorePackageStatusLambdaQueryWrapper.eq(WmScorePackageStatus::getStatus, "1");
//
//					}
//
//					wmScorePackageStatusLambdaQueryWrapper.orderByDesc(WmScorePackageStatus::getCreateTime);
//					wmScorePackageStatus.setUserId(userVO1.getUserId() + "");
//					scorePage = wmScorePackageStatusService.page(page, wmScorePackageStatusLambdaQueryWrapper);
//					List<WmScorePackageStatus> statusList = scorePage.getRecords();
//
//					List<String> stringList = new ArrayList<>();
//
//					if (statusList.size() > 0) {
//						for (WmScorePackageStatus wmScorePackageStatus1 : statusList) {
//							stringList.add(wmScorePackageStatus1.getPackageId());
//						}
//					}
//
//					if (stringList.size() > 0) {
//						for (String str1 : stringList) {
//							WmScorePackage wmScorePackage1 = wmScorePackageService.getById(str1);
//							if (null != wmScorePackage1) {
//								type2List.add(wmScorePackage1);
//							}
//						}
//					} else {
//						wmScorePackage.setZbId(SecurityUtils.getUser().getId() + "");
//					}
//				}
//
//			}
//		}
//
//		//获取积分包配置
//
//		List<WmScorePackage> list = new ArrayList<>();
//		if (isZbRole(userVO1.getRoleList(), 5)) {
//			list = scorePage.getRecords();
//		} else {
//			if (1 == selType) {
//				list = scorePage.getRecords();
//			} else {
//				if (StringUtils.isNotEmpty(activeId) && "2".equals(activeId)) {
//					list = scorePage.getRecords();
//
//				} else if (StringUtils.isNotEmpty(activeId) && "4".equals(activeId)) {
//
//					list = scorePage.getRecords();
//				} else {
//					list = type2List;
//				}
//
//			}
//		}
//
//
//		System.out.println("list:" + list.size());
//		if (list.size() > 0) {
//			List<String> notInStatus = new ArrayList<>();
//			notInStatus.add("1000000000");
//			for (WmScorePackage wms : list) {
//				Map<String, Object> map = new HashMap<>();
//				WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getById(wms.getDrugEntId());
//				if (null != wmDaDrugEnt) {
//					map.put("drugEntName", wmDaDrugEnt.getEntname());
//				} else {
//					map.put("drugEntName", "");
//				}
//
//				if (null != wms.getLevel2Id() && !"".equals(wms.getLevel2Id())) {
//					WmDaAgent wmDaAgent = wmDaAgentService.getById(wms.getLevel2Id());
//					map.put("packageEntName", wmDaAgent.getGsmc());
//				} else {
//					if (null != wms.getLevel1Id() && !"".equals(wms.getLevel1Id())) {
//						WmDaAgent wmDaAgent = wmDaAgentService.getById(wms.getLevel1Id());
//						map.put("packageEntName", wmDaAgent.getGsmc());
//					} else {
//						map.put("packageEntName", wmDaDrugEnt.getEntname());
//					}
//				}
//				if (null != wms.getTaskRuleId()) {
//					WmTaskRule wmTaskRule = wmTaskRuleService.getById(wms.getTaskRuleId());
//					if (null != wmTaskRule) {
//						map.put("termDate", wmTaskRule.getRuleMonth() + "-01 至 " + wmTaskRule.getRuleMonth() + "-30");
//						DateFormat format = new SimpleDateFormat("yyyy-MM");
//						DateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");
//
//						try {
//							Date adata = format.parse(wmTaskRule.getRuleMonth());
//							// 获取Calendar
//							Calendar calendar = Calendar.getInstance();
//							// 设置时间,当前时间不用设置
//							calendar.setTime(adata);
//							// 设置日期为本月最大日期
//							calendar.set(Calendar.DATE, calendar.getActualMaximum(Calendar.DATE));
//
//							// 打印
//							String endDate = format1.format(calendar.getTime());
//							if (null != endDate) {
//								map.put("termDate", wmTaskRule.getRuleMonth() + "-01 至 " + endDate);
//							}
//
//						} catch (ParseException e) {
//							e.printStackTrace();
//						}
//
//					}
//				}
//
//				map.put("packageName", wms.getScoreName());
//				map.put("socre", wms.getScore());
//				map.put("createTime", wms.getCreateTime());
//				map.put("id", wms.getId());
//				map.put("finishScore", "0");
//				map.put("submitScore", "0");
//				map.put("cannelAuditScore", "0");
//				map.put("speedProgress", "0");
//
//
//				WmTask wmTask = new WmTask();
//				wmTask.setDelFlag("0");
//				wmTask.setEnableFlag("0");
//				wmTask.setScorePackageId(wms.getId());
//				/**
//				 * TODO 审核不通过的分数 不计入积分包
//				 * .ne(WmTask::getRealFlag,"1")
//				 */
//				List<WmTask> wmTaskList = wmTaskService.
//						list(Wrappers.query(wmTask).lambda().ne(WmTask::getRealFlag, "1"));
//				if (wmTaskList.size() > 0) {
//					Integer submitScore = 0;
//					Integer finishScore = 0;
//					Integer cannelAuditScore = 0;
//					for (WmTask wmT : wmTaskList
//					) {
//						if ("4".equals(wmT.getTaskStatus())) {
//							cannelAuditScore += wmT.getScore();
//						} else {
//							submitScore += wmT.getScore();
//						}
//						finishScore += wmT.getScore();
//					}
//
//					map.put("finishScore", finishScore + "");
//					map.put("submitScore", submitScore + "");
//					if (wms.getScore() > 0) {
//						double d = Math.ceil(submitScore * 100 / wms.getScore());
//						if (d > 100) {
//							d = 100;
//						}
//						map.put("speedProgress", new Double(d).intValue());
//
//					}
//					map.put("cannelAuditScore", cannelAuditScore + "");
//				}
//
//				if (isZbRole(userVO1.getRoleList(), 5)) {
//					if ("4".equals(wms.getPackageStatus())) {
//						map.put("status", "已终止");
//						map.put("statusId", "4");
//					} else {
//						map.put("status", "已领取");
//					}
//				}
//
//
//				if (SecurityUtils.getRoles().contains(6)) {
//					if (1 == selType) {
//						map.put("status", "未领取");
//						map.put("statusId", 0);
//					} else {
//						WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
//						wmScorePackageStatus.setPackageId(wms.getId());
//						wmScorePackageStatus.setUserId(userVO1.getUserId() + "");
//						List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(Wrappers.query(wmScorePackageStatus).lambda().notIn(true, WmScorePackageStatus::getId, notInStatus).orderByDesc(WmScorePackageStatus::getCreateTime));
//						if (statusList.size() > 0) {
//							notInStatus.add(statusList.get(0).getId() + "");
//							if ("1".equals(statusList.get(0).getStatus())) {
//								map.put("status", "审核中");
//								map.put("statusId", 1);
//							} else if ("2".equals(statusList.get(0).getStatus())) {
//								map.put("status", "审核通过");
//								map.put("statusId", 2);
//							} else if ("3".equals(statusList.get(0).getStatus())) {
//								map.put("status", "审核不通过");
//								map.put("statusId", 3);
//							} else if ("3".equals(statusList.get(0).getStatus())) {
//								map.put("status", "审核不通过");
//								map.put("statusId", 3);
//							}
//
//							map.put("statusId", statusList.get(0).getStatus());
//
//							if ("4".equals(wms.getPackageStatus())) {
//								map.put("status", "已终止");
//								map.put("statusId", "4");
//
//							}
//						}
//						//map.put("status","审核通过");
//						//map.put("statusId",2);
//					}
//				}
//				map.put("packageFinishStatus", wms.getPackageFinishStatus());
//				answerList.add(map);
//			}
//		}
//		scorePage.setRecords(answerList);
//		return R.ok(scorePage);
//
//	}


	/**
	 * 通过id查询积分包
	 *
	 * @param id id
	 * @return R
	 */
	@ApiOperation(value = "积分包-", notes = "通过id查询")
	@GetMapping("/getScorePackageInfoById")
	public R getScorePackageInfoById(String id) {
		WmScorePackage wms = wmScorePackageService.getById(id);
		Map<String, Object> map = new HashMap<>();
//		WmDaDrugEnt wmDaDrugEnt = wmDaDrugEntService.getById(wms.getDrugEntId());
//		map.put("drugEntId", wmDaDrugEnt.getId());
//		if (null != wmDaDrugEnt) {
//			map.put("drugEntName", wmDaDrugEnt.getEntname());
//		} else {
//			map.put("drugEntName", "");
//		}
//
//		if (null != wms.getLevel2Id() && !"".equals(wms.getLevel2Id())) {
//			WmDaAgent wmDaAgent = wmDaAgentService.getById(wms.getLevel2Id());
//			map.put("packageEntName", wmDaAgent.getGsmc());
//			map.put("packageEntId", wmDaAgent.getId());
//
//		} else {
//			if (null != wms.getLevel1Id() && !"".equals(wms.getLevel1Id())) {
//				WmDaAgent wmDaAgent = wmDaAgentService.getById(wms.getLevel1Id());
//				map.put("packageEntName", wmDaAgent.getGsmc());
//				map.put("packageEntId", wmDaAgent.getId());
//
//			} else {
//				map.put("packageEntName", wmDaDrugEnt.getEntname());
//				map.put("packageEntId", wmDaDrugEnt.getId());
//
//			}
//		}

		SysDept dept = sysDeptService.getById(wms.getSendPackageDeptId());
		map.put("packageEntName", dept.getName());
		map.put("packageEntId", dept.getDeptId());

//		if (null != wms.getTaskRuleId()) {
//			WmTaskRule wmTaskRule = wmTaskRuleService.getById(wms.getTaskRuleId());
//			if (null != wmTaskRule) {
//				map.put("termDate", wmTaskRule.getRuleMonth() + "-01 至 " + wmTaskRule.getRuleMonth() + "-30");
//				DateFormat format = new SimpleDateFormat("yyyy-MM");
//				DateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");
//
//				try {
//					Date adata = format.parse(wmTaskRule.getRuleMonth());
//					// 获取Calendar
//					Calendar calendar = Calendar.getInstance();
//					// 设置时间,当前时间不用设置
//					calendar.setTime(adata);
//					// 设置日期为本月最大日期
//					calendar.set(Calendar.DATE, calendar.getActualMaximum(Calendar.DATE));
//
//					// 打印
//					String endDate = format1.format(calendar.getTime());
//					if (null != endDate) {
//						map.put("termDate", wmTaskRule.getRuleMonth() + "-01 至 " + endDate);
//					}
//
//				} catch (ParseException e) {
//					e.printStackTrace();
//				}
//
//			}
//		}
		if (StringUtils.isNotEmpty(wms.getBelongDate())) {
			map.put("termDate", wms.getBelongDate() + "-01 至 " + wms.getBelongDate() + "-30");
			DateFormat format = new SimpleDateFormat("yyyy-MM");
			DateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");

			try {
				Date adata = format.parse(wms.getBelongDate());
				// 获取Calendar
				Calendar calendar = Calendar.getInstance();
				// 设置时间,当前时间不用设置
				calendar.setTime(adata);
				// 设置日期为本月最大日期
				calendar.set(Calendar.DATE, calendar.getActualMaximum(Calendar.DATE));

				// 打印
				String endDate = format1.format(calendar.getTime());
				if (null != endDate) {
					map.put("termDate", wms.getBelongDate() + "-01 至 " + endDate);
				}

			} catch (ParseException e) {
				e.printStackTrace();
			}

		}
		map.put("status", wms.getPackageStatus());
		map.put("packageName", wms.getScorePackageName());
//		map.put("packageName", wms.getScoreName());
		if (PackageTypeEnum.TYPE1_HCP_PACKAGE.val().equals(wms.getPackageType1())) {
			// 如果是患者教育，则需要转换积分包单位 ‘分’->‘元’
			map.put("score", String.format("%.2f", wms.getScore() / 100.0) + "分");
		} else {
			map.put("score", wms.getScore() + "分");
		}
		map.put("userNum", wms.getUserNum());
		map.put("createTime", wms.getCreateTime());
		map.put("packageType1", wms.getPackageType1());
		map.put("id", wms.getId());
		map.put("finishScore", "0");
//		map.put("packageFinishStatus", wms.getPackageFinishStatus()+"");

		WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
		wmScorePackageStatus.setUserId(SecurityUtils.getUser().getId() + "");
		wmScorePackageStatus.setPackageId(id);
		wmScorePackageStatus.setDelFlag("0");
		wmScorePackageStatus.setEnableFlag("0");
		List<WmScorePackageStatus> statusList = wmScorePackageStatusService.
				list(Wrappers.query(wmScorePackageStatus).lambda().ne(WmScorePackageStatus::getStatus, "3"));

		if (CollectionUtils.isNotEmpty(statusList)) {
			map.put("receiveFlag", 0);
			if (wms.getTaskNum() == null) {
				map.put("taskNum", statusList.size() + "个");
			}
		} else {
			map.put("receiveFlag", 1);
			if (wms.getTaskNum() == null) {
				map.put("taskNum", "0个");
			}
		}

		/**
		 * 判断是否可导出任务明细
		 */
		WmTask wmTask = new WmTask();
//		List<String> list = new ArrayList<>();
//		list.add(id);
//		wmTask.setExtIds(list);
		wmTask.setScorePackageId(id);
		wmTask.setTaskStatus("3");
//		List<WmTask> wmTaskList = wmTaskService.list(Wrappers.query(wmTask));
		int count = wmTaskService.count(Wrappers.query(wmTask));
//		List<WmTask> wmTaskList = wmTaskService.getTaskListByPackageIdsReturnWmtaskInfo(wmTask);
		if (count > 0) {
			map.put("exportFlag", "1");
		} else {
			map.put("exportFlag", "0");
		}
		map.put("email", redisTemplate.opsForValue()
				.get(CacheConstants.EMAIL_KEY + SecurityUtils.getUser().getPlatId()));

		if ("1".equals(wms.getEnableFlag())) {
			map.put("receiveFlag", 0);
		}
		if (!"0".equals(wms.getEnableType())) {
			map.put("receiveFlag", 0);
		}

		return R.ok(map);
	}


	/**
	 * 小程序领取积分包
	 * <p>
	 * 垃圾逻辑，配合试卷提交废弃
	 *
	 * @param packageId 积分包id
	 * @return R
	 */
	@Deprecated
	@ApiOperation(value = "积分包-领取", notes = "积分包-领取")
	@GetMapping("/receivePackage")
	public R receivePackage(String packageId) {
		WmScorePackage wmScorePackage = wmScorePackageService.getById(packageId);
		if (null == wmScorePackage) {
			return R.failed("积分包不存在");
		}

		if ("1".equals(wmScorePackage.getEnableFlag())) {
			return R.failed("积分包已终止，不能领取");
		}

		if (!"0".equals(wmScorePackage.getEnableType())) {
			return R.failed("积分包剩余积分值已收回，不能领取");
		}

		if ("1".equals(wmScorePackage.getIsReceive())) {
			return R.failed("积分包不能领取");
		}

//		UserDTO userDTO = new UserDTO();
//		userDTO.setPlatId(SecurityUtils.getUser().getPlatId());
//		userDTO.setDrugEntId(wmScorePackage.getDrugEntId());
		UserVO userVO = sysUserService.selectUserVoById(SecurityUtils.getUser().getId());
//		List<UserVO> userVOList = sysUserService.getUserVoByPlatId(userDTO);
		if (null == userVO) {
			return R.failed("账号出错");
		}
		if (isZbRole(userVO.getRoleList(), 5)) {
			return R.failed("全职学术推广员不能领取积分包");
		}

		// 校验超过60周岁,不能做任务
		Map<String, String> checkResult = sysUserService.checkSixtyYearsOld(userVO);
		if (CollUtil.isNotEmpty(checkResult) && checkResult.containsKey("OVER")) {
			throw new RuntimeException(checkResult.get("OVER"));
		}

		WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
		wmScorePackageStatus.setPackageId(packageId);
		wmScorePackageStatus.setUserId(userVO.getUserId() + "");
		wmScorePackageStatus.setDelFlag("0");
		wmScorePackageStatus.setEnableFlag("0");
		List<WmScorePackageStatus> wmScorePackageStatusList = wmScorePackageStatusService.
				list(Wrappers.query(wmScorePackageStatus).lambda().ne(WmScorePackageStatus::getStatus, 3));
		if (wmScorePackageStatusList.size() > 0) {
			return R.failed("积分包已领取");
		}

		wmScorePackageStatus.setStatus("1");
		wmScorePackageStatus.setTaskAddFlag("1");
		if (PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val().equals(wmScorePackage.getPackageType1())
				|| PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
			wmScorePackageStatus.setUserScore(wmScorePackage.getScore() + "");
		} else {
			wmScorePackageStatus.setUserScore(wmScorePackage.getUserScore());
		}
		wmScorePackageStatus.setTaskNum(wmScorePackage.getTaskNum());
		wmScorePackageStatus.setDeptId(userVO.getDeptId() + "");
		LocalDateTime localDateTime = LocalDateTime.now();
		wmScorePackageStatus.setCreateTime(localDateTime);
		wmScorePackageStatus.setUpdateTime(localDateTime);
		wmScorePackageStatusService.save(wmScorePackageStatus);

		WmScorePackageStatus query = new WmScorePackageStatus();
		query.setPackageId(packageId);
		query.setStatus("1");
		query.setDelFlag("0");
		query.setEnableFlag("0");
		int total = wmScorePackageStatusService.count(Wrappers.query(query));
		/**
		 * 显示用的
		 */
		if (total == 1) {
			WmScorePackage update = new WmScorePackage();
			update.setId(wmScorePackage.getId());
			update.setScorePackageStatus("2");
//			wmScorePackage.setPackageStatus("1");
			update.setIsConduct("1");
			wmScorePackageService.updateById(update);
		}

		return R.ok();

	}

	/**
	 * 小程序领取积分包
	 *
	 * @param resource 积分包信息
	 * @return 领取结果
	 */
	@PostMapping("/pkg/pickup")
	@Transactional(rollbackFor = Exception.class)
	public R<?> receivePackage(@Valid @RequestBody WmPkgDTO.OnPkgPickup resource) {

		String pkgId = resource.getPkgId();
		WmScorePackage wmScorePackage = wmScorePackageService.getById(pkgId);
		if (null == wmScorePackage) {
			return R.failed("积分包不存在");
		}

		if (!"0".equals(wmScorePackage.getEnableType())) {

			return R.failed("积分包剩余积分值已收回，不能领取");
		}

		if ("1".equals(wmScorePackage.getEnableFlag())) {
			return R.failed("积分包已终止，不能领取");
		}

		if ("1".equals(wmScorePackage.getIsReceive())) {
			return R.failed("积分包不能领取");
		}

		UserVO userVO = sysUserService.selectUserVoById(SecurityUtils.getUser().getId());

		if (null == userVO) {
			return R.failed("账号出错");
		}

		if (isZbRole(userVO.getRoleList(), 5)) {
			return R.failed("全职学术推广员不能领取积分包");
		}

		// 校验超过60周岁,不能做任务
		Map<String, String> checkResult = sysUserService.checkSixtyYearsOld(userVO);
		if (CollUtil.isNotEmpty(checkResult) && checkResult.containsKey("OVER")) {
			throw new RuntimeException(checkResult.get("OVER"));
		}

		// 校验是否已经领取

		int count = wmScorePackageStatusService.count(Wrappers.<WmScorePackageStatus>lambdaQuery()
				.eq(WmScorePackageStatus::getPackageId, pkgId)
				.eq(WmScorePackageStatus::getUserId, userVO.getUserId().toString())
				.eq(WmScorePackageStatus::getDelFlag, "0")
				.eq(WmScorePackageStatus::getEnableFlag, "0")
				.ne(WmScorePackageStatus::getStatus, 3)
		);

		if (count > 0) {
			return R.failed("积分包已领取");
		}

		// 封装结果
		WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
		wmScorePackageStatus.setPackageId(pkgId);
		wmScorePackageStatus.setUserId(userVO.getUserId().toString());
		wmScorePackageStatus.setDelFlag("0");
		wmScorePackageStatus.setEnableFlag("0");
		wmScorePackageStatus.setStatus("1");
		wmScorePackageStatus.setTaskAddFlag("1");
		if (PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val().equals(wmScorePackage.getPackageType1()) || PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
			wmScorePackageStatus.setUserScore(wmScorePackage.getScore().toString());
		} else {
			wmScorePackageStatus.setUserScore(wmScorePackage.getUserScore());
		}
		wmScorePackageStatus.setTaskNum(wmScorePackage.getTaskNum());
		wmScorePackageStatus.setDeptId(userVO.getDeptId().toString());
		LocalDateTime localDateTime = LocalDateTime.now();
		wmScorePackageStatus.setCreateTime(localDateTime);
		wmScorePackageStatus.setUpdateTime(localDateTime);
		wmScorePackageStatus.setQuizResult(resource.getQuizResults());

		boolean saved = wmScorePackageStatusService.save(wmScorePackageStatus);

		return saved ? R.ok(true, "领取积分包成功") : R.failed(false, "领取积分包失败");

	}

	/**
	 * 根据积分包获取任务列表
	 *
	 * @return 根据积分包获取任务列表
	 */
	@ApiOperation(value = "根据积分包获取任务列表", notes = "根据积分包获取任务列表")
	@GetMapping("/getTaskListByPackageId")
	public R getTaskListByPackageId(Page page, WmTask wmTask) {

		Page<WmTask> taskPage = wmTaskService.page(page,
				Wrappers.<WmTask>lambdaQuery()
						.eq(WmTask::getScorePackageId, wmTask.getScorePackageId())
						.eq(WmTask::getTaskUserId, wmTask.getTaskUserId())
						.ne(WmTask::getScore, 0)
						.eq(WmTask::getRealFlag, "0")
						.eq(WmTask::getDelFlag, DelEnum.NOT_DEL.val())
						.orderByDesc(WmTask::getCreateTime));

		List<WmTask> wmTaskList = taskPage.getRecords();

		List<WmTaskType> wmTaskTypeList = wmTaskTypeService.
				list(Wrappers.<WmTaskType>lambdaQuery().eq(WmTaskType::getTaskTypeLevel, "1"));

		Map<String, String> typeMap = wmTaskTypeList.stream()
				.collect(Collectors.toMap(WmTaskType::getId, WmTaskType::getTaskTypeName));

		for (int i = 0; i < wmTaskList.size(); i++) {
			wmTaskList.get(i).setTaskTypeId(typeMap.get(wmTaskList.get(i).getTaskTypeId()));
		}
		taskPage.setRecords(wmTaskList);

		return R.ok(taskPage);
	}


	/**
	 * 获取药企列表
	 *
	 * @return 角色列表
	 */
	@ApiOperation(value = "任务-我的任务记录列表", notes = "任务-我的任务记录列表")
	@GetMapping("/getHistoryTaskList")
	public R getHistoryTaskList(Page page, WmTask wmTask) {
		wmTask.setEnableFlag("0");
		wmTask.setDelFlag("0");
		UserDTO userDTO = new UserDTO();
		userDTO.setPlatId(SecurityUtils.getUser().getPlatId());
		List<UserVO> userVOList = sysUserService.getUserVoByPlatId(userDTO);
		Page<WmTask> taskPage = null;
		LambdaQueryWrapper<WmTask> queryWrapper = Wrappers.lambdaQuery();

		int num = 0;
		int allnum = 0;
		for (UserVO userVO : userVOList) {

			if (null != wmTask.getTaskRuleId() && !"".equals(wmTask.getTaskRuleId())) {
				WmTaskRule wmTaskRule = new WmTaskRule();
				wmTaskRule.setRuleMonth(wmTask.getTaskRuleId());
				wmTaskRule.setDrugentId(userVO.getDrugEntId());
				List<WmTaskRule> wmTaskRuleList = wmTaskRuleService.list(Wrappers.query(wmTaskRule));
				if (wmTaskRuleList.size() > 0) {
					if (num == 0) {
						queryWrapper.and(
								Wrapper -> Wrapper.eq(WmTask::getTaskRuleId, wmTaskRuleList.get(0).getId() + "")
										.eq(WmTask::getTaskUserId, userVO.getUserId() + "")
						);
					} else {
						queryWrapper.or(
								Wrapper -> Wrapper.eq(WmTask::getTaskRuleId, wmTaskRuleList.get(0).getId() + "")
										.eq(WmTask::getTaskUserId, userVO.getUserId() + "")
						);
					}

				} else {
					queryWrapper.eq(WmTask::getTaskRuleId, "-100");
				}
				num++;


//				queryWrapper.ge(WmTask::getCreateTime,getLocalDateTime(wmTask.getTaskRuleId(),"start"));
//				queryWrapper.le(WmTask::getCreateTime,getLocalDateTime(wmTask.getTaskRuleId(),"end"));

			} else {
				if (allnum == 0) {
					queryWrapper.and(Wrapper -> Wrapper.eq(WmTask::getTaskUserId, userVO.getUserId()));
				} else {
					queryWrapper.or(Wrapper -> Wrapper.eq(WmTask::getTaskUserId, userVO.getUserId()));
				}
				allnum++;

			}
		}

		queryWrapper.ne(WmTask::getScore, 0);
		queryWrapper.orderByDesc(WmTask::getCreateTime);
		taskPage = wmTaskService.page(page, queryWrapper);
		List<WmTask> wmTaskList = taskPage.getRecords();

		for (int i = 0; i < wmTaskList.size(); i++) {
			WmTaskType wmTaskType = wmTaskTypeService.getById(wmTaskList.get(i).getTaskTypeId());
			if (null != wmTaskType) {
				wmTaskList.get(i).setTaskTypeId(wmTaskType.getTaskTypeName());
			}
		}
		taskPage.setRecords(wmTaskList);

		return R.ok(taskPage);
	}


	/**
	 * 新增任务内容表
	 *
	 * @param taskId 任务内容表
	 * @return R
	 */
	@ApiOperation(value = "任务-根据ID获取任务", notes = "任务-根据ID获取任务")
	@SysLog("任务-根据ID获取任务")
	@GetMapping("/getTaskInfoById")
	public R getTaskInfoById(String taskId) {
		Map<String, Object> map = new HashMap<>();
		WmTask wmTask = wmTaskService.getById(taskId);
		if (null != wmTask) {
			map.put("taskType", wmTask.getTaskTypeId());
			WmTaskType wmTaskType = wmTaskTypeService.getById(wmTask.getTaskTypeId());
			map.put("taskInfo", wmTask);
			WmTaskContent wmTaskContent = wmTaskContentService.getById(wmTask.getTaskContentId());
			if (null != wmTaskContent) {
				WmScorePackage wmScorePackage = wmScorePackageService.getById(wmTask.getScorePackageId());
				if (null != wmScorePackage) {
					wmTaskContent.setTemp32(wmScorePackage.getScorePackageName());
				}
				// 设置地图地址
				if ("30".equals(wmTask.getTaskTypeId()) || "15".equals(wmTask.getTaskTypeId())) {
					wmTaskContent.setTemp31(wmTaskContent.getTemp16());
				}
				if ("16".equals(wmTask.getTaskTypeId())) {
					wmTaskContent.setTemp31(wmTaskContent.getTemp4());
				}
			}
			map.put("wmTaskContent", wmTaskContent);

			if ("8".equals(wmTask.getTaskTypeId()) || "11".equals(wmTask.getTaskTypeId()) || "9".equals(wmTask.getTaskTypeId()) || "10"
					.equals(wmTask.getTaskTypeId())) {
				map.put("title", "");
				WmWkArticleShare wmWkArticleShare = wmWkArticleShareService.getById(wmTask.getTaskContentId());
				if (null != wmWkArticleShare) {
					if ("8".equals(wmTask.getTaskTypeId()) || "11".equals(wmTask.getTaskTypeId())) {
						WmWkAlbum wmWkAlbum = wmWkAlbumService.getById(wmWkArticleShare.getArctileId());
						map.put("title", wmWkAlbum.getXcmc());
					} else {
						WmWkArticle wmWkArticle = wmWkArticleService.getById(wmWkArticleShare.getArctileId());
						map.put("title", wmWkArticle.getTitle());
					}
				}
				map.put("score", wmTask.getScore());
				map.put("shareId", wmWkArticleShare.getArctileId());
				map.put("remark", wmWkArticleShare.getTemp1());

			}

			if (null != wmTaskType) {
				wmTask.setTaskTypeId(wmTaskType.getTaskTypeName());
			}
		}
		return R.ok(map);
	}


	/**
	 * 通过id查询用户签到表
	 *
	 * @param id id
	 * @return R
	 */
	@ApiOperation(value = "签到-通过ID获取签到信息", notes = "通过id查询")
	@GetMapping("/getSignInfoByTaskId")
	public R getSignInfoByTaskId(Integer id) {
		WmTask wmTask = wmTaskService.getById(id);
		if (null != wmTask) {
			if (null != wmTask.getTaskContentId()) {
				WmTaskContent wmTaskContent = wmTaskContentService.getById(wmTask.getTaskContentId());

				if (null != wmTaskContent) {
					if (null != wmTaskContent.getTemp3()) {
						List<WmUserSign> wmUserSignList = new ArrayList<>();
						WmUserSign userSign = wmUserSignService.getById(wmTaskContent.getTemp3());
						// 如果配置了医院拜访的任务类型模板，则关联查询签到详情
						if (wmDeptTaskTypeTemplateService.checkDeptIdHospitalTemplate(Integer.valueOf(wmTask.getDeptId()), wmTask.getTaskTypeId())) {
							WmUserSignDetail userSignDetail = wmUserSignDetailService.getOne(Wrappers.<WmUserSignDetail>lambdaQuery()
									.eq(WmUserSignDetail::getSignId, userSign.getId()));
							if (userSignDetail != null) {
								if (ArrayUtil.isNotEmpty(userSignDetail.getPurpose())) {
									List<Integer> purposeList = Stream.of(userSignDetail.getPurpose())
											.map(Integer::parseInt)
											.collect(Collectors.toList());
									String dictType = null;
									switch (userSign.getSignEntType()) {
										case "1":
											dictType = "user_sign_detail_purpose";
											break;
										case "2":
											dictType = "user_sign_detail_distribution_purpose";
											break;
										case "3":
											dictType = "user_sign_detail_pharmacy_purpose";
											break;
										default:
											dictType = "";
									}
									List<SysDictItem> itemList = sysDictItemService.list(Wrappers.<SysDictItem>lambdaQuery()
											.in(SysDictItem::getValue, purposeList)
											.eq(SysDictItem::getType, dictType)
											.eq(SysDictItem::getDelFlag, DelEnum.NOT_DEL.val()));
									if (CollUtil.isNotEmpty(itemList)) {
										String[] purposeNameArr = itemList.stream()
												.map(SysDictItem::getLabel)
												.toArray(String[]::new);
										userSignDetail.setPurposeName(purposeNameArr);
									}
								}
								if (StrUtil.isNotBlank(userSignDetail.getResult())) {
									userSignDetail.setResultName(UserSignResultEnum.resolve(userSignDetail.getResult()).getName());
								}
								userSign.setUserSignDetail(userSignDetail);
							}
						}
						wmUserSignList.add(userSign);
						return R.ok(wmUserSignList);
					}
				}
			}
		}
		return R.ok();
	}

	/**
	 * 新增任务内容表
	 *
	 * @return R
	 */
	@ApiOperation(value = "根据链接生成二维码图片", notes = "根据链接生成二维码图片")
	@GetMapping("/getQrCodeByUrl")
	public R getQrCodeByUrl(String url, int width, int height) throws FileNotFoundException {

		String QR_CODE_IMAGE_PATH = "/" + UUID.randomUUID() + ".png";
		try {
			QRCodeGenerator.generateQRCodeImage(url, width, height, QR_CODE_IMAGE_PATH);
		} catch (WriterException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		File imageFile = new File(QR_CODE_IMAGE_PATH);
		FileInputStream in = new FileInputStream(imageFile);
		MultipartFile file = null;
		try {
			file = new MockMultipartFile("file", imageFile.getName(), "text/plain", IOUtils.toByteArray(in));
		} catch (IOException e) {
			e.printStackTrace();
		}

		return R.ok(sysFileService.uploadFile(file));
	}


	/**
	 * 修改用户信息接口
	 *
	 * @return R
	 */
	@ApiOperation(value = "修改用户信息接口", notes = "修改用户信息接口")
	@SysLog("修改用户信息接口")
	@PostMapping("/updateUserInfo")
	public R<?> updateUserInfo(@RequestBody UserUpdateInput userUpdateInput) {

		List<SysUser> list = sysUserService.getUserByPlatId(SecurityUtils.getUser().getPlatId());
		Optional<SysUser> userOptional = list.stream()
				.filter(user -> StringUtils.equals(String.valueOf(user.getUserId()), userUpdateInput.getUserId()))
				.findAny();

		if (!userOptional.isPresent()) {
			return R.failed("只能修改自己的用户信息");
		}

		SysUser sysUser = sysUserService.getById(userUpdateInput.getUserId());

		// 获取更新操作的用户角色
		List<Integer> roles = SecurityUtils.getRoles();

		Integer ageByIdCard = null;
		// 如果角色中包含全职和兼职就需要校验身份证年龄
		if (roles.contains(5) || roles.contains(6)) {
			// 校验身份证上的年龄
			if (StringUtils.isNotEmpty(userUpdateInput.getIdCardNumber())) {
				ageByIdCard = IdcardUtil.getAgeByIdCard(userUpdateInput.getIdCardNumber());
				if (ageByIdCard < 18) {
					return R.failed("年龄未满十八");
				}
			}
		}

		// /**
		//  * 小程序的认证
		//  * @Modify: start
		//  * @Version: v2021.4.16
		//  * @Author: ryz
		//  * @Date: 2021/4/28
		//  */
		// boolean updateFlag = true;
		// if (null != sysUser.getCertStatus()) {
		// 	if (sysUser.getCertStatus() != 10) {
		// 		updateFlag = false;
		// 	}
		//
		// }
		// if (null != sysUser.getRljCertStatus()) {
		// 	if (sysUser.getRljCertStatus() == 1 || sysUser.getRljCertStatus() == 3) {
		// 		updateFlag = false;
		// 	}
		// }
		// if (!updateFlag) {
		// 	if (!userUpdateInput.getRealname().equals(sysUser.getRealname())) {
		// 		return R.failed("用户认证通过或正在认证，暂不能修改姓名");
		// 	}
		// 	if (!userUpdateInput.getIdCardNumber().equals(sysUser.getIdCardNumber())) {
		// 		return R.failed("用户认证通过或正在认证，暂不能修改身份证号");
		// 	}
		// }
		//
		// SysDept sysDept = sysDeptService.getById(sysUser.getDeptId());
		//
		// Map<SubjectTypeEnum, String> errorMap = new HashMap<>(2);
		//
		// // 开启认证
		// if (CollectionUtils.isNotEmpty(userUpdateInput.getSubList())) {
		// 	for (String subType : userUpdateInput.getSubList()) {
		//
		// 		if (SubjectTypeEnum.TYPE_RENLIJIA.getCode().equals(subType)) {
		//
		// 			// 校验身份证上的年龄 60周岁前15天
		// 			if (ageByIdCard != null && StringUtils.isNotEmpty(userUpdateInput.getIdCardNumber())) {
		//
		// 				boolean over60 = false;
		// 				log.warn("ageByIdCard:{}", ageByIdCard);
		// 				if (ageByIdCard == 59) {
		// 					String birth = IdcardUtil.getBirth(userUpdateInput.getIdCardNumber());
		// 					log.warn("birth string:{}", birth);
		// 					LocalDate birthday = LocalDate.parse(birth, DatePattern.PURE_DATE_FORMATTER);
		//
		// 					// 获取今年的生日
		// 					LocalDate thisBirthday = LocalDate.of(LocalDate.now().getYear(), birthday.getMonthValue(), birthday.getDayOfMonth());
		// 					LocalDate limit = thisBirthday.minus(15, ChronoUnit.DAYS);
		// 					log.warn("this year birthday:{}, before 15 days: {}", thisBirthday, limit);
		//
		// 					if (LocalDate.now().isAfter(limit)) {
		// 						over60 = true;
		// 					}
		//
		// 				} else if (ageByIdCard >= 60) {
		// 					over60 = true;
		// 				}
		//
		// 				if (over60) {
		// 					errorMap.put(SubjectTypeEnum.TYPE_RENLIJIA, "年龄已超过六十");
		// 					continue;
		// 				}
		// 			}
		//
		// 			SysDeptSub subCondition = new SysDeptSub();
		// 			subCondition.setEnableFlag(SubjectTypeEnum.ENABLE_FLAG_TRUE.getCode());
		// 			subCondition.setDeptId(sysDept.getDeptId());
		// 			subCondition.setSubjectType(SubjectTypeEnum.TYPE_RENLIJIA.getCode());
		// 			SysDeptSub deptSub = sysDeptSubService.getOne(Wrappers.query(subCondition));
		// 			if (null == deptSub || StringUtils.isBlank(deptSub.getAppId())) {
		// 				errorMap.put(SubjectTypeEnum.TYPE_RENLIJIA, "人员所在机构未配置结算信息");
		// 				continue;
		// 			}
		//
		// 			DingConfig config = new DingConfig();
		// 			config.setAppId(deptSub.getAppId());
		// 			config.setAppSecret(deptSub.getAppSecret());
		// 			config.setQueryUrl(deptSub.getQueryUrl());
		//
		// 			Map map = new HashMap();
		// 			map.put("name", userUpdateInput.getRealname());
		// 			map.put("mobile", sysUser.getPhone());
		// 			map.put("idCard", userUpdateInput.getIdCardNumber());
		// 			map.put("idType", "1");
		// 			List certList = new ArrayList();
		// 			certList.add(map);
		//
		// 			EmployCheckResponse response = dingService.check(config, certList);
		// 			if (!response.isSuccess()) {
		// 				errorMap.put(SubjectTypeEnum.TYPE_RENLIJIA, "人力家接口调用异常");
		// 				continue;
		// 			}
		// 			//接口请求成功，但是接口返回的状态还需区分checkStatus，1:验证通过，状态改成已提交，2:验证不通过，状态改成认证失败
		// 			List<EmployCheckResultItem> freelancesResult = response.getData().getFreelancesResult();
		// 			if (CollectionUtils.isNotEmpty(freelancesResult)) {
		// 				for (EmployCheckResultItem employCheckResultItem : freelancesResult) {
		// 					if (employCheckResultItem.getIdCard().equals(userUpdateInput.getIdCardNumber())) {
		// 						if (employCheckResultItem.getCheckStatus() == 1) {//验证通过
		// 							sysUser.setRljCertStatus(DingEnum.CER_STATUS_3.getType());
		// 							continue;
		// 						} else {//验证不通过
		// 							if ("1014".equals(employCheckResultItem.getCheckRemark())) {
		// 								log.info("认证返回1014按成功处理：{},{}", sysUser.getRealname(), sysUser.getUsername());
		// 								sysUser.setRljCertStatus(DingEnum.CER_STATUS_3.getType());
		// 								continue;
		// 							}
		// 							if ("1018".equals(employCheckResultItem.getCheckRemark())) {
		// 								log.info("认证返回1018按处理中处理：{},{}", sysUser.getRealname(), sysUser.getUsername());
		// 								sysUser.setRljCertStatus(DingEnum.CER_STATUS_3.getType());
		// 								continue;
		// 							}
		// 							if ("1019".equals(employCheckResultItem.getCheckRemark())) {
		// 								log.info("认证返回1019按成功处理：{},{}", sysUser.getRealname(), sysUser.getUsername());
		// 								sysUser.setRljCertStatus(DingEnum.CER_STATUS_1.getType());
		// 								continue;
		// 							}
		// 							if ("1020".equals(employCheckResultItem.getCheckRemark())) {
		// 								log.info("认证返回1020按认证失败处理：{},{}", sysUser.getRealname(), sysUser.getUsername());
		// 								sysUser.setRljCertStatus(DingEnum.CER_STATUS_2.getType());
		// 								continue;
		// 							}
		// 							log.info("认证失败:" + employCheckResultItem.getCheckRemark());
		// 							errorMap.put(SubjectTypeEnum.TYPE_RENLIJIA, "认证失败:人力家认证失败");
		// 						}
		// 					}
		// 				}
		// 			} else {
		// 				errorMap.put(SubjectTypeEnum.TYPE_RENLIJIA, "人力家接口调用异常");
		// 			}
		//
		// 		} else if (SubjectTypeEnum.TYPE_SHUIBANGYUN.getCode().equals(subType)) {
		//
		// 			// 校验身份证上的年龄 60周岁前15天
		// 			if (ageByIdCard != null && StringUtils.isNotEmpty(userUpdateInput.getIdCardNumber())) {
		// 				if (ageByIdCard > 65) {
		// 					errorMap.put(SubjectTypeEnum.TYPE_SHUIBANGYUN, "年龄已超过六十五");
		// 					continue;
		// 				}
		// 			}
		//
		// 			SysDeptSub subCondition = new SysDeptSub();
		// 			subCondition.setEnableFlag(SubjectTypeEnum.ENABLE_FLAG_TRUE.getCode());
		// 			subCondition.setDeptId(sysDept.getDeptId());
		// 			subCondition.setSubjectType(SubjectTypeEnum.TYPE_SHUIBANGYUN.getCode());
		// 			SysDeptSub deptSub = sysDeptSubService.getOne(Wrappers.query(subCondition));
		// 			if (null == deptSub || StringUtils.isBlank(deptSub.getAppId())) {
		// 				errorMap.put(SubjectTypeEnum.TYPE_SHUIBANGYUN, "人员所在机构未配置结算信息");
		// 				continue;
		// 			}
		//
		// 			TaxHelperConfig config = new TaxHelperConfig();
		// 			config.setAppId(deptSub.getAppId());
		// 			config.setAppSecrete(deptSub.getAppSecret());
		// 			config.setQueryUrl(deptSub.getQueryUrl());
		//
		//
		// 			TaxHelperAddMemberModel model = new TaxHelperAddMemberModel(config);
		// 			model.setIdCard(userUpdateInput.getIdCardNumber());
		// 			model.setPhone(sysUser.getUsername());
		// 			model.setType(Integer.parseInt(deptSub.getSubjectUserType()));
		// 			model.setName(sysUser.getRealname());
		// 			model.setNotifyUrl("http://localhost:8808");
		// 			boolean isPingAnBank = StrUtil.isNotEmpty(userUpdateInput.getBankCardNumber());
		// 			if (isPingAnBank) {
		// 				model.setPayAccount(userUpdateInput.getBankCardNumber());
		// 			}
		// 			model.setEnterpriseCode(sysDept.getTaxCode());
		// 			if (StringUtils.isEmpty(model.getEnterpriseCode())) {
		//
		// 				errorMap.put(SubjectTypeEnum.TYPE_SHUIBANGYUN, "未配置企业的统一社会信用代码");
		// 				continue;
		// 			}
		//
		// 			TaxHelperAddMemberRequest request = new TaxHelperAddMemberRequest(model);
		// 			TaxHelperResponse response = taxHelperService.addMembers(request);
		//
		// 			// 记录认证结果
		// 			SysCertResultRecord record = new SysCertResultRecord();
		// 			record.setCode(response.getCode());
		// 			record.setCreateTime(LocalDateTime.now());
		// 			record.setDeptId(sysDept.getDeptId());
		// 			record.setMessage(StringUtils.isNotEmpty(response.getMessage()) ? response.getMessage() : "无");
		// 			record.setStatus(null);
		// 			record.setSubjectType(1);
		// 			record.setMethod(isPingAnBank ? "增员(平安银行)" : "增员");
		// 			record.setUserId(sysUser.getUserId());
		// 			sysCertResultRecordMapper.insert(record);
		//
		// 			if (response.success()) {
		// 				sysUser.setCertStatus(isPingAnBank ? TaxHelperCertStatus.UNCHECKED_BIND.getCode() : TaxHelperCertStatus.ADD_MEMBER.getCode());
		// 			} else {
		// 				log.info("税邦云增员失败：{},{}，原因是：{}", sysUser.getRealname(), sysUser.getUsername(), response.getMessage());
		// 				userUpdateInput.setIdCardNumber(null);
		// 				userUpdateInput.setBankCardNumber(null);
		// 				errorMap.put(SubjectTypeEnum.TYPE_SHUIBANGYUN, "税邦云增员失败");
		// 			}
		// 		}
		// 	}
		// }
		//
		// String msg = "";
		// for (Map.Entry<SubjectTypeEnum, String> entry : errorMap.entrySet()) {
		// 	if (SubjectTypeEnum.TYPE_RENLIJIA.equals(entry.getKey())) {
		// 		msg += SubjectTypeEnum.TYPE_RENLIJIA.getDesc() + "认证结果：" + entry.getValue() + ";";
		// 	}
		// 	if (SubjectTypeEnum.TYPE_SHUIBANGYUN.equals(entry.getKey())) {
		// 		msg += SubjectTypeEnum.TYPE_SHUIBANGYUN.getDesc() + "认证结果：" + entry.getValue() + ";";
		// 	}
		// }
		//
		// // 两家都失败了,就中止
		// if (errorMap.size() == 2) {
		// 	return R.failed(errorMap,msg);
		// }


		sysUser.setAvatar(userUpdateInput.getAvatar());
		// if (StringUtils.isNotEmpty(userUpdateInput.getIdCardNumber())) {
		// 	sysUser.setIdCardNumber(userUpdateInput.getIdCardNumber());
		//
		// }
		// 姓名去除空格（包括字符之间的所有空格都会去除）
		sysUser.setRealname(StrUtil.cleanBlank(userUpdateInput.getRealname()));
		sysUser.setUserSign(userUpdateInput.getUserSign());
		// sysUser.setBankCardNumber(userUpdateInput.getBankCardNumber());
		// if (StringUtils.isNotEmpty(userUpdateInput.getTaxHelperAgreementSignature())) {
		// 	sysUser.setTaxHelperAgreementSignature(StringUtils.equals(SignatureStatusEnum.SIGNED.name(), userUpdateInput
		// 			.getTaxHelperAgreementSignature()) ? 1 : 0);
		// }
		sysUserService.updateById(sysUser);


		return R.ok();
	}


	/**
	 * 修改意见反馈
	 *
	 * @param wmFeedback 意见反馈
	 * @return R
	 */
	@ApiOperation(value = "修改意见反馈", notes = "修改意见反馈")
	@SysLog("修改意见反馈")
	@PostMapping("/saveFeedBack")
	public R saveFeedBack(@RequestBody WmFeedback wmFeedback) {
		return R.ok(wmFeedbackService.save(wmFeedback));
	}


	/**
	 * 新增任务内容表
	 *
	 * @return R
	 */
	@ApiOperation(value = "分享名片接口", notes = "分享名片接口")
	@SysLog("分享名片接口")
	@GetMapping("/shareUserCard")
	public R shareUserCard(String imgUrl) throws FileNotFoundException {
		int socre = 0;
		SysUser sysUser = sysUserService.getById(SecurityUtils.getUser().getId());

		if (sysUser == sysUser) {
			List<SysUser> listUsers = sysUserService.getUserByPlatId(sysUser.getPlatId());
			if (listUsers.size() > 0) {
				for (SysUser sysU : listUsers) {
					WmWkArticleShare wmWkArticleShare = new WmWkArticleShare();
					wmWkArticleShare.setShareUserid(sysU.getUserId() + "");
					wmWkArticleShare.setShareType("1");
					wmWkArticleShare.setCreateTime(LocalDateTime.now());
					wmWkArticleShare.setArctileId(imgUrl);
					wmWkArticleShareService.save(wmWkArticleShare);


					WmTask wmTask = new WmTask();
					wmTask.setTaskFrom("1");
					wmTask.setTaskUserId(sysU.getUserId() + "");  //任务提交人
					wmTask.setLookintoDate(LocalDateTime.now());       //调研时间
					wmTask.setTaskStatus("1");
					wmTask.setSubmitStatus("0");
					wmTask.setDrugEntId(sysU.getDrugEntId());//任务状态
					wmTask.setTaskTypeId("7");
					wmTask.setShareImgUrl(imgUrl);

					SysDept sysDept = sysDeptService.getById(sysU.getDeptId());
					WmTaskType wmTaskType = new WmTaskType();
					wmTaskType.setDurgentId(sysU.getDrugEntId());
					WmTaskType wmTaskType1 = wmTaskTypeService.getById("7");
					wmTaskType.setTaskTypeName(wmTaskType1.getTaskTypeName());
					wmTaskType.setTaskEntId(sysDept.getLevel2Id() + "");
					socre = wmTaskTypeService.getWmTaskTypeByEnt(wmTaskType);
					System.out.println("获取任务得分：" + socre);
					if (socre < 0) {
						return R.failed("获取任务积分失败");
					}
					wmTask.setScore(socre);

					WmScorePackage wmScorePackage = new WmScorePackage();
					if (SecurityUtils.getRoles().contains(6)) {
						wmScorePackage.setZbId(sysU.getUserId() + "");
					} else {
						wmScorePackage.setXxdbId(sysU.getUserId() + "");
					}

					wmScorePackage.setDrugEntId(sysU.getDrugEntId());
					WmScorePackage tWmScorePackage = wmScorePackageService.getPackageScoreByTaskInfo(wmScorePackage);
					try {
						String packageEntId = wmScorePackageService.getPackageScoreEntByTaskInfo(wmScorePackage);
						wmTask.setScorePackageLevel1Id(packageEntId);
					} catch (Exception ex) {

					}
					System.out.println("获取积分包ID：" + tWmScorePackage);
					if (null == tWmScorePackage) {
						//return R.failed("获取积分包失败");
					} else {
						wmTask.setScorePackageId(tWmScorePackage.getId());
						wmTask.setTaskRuleId(tWmScorePackage.getTaskRuleId());
					}

					wmTask.setTaskContentId(wmWkArticleShare.getId() + "");

					if (SecurityUtils.getRoles().contains(5)) {
						wmTask.setTaskUserType("5");
					}

					wmTask.setCreateTime(LocalDateTime.now());

					if (SecurityUtils.getRoles().contains(6)) {
						wmTask.setTaskUserType("6");
					}

					wmTask.setDeptId(sysU.getDeptId() + "");
					wmTask.setSubmitStatus("0");
					wmTask.setTaskNumber(taskSequence.nextNo());
					boolean isSave = wmTaskService.save(wmTask);   //保存任务

					//判断任务是否完成
					if (isSave && null != tWmScorePackage) {
						WmScorePackage wmScorePackage1 = wmScorePackageService.getById(tWmScorePackage.getId());
						if (null != wmScorePackage1) {
							WmTask wmTask1 = new WmTask();
							wmTask1.setScorePackageId(tWmScorePackage.getId());
							wmTask1.setDrugEntId(sysU.getDrugEntId());
							List<WmTask> wmTaskList = wmTaskService.list(Wrappers.query(wmTask1));
							int totalCount = 0;
							for (WmTask wmtask : wmTaskList) {
								totalCount += wmtask.getScore();
							}

							if (totalCount >= wmScorePackage1.getScore()) {
								wmScorePackage1.setPackageFinishStatus("1");
							}
							wmScorePackage1.setIsConduct("1");
							wmScorePackageService.updateById(wmScorePackage1);
						}
					} else {
						return R.failed("任务保存失败");
					}
				}
			}
		}
		Map<String, String> map = new HashMap<>();
		map.put("score", socre + "");
		return R.ok(map);
	}

	private boolean isZbRole(List<SysRole> sysRoles, int roleId) {
		for (SysRole sysRole : sysRoles) {
			if (sysRole.getRoleId() == roleId) {
				return true;
			}
		}
		return false;
	}


	private LocalDateTime getLocalDateTime(String monthStr, String type) {
		DateFormat format = new SimpleDateFormat("yyyy-MM");
		DateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");

		try {
			Date date1 = format.parse(monthStr);
			Instant instant = date1.toInstant();
			ZoneId zoneId = ZoneId.systemDefault();
			LocalDateTime date = instant.atZone(zoneId).toLocalDateTime();
			LocalDateTime firstday = date.with(TemporalAdjusters.firstDayOfMonth());
			LocalDateTime lastDay = date.with(TemporalAdjusters.lastDayOfMonth())
					.withHour(23)
					.withMinute(59)
					.withSecond(59);

			if ("start".equals(type)) {
				return firstday;
			} else {
				return lastDay;
			}

		} catch (Exception ex) {

		}

		return null;

	}


	/**
	 * 分页查询
	 *
	 * @param page           分页对象
	 * @param wmScorePackage 积分包
	 * @return
	 */
	@ApiOperation(value = "分页查询", notes = "分页查询")
	@GetMapping("/h5PackagePage")
	public R h5PackagePage(Page page, WmScorePackage wmScorePackage) {
		String id = wmScorePackage.getId();
		if (StringUtils.isBlank(id)) {
			return R.failed("积分包ID不能为空");
		}
		wmScorePackage.setId(null);

		String[] ids = id.split(" +");
		List<String> listIds = new ArrayList<>();
		listIds.addAll(Arrays.asList(ids));
		WmTask wmTask = new WmTask();
		wmTask.setExtIds(listIds);
		return R.ok(wmTaskService.getH5PackageList(page, wmTask));
	}


	/**
	 * 分页查询
	 *
	 * @param page   分页对象
	 * @param wmTask 任务
	 * @return
	 */
	@ApiOperation(value = "分页查询", notes = "分页查询")
	@GetMapping("/h5TaskPage")
	public R h5TaskPage(Page page, WmTask wmTask) {
		if (StringUtils.isBlank(wmTask.getId())) {
			return R.failed("积分包ID不能为空");
		}

		String id = wmTask.getId();
		wmTask.setId(null);
		wmTask.setScorePackageId(id);
		return R.ok(wmTaskService.getH5TaskList(page, wmTask));
	}


	/**
	 * 分页查询
	 *
	 * @param taskId 积分包
	 * @return
	 */
	@ApiOperation(value = "分页查询", notes = "分页查询")
	@GetMapping("/getH5To")
	public R getH5To(String taskId) {
		WmTask wmTask = wmTaskService.getById(taskId);
		if (null != wmTask) {
			BufferedImage bufferedImage = null;
			try {
				bufferedImage = Html2ImageByJsWrapper.renderHtml2Image(upmsConfig.getApiUrl()
						+ "/h5/#/pages/task/task-detail/index?id=" + wmTask.getId(), upmsConfig.getServerUrl());
			} catch (IOException e) {
				e.printStackTrace();
			}

			ByteArrayOutputStream bs = new ByteArrayOutputStream();
			ImageOutputStream imOut = null;
			try {
				imOut = ImageIO.createImageOutputStream(bs);
			} catch (IOException e) {
				e.printStackTrace();
			}
			try {
				ImageIO.write(bufferedImage, "png", imOut);
			} catch (IOException e) {
				e.printStackTrace();
			}
			InputStream inputStream = new ByteArrayInputStream(bs.toByteArray());
			String path = sysFileService.uploadImgByByte(inputStream);
			wmTask.setTaskInfoImg(path);
			wmTaskService.updateById(wmTask);
		}
		return R.ok();
	}


	/**
	 * @param longitude
	 * @param latitude
	 * @return
	 */
	@ApiOperation(value = "分页查询", notes = "分页查询")
	@GetMapping("/getPointSignInfo")
	public R getPointSignInfo(String longitude, String latitude) {
		List<Map<String, Object>> mapList = new ArrayList<>();

		// 医院
		WmDaHospital qWmDaHospital = new WmDaHospital();
		qWmDaHospital.setLongitude(longitude);
		qWmDaHospital.setLatitude(latitude);

		List<WmDaHospital> wmDaHospitalList = wmDaHospitalService.listByPoint(qWmDaHospital);
		if (wmDaHospitalList.size() > 0) {
			for (WmDaHospital wmDaHospital : wmDaHospitalList) {
				Map<String, Object> map = new HashMap<>();
				map.put("signEntId", wmDaHospital.getId());
				map.put("signEntName", wmDaHospital.getYymc());
				map.put("longitude", wmDaHospital.getLongitude());
				map.put("latitude", wmDaHospital.getLatitude());
				map.put("signEntType", "1");
				mapList.add(map);
			}
		}

		// 商业公司
		WmDaDistribution qwmDaDistribution = new WmDaDistribution();
		qwmDaDistribution.setLatitude(latitude);
		qwmDaDistribution.setLongitude(longitude);

		List<WmDaDistribution> wmDaDistributions = wmDaDistributionService.listByPoint(qwmDaDistribution);
		if (wmDaDistributions.size() > 0) {
			for (WmDaDistribution wmDaDistribution : wmDaDistributions) {
				Map<String, Object> map = new HashMap<>();
				map.put("signEntId", wmDaDistribution.getId());
				map.put("signEntName", wmDaDistribution.getGsmc());
				map.put("longitude", wmDaDistribution.getLongitude());
				map.put("latitude", wmDaDistribution.getLatitude());
				map.put("signEntType", "2");
				mapList.add(map);

			}
		}

		// 药店
		WmDaPharmacy qWmDaPharmacy = new WmDaPharmacy();
		qWmDaPharmacy.setLatitude(latitude);
		qWmDaPharmacy.setLongitude(longitude);
		List<WmDaPharmacy> pharmacyList = wmDaPharmacyService.listByPoint(qWmDaPharmacy);
		if (CollectionUtil.isNotEmpty(pharmacyList)) {
			pharmacyList.forEach(wmDaPharmacy -> {
				Map<String, Object> map = new HashMap<>();
				map.put("signEntId", wmDaPharmacy.getId());
				map.put("signEntName", wmDaPharmacy.getPharmacyName());
				map.put("longitude", wmDaPharmacy.getLongitude());
				map.put("latitude", wmDaPharmacy.getLatitude());
				map.put("signEntType", "3");
				mapList.add(map);
			});
		}

		return R.ok(mapList);
	}

	/**
	 * 小程序去掉通知--不再提示
	 *
	 * @return
	 */
	@ApiOperation(value = "不再提示", notes = "不再提示")
	@SysLog("小程序去掉通知")
	@PostMapping("/removeNotice")
	public R removeNotice(@RequestBody NoticeApiInput input) {
		if (StringUtils.isEmpty(input.getUserId())) {
			return R.failed("参数异常，请求失败");
		}
		if (StringUtils.isEmpty(input.getType())) {
			return R.failed("参数异常，请求失败");
		}
		if ("1".equals(input.getType())) {
			redisTemplate.delete(CacheConstants.USER_NOTICE_KEY + input.getUserId());
		}
		if ("2".equals(input.getType())) {
			redisTemplate.delete(CacheConstants.USER_ADD_NOTICE_KEY + input.getUserId());
		}
		return R.ok();
	}

	/**
	 * 获取登录人积分包
	 *
	 * @param type 任务类型
	 * @return 积分包信息
	 */
	@SysLog("获取登录人积分包")
	@GetMapping("/getPackageListByTaskType")
	public R<?> getPackageListByTaskType(@RequestParam(value = "type") String type) {

		HnqzUser user = SecurityUtils.getUser();

		WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
		wmScorePackageStatus.setUserId(user.getId() + "");
		wmScorePackageStatus.setTaskAddFlag("1");
		wmScorePackageStatus.setStatus("2");
		wmScorePackageStatus.setDelFlag("0");
		wmScorePackageStatus.setEnableFlag("0");
		List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(Wrappers.query(wmScorePackageStatus));

		if (CollUtil.isEmpty(statusList)) {
			return R.ok(Collections.emptyList());
		}

		List<Map<String, Object>> listMap = new LinkedList<>();

		// 获取领包记录对应的积分包ID && 获取积分包信息
		Set<String> pkgIds = statusList.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
		List<WmScoreTaskType> scoreTaskTypes = wmScoreTaskTypeService.list(Wrappers.<WmScoreTaskType>lambdaQuery().eq(WmScoreTaskType::getTaskTypeId, type).in(WmScoreTaskType::getScoreId, pkgIds));

		Set<String> availPkgIds = scoreTaskTypes.stream().map(WmScoreTaskType::getScoreId).collect(Collectors.toSet());
		if (CollUtil.isEmpty(availPkgIds)) {
			return R.ok(Collections.emptyList());
		}

		List<WmScorePackage> packages = wmScorePackageService.listByIds(availPkgIds);

		for (WmScorePackage wmScorePackage : packages) {

			if ("0".equals(wmScorePackage.getTaskAddFlag())
					|| "1".equals(wmScorePackage.getEnableFlag())
					|| "3".equals(wmScorePackage.getPackageType1())
					|| (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2()) && !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1()))) {
				continue;
			}

			Map<String, Object> map = new HashMap<>(5);
			map.put("label", wmScorePackage.getScorePackageName());
			map.put("value", wmScorePackage.getId());
			String drugProducer = ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList()) ? "" : String.join(StrUtil.COMMA, wmScorePackage.getDrugProducerList());
			map.put("drugProducer", drugProducer);
			map.put("deptId", wmScorePackage.getDeptId());
			map.put("relDeptId", wmScorePackage.getRelatedService());
			listMap.add(map);

		}

		return R.ok(listMap);
	}


	/**
	 * 获取登录人积分包（药品生产商发包或者cso单独发包）
	 *
	 * @param type    积分包类型
	 * @param albumId 产品相册id
	 * @return 积分包列表
	 */
	@ApiOperation(value = "获取登录人积分包", notes = "药品生产商发包或者cso单独发包")
	@SysLog("获取登录人积分包（药品生产商发包或者cso单独发包")
	@GetMapping("/getPackageListByTaskTypeAndAlbumId")
	public R getPackageListByTaskTypeAndAlbumId(String type, Integer albumId) {
		if (StringUtils.isEmpty(type) || albumId == null) {
			return R.failed("参数异常，请求失败");
		}
		//获取用户基本信息
		if (null == SecurityUtils.getUser().getId()) {
			return R.failed("请求失败");
		}

		SysUser sysUser = sysUserService.getById(SecurityUtils.getUser().getId());

		// 获取相册信息
		WmWkAlbum album = wmWkAlbumService.getById(albumId);
		// 获取相册的关联的药品
		WmDaDrugEntDrugtable daDrugEntDrugtable = wmDaDrugEntDrugtableService.getById(album.getGlyp());
		// 获取关联药品的生产企业
		String drugProducer = daDrugEntDrugtable.getDrugEntName();
		//筛选积分包
		WmScorePackageStatus wmScorePackageStatus = new WmScorePackageStatus();
		wmScorePackageStatus.setUserId(sysUser.getUserId() + "");
		wmScorePackageStatus.setTaskAddFlag("1");
		wmScorePackageStatus.setStatus("2");
		wmScorePackageStatus.setDelFlag("0");
		wmScorePackageStatus.setEnableFlag("0");
		List<WmScorePackageStatus> statusList = wmScorePackageStatusService.
				list(Wrappers.query(wmScorePackageStatus));

		List<Map<String, Object>> listMap = new ArrayList<>();

		for (WmScorePackageStatus item : statusList) {
			WmScorePackage wmScorePackage = wmScorePackageService.getOne(Wrappers.<WmScorePackage>lambdaQuery()
					.eq(WmScorePackage::getId, item.getPackageId()));
			// Map<String, Object> tmp = wmScorePackageService.getOne(Wrappers.<WmScorePackage>lambdaQuery()
			// 		.eq(WmScorePackage::getId, item.getPackageId()));
			// WmScorePackage wmScorePackage = BeanUtil.copyProperties(tmp,WmScorePackage.class);
			if (null != wmScorePackage) {
				if ("0".equals(wmScorePackage.getTaskAddFlag())) {
					continue;
				}
				if ("1".equals(wmScorePackage.getEnableFlag())) {
					continue;
				}
				if (PackageTypeEnum.TYPE2_SETTLE_PACKAGE.val().equals(wmScorePackage.getPackageType2())
						&& !PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val().equals(wmScorePackage.getPackageType1())) {
					continue;
				}
				if ("3".equals(wmScorePackage.getPackageType1())) {
					continue;
				}
				if (ArrayUtils.isEmpty(wmScorePackage.getDrugProducerList())) {
					continue;
				}
				boolean flag = false;
				for (String name : wmScorePackage.getDrugProducerList()) {
					if (StringUtils.equals(name, drugProducer)) {
						flag = true;
						break;
					}
				}

				if (!flag) {
					continue;
				}

				/**
				 * 过滤有效任务类型
				 */
				WmScoreTaskType taskType = new WmScoreTaskType();
				taskType.setTaskTypeId(type);
				taskType.setScoreId(wmScorePackage.getId());
				int total = wmScoreTaskTypeService.count(Wrappers.query(taskType));

				if (total != 0) {
					Map<String, Object> map = new HashMap<>();
					map.put("label", wmScorePackage.getScorePackageName());
					map.put("value", wmScorePackage.getId());
					listMap.add(map);
				}

			}
		}
		return R.ok(listMap);
	}

	/**
	 * 获取阅读人openid
	 *
	 * @param authCode 授权code
	 * @return 获取结果
	 */
	private String getReaderOpenId(String authCode) {
		//获取小程序openid
		log.info("小程序登录AUTH_CODE:{}", authCode);
		Map<String, Object> resultMap = GetOpenIDUtil.oauth2GetOpenid(authCode.trim(), upmsConfig.getWechatEnv());
		log.warn("小程序登录结果信息:{}", resultMap);
		return (String) resultMap.get("openid");
	}

	/**
	 * 分享阅读任务方法
	 *
	 * @param id               文章或者相册id
	 * @param shareUserId      分享人id
	 * @param openUserId       打开人获取openid授权码
	 * @param type             操作类型：share->分享， open->打开
	 * @param packageId        积分包id
	 * @param sharePicUrl      分享图片链接
	 * @param taskCategoryName 任务类别名称
	 * @param remark           备注
	 * @return 结果
	 */
	private R<?> shareAndReadTaskMethod(String id, String shareUserId, String openUserId, String type, String packageId,
										String sharePicUrl, String taskCategoryName, String remark) {

		LocalDateTime now = LocalDateTime.now();
		int score = 0;
		String msg = "";
		WmWkAlbum wmWkAlbum = null;
		WmWkArticle wmWkArticle = null;
		WmScorePackageStatus scorePackageStatus = null;

		if (StringUtils.isEmpty(id) || StringUtils.isEmpty(packageId)) {
			return R.ok();
		}

		if (StringUtils.isEmpty(shareUserId)) {
			return R.failed("分享人ID不能为空");
		}

		WmScorePackage tWmScorePackage = wmScorePackageService.getById(packageId);
		if (null == tWmScorePackage) {
			return R.failed("积分包异常，请选择其他积分包");
		}
		if ("0".equals(tWmScorePackage.getTaskAddFlag())) {
			return R.ok();
		}
		if (StringUtils.isEmpty(tWmScorePackage.getRuleId())) {
			return R.failed("积分包未配置积分规则");
		}

		if ("article".equalsIgnoreCase(taskCategoryName)) {
			wmWkArticle = wmWkArticleService.getById(id);
		} else if ("album".equalsIgnoreCase(taskCategoryName)) {
			wmWkAlbum = wmWkAlbumService.getById(id);
		}


		// 获取分享人
		SysUser sysUser = sysUserService.getById(shareUserId);

		if (null != sysUser) {
			UserVO userVO = sysUserService.selectUserVoById(sysUser.getUserId());
			if (null != userVO) {

				if (!StringUtils.equalsAny(type, "share", "open")) {
					return R.failed("操作类型错误");
				}

				// 校验相册和文章转发次数限制
				if ("share".equals(type)) {
					String info = null;
					if ("album".equalsIgnoreCase(taskCategoryName)) {
						info = checkAlbumLimit(wmWkAlbum, sysUser, "8", tWmScorePackage.getRelatedService());
					} else if ("article".equalsIgnoreCase(taskCategoryName)) {
						info = checkArticleLimit(wmWkArticle, sysUser, "9", tWmScorePackage.getRelatedService());
					}
					if (StringUtils.isNotEmpty(info)) {
						return R.failed(info);
					}
				}

				if (StrUtil.equals(PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val(), tWmScorePackage.getPackageType1())
						|| StrUtil.equals(PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val(), tWmScorePackage.getPackageType1())) {

					String limitValue = "30000";
					// 查询当前企业配置的积分限制
					List<WmTaskSubmissionRule> scoreLimitRuleList = taskSubmissionRuleService.list(Wrappers.<WmTaskSubmissionRule>lambdaQuery()
							.in(WmTaskSubmissionRule::getDeptId, CollUtil.newHashSet(sysUser.getDeptId(), 1))
							.eq(WmTaskSubmissionRule::getOptFlag, CommonFlag.OptFlag.OK)
							.eq(WmTaskSubmissionRule::getSubCategory, UpmsType.TaskSubCategory.SCORE_LIMIT));

					// 公共参数配置的
					String userTaskSubScore = sysPublicParamService.getSysPublicParamKeyToValue("USER_TASK_SUB_SCORE");

					if (CollUtil.isNotEmpty(scoreLimitRuleList)) {
						Map<Integer, WmTaskSubmissionRule.SubmissionRule> submissionRuleMap = scoreLimitRuleList.stream()
								.collect(Collectors.toMap(WmTaskSubmissionRule::getDeptId, rules ->
										BeanUtil.toBean(rules.getRule().get(0), WmTaskSubmissionRule.SubmissionRule.class)));
						WmTaskSubmissionRule.SubmissionRule submissionRule = null;
						if (submissionRuleMap.containsKey(sysUser.getDeptId())) {
							submissionRule = submissionRuleMap.get(sysUser.getDeptId());
						} else {
							submissionRule = submissionRuleMap.get(1);
						}
						limitValue = String.valueOf(submissionRule.getFrequency().get(0).get("quantity"));
					} else if (StrUtil.isNotBlank(userTaskSubScore)) {
						limitValue = userTaskSubScore;
					}

					boolean fullFlag = wmTaskService.checkUserTaskSubScore(String.valueOf(userVO.getUserId()), limitValue);
					if (fullFlag) {
						String info = String.format("每日最多提交%s积分", limitValue);
						log.warn("系统当前限制积分上限：【{}】，提示：【{}】", limitValue, info);
						return R.failed(info + "，积分+0");
					}
				}

				List<WmScorePackageStatus> statusList = wmScorePackageStatusService.list(
						Wrappers.<WmScorePackageStatus>lambdaQuery()
								.eq(WmScorePackageStatus::getUserId, String.valueOf(userVO.getUserId()))
								.eq(WmScorePackageStatus::getStatus, "2")
								.eq(WmScorePackageStatus::getTaskAddFlag, "1")
								.eq(WmScorePackageStatus::getPackageId, tWmScorePackage.getId())
								.eq(WmScorePackageStatus::getDelFlag, "0")
								.eq(WmScorePackageStatus::getEnableFlag, "0")
				);

				if (CollectionUtils.isEmpty(statusList)) {
					return R.ok();
				}

				if (statusList.size() != 1) {
					log.warn("获取积分包异常，任务保存失败9002：{}", tWmScorePackage.getId());
					return R.failed("获取积分包异常，任务保存失败");
				}

				scorePackageStatus = statusList.get(0);

				WmWkArticleShare wmWkArticleShare = new WmWkArticleShare();
				wmWkArticleShare.setShareUserid(userVO.getUserId() + "");
				wmWkArticleShare.setShareType("1");
				wmWkArticleShare.setCreateTime(LocalDateTime.now());
				wmWkArticleShare.setArctileId(id);

				// if ("open".equals(type)){
				// 	List<WmWkArticleShare> list = wmWkArticleShareService.list(Wrappers.<WmWkArticleShare>lambdaQuery()
				// 			.eq(WmWkArticleShare::getArctileId, id)
				// 			.isNull(WmWkArticleShare::getOpenUser));
				// 	if (CollUtil.isNotEmpty(list)){
				// 		int index = (int) (Math.random() * list.size());
				// 		remark = list.get(index).getTemp1();
				// 	}
				// }

				wmWkArticleShare.setTemp1(remark);

				WmTask wmTask = new WmTask();
				log.info("获取积分包ID：{}", tWmScorePackage.getId());
				// 根据任务类型获取积分值

				if ("share".equalsIgnoreCase(type)) {
					if ("article".equalsIgnoreCase(taskCategoryName)) {
						wmTask.setTaskTypeId("9");
					} else if ("album".equalsIgnoreCase(taskCategoryName)) {
						wmTask.setTaskTypeId("8");
					}
				} else if ("open".equalsIgnoreCase(type)) {
					if ("article".equalsIgnoreCase(taskCategoryName)) {
						wmTask.setTaskTypeId("10");
					} else if ("album".equalsIgnoreCase(taskCategoryName)) {
						wmTask.setTaskTypeId("11");
					}
				}

				// 校验超过60周岁,不能做任务
				Map<String, String> checkResult = sysUserService.checkSixtyYearsOld(BeanUtil.copyProperties(sysUser, UserVO.class));
				if (CollUtil.isNotEmpty(checkResult) && checkResult.containsKey("OVER")) {
					throw new RuntimeException(checkResult.get("OVER"));
				}

				// 查询任务类型启用状态
				List<WmTaskSubmissionPercentRule> rules = wmTaskSubmissionPercentRuleService.list(Wrappers.<WmTaskSubmissionPercentRule>lambdaQuery()
						.eq(WmTaskSubmissionPercentRule::getDeptId, sysUser.getDeptId())
						.eq(WmTaskSubmissionPercentRule::getSubCategory, UpmsType.TaskSubCategory2.TASK_TYPE_CONFIG));
				if (CollUtil.isEmpty(rules)) {
					throw new RuntimeException("当前企业未开启该任务！");
				}
				String[] taskTypeIds = rules.get(0).getRule().getTaskTypeIds();
				if (!ArrayUtil.contains(taskTypeIds, wmTask.getTaskTypeId())) {
					throw new RuntimeException("当前企业未开启该任务！");
				}

				WmTaskType _baseTaskType = wmTaskTypeService.getById(wmTask.getTaskTypeId());

				// 校验任务类型是否启用
				WmTaskType queryTaskType = new WmTaskType();
				queryTaskType.setRuleId(tWmScorePackage.getRuleId());
				queryTaskType.setTaskTypeName(_baseTaskType.getTaskTypeName());
				queryTaskType.setDelFlag("0");
				List<WmTaskType> deptTaskTypes = wmTaskTypeService.list(Wrappers.query(queryTaskType));
				if (CollUtil.isEmpty(deptTaskTypes)) {
					msg = _baseTaskType.getTaskTypeName() + "任务类型不存在";
					log.info(msg);
					return R.failed(_baseTaskType.getTaskTypeName() + "任务类型不存在");
				}

				WmTaskType deptTaskType = deptTaskTypes.get(0);
				if (EnableEnum.DISABLE.val().equals(deptTaskType.getEnableFlag())) {
					msg = _baseTaskType.getTaskTypeName() + "任务类型已停用";
					log.info(msg);
					wmTask.setScore(0);
				} else {
					WmTaskType wmTaskType = new WmTaskType();
					wmTaskType.setRuleId(tWmScorePackage.getRuleId());
					wmTaskType.setTaskTypeName(_baseTaskType.getTaskTypeName());
					score = deptTaskType.getScore();
				}

				log.info("任务类型预设积分：{}", score);
				if (score < 0) {
					return R.failed("获取任务积分失败");
				}
				wmTask.setScore(score);


				boolean needToCheckLimit = tWmScorePackage.getScore() > 3000;
				if ("open".equals(type)) {
					List<WmWkArticleShare> wmWkArticleShareList = wmWkArticleShareService.list(Wrappers.
							<WmWkArticleShare>lambdaQuery()
							.eq(WmWkArticleShare::getArctileId, id)
							.eq(WmWkArticleShare::getShareType, "1")
							.orderByDesc(WmWkArticleShare::getCreateTime));
					if (CollectionUtils.isNotEmpty(wmWkArticleShareList)) {
						List<String> stringList = wmWkArticleShareList.stream()
								.map(articleShare -> String.valueOf(articleShare.getId())).collect(Collectors.toList());
						List<WmTask> wmTaskList = wmTaskService.list(Wrappers.<WmTask>lambdaQuery()
								.in(WmTask::getTaskContentId, stringList)
								.orderByDesc(WmTask::getCreateTime));
						if (CollectionUtils.isNotEmpty(wmTaskList)) {
							Optional<WmTask> first = wmTaskList.stream()
									.filter(t -> StringUtils.isNotEmpty(t.getShareImgUrl()))
									.findFirst();
							first.ifPresent(task -> wmTask.setShareImgUrl(task.getShareImgUrl()));
						}
					}

					// 获取打开用户的openid
					if (StringUtils.isEmpty(openUserId)) {
						log.info("openUserId为null，任务积分为0。");
						wmTask.setScore(0);
					} else {
						String readerOpenId = getReaderOpenId(openUserId.trim());
						if (readerOpenId.contains("null")) {
							log.info("获取阅读者openid失败，积分值为0");
							wmTask.setScore(0);
						} else {
							// 过滤文章分享list，如果阅读者已经阅读过同一个分享人分享的的同一篇文章，就不再记录分数
							List<WmWkArticleShare> shares = wmWkArticleShareList
									.stream()
									.filter(s -> readerOpenId.equals(s.getOpenUser()) && shareUserId.equals(s.getShareUserid()))
									.collect(Collectors.toList());
							if (CollectionUtils.isNotEmpty(shares)) {
								log.info("同一个分享存在多次打开记录:{}", shares);
								wmTask.setScore(0);
							}
							//  记录阅读者openid
							wmWkArticleShare.setOpenUser(readerOpenId);

						}
					}

					// 校验打开结果
					if (needToCheckLimit) {
						if ("article".equalsIgnoreCase(taskCategoryName)) {
							needToCheckLimit = checkArticleOpenLimit(wmWkArticle, sysUser, wmTask, "10", tWmScorePackage.getRelatedService());
						} else if ("album".equalsIgnoreCase(taskCategoryName)) {
							needToCheckLimit = checkAlbumOpenLimit(wmWkAlbum, sysUser, wmTask, "11", tWmScorePackage.getRelatedService());
						}
					}
				}

				// 记录分享记录
				wmWkArticleShareService.save(wmWkArticleShare);

				wmTask.setTaskFrom("1");
				wmTask.setTaskUserId(String.valueOf(userVO.getUserId()));  //任务提交人
				wmTask.setLookintoDate(now);       //调研时间
				wmTask.setUpdateTime(now);
				wmTask.setDrugEntId(userVO.getDrugEntId());
				wmTask.setShareImgUrl(sharePicUrl);
				wmTask.setScorePackageId(tWmScorePackage.getId());
				wmTask.setTaskRuleId(tWmScorePackage.getTaskRuleId());
				wmTask.setTaskContentId(String.valueOf(wmWkArticleShare.getId()));
				wmTask.setCreateTime(now);
				wmTask.setDeptId(String.valueOf(userVO.getDeptId()));

				if (isZbRole(userVO.getRoleList(), 5)) {
					wmTask.setTaskUserType("5");
				}

				if (isZbRole(userVO.getRoleList(), 6)) {
					wmTask.setTaskUserType("6");
				}


				// 判断是否保存前最后校验一遍文章分享和文章阅读以及产品分享和产品分享阅读所做的积分值是否在比例范围之内
				// （初始设定为30%，积分包值小于3000不做校验）
				if (needToCheckLimit && null != scorePackageStatus) {
//					String value = sysPublicParamService.getSysPublicParamKeyToValue("SHARE_READ_TASK_SCORE_UPPER_LIMIT_RATIO");
//					value = StringUtils.isEmpty(value) ? "0.3" : value;
//					log.warn("系统当前分享类及分享阅读类积分上限：【{}】", value);
//					int limit = (int) (Integer.parseInt(scorePackageStatus.getUserScore()) * Double.parseDouble(value));
//					List<WmTask> taskList = wmTaskService.list(Wrappers.<WmTask>lambdaQuery()
//							// 两对分享阅读任务
//							.in(WmTask::getTaskTypeId, Arrays.asList("8", "9", "10", "11"))
//							// 同一个积分包
//							.eq(WmTask::getScorePackageId, tWmScorePackage.getId())
//							// 分享人
//							.eq(WmTask::getTaskUserId, shareUserId)
//							// 审核不通过
//							.ne(WmTask::getTaskStatus, "4")
//					);
//
//					int sum = taskList.stream().mapToInt(WmTask::getScore).sum();
//					log.info("当前积分包值限制上限为:{},当前任务积分和为:{}", limit, sum);
//					if (sum >= limit) {
//						log.warn("完成任务积分值已经超过上限，设置为0");
//						wmTask.setScore(0);
//						msg = String.format("转发类任务所得积分不得大于积分包值的%d%s",
//								new BigDecimal(value).multiply(new BigDecimal("100"))
//										.setScale(0, BigDecimal.ROUND_HALF_UP).intValue(), "%");
//					}
				}

				// 校验任务百分比限制规则（如果积分包值大于【任务配置】-【百分比限制】配置的起始值，
				// 且【任务配置】-【百分比限制】所选的任务类型对应的任务总完成积分值>积分包值*【任务配置】-【百分比限制】配置的百分比，则校验不通过）
				R<?> checkPercentRuleResult =
						wmTaskSubmissionPercentRuleService.checkPercentRule(tWmScorePackage, sysUser.getDeptId(),
								Integer.valueOf(shareUserId), Arrays.asList("8", "9", "10", "11"));
				if (checkPercentRuleResult.getCode() != 0) {
					wmTask.setScore(0);
					msg = checkPercentRuleResult.getMsg();
				}

				// 校验结果为0积分的自动审核不通过
				boolean autoRejectFlag = wmTask.getScore() == 0;

				wmTask.setTaskStatus(autoRejectFlag ? "4" : "2"); //任务状态
				wmTask.setSubmitStatus(autoRejectFlag ? "1" : "0");
				wmTask.setTaskNumber(taskSequence.nextNo());
				boolean isSave = wmTaskService.save(wmTask);   //保存任务


				//判断任务是否完成
				if (isSave) {
					WmScorePackage wmScorePackage1 = wmScorePackageService.getById(tWmScorePackage.getId());
					//判断任务是否完成
					if (null != wmScorePackage1) {
						// 查询出 审核通过和审核中的任务
						List<WmTask> wmTaskList = wmTaskService.list(Wrappers.<WmTask>lambdaQuery()
								.eq(WmTask::getScorePackageId, tWmScorePackage.getId())
								// 查询出 审核通过和审核中的任务
								.ne(WmTask::getTaskStatus, "4")
								.eq(WmTask::getRealFlag, "0"));
						// 判断定量还是定额 1- 定额   2-定量 6-定额+定量
						if (StrUtil.equals(PackageTypeEnum.TYPE1_SCOTE_PACKAGE.val(), wmScorePackage1.getPackageType1())) {

							int totalCount = 0;
							for (WmTask wmtask : wmTaskList) {
								totalCount += wmtask.getScore();
							}

							if (totalCount >= wmScorePackage1.getScore()) {
								wmScorePackage1.setTaskAddFlag("0");
								scorePackageStatus.setTaskAddFlag("0");
								wmScorePackageStatusService.updateById(scorePackageStatus);
							}
						} else if (StrUtil.equals(PackageTypeEnum.TYPE1_SCORE_AND_TASK_PACKAGE.val(), wmScorePackage1.getPackageType1())) {
							// 多人积分包处理
							int totalCount = 0;
							for (WmTask wmtask : wmTaskList) {
								totalCount += wmtask.getScore();
							}

							if (totalCount >= wmScorePackage1.getScore()) {
								wmScorePackage1.setTaskAddFlag("0");
								List<WmScorePackageStatus> packageStatusList = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
										.eq(WmScorePackageStatus::getStatus, "2")
										.eq(WmScorePackageStatus::getTaskAddFlag, "1")
										.eq(WmScorePackageStatus::getPackageId, tWmScorePackage.getId()));
								if (CollUtil.isNotEmpty(packageStatusList)) {
									packageStatusList.forEach(packageStatus -> {
										WmScorePackageStatus updatePackageStatus = new WmScorePackageStatus();
										updatePackageStatus.setId(packageStatus.getId());
										updatePackageStatus.setTaskAddFlag("0");
										updatePackageStatus.setUpdateTime(LocalDateTime.now());
										wmScorePackageStatusService.updateById(updatePackageStatus);
									});
								}
							}
						} else if ("2".equals(wmScorePackage1.getPackageType1())) {
							score = 0;

							List<WmTask> userTaskList = wmTaskList.stream()
									.filter(item -> item.getTaskUserId().equals(String.valueOf(userVO.getUserId())))
									.collect(Collectors.toList());

							if (userTaskList.size() >= scorePackageStatus.getTaskNum()) {
								scorePackageStatus.setTaskAddFlag("0");
								wmScorePackageStatusService.updateById(scorePackageStatus);
								// 改变大包状态
								WmScorePackageStatus queryAll = new WmScorePackageStatus();
								queryAll.setPackageId(tWmScorePackage.getId());
								queryAll.setStatus("2");
								queryAll.setTaskAddFlag("0");
								List<WmScorePackageStatus> statusAll = wmScorePackageStatusService.
										list(Wrappers.query(queryAll));
								if (new BigDecimal(wmScorePackage1.getUserNum())
										.compareTo(new BigDecimal(statusAll.size())) <= 0) {
									wmScorePackage1.setTaskAddFlag("0");
								}
							}

						}

						wmScorePackage1.setIsConduct("1");
						wmScorePackageService.updateById(wmScorePackage1);

					}

				} else {
					return R.failed("任务保存失败");
				}
			}
		}

		if ("album".equalsIgnoreCase(taskCategoryName)) {
			if ("share".equalsIgnoreCase(type)) {
				wmWkAlbum.setForwardNum(wmWkAlbum.getForwardNum() + 1);
			}
			wmWkAlbumService.updateById(wmWkAlbum);
			wmWkAlbum.setScore(String.valueOf(score));

			return R.ok(wmWkAlbum, msg);
		} else if ("article".equalsIgnoreCase(taskCategoryName)) {
			if ("share".equalsIgnoreCase(type)) {
				wmWkArticle.setForwardNum(wmWkArticle.getForwardNum() + 1);
			}
			wmWkArticleService.updateById(wmWkArticle);
			wmWkArticle.setScore(String.valueOf(score));
			return R.ok(wmWkArticle, msg);
		}

		return R.ok(null, msg);
	}


	/**
	 * 文章打开判断
	 *
	 * @param article    文章
	 * @param user       分享用户
	 * @param task       任务
	 * @param taskTypeId 任务类型id
	 * @param pkgId      积分包id
	 * @return 校验信息
	 */
	private Boolean checkArticleOpenLimit(WmWkArticle article, SysUser user, WmTask task, String taskTypeId, String pkgId) {
		Assert.notNull(article);

		List<WmTaskSubmissionRule.SubmissionRule> rules = wmTaskContentService.getTaskSubmissionRule(taskTypeId, pkgId);

		int maxShareTimes = upmsConfig.getMaxShareTimes();
		if (CollUtil.isNotEmpty(rules)) {
			// 获取限制
			for (int i = 0, size = rules.size(); i < size; i++) {
				Map<String, Object> map = (Map<String, Object>) rules.get(i);
				WmTaskSubmissionRule.SubmissionRule r = BeanUtil.mapToBean(map, WmTaskSubmissionRule.SubmissionRule.class, true, new CopyOptions());

				if ("同一个人对同一篇文章的转发上限".equals(r.getManual())) {

					List<Integer> quantity = r.getFrequency().stream().map(f -> {
						Object o = f.get("quantity");
						return o instanceof String ? Integer.parseInt((String) o) : (int) o;
					}).sorted().collect(Collectors.toList());
					maxShareTimes = quantity.get(0);
				}
			}


		}

		LocalDateTime now = LocalDateTime.now();
		final String cacheKey = CacheConstants.ARTICLE_PERSONAL_SHARE_KEY + DateUtil.format(now, "yyyyMMdd:")
				+ user.getUserId() + ":" + article.getId();
		Integer times = (Integer) redisTemplate.opsForValue().get(cacheKey);
		if (null != times && times >= maxShareTimes) {
			log.info("{}:{}已经转发文章{}次数:{}", user.getUserId(), user.getRealname(), article.getId(), times);
			task.setScore(0);
			return false;
		}
		return true;
	}

	/**
	 * 相册打开判断
	 *
	 * @param album      相册
	 * @param user       分享用户
	 * @param task       任务
	 * @param taskTypeId 任务类型id
	 * @param pkgId      积分包id
	 * @return 校验信息
	 */
	private Boolean checkAlbumOpenLimit(WmWkAlbum album, SysUser user, WmTask task, String taskTypeId, String pkgId) {
		Assert.notNull(album);

		List<WmTaskSubmissionRule.SubmissionRule> rules = wmTaskContentService.getTaskSubmissionRule(taskTypeId, pkgId);

		int maxShareTimes = upmsConfig.getMaxShareTimes();
		if (CollUtil.isNotEmpty(rules)) {
			// 获取限制
			for (int i = 0, size = rules.size(); i < size; i++) {
				Map<String, Object> map = (Map<String, Object>) rules.get(i);
				WmTaskSubmissionRule.SubmissionRule r = BeanUtil.mapToBean(map, WmTaskSubmissionRule.SubmissionRule.class, true, new CopyOptions());

				if ("同一个人对同一个相册的转发上限".equals(r.getManual())) {

					List<Integer> quantity = r.getFrequency().stream().map(f -> {
						Object o = f.get("quantity");
						return o instanceof String ? Integer.parseInt((String) o) : (int) o;
					}).sorted().collect(Collectors.toList());
					maxShareTimes = quantity.get(0);
				}
			}


		}

		if (StringUtils.isNotEmpty(album.getGlyp())) {
			List<WmDaDrugEntDrugtable> drugTableList =
					wmDaDrugEntDrugtableService.listByIds(Arrays.asList(album.getGlyp().split(",")));
			if (CollectionUtils.isNotEmpty(drugTableList)) {
				String date = DateUtil.today() + ":";
				log.info("DateUtil.today():{}", date);
				for (WmDaDrugEntDrugtable drug : drugTableList) {
					if (StringUtils.isEmpty(drug.getDrugEntId())) {
						continue;
					}
					String key = CacheConstants.DRUG_ENT_PERSONAL_SHARE_KEY1 + date
							+ drug.getDrugEntId() + CacheConstants.DRUG_ENT_PERSONAL_SHARE_KEY2 + user.getUserId();
					log.info("key:{}", key);
					Integer times = (Integer) redisTemplate.opsForValue().get(key);
					if (times != null && times >= maxShareTimes) {
						task.setScore(0);
						return false;
					}
				}
			}
		}
		return true;
	}

	/**
	 * 校验文章转发限制
	 *
	 * @param wmWkArticle 文章
	 * @param sysUser     转发人
	 * @param taskTypeId  任务类型id
	 * @param pkgId       积分包id
	 * @return 校验信息
	 */
	private String checkArticleLimit(WmWkArticle wmWkArticle, SysUser sysUser, String taskTypeId, String pkgId) {
		Assert.notNull(wmWkArticle);

		List<WmTaskSubmissionRule.SubmissionRule> rules = wmTaskContentService.getTaskSubmissionRule(taskTypeId, pkgId);

		int maxShareTimes = upmsConfig.getMaxShareTimes();
		if (CollUtil.isNotEmpty(rules)) {
			// 获取限制
			for (int i = 0, size = rules.size(); i < size; i++) {
				Map<String, Object> map = (Map<String, Object>) rules.get(i);
				WmTaskSubmissionRule.SubmissionRule r = BeanUtil.mapToBean(map, WmTaskSubmissionRule.SubmissionRule.class, true, new CopyOptions());

				if ("同一个人对同一篇文章的转发上限".equals(r.getManual())) {

					List<Integer> quantity = r.getFrequency().stream().map(f -> {
						Object o = f.get("quantity");
						return o instanceof String ? Integer.parseInt((String) o) : (int) o;
					}).sorted().collect(Collectors.toList());
					maxShareTimes = quantity.get(0);
				}
			}


		}


		LocalDateTime now = LocalDateTime.now();
		final String cacheKey = CacheConstants.ARTICLE_PERSONAL_SHARE_KEY + DateUtil.format(now, "yyyyMMdd:")
				+ sysUser.getUserId() + ":" + wmWkArticle.getId();
		Integer times = (Integer) redisTemplate.opsForValue().get(cacheKey);
		if (null != times) {
			log.info("{}:{}已经转发文章{}次数:{}", sysUser.getUserId(), sysUser.getRealname(), wmWkArticle.getId(), times);
			if (times++ >= maxShareTimes) {
				return String.format("您当日转发的该药企产品相册次数已超过%s次，转发将不再获得积分", maxShareTimes);
			}
		} else {
			log.info("{}:{}已经首次转发文章:{}", sysUser.getUserId(), sysUser.getRealname(), wmWkArticle.getId(), times);
			times = 1;
		}
		redisTemplate.opsForValue()
				.set(cacheKey, times, Duration.between(now, LocalDateTime.of(now.toLocalDate(), LocalTime.MAX)));
		return null;
	}

	/**
	 * 校验相册转发限制
	 *
	 * @param wmWkAlbum  相册
	 * @param sysUser    分享人
	 * @param taskTypeId 任务类型id
	 * @param pkgId      积分包id
	 * @return 校验结果信息
	 */
	private String checkAlbumLimit(WmWkAlbum wmWkAlbum, SysUser sysUser, String taskTypeId, String pkgId) {

		Assert.notNull(wmWkAlbum);

		List<WmTaskSubmissionRule.SubmissionRule> rules = wmTaskContentService.getTaskSubmissionRule(taskTypeId, pkgId);

		int maxShareTimes = upmsConfig.getMaxShareTimes();
		if (CollUtil.isNotEmpty(rules)) {
			// 获取限制
			for (int i = 0, size = rules.size(); i < size; i++) {
				Map<String, Object> map = (Map<String, Object>) rules.get(i);
				WmTaskSubmissionRule.SubmissionRule r = BeanUtil.mapToBean(map, WmTaskSubmissionRule.SubmissionRule.class, true, new CopyOptions());

				if ("同一个人对同一个相册的转发上限".equals(r.getManual())) {

					List<Integer> quantity = r.getFrequency().stream().map(f -> {
						Object o = f.get("quantity");
						return o instanceof String ? Integer.parseInt((String) o) : (int) o;
					}).sorted().collect(Collectors.toList());
					maxShareTimes = quantity.get(0);
				}
			}


		}

		if (StringUtils.isNotEmpty(wmWkAlbum.getGlyp())) {
			List<WmDaDrugEntDrugtable> drugTableList =
					wmDaDrugEntDrugtableService.listByIds(Arrays.asList(wmWkAlbum.getGlyp().split(",")));
			if (CollectionUtils.isNotEmpty(drugTableList)) {
				/**
				 * 2020-12-13 修改
				 * 需求有逻辑BUG
				 */
				String date = DateUtil.today() + ":";
				System.err.println("DateUtil.today():" + date);
				for (int i = 0; i < drugTableList.size(); i++) {
					WmDaDrugEntDrugtable drug = drugTableList.get(i);
					if (StringUtils.isEmpty(drug.getDrugEntId())) {
						continue;
					}
					String key = CacheConstants.DRUG_ENT_PERSONAL_SHARE_KEY1 + date
							+ drug.getDrugEntId() + CacheConstants.DRUG_ENT_PERSONAL_SHARE_KEY2 + sysUser.getUserId();
					System.err.println("key" + key);
					if (redisTemplate.hasKey(key)) {
						int times = Integer.parseInt(redisTemplate.opsForValue().get(key).toString());
						if (times >= maxShareTimes) {
							return String.format("您当日转发的该药企产品相册次数已超过%s次，转发将不再获得积分", maxShareTimes);
						}
						times++;
						redisTemplate.opsForValue().set(key, times, CacheConstants.SHARE_TIME, TimeUnit.DAYS);
					} else {
						redisTemplate.opsForValue().set(key, 1, CacheConstants.SHARE_TIME, TimeUnit.DAYS);
					}

				}
			}
		}
		return null;
	}

	/**
	 * 小程序上传
	 *
	 * @param file 资源
	 * @return R(/ admin / bucketName / filename)
	 */
	@PostMapping("/file/upload/mobile")
	public R uploadForMobile(@RequestParam("file") MultipartFile file) throws IOException, NoSuchAlgorithmException {

		String originalFilename = file.getOriginalFilename();

		String extName = FileUtil.extName(originalFilename);

		List<String> IMG_EXT_NAME = Arrays.asList("png", "jpg", "gif", "jpeg", "tif", "bmp");

		log.info("源文件名称:{}", originalFilename);
		log.info("源文件后缀:{}", extName);
		if (IMG_EXT_NAME.contains(extName)) {
			HnqzUser user = SecurityUtils.getUser();
			log.info("用户:{}", user);
			if (user == null) {
				return R.failed("无法获取用户id");
			}
			Integer id = user.getId();

			// 文件md5

			byte[] bytes = file.getBytes();
			MessageDigest md5 = MessageDigest.getInstance("MD5");
			byte[] digest = md5.digest(bytes);
			String hash = new BigInteger(1, digest).toString(16);

			log.info("图片md5:{}", hash);
			// Boolean aBoolean = redisTemplate.opsForValue().setIfAbsent(String.format("%s:%s", id, hash), originalFilename, 7, TimeUnit.DAYS);
			//
			// if (aBoolean != null && !aBoolean){
			// 	log.error("上传了重复的图片");
			// 	return R.failed(hash,"duplicate");
			// }

		}

		return sysFileService.uploadFile(file);
	}

	/**
	 * 记录广告点击情况
	 *
	 * @param json 请求参数
	 * @return 记录结果
	 */
	@PostMapping(value = "/ad-record")
	@Transactional(rollbackFor = Exception.class)
	public R<Boolean> insertAdRecord(@RequestBody String json) {
		JSONObject jsonObject = JSONObject.parseObject(json);
		WmAdRecord record = new WmAdRecord();
		record.setUrl(jsonObject.getString("url"));
		record.setUserId(SecurityUtils.getUser().getId());
		return R.failed(adRecordService.save(record));
	}

	/**
	 * 获取e-token
	 * <p>
	 * 每人每天最多获取5次
	 *
	 * @return e-token
	 */
	@SysLog("获取e-token")
	@GetMapping(value = "/eid")
	public R<?> getEidToken(@RequestParam(value = "idCard") String idCard,
							@RequestParam(value = "realName") String realName,
							@RequestParam(value = "endType", required = false) String endType) {

		if (StrUtil.isBlank(endType)) {
			endType = upmsConfig.getEndType();
		}

		String tokenUrl = upmsConfig.getGigServiceUrl() + "/gig/operation/eid?idCard={idCard}&realName={realName}&endType={endType}";

		ResponseEntity<String> tokenResult = new RestTemplate().getForEntity(tokenUrl, String.class, idCard, realName, endType);

		log.info("获取e-token：{}", tokenResult.getBody());

		cn.hutool.json.JSONObject jsonObject = JSONUtil.parseObj(tokenResult.getBody());

		return R.builder().code(jsonObject.getInt("code")).msg(jsonObject.getStr("msg")).data(jsonObject.getStr("data")).build();


	}


	/**
	 * 获取合身视频结果
	 *
	 * @param token e-token
	 * @return 合身视频结果
	 */
	@SysLog("获取e-token合身视频结果")
	@GetMapping(value = "/eid/result")
	public R<?> getEidResult(@RequestParam(value = "token") String token,
							 @RequestParam(value = "endType", required = false) String endType) {

		if (StrUtil.isBlank(endType)) {
			endType = upmsConfig.getEndType();
		}

		String tokenUrl = upmsConfig.getGigServiceUrl() + "/gig/operation/eid/result?token={token}&endType={endType}";

		ResponseEntity<String> tokenResult = new RestTemplate().getForEntity(tokenUrl, String.class, token, endType);

		log.info("获取e-token认证结果：{}", tokenResult.getBody());

		cn.hutool.json.JSONObject jsonObject = JSONUtil.parseObj(tokenResult.getBody());

		if (CommonConstants.SUCCESS.equals(jsonObject.getInt("code"))) {
			cn.hutool.json.JSONObject data = jsonObject.getJSONObject("data");
			if (data != null) {
				if (CommonConstants.SUCCESS.equals(data.getInt("compareCode"))) {

					Boolean absent = redisTemplate.opsForValue()
							.setIfAbsent(CacheConstants.EID_RESULT_KEY + token, tokenResult.getBody(), 30, TimeUnit.SECONDS);
					if (absent) {
						// 认证成功，则保存
						sysUserExtRecordService.eidResultHandler(data);
					}
				}
			}
		}

		return R.builder().code(jsonObject.getInt("code")).msg(jsonObject.getStr("msg")).data(jsonObject.getObj("data")).build();


	}

	/**
	 * 获取任务类型的小程序端限制规则
	 *
	 * @param deptId      企业id
	 * @param subCategory 二级分类
	 * @return 限制规则
	 */
	@GetMapping(value = "/task-sub-rule")
	public R<?> listTaskSubmissionRule(@RequestParam(value = "deptId") Integer deptId, @RequestParam(value = "subCategory") UpmsType.TaskSubCategory subCategory) {
		WmTaskSubmissionRule rule = taskSubmissionRuleService.getOne(Wrappers.<WmTaskSubmissionRule>lambdaQuery()
				.eq(WmTaskSubmissionRule::getDeptId, deptId)
				.eq(WmTaskSubmissionRule::getSubCategory, subCategory)
		);
		return R.ok(rule.getRule());

	}

	/**
	 * 校验是财务验证码是否存在
	 *
	 * @return 校验结果
	 */
	@GetMapping(value = "/check-code/for-fina")
	public R<?> checkFinaCode(@RequestParam(value = "code") String code) {


		Integer userId = SecurityUtils.getUser().getId();

		// 获取用户信息判断，是否需要发送验证码
		SysUser sysUser = sysUserService.getById(userId);

		if (Objects.isNull(sysUser)) {
			log.error("用户不存在");
			return R.failed("用户不存在");
		}

		log.info("是否需要发送验证码temp3：{}", sysUser.getTemp3());
		String username = sysUser.getUsername();

		final String key = com.qunzhixinxi.hnqz.common.core.constant.CacheConstants.DEFAULT_CODE_KEY + LoginTypeEnum.SMS.getType() + StringPool.AT + username + "@fina";


		Boolean res = redisTemplate.hasKey(key) ? code.equals(redisTemplate.opsForValue().get(key)) : Boolean.FALSE;

		if (res) {
			redisTemplate.delete(key);
		}

		return R.ok(res);

	}

	/**
	 * 我的积分-积分记录列表
	 *
	 * @param page   分页参数
	 * @param status 状态
	 * @return 分页结果
	 */
	@GetMapping("/page-accumulative-score")
	public R<Page<PersonalScoreRecordVO>> pageAccumulativeScore(Page<PersonalScoreRecordVO> page,
																@RequestParam(value = "status", required = true) PersonalScoreRecordVO.PersonalScoreRecordStatus status) {

		Integer userId = SecurityUtils.getUser().getId();

		// 获取当前用户任务领包记录
		List<WmScorePackageStatus> packageStatuses = wmScorePackageStatusService.list(Wrappers.<WmScorePackageStatus>lambdaQuery()
				.eq(WmScorePackageStatus::getUserId, userId)
				.eq(WmScorePackageStatus::getStatus, PackageStatusEnum.APPROVED.val()));
		if (CollUtil.isEmpty(packageStatuses)) {
			return R.ok(page);
		}

		// 查询积分包
		Set<String> ids = packageStatuses.stream().map(WmScorePackageStatus::getPackageId).collect(Collectors.toSet());
		List<WmScorePackage> packages = wmScorePackageService.listByIds(ids);
		// 转为map key-积分包id，value-积分包名称
		Map<String, String> packageMap = packages.stream()
				.filter(pkg -> StrUtil.split(status.getScorePackageStatus(), StrUtil.COMMA).contains(pkg.getScorePackageStatus()))
				.filter(pkg -> {
					if (PersonalScoreRecordVO.PersonalScoreRecordStatus.PAID.getSettleStatus().equals(String.valueOf(pkg.getSettleStatus()))) {
						// 如果条件是已结算，则直接返回
						return true;
					} else {
						// 如果是待结算，则过滤掉对应的积分包状态
						return StrUtil.split(status.getScorePackageStatus(), StrUtil.COMMA).contains(pkg.getScorePackageStatus());
					}
				})
				.collect(Collectors.toMap(WmScorePackage::getId, WmScorePackage::getScorePackageName));

		if (CollUtil.isEmpty(packageMap)) {
			return R.ok(page);
		}

		// 过滤得已结算、待结算积分包id
		Set<String> packageIds = packageMap.keySet();

		// 查询taskType
		List<WmTaskType> taskTypeList = wmTaskTypeService.list(Wrappers.<WmTaskType>lambdaQuery()
				.eq(WmTaskType::getTaskTypeLevel, "1")
				.eq(WmTaskType::getDelFlag, DelEnum.NOT_DEL.val())
				.eq(WmTaskType::getEnableFlag, EnableEnum.ENABLE.val()));
		// taskType通过id分组（key为parentId，value为taskTypeId的set）
		Map<String, String> taskTypeIdMap = taskTypeList.stream()
				.collect(Collectors.toMap(WmTaskType::getId, WmTaskType::getTaskTypeName));

		// 查询任务
		Page<WmTask> wmTaskPage = wmTaskService.page(new Page<>(page.getCurrent(), page.getSize()), Wrappers.<WmTask>lambdaQuery()
				.in(WmTask::getScorePackageId, packageIds)
				.eq(WmTask::getTaskUserId, userId)
				.eq(WmTask::getTaskStatus, TaskStatusEnum.APPROVED.val())
				.eq(WmTask::getDelFlag, DelEnum.NOT_DEL.val())
				.eq(WmTask::getEnableFlag, EnableEnum.ENABLE.val()));
		List<PersonalScoreRecordVO> recordVOS = new ArrayList<>();
		wmTaskPage.getRecords().forEach(wmTask -> {
			PersonalScoreRecordVO recordVO = new PersonalScoreRecordVO();
			recordVO.setScore(wmTask.getScore());
			recordVO.setTaskTypeId(wmTask.getTaskTypeId());
			recordVO.setLookintoDate(wmTask.getLookintoDate());
			recordVO.setScorePackageId(wmTask.getScorePackageId());
			recordVO.setScorePackageName(packageMap.get(wmTask.getScorePackageId()));
			recordVO.setTaskTypeName(taskTypeIdMap.get(wmTask.getTaskTypeId()));
			recordVOS.add(recordVO);
		});

		page.setRecords(recordVOS);
		page.setTotal(wmTaskPage.getTotal());
		page.setPages(wmTaskPage.getPages());

		return R.ok(page);
	}

	/**
	 * 获取当前积分包对应的积分规则
	 *
	 * @param packageId 积分包id
	 * @return
	 */
	@GetMapping("/package-rule-task-type/{packageId}")
	public R<?> getScorePackageRuleScore(@PathVariable("packageId") String packageId) {
		WmScorePackage scorePackage = wmScorePackageService.getById(packageId);
		if (scorePackage == null) {
			throw new RuntimeException("积分包不存在");
		}
		// 查询当前企业的任务类型积分
		WmTaskType queryTaskType = new WmTaskType();
		queryTaskType.setRuleId(scorePackage.getRuleId());
		queryTaskType.setDelFlag("0");
		queryTaskType.setEnableFlag("0");
		List<WmTaskType> list = wmTaskTypeService.list(Wrappers.query(queryTaskType));
		if (CollUtil.isNotEmpty(list)) {
			List<Map<String, Object>> result = list.stream().map(wmTaskType -> {
				Map<String, Object> map = new HashMap<>(3);
				map.put("taskTypeName", wmTaskType.getTaskTypeName());
				if (wmTaskType.getTaskTypeName().startsWith("应收账款回款")) {
					// 应收账款回款 任务类 保存的是1000倍数，需要转换回来
					map.put("score", String.valueOf(wmTaskType.getScore() / 1000.0D));
				} else {
					map.put("score", String.valueOf(wmTaskType.getScore()));
				}
				return map;
			}).collect(Collectors.toList());
			return R.ok(result);
		}

		return R.ok(Collections.emptyList());
	}

	/**
	 * 小程序签署协议
	 *
	 * @param signAgreementDTO 请求参数
	 * @return {@link R}<{@link ?}> 结果
	 */
	@SysLog("小程序签署协议")
	@PostMapping("/sign-agreement")
	public R<Boolean> signAgreement(@Validated @RequestBody SignAgreementDTO signAgreementDTO) {
		log.info("小程序签署协议请求:{}", signAgreementDTO);

		Integer userId = SecurityUtils.getUser().getId();
		SysUser queryUser = sysUserService.getById(userId);

		List<Object> signAgreementDTOList = new ArrayList<>();
		if (StrUtil.isBlank(queryUser.getSignAgreement())) {
			signAgreementDTOList.add(signAgreementDTO);
		} else {
			JSONArray agreements = JSONUtil.parseArray(queryUser.getSignAgreement());
			signAgreementDTOList.addAll(agreements);
			// 如果已存在该协议,则不再重复保存
			boolean anyMatch = agreements.stream()
					.map(o -> BeanUtil.toBean(o, SignAgreementDTO.class))
					.anyMatch(dto -> SignAgreementDTO.SignAgreementType.HONEST_AGREEMENT.equals(dto.getAgreementType()));
			if (anyMatch) {
				return R.ok();
			}
			signAgreementDTOList.add(signAgreementDTO);
		}


		boolean update = sysUserService.update(Wrappers.<SysUser>lambdaUpdate()
				.eq(SysUser::getUsername, queryUser.getUsername())
				.set(SysUser::getSignAgreement, JSONUtil.toJsonStr(signAgreementDTOList))
				.set(SysUser::getUpdateTime, LocalDateTime.now()));

		return R.ok(update);
	}

	/**
	 * 关闭年满60周岁提醒
	 *
	 * @return {@link R}<{@link Boolean}>
	 */
	@PostMapping("/stop-sixtyyearsold-reminder")
	public R<Boolean> stopSixtyYearsOldReminder() {
		Integer userId = SecurityUtils.getUser().getId();
		SysUser queryUser = sysUserService.getById(userId);
		log.info("关闭年满60周岁提醒:userId={},idCardNumber={}", userId, queryUser.getIdCardNumber());

		boolean update = false;
		if (StrUtil.isNotBlank(queryUser.getIdCardNumber())) {
			update = sysUserService.update(Wrappers.<SysUser>lambdaUpdate()
					.eq(SysUser::getIdCardNumber, queryUser.getIdCardNumber())
					.set(SysUser::getAgeReminder, Boolean.FALSE)
					.set(SysUser::getUpdateTime, LocalDateTime.now()));
		}

		return R.ok(update);
	}
}
